var isResumeLoadingShown = false;
var welcomepicpath = null;
var HotUpdateLayer = cc.Layer.extend({
    
    _am : null,
    _percent : 0,
    _callback : null,
    _failCount : 0,
    _maxFailCount : 3,

    ctor: function () {
        this._super();

        this.initUI();
    },

    onEnter: function () {
        this._super();
        this.checkBigVersionUpdate();
    },

    initUI: function() {
        var size = cc.winSize;

        var bg = new ccui.ImageView("res/splash/splashBg1.png");
        bg.setPosition(size.width / 2, size.height / 2);
        this.addChild(bg);

        // var logo = new ccui.ImageView("res/splash/splashLogo.png");
        // logo.setPosition(size.width / 2, size.height - 200);
        // this.addChild(logo);

        var processBarBg = new ccui.ImageView("res/splash/processBarBg.png");
        processBarBg.setPosition(size.width / 2, 60);
        this.addChild(processBarBg);
        
        this.processBar = new ccui.LoadingBar("res/splash/processBar.png");
        this.processBar.setPosition(size.width / 2, 64);
        this.processBar.setPercent(this._percent);
        this.addChild(this.processBar);

        this.processThumb = new ccui.ImageView("res/splash/processBarThub.png");
        this.processThumb.x = (size.width - this.processBar.width) / 2 + 3 + this.processBar.width * this._percent / 100;
        this.processThumb.y = 64;
        this.addChild(this.processThumb);

        this.hint = new cc.LabelTTF("检查资源", "Arial", 38);
        this.hint.setPosition(size.width / 2, 120);
        this.addChild(this.hint);
    },

    updateHint: function(text) {
        this.hint.setString(text);
    },

    cb: function(event) {
        switch (event.getEventCode())
        {
            case jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST:
                this.updateHint("没有本地Manifest文件错误");
                this.onFail();
                break;

            case jsb.EventAssetsManager.UPDATE_PROGRESSION:
                this.updateHint("更新中...");
                this._percent = event.getPercentByFile();
                break;

            case jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST:
                this.updateHint("下载远程Manifest失败错误");
                this.onFail();
                break;

            case jsb.EventAssetsManager.ERROR_PARSE_MANIFEST:
                this.updateHint("解析Manifest错误");
                this.onFail();
                break;

            case jsb.EventAssetsManager.ALREADY_UP_TO_DATE:
                this.updateHint("已经是最新版本");
                this.onSuccess();
                break;

            case jsb.EventAssetsManager.UPDATE_FINISHED:
                this.updateHint("更新完成");
                this.onSuccess();
                break;

            case jsb.EventAssetsManager.UPDATE_FAILED:
                this.updateHint("更新失败: " + event.getMessage());

                this._failCount ++;
                if (this._failCount < this._maxFailCount)
                {
                    this.updateHint("第" + this._failCount.toString() + "次下载失败资源尝试");
                    this._am.downloadFailedAssets();
                }
                else
                {
                    this.updateHint("达到最大尝试次数");
                    this.onFail();
                }
                break;

            case jsb.EventAssetsManager.ERROR_UPDATING:
                this.updateHint("更新错误: " + event.getAssetId() + ", " + event.getMessage());
                this.onFail();
                break;

            case jsb.EventAssetsManager.ERROR_DECOMPRESS:
                this.updateHint("解压缩错误");
                this.onFail();
                break;

            default:
                break;

        }
    },

    checkBigVersionUpdate:function() {
        var params = new Object();
        params.clientVersion = "1.6.0";
        params.protocalVersion = "1.0.0";

        cc.log("debugMode:" + cc.game.config["debugMode"]);
        if(cc.sys.os === cc.sys.OS_ANDROID) {
            params.osType = "Android";
            params.osVersion = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getOsVersion", "()Ljava/lang/String;");
            params.vender = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getVender", "()Ljava/lang/String;");

            var address = "http://test.lyingmanonline.com";
            if(cc.game.config["debugMode"] == 0 || 1) {
                address = "https://api.lyingmanonline.com";
            }
            var path = "/config/checkConfig";
            var jsonBody = JSON.stringify(params);
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/AliGatewayUtil", "asynPostRequest"
                , "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", address, path, jsonBody, "onCheckBigVersionResponse");
        } else if (cc.sys.os === cc.sys.OS_IOS) {
            params.osType = "IOS";
            params.osVersion = jsb.reflection.callStaticMethod("KeyCenter", "getOsVersion");
            params.vender = jsb.reflection.callStaticMethod("KeyCenter", "getVender");

            var address = "test.lyingmanonline.com";
            if(cc.game.config["debugMode"] == 0 || 1) {
                address = "api.lyingmanonline.com";
            }
            var path = "/config/checkConfig";
            var jsonBody = JSON.stringify(params);
            jsb.reflection.callStaticMethod("AliGatewayUtil", "asynPostRequest:path:jsonBody:callBack:", address, path, jsonBody, "onCheckBigVersionResponse");
        }
    },

    initLogic: function() {
        cc.log("进入热更新流程");
        var manifestPath = "res/project.manifest";
        var storagePath = (jsb.fileUtils ? jsb.fileUtils.getWritablePath() + "cocosstorage/" : "./cocosstorage/");
        cc.log("storagePath: " + storagePath);
        this._am = new jsb.AssetsManager(manifestPath, storagePath);
        this._am.retain();

        if (!this._am.getLocalManifest().isLoaded())
        {
            this.updateHint("无法加载本地Manifest");
            this.onFail();
        }
        else
        {
            this._callback = this.cb.bind(this);
            var listener = new jsb.EventListenerAssetsManager(this._am, this._callback);
            cc.eventManager.addListener(listener, 1);
            this._am.update();
        }

        this.schedule(this.updateProgress, 0.5);
    },

    updateProgress: function () {
        this.processBar.setPercent(this._percent);
    },

    updateProgressByValue: function (percent) {
        this.processBar.setPercent(percent);
    },

    onSuccess: function() {
        cc.log("热更新成功回调函数");
        cc.loader.loadJs(["src/jsList.js"], function(){
            cc.loader.loadJs(jsList, function(){
                // enter the game
                cc.eventManager.addCustomListener(cc.game.EVENT_HIDE, function(){
                        cc.log("游戏进入后台1");
                        isResumeLoadingShown = false;
                        if (cc.director.getRunningScene() instanceof RoomScene) {
                            cc.log("游戏进入后台2");
                            cc.director.runScene(new ResumeLoadingScene());
                            cc.log("游戏进入后台3");
                            isResumeLoadingShown = true;
                        } else if (cc.director.getRunningScene() instanceof ResumeLoadingScene) {
                            isResumeLoadingShown = true;
                        }

                        if(cc.sys.os === cc.sys.OS_IOS) {
                            closeMic();
                            closeSpeaker();
                        }

                        cc.audioEngine.stopAllEffects();
                        tranferMqttMessage();
                });

                cc.eventManager.addCustomListener(cc.game.EVENT_SHOW, function(){
                    cc.log("游戏进入前台111");
                    MqttClient.getInstance()._isExcuteFinish = true;
                    if(isResumeLoadingShown) {
                        cc.log("游戏进入前台1");
                        if(isMqttConnected()) {
                            cc.log("游戏进入前台2");
                            sendResumeRequest();
                        }
                    }

                    if (cc.director.getRunningScene() instanceof ShopScene) {
                        cc.director.runScene(new ShopScene());
                    }
                    if (cc.director.getRunningScene() instanceof RankScene) {
                        cc.director.runScene(new RankScene());
                    }
                    if (cc.director.getRunningScene() instanceof HallScene) {
                        cc.director.runScene(new HallScene());
                    }
                    if (cc.director.getRunningScene() instanceof FriendMessageScene) {
                        cc.director.runScene(new FriendMessageScene());
                    }
                    if (cc.director.getRunningScene() instanceof HomeScene) {
                        cc.director.runScene(new HomeScene());
                    }
                });

                cc.log("热更新成功回调函数1");
                if (welcomepicpath != null && welcomepicpath != "" && welcomepicpath != undefined && welcomepicpath.length > 0 &&
                    jsb.fileUtils.isFileExist(welcomepicpath)) {
                    cc.director.runScene(new WelcomeScene(welcomepicpath));
                } else {
                    cc.director.runScene(new SigninScene());
                }
                cc.log("热更新成功回调函数2");
                // enter the demo
                //cc.director.runScene(new DemoScene());
            }); 
        });
    },

    onFail: function() {
        cc.log("热更新失败回调函数");

        var size = cc.winSize;

        var alterBg = new ccui.ImageView("res/yesOrNoDialogBg.png");
        alterBg.setPosition(size.width / 2, size.height / 2);
        this.addChild(alterBg);

        var titleBg = new ccui.ImageView("res/dialogTitle.png");
        titleBg.setPosition(size.width / 2, size.height / 2 + 130);
        this.addChild(titleBg);

        var titleTTF = new cc.LabelTTF("通知", "Arial", 38);
        titleTTF.setPosition(size.width / 2, size.height / 2 + 130);
        titleTTF.setColor(cc.color(251, 228, 178));
        this.addChild(titleTTF);

        var infoTTF = new cc.LabelTTF("更新资源失败, 请稍后再试...", "Arial", 30);
        infoTTF.setPosition(size.width / 2, size.height / 2 + 20);
        this.addChild(infoTTF);

        var confirmButton = new ccui.Button("res/directJoinRoom.png", "res/directJoinRoomDown.png");
        confirmButton.setPosition(size.width / 2, size.height / 2 - 80);
        confirmButton.addClickEventListener(function () {
            cc.game.restart();
        });
        this.addChild(confirmButton);

        var buttonTitle = new ccui.ImageView("res/common/confirmLabel.png");
        buttonTitle.setPosition(size.width / 2, size.height / 2 - 80);
        this.addChild(buttonTitle);
    }
});

function onCheckBigVersionResponse(responseString) {
    cc.log("checkBigVersionResponse = " + responseString);

    if(responseString == null || responseString == "" || responseString == undefined) {
        var currentScene = cc.director.getRunningScene();
        if(currentScene instanceof HotUpdateScene) {
            currentScene.startHotUpdate();
        }
    } else {
        var obj = JSON.parse(responseString);
        welcomepicpath = obj.retBody.welcomepicurl;
        cc.log("welcomepicpath === " + welcomepicpath);
        if(obj.retCode == 1 || obj.retCode == 4) {
            var currentScene = cc.director.getRunningScene();
            if(currentScene instanceof HotUpdateScene) {
                currentScene.startHotUpdate();
            }
        } else if (obj.retCode == 2){
            var dialog = new CheckBigVersionDialog(2, obj.retBody.message, obj.retBody.downloadUrl);
            dialog.popup();
        } else if (obj.retCode == 3) {
            var dialog = new CheckBigVersionDialog(3, obj.retBody.message, obj.retBody.downloadUrl);
            dialog.popup();
        } else if (obj.retCode == 4) {
            var dialog = new CheckBigVersionDialog(4, obj.retBody.message, "");
            dialog.popup();
        } else if (obj.retCode == 5) {
            var dialog = new CheckBigVersionDialog(5, obj.retBody.message, "");
            dialog.popup();
        } else {
            var currentScene = cc.director.getRunningScene();
            if(currentScene instanceof HotUpdateScene) {
                currentScene.startHotUpdate();
            }
        }
    }
};

function updateProgressFromNative(percent) {
    cc.log("updateProgressFromNative " + percent);
    var currentScene = cc.director.getRunningScene();
    if(currentScene instanceof HotUpdateScene) {
        currentScene.updateProgressByValue(percent);
    }
};

function updateHintFromNative(hintText) {
    var currentScene = cc.director.getRunningScene();
    if(currentScene instanceof HotUpdateScene) {
        currentScene.updateHint(hintText);
    }
};

var HotUpdateScene = cc.Scene.extend({
    onEnter: function () {
        this._super();
        this.layer = new HotUpdateLayer();
        this.addChild(this.layer);
    },

    startHotUpdate:function () {
        this.layer.initLogic();
    },

    updateProgressByValue: function (percent) {
        this.layer.updateProgressByValue(percent);
    },

    updateHint:function (hintText) {
        this.layer.updateHint(hintText);
    },
});
