/**
 * Created by junji on 2017/1/23.
 */

var BuyDialog = cc.LayerColor.extend({

    _listener:null,

    ctor: function(type, skuId, price1, price2) {
        this._super(cc.color.BLACK);
        this.setOpacity(140);       //透明度

        if(type == DialogType.BuyProp) {
            this._initBuyPropDialog(skuId, price1, price2);
        } else if (type == DialogType.BuyDiamond) {
            this._initBuyDiamondDialog(skuId, price1);
        }

        return true;
    },

    onEnter: function()
    {
        this._super();
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initBuyPropDialog: function(skuId, price1, price2)
    {
        var _this = this;
        //背景
        var bg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.director.getVisibleSize().width*0.5, cc.director.getVisibleSize().height*0.5);
        bg.setScale9Enabled(true);
        bg.setContentSize(cc.director.getVisibleSize().width*0.7, cc.director.getVisibleSize().height*0.2);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setScale(1.1);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("确认购买", "Arial", 28);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var messageContent = new cc.LabelTTF("是否确定购买此商品？","Arial", 27);
        messageContent.boundingWidth = bg.width * 0.8;
        messageContent.boundingHeight = 0;
        messageContent.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
        messageContent.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);
        messageContent.setAnchorPoint(0, 1);
        messageContent.setPosition(bg.width*0.1, bg.height - 70);
        bg.addChild(messageContent);

        var confirmButton = new ccui.Button(res.ConfirmButton_png, res.ConfirmButtonDown_png, "");
        confirmButton.setAnchorPoint(0, 0);
        confirmButton.setPosition(30, 30);
        confirmButton.setScale(1.1);
        confirmButton.addClickEventListener(function () {
            var buyPropApi = new BuyPropApi();
            buyPropApi.buyTool(skuId, price1, price2, "buyToolResponse",function () {

            },function () {

            },function () {

            });
        });
        bg.addChild(confirmButton);

        var cancelButton = new ccui.Button(res.CancelButton_png, res.CancelButtonDown_png, "");
        cancelButton.setAnchorPoint(1, 0);
        cancelButton.setPosition(bg.width - 30, 30);
        cancelButton.setScale(1.1);
        cancelButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(cancelButton);

        this.setVisible(false);     //默认设置为不可见
    },

    //初始化对话框
    _initBuyDiamondDialog: function(skuId, price1)
    {
        var _this = this;
        //背景
        var bg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.director.getVisibleSize().width*0.5, cc.director.getVisibleSize().height*0.5);
        bg.setScale9Enabled(true);
        bg.setContentSize(cc.director.getVisibleSize().width*0.7, cc.director.getVisibleSize().height*0.27);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setScale(1.1);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("提示消息", "Arial", 30);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var messageContent = new ccui.Text("支付方式", "Arial", 30);
        messageContent.setColor(cc.color(255,254,214));
        messageContent.setPosition(bg.width*0.5, bg.height-100);
        bg.addChild(messageContent);

        var messageContent1 = new ccui.Text("请您选择支付方式", "Arial", 30);
        messageContent1.setColor(cc.color(245,42,30));
        messageContent1.setPosition(bg.width/2, bg.height - 180);
        bg.addChild(messageContent1);

        var closeButton = new ccui.Button(res.RedClose_png, res.RedClose_png, "");
        closeButton.setAnchorPoint(1, 1);
        closeButton.setPosition(bg.width, bg.height);
        closeButton.setContentSize(80, 80);
        closeButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(closeButton);

        var aliPayButton = new ccui.Button(res.IdJoinRoom_png, res.IdJoinRoomDown_png, "");
        aliPayButton.setAnchorPoint(0, 0);
        aliPayButton.setPosition(30, 30);
        aliPayButton.setScale(1.1);
        aliPayButton.addClickEventListener(function () {
            var buyDiamondApi = new BuyDiamondApi();
            buyDiamondApi.preBuyDiamond(skuId, price1, 1, "buyDiamondResponse", function () {
            }, function () {
            }, function () {
            });
        });
        bg.addChild(aliPayButton);

        var aliPayLabel = new ccui.ImageView(res.AlipayLabel_png);
        aliPayLabel.setPosition(aliPayButton.width/2, aliPayButton.height/2);
        aliPayButton.addChild(aliPayLabel);

        var wechatPayButton = new ccui.Button(res.QuickJoinRoom_png, res.QuickJoinRoomDown_png, "");
        wechatPayButton.setAnchorPoint(1, 0);
        wechatPayButton.setPosition(bg.width - 30, 30);
        wechatPayButton.setScale(1.1);
        wechatPayButton.addClickEventListener(function () {
            var buyDiamondApi = new BuyDiamondApi();
            buyDiamondApi.preBuyDiamond(skuId, price1, 2, "buyDiamondResponse", function () {
                
            }, function () {
                
            }, function () {
                
            });
        });
        bg.addChild(wechatPayButton);

        var wechatPayLabel = new ccui.ImageView(res.WechatPayLabel_png);
        wechatPayLabel.setPosition(wechatPayButton.width/2, wechatPayButton.height/2);
        wechatPayButton.addChild(wechatPayLabel);

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this, 100);
        this.setVisible(true);
        this._listener.setSwallowTouches(true);

        var bg = this.getChildByTag(101);
        bg.setScale(0);
        var scaleTo1 = new cc.ScaleTo(0.1, 1.25);
        var scaleTo2 = new cc.ScaleTo(0.1, 1);
        var actionArray = new Array();
        actionArray.push(scaleTo1);
        actionArray.push(scaleTo2);
        var sequence = new cc.Sequence(actionArray);
        bg.runAction(sequence);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});
