/**
 * Created by junji on 2017/1/28.
 */

var BuyResultDialog = cc.LayerColor.extend({

    _listener:null,

    ctor: function(title, params) {
        this._super(cc.color.BLACK);
        this.setOpacity(140);       //透明度

        this._showBuyResultDialog(title, params);

        return true;
    },

    onEnter: function()
    {
        this._super();
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _showBuyResultDialog: function(title, params)
    {
        var _this = this;
        //背景

        var bg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.winSize.width*0.5, cc.winSize.height*0.5);
        bg.setScale9Enabled(true);
        bg.setContentSize(BaseWindowConf.WIDTH*0.7, 120 + 60 * params.length);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setScale(1.1);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text(title, "Arial", 32);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        for(var i = 0; i < params.length; i++) {
            var skuText = new ccui.Text(params[i], "Arial", 30);
            skuText.setPosition(bg.width/2, bg.height - 90 - 50*i);
            skuText.setTextColor(cc.color(228,195,88));
            bg.addChild(skuText);
        }

        var closeButton = new ccui.Button(res.RedClose_png);
        closeButton.setPosition(bg.width - 10, bg.height - 10);
        closeButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(closeButton);

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this, 100);
        this.setVisible(true);
        this._listener.setSwallowTouches(true);

        var bg = this.getChildByTag(101);
        bg.setScale(0);
        var scaleTo1 = new cc.ScaleTo(0.1, 1.25);
        var scaleTo2 = new cc.ScaleTo(0.1, 1);
        var actionArray = new Array();
        actionArray.push(scaleTo1);
        actionArray.push(scaleTo2);
        var sequence = new cc.Sequence(actionArray);
        bg.runAction(sequence);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});