/**
 * Created by junji on 2017/3/28.
 */

var ChatGiftCard = ccui.Button.extend({

    _toUserId:-1,
    _giftData:[
        {
            "giftIcon":res.ChatSendGiftFlower1_png,
            "giftPrice":30,
            "currencyType":2,
            "giftType":8
        },
        {
            "giftIcon":res.ChatSendGiftFlower2_png,
            "giftPrice":520,
            "currencyType":2,
            "giftType":9
        },
        {
            "giftIcon":res.ChatSendGiftFlower3_png,
            "giftPrice":1250,
            "currencyType":2,
            "giftType":10
        },
        {
            "giftIcon":res.ChatSendGiftFlower4_png,
            "giftPrice":350,
            "currencyType":1,
            "giftType":11
        },
        {
            "giftIcon":res.ChatSendGiftFlower5_png,
            "giftPrice":1200,
            "currencyType":1,
            "giftType":12
        },
        {
            "giftIcon":res.ChatSendGiftFlower6_png,
            "giftPrice":9000,
            "currencyType":1,
            "giftType":13
        }
    ],

    ctor:function (index, toUserId) {
        var _this = this;
        var giftData = this._giftData[index];
        this.setUserData(giftData["giftType"]);
        this._toUserId = toUserId;
        this._super(res.ChatSendGiftCard_png, "");
        this.addClickEventListener(function () {
            var giftType = this.getUserData();

            sendGiftResponse = function (responseString) {
                if(responseString == null || responseString == "" || responseString == undefined) {
                    ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
                } else {
                    var responseObj = JSON.parse(responseString);
                    cc.log("retCode " + responseObj.retCode);
                    if (responseObj.retCode == 1) {
                        cc.log("赠送成功");
                        if(giftType == 11 || giftType == 12 || giftType == 13) {
                            ClickRecod("DiamondUseType", UMengStatistics.get(giftType));
                        } else {
                            ClickRecod("GoldUseType", UMengStatistics.get(giftType));
                        }
                        var obj = new Object();
                        obj.type = "gift";
                        obj.desc = "[好友礼物]";
                        obj.giftType = giftType;
                        TXIMSDK_sendCustomMessagetoClient(JSON.stringify(obj), _this._toUserId + "");
                        var currentScene = cc.director.getRunningScene();
                        if(currentScene instanceof FriendChatScene) {
                            currentScene.addGiftCard(giftType);
                            PropsSpineSprite.playAninWithPos(giftType, cc.p(cc.winSize.width/2, 50), cc.p(cc.winSize.width/2, cc.winSize.height - 150), function () {
                            });
                        }
                        cc.director.getRunningScene().removeChildByTag(DialogType.ChatSendGiftDialog);
                    } else {
                        ToastUtil.systemToastInMiddle(responseObj.retBody.message, 2.0);
                    }
                }
            };

            var friendApi = new FriendApi();
            friendApi.sendGift(_this._toUserId, giftType, "sendGiftResponse", function () {
            },function () {
            },function () {
            });
        });

        var width = this.width;
        var height = this.height;

        var giftIconImage = new ccui.ImageView(giftData["giftIcon"]);
        giftIconImage.setPosition(width/2, height/2+30);
        this.addChild(giftIconImage);

        var giftPriceText = new ccui.Text("" + giftData["giftPrice"], "Arial", 28);
        giftPriceText.setPosition(width/2 + 25, 45);
        giftPriceText.setColor(cc.color(57,21,12));
        this.addChild(giftPriceText);

        var giftCurrencyImage = new ccui.ImageView(res.Diamond_png);
        if(giftData["currencyType"] == 2) {
            giftCurrencyImage.loadTexture(res.GoldCoin_png);
        }
        giftCurrencyImage.setPosition(width/2 - 27, 45);
        this.addChild(giftCurrencyImage);
    }

});

var ChatSendGiftDialog = cc.LayerColor.extend({

    _listener:null,
    _toUserId:-1,

    ctor: function(toUserId) {
        this._toUserId = toUserId;
        this._super(cc.color.BLACK);
        cc.log('jijun ctor');
        this.setOpacity(140);       //透明度
        this._initDialog();
        this.setTag(DialogType.ChatSendGiftDialog);

        return true;
    },

    onEnter: function()
    {
        this._super();
        var _this = this;
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                _this.hidden();
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initDialog: function()
    {
        var _this = this;
        var size = cc.winSize;

        //背景
        var bg = new ccui.ImageView(res.ChatSendGiftBg_png);
        bg.setAnchorPoint(0.5, 0);
        bg.setPosition(size.width*0.5, 0);
        this.addChild(bg, 0, 101);

        var pageView = new ccui.PageView();
        pageView.setTouchEnabled(true);
        pageView.setContentSize(bg.width, bg.height);
        bg.addChild(pageView);

        for(var i = 0; i < 1; i++) {
            var layout = new ccui.Layout();
            layout.setContentSize(bg.width, bg.height);
            layout.setAnchorPoint(0.5, 0);
            layout.setPosition(size.width/2, 0);
            for (var j = 0; j < 6; j++) {
                var card = new ChatGiftCard(i * 6 + j, _this._toUserId);
                card.setAnchorPoint(0, 1);
                card.setPosition(10 + 245*(j%3), layout.height - 25 - 290*Math.floor(j/3));
                layout.addChild(card);
            }
            pageView.insertPage(layout, i);
        }
        pageView.setCurrentPageIndex(0);

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this);
        this._listener.setSwallowTouches(true);
        this.setVisible(true);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});

function sendGiftResponse(responseString) {
};
