/**
 * Created by junji on 2017/2/2.
 */

var CommonDialog = cc.LayerColor.extend({

    _listener:null,

    ctor: function(dialogType, params) {
        this._super(cc.color.BLACK);
        cc.log('jijun ctor');
        this.setOpacity(140);       //透明度
        this._initCommonDialog(dialogType, params);

        return true;
    },

    onEnter: function()
    {
        this._super();
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initCommonDialog: function(dialogType, params)
    {
        var _this = this;
        //背景
        var bg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.winSize.width*0.5, cc.winSize.height*0.5);
        bg.setScale9Enabled(true);
        bg.setContentSize(cc.winSize.width*0.75, cc.winSize.height*0.23);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setScale(1.1);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("", "Arial", 28);
        if(dialogType == DialogType.GagConfirmDialog || dialogType == DialogType.KickoutConfirmDialog) {
            titleText.setString("确认选择");
        } else if(dialogType == DialogType.QuitRoomConfirmDialog || dialogType == DialogType.QuitAppConfrimDialog) {
            titleText.setString("退出确认");
        } else if (dialogType == DialogType.ExplodeConfirmDialog) {
            titleText.setString("自曝确认");
        } else if (dialogType == DialogType.ResumeConfirmDialog) {
            titleText.setString("恢复房间确认");
        } else if (dialogType == DialogType.ChatSendGiftConfirmDialog) {
            titleText.setString("赠送礼物确认");
        } else if (dialogType == DialogType.AddFriendConfirmDialog) {
            titleText.setString("添加好友");
        } else  if (dialogType == DialogType.ConfirmSkinRoomDialog) {
            titleText.setString("房间类型确认");
        }
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var contentText = new ccui.Text("", "Arial", 28);
        if(dialogType == DialogType.KickoutConfirmDialog) {
            contentText.setString("花费"+ params[1] + "钻石，踢出" + DataManager.getInstance().getCurrentRoomData().getSeatNumber(params[0]) + "号玩家？");
        } else if (dialogType == DialogType.GagConfirmDialog) {
            contentText.setString("花费"+ params[1] + "钻石，禁言" + DataManager.getInstance().getCurrentRoomData().getSeatNumber(params[0]) + "号玩家？");
        } else if (dialogType == DialogType.QuitRoomConfirmDialog) {
            contentText.setString("确定退出房间？");
        } else if (dialogType == DialogType.QuitAppConfrimDialog) {
            contentText.setString("确定退出程序？");
        } else if (dialogType == DialogType.ExplodeConfirmDialog) {
            contentText.setString("确定进行自曝？");
        } else if (dialogType == DialogType.ResumeConfirmDialog) {
            contentText.setString("您正在" + params + "号房间，是否恢复？");
        } else if (dialogType == DialogType.ChatSendGiftConfirmDialog) {
            contentText.setString("是否确认赠送礼物？");
        } else  if (dialogType == DialogType.ConfirmSkinRoomDialog) {
            contentText.setString("请选择创建的房间类型");
        } else if (dialogType) {
            contentText.setString("是否赠送10朵鲜花(100金币)\n加对方为好友？");
        }
        contentText.setAnchorPoint(0.5, 0.5);
        contentText.setPosition(bg.width/2, bg.height/2 + 30);
        bg.addChild(contentText);

        var confirmButton = new ccui.Button(res.IdJoinRoom_png, res.IdJoinRoomDown_png);
        confirmButton.setPosition(120, 70);
        confirmButton.addClickEventListener(function () {
            if(dialogType == DialogType.KickoutConfirmDialog) {
                ClickRecod("DiamondUseType", "KickPlayer");
                MqttHelper.getInstance().userKickOutRequest(params[0]);
            } else if (dialogType == DialogType.GagConfirmDialog) {
                MqttHelper.getInstance().userGagRequest(params[0]);
            } else if (dialogType == DialogType.QuitRoomConfirmDialog) {
                var loadingDialog = new LoadingDialog();
                loadingDialog.setTag(997001);
                loadingDialog.popup();
                if(DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
                    quitTecentRoom(true, "");
                } else {
                    MqttHelper.getInstance().quitRoomRequest();
                }
            } else if (dialogType == DialogType.QuitAppConfrimDialog) {
                cc.log("quit app");
                jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "exitApp", "()V");
            } else if (dialogType == DialogType.ExplodeConfirmDialog) {
                for(var i = 999001; i <= 999045; i++) {
                    if(cc.director.getRunningScene().getChildByTag(i) != null
                        && cc.director.getRunningScene().getChildByTag(i) != undefined) {
                        cc.director.getRunningScene().removeChildByTag(i);
                    }
                }
                MqttHelper.getInstance().explodeRequest(DataManager.getInstance().getCurrentRoomData()._myRole);
            } else if (dialogType == DialogType.ResumeConfirmDialog) {
                var loadingDialog = new LoadingDialog();
                loadingDialog.setTag(997001);
                loadingDialog.popup();
                MqttHelper.getInstance().joinRoom(params);
            } else if (dialogType == DialogType.ChatSendGiftConfirmDialog) {
                // TODO
            } else if (dialogType == DialogType.AddFriendConfirmDialog) {
                addFriendResponse = function (responseString) {
                    if(responseString == null || responseString == "" || responseString == undefined) {
                        ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
                    } else {
                        var responseObj = JSON.parse(responseString);
                        cc.log("retCode " + responseObj.retCode);
                        if (responseObj.retCode == 1) {
                            TXIMSDK_addFriendSucc = function () {
                                TXIMSDK_sendTextMessagetoClient("Hi，我送了你10朵玫瑰，我们已经是好友啦！", params.toString());
                                ToastUtil.systemToastInMiddle("好友添加成功", 2.0);
                                ClickRecod("GoldUseType", UMengStatistics.get(7));
                                var event = new cc.EventCustom("onAddFriendSuccess");
                                cc.eventManager.dispatchEvent(event);
                                _this.hidden();
                            };

                            TXIMSDK_addFriendFail = function (code, message) {
                                if(code == 6011) {
                                    ToastUtil.systemToastInMiddle("该用户没有更新到最新版本", 2.0);
                                } else {
                                    ToastUtil.systemToastInMiddle(code + ":" +message, 2.0);
                                }
                                _this.hidden();
                            };

                            TXIMSDK_addFriend(params+"");
                        } else {
                            ToastUtil.systemToastInMiddle(responseObj.retBody.message, 2.0);
                        }
                    }
                };

                var friendApi = new FriendApi();
                friendApi.sendGift(params, 7, "addFriendResponse", function () {
                }, function () {
                }, function () {
                });
            } else  if (dialogType == DialogType.ConfirmSkinRoomDialog) {
                MqttHelper.getInstance().createRoom(params[0], params[1], params[2], params[3], params[4], 2);
                ClickRecod(params[5], params[6]);
                var loadingDialog = new LoadingDialog();
                loadingDialog.setTag(997001);
                loadingDialog.popup();
            }
            _this.hidden();
        });
        bg.addChild(confirmButton);

        //如果是创建皮肤房间，则确认按钮文字换成普通肤房
        var confirmLabel;
        if (dialogType == DialogType.ConfirmSkinRoomDialog) {
            confirmLabel = new ccui.ImageView(res.SkinRoom_png);
        } else {
            confirmLabel = new ccui.ImageView(res.CommonConfirmLabel_png);
        }
        confirmLabel.setPosition(confirmButton.width/2, confirmButton.height/2);
        confirmButton.addChild(confirmLabel);

        var cancelButton = new ccui.Button(res.CreateRoom_png, res.CreateRoomDown_png);
        cancelButton.setPosition(bg.width - 120, 70);
        cancelButton.addClickEventListener(function () {
            if (dialogType == DialogType.ConfirmSkinRoomDialog) {
                MqttHelper.getInstance().createRoom(params[0], params[1], params[2], params[3], params[4], 1);
                ClickRecod(params[5], params[6]);
                var loadingDialog = new LoadingDialog();
                loadingDialog.setTag(997001);
                loadingDialog.popup();
            }
            _this.hidden();
        });
        bg.addChild(cancelButton);

        //如果是创建皮肤房间，则取消按钮文字换成皮肤房
        var cancelLabel;
        if (dialogType == DialogType.ConfirmSkinRoomDialog) {
            cancelLabel = new ccui.ImageView(res.CommonRoom_png);
        } else {
            cancelLabel = new ccui.ImageView(res.CancelLabel_png);
        }
        cancelLabel.setPosition(cancelButton.width/2, cancelButton.height/2);
        cancelButton.addChild(cancelLabel);

        var closeButton = new ccui.Button(res.RedClose_png, res.RedClose_png, "");
        closeButton.setAnchorPoint(1, 1);
        closeButton.setPosition(bg.width, bg.height);
        closeButton.setContentSize(90, 90);
        closeButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(closeButton);

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this, 100);
        this.setVisible(true);
        this._listener.setSwallowTouches(true);

        var bg = this.getChildByTag(101);
        bg.setScale(0);
        var scaleTo1 = new cc.ScaleTo(0.1, 1.25);
        var scaleTo2 = new cc.ScaleTo(0.1, 1);
        var actionArray = new Array();
        actionArray.push(scaleTo1);
        actionArray.push(scaleTo2);
        var sequence = new cc.Sequence(actionArray);
        bg.runAction(sequence);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});