/**
 * Created by junji on 2017/2/1.
 */

var CompleteInfoDialog = cc.LayerColor.extend({

    _listener:null,
    _gender:-1,


    ctor: function() {
        this._super(cc.color.BLACK);
        cc.log('jijun ctor');
        this.setOpacity(140);       //透明度
        this._initCompleteInfoDialog();

        return true;
    },

    onEnter: function()
    {
        this._super();
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initCompleteInfoDialog: function()
    {
        var _this = this;
        //背景
        var bg = new ccui.ImageView(res.CommonDialogBg_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.director.getVisibleSize().width*0.5, cc.director.getVisibleSize().height*0.5);
        bg.setScale9Enabled(true);
        bg.setContentSize(670, 450);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setScale(1.1);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("完善信息", "Arial", 28);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var innerBg = new ccui.ImageView(res.CompleteInfoInnerBg_png);
        innerBg.setScale9Enabled(true);
        innerBg.setAnchorPoint(0.5, 1);
        innerBg.setPosition(bg.width/2, bg.height - 60);
        innerBg.setContentSize(570, 250);
        bg.addChild(innerBg);

        var nicknameTextFieldBg =new cc.Scale9Sprite(res.CompleteInfoInputBg_png);
        var nicknameTextField = new cc.EditBox(cc.size(470,70), nicknameTextFieldBg);
        nicknameTextField.setPosition(innerBg.width/2, innerBg.height - 40);
        nicknameTextField.setAnchorPoint(0.5, 1);
        nicknameTextField.setFontSize(35);
        nicknameTextField.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
        nicknameTextField.setPlaceHolder("请输入昵称");
        nicknameTextField.setPlaceholderFontSize(35);
        nicknameTextField.setMaxLength(6);
        innerBg.addChild(nicknameTextField);

        if(cc.sys.os === cc.sys.OS_IOS) {
            var optionText = new ccui.Text("(选填)", "Arial", 28);
            optionText.setAnchorPoint(0, 0.5);
            optionText.setPosition(10, 65);
            innerBg.addChild(optionText);
        }

        var maleButton = new ccui.Button(res.CompleteInfoMaleNormal_png, res.CompleteInfoMaleDown_png);
        maleButton.setScale9Enabled(true);
        maleButton.setPosition(170, 65);
        maleButton.addClickEventListener(function () {
            maleButton.setBright(true);
            femaleButton.setBright(false);
            _this._gender = 1;
        });
        innerBg.addChild(maleButton);

        var femaleButton = new ccui.Button(res.CompleteInfoFemaleNormal_png, res.CompleteInfoFemaleDown_png);
        femaleButton.setScale9Enabled(true);
        femaleButton.setPosition(innerBg.width - 170, 65);
        femaleButton.addClickEventListener(function () {
            maleButton.setBright(false);
            femaleButton.setBright(true);
            _this._gender = 2;
        });
        innerBg.addChild(femaleButton);

        var nickNamePattern = new RegExp("^[\u4E00-\u9FA5\uF900-\uFA2D]{6}$");
        var nickNamePattern1 = new RegExp("^[\u4E00-\u9FA5\uF900-\uFA2D\u0800-\u4E00\x3130-\x318F\xAC00-\xD7A3a-zA-Z0-9!@#$%^&*?]+$");

        var confirmButton = new ccui.Button(res.IdJoinRoom_png, res.IdJoinRoomDown_png);
        confirmButton.setPosition(150, 80);
        confirmButton.addClickEventListener(function () {
            var nickname = nicknameTextField.getString();
            if(_this._gender == -1 && cc.sys.os === cc.sys.OS_ANDROID) {
                ToastUtil.systemToastInMiddle("请选择性别", 2.0);
            } else if (nickname == "" || nickname == null || nickname == undefined || !nickNamePattern1.test(nickname)) {
                ToastUtil.systemToastInMiddle("昵称不能为空，不能包含非法字符", 2.0);
            } else if (nickNamePattern.test(nickname)) {
                ToastUtil.systemToastInMiddle("昵称最多只能5个汉字哦～", 2.0);
            } else {
                if(cc.sys.os === cc.sys.OS_IOS) {
                    if(_this._gender == -1) {
                        _this._gender = 1;
                    }
                }
                var userApi = new UserApi();
                userApi.signupByThirdParty(DataManager.getInstance().getUserData()._openId,
                      DataManager.getInstance().getUserData()._unionId, 2, nickname, _this._gender, "signupByThirdPartyResponse",
                      function () {},function () {},function () {});
                _this.hidden();
            }
        });
        bg.addChild(confirmButton);

        var confirmLabel = new ccui.ImageView(res.CommonConfirmLabel_png);
        confirmLabel.setPosition(confirmButton.width/2, confirmButton.height/2);
        confirmButton.addChild(confirmLabel);

        var cancelButton = new ccui.Button(res.IdJoinRoom_png, res.IdJoinRoomDown_png);
        cancelButton.setPosition(bg.width - 150, 80);
        cancelButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(cancelButton);

        var cancelLabel = new ccui.ImageView(res.CancelLabel_png);
        cancelLabel.setPosition(cancelButton.width/2, cancelButton.height/2);
        cancelButton.addChild(cancelLabel);

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this, 100);
        this.setVisible(true);
        this._listener.setSwallowTouches(true);

        var bg = this.getChildByTag(101);
        bg.setScale(0);
        var scaleTo1 = new cc.ScaleTo(0.1, 1.25);
        var scaleTo2 = new cc.ScaleTo(0.1, 1);
        var actionArray = new Array();
        actionArray.push(scaleTo1);
        actionArray.push(scaleTo2);
        var sequence = new cc.Sequence(actionArray);
        bg.runAction(sequence);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});