/**
 * Created by junji on 2017/3/30.
 */

var ConfirmDialog = cc.LayerColor.extend({

    _listener:null,

    ctor: function(title, message, okCallback, cancelCallback) {
        this._super(cc.color.BLACK);
        cc.log('jijun ctor');
        this.setOpacity(140);       //透明度
        this._initCheckBigVersionDialog(title, message, okCallback, cancelCallback);

        return true;
    },

    onEnter: function()
    {
        this._super();
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initCheckBigVersionDialog: function(title, message, okCallback, cancelCallback)
    {
        cc.log("_initCheckBigVersionDialog");
        var _this = this;
        //背景
        var bg = new ccui.ImageView("res/yesOrNoDialogBg.png");
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.director.getVisibleSize().width*0.5, cc.director.getVisibleSize().height*0.5);
        bg.setScale9Enabled(true);

        cc.log("_initCheckBigVersionDialog1");
        var contentText = new ccui.Text(message, "Arial", 28);
        contentText.setAnchorPoint(0.5, 0.5);
        contentText.ignoreContentAdaptWithSize(false);
        contentText.textAlign = cc.TEXT_ALIGNMENT_CENTER;
        bg.setContentSize(cc.director.getVisibleSize().width*0.75, contentText.height + 250);

        contentText.setPosition(bg.width/2, bg.height/2 + 30);

        this.addChild(bg, 0, 101);

        cc.log("_initCheckBigVersionDialog2");
        var titleBg = new ccui.ImageView("res/dialogTitle.png");
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setScale(1.1);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        cc.log("_initCheckBigVersionDialog3");
        var titleText = new ccui.Text(title, "Arial", 28);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        bg.addChild(contentText);

        cc.log("_initCheckBigVersionDialog4");
        var confirmButton = new ccui.Button("res/directJoinRoom.png", "res/directJoinRoom.png");
        confirmButton.setPosition(120, 70);

        confirmButton.addClickEventListener(function () {
            okCallback();
            _this.hidden();
        });

        bg.addChild(confirmButton);

        var confirmLabel = new ccui.ImageView("res/common/confirmLabel.png");
        confirmLabel.setPosition(confirmButton.width/2, confirmButton.height/2);
        confirmButton.addChild(confirmLabel);

        var cancelButton = new ccui.Button("res/creatRoomButton.png", "res/creatRoomButton.png");
        cancelButton.setPosition(bg.width - 120, 70);
        cancelButton.addClickEventListener(function () {
            cancelCallback();
            _this.hidden();
        });
        bg.addChild(cancelButton);

        var cancelLabel = new ccui.ImageView("res/createroom/cancelLabel.png");
        cancelLabel.setPosition(cancelButton.width/2, cancelButton.height/2);
        cancelButton.addChild(cancelLabel);

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this, 100);
        this.setVisible(true);
        this._listener.setSwallowTouches(true);

        var bg = this.getChildByTag(101);
        bg.setScale(0);
        var scaleTo1 = new cc.ScaleTo(0.1, 1.25);
        var scaleTo2 = new cc.ScaleTo(0.1, 1);
        var actionArray = new Array();
        actionArray.push(scaleTo1);
        actionArray.push(scaleTo2);
        var sequence = new cc.Sequence(actionArray);
        bg.runAction(sequence);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    }
});
