/**
 * Created by junji on 2016/11/20.
 */
var verifyRoomId = 0;

var ModalDialogueBox = cc.LayerColor.extend({
    _listener: null,
    _dialogType:-1,
    ctor: function(dialogType, params) {
        this._super(cc.color.BLACK);
        cc.log('ctor');
       // this.ignoreAnchorPointForPosition(false);   //忽略锚点设置为false，默认为true，锚点(0, 0)
      //  this.setAnchorPoint(0.5,0.5);
        this.setOpacity(128);       //透明度
        this._dialogType = dialogType;

        switch (dialogType) {
            case DialogType.InputRoomNumber:
                this._initInputRoomIdDialog();
                break;
            case DialogType.InputPassword:
                this._initInputPasswordDialog(params);
                break;
            case DialogType.RougueChooseRole:
                this._initChooseRoleDialog(params);
                break;
            case DialogType.WitchChooseTarget:
                this._initWitchChooseDialog(params);
                break;
            case DialogType.ShowVoteResult:
                this._initShowVoteResult(dialogType, params);
                break;
            case DialogType.GameResult:
                this._initGameResult(dialogType,params);
                break;
            case DialogType.ShowMvp:
                if(params != -1) {
                    this._initShowMvp(dialogType, params);
                }
                break;
            case DialogType.GuardChooseTarget:
            case DialogType.GagElderChooseTarget:
            case DialogType.CupidChooseTarget:
            case DialogType.WildChildChooseTarget:
            case DialogType.ProphetChooseTarget:
            case DialogType.WolfChooseTarget:
            case DialogType.VotePolice:
            case DialogType.TransferPolice:
            case DialogType.Vote:
            case DialogType.PoliceCallVote:
            case DialogType.HunterKill:
            case DialogType.PoisonUse:
            case DialogType.WhiteWolfKingSelect:
            case DialogType.PlaneVote:
            case DialogType.ChooseMvp:
                this._initChooseTarget(dialogType, params);
                break;
            case DialogType.StalkerChooseTarget:
            case DialogType.PoliceCompete:
            case DialogType.OrganizeSpeech:
                this._initYesOrNotDialog(dialogType, params);
                break;
            case DialogType.GestureChoose:
                this._initGestureChooseDialog();
                break;
            case DialogType.RoomConf:
                this._initRoomConfDialog(dialogType, params);
                break;
            default:
                this._initDialog();
                break;
        }

        return true;
    },

    onEnter: function()
    {
        this._super();
        //监听器
        cc.log("onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initDialog: function()
    {
        var winSize = cc.winSize;

        //背景
        var bg = new ccui.ImageView(res.TextButtonBg_png);
        bg.setScale9Enabled(true);
        bg.setPosition(winSize.width / 2, winSize.height / 2);
        bg.setContentSize(winSize.width * 0.7, winSize.height * 0.4);
        this.addChild(bg, 0, 101);

        //OK按钮
        var OKLabel = new cc.LabelTTF("OK", "Arial", 36);
        var OKMenuItem = new cc.MenuItemLabel(OKLabel, this._onCallback, this);
        OKMenuItem.setAnchorPoint(0, 0);
        OKMenuItem.setPosition(0, 0);

        //Cancel按钮
        var cancelLabel = new cc.LabelTTF("Cancel", "Arial", 36);
        var cancelMenuItem = new cc.MenuItemLabel(cancelLabel, this._onCallback, this);
        cancelMenuItem.setAnchorPoint(1, 0);
        cancelMenuItem.setPosition(cc.p(bg.width, 0));

        //菜单
        var menu = new cc.Menu(OKMenuItem, cancelMenuItem);
        menu.setPosition(cc.p(0, 0));
        bg.addChild(menu);      //注意是添加到背景里面

        this.setVisible(false);     //默认设置为不可见
    },

    _initRoomConfDialog:function (dialogType, params) {
        var winSize = cc.director.getVisibleSize();
        var _this = this;

        var bg = new ccui.ImageView(res.CommonDialogBg_png);
        bg.setScale9Enabled(true);
        bg.setPosition(winSize.width / 2, winSize.height / 2);
        bg.setContentSize(winSize.width * 0.8, winSize.height * 0.73);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("房间配置", "Arial", 24);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var innerBg = new ccui.ImageView(res.CommonDialogInnerBg_png);
        innerBg.setScale9Enabled(true);
        innerBg.setContentSize(bg.width * 0.85, bg.height * 0.77);
        innerBg.setAnchorPoint(0.5, 1);
        innerBg.setPosition(bg.width * 0.5, bg.height - 50);
        bg.addChild(innerBg);

        var contentList = new ccui.ListView();
        contentList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        contentList.setTouchEnabled(true);
        contentList.setBounceEnabled(true);
        contentList.setContentSize(innerBg.width - 5, innerBg.height - 10);
        contentList.setAnchorPoint(0.5, 0.5);
        contentList.setPosition(innerBg.width * 0.5, innerBg.height * 0.5);
        innerBg.addChild(contentList);

        var villagerNum = 0;
        var godList = new Array();
        var wolfNum = 0;
        var whiteWolfNum = 0;
        var otherList = new Array();
        var cupidNum = 0;
        var wolfList = new Array();
        var goodManList = new Array();

        var roomIdLayout = new ccui.Layout();
        var roomIdText = new ccui.Text("房间号码:" + DataManager.getInstance().getCurrentRoomData()._roomId, "Arial", 24);
        roomIdLayout.setContentSize(contentList.width, roomIdText.height + 10);
        roomIdText.setAnchorPoint(0, 0.5);
        roomIdText.setPosition(30, roomIdLayout.height/2);
        roomIdLayout.addChild(roomIdText);
        contentList.pushBackCustomItem(roomIdLayout);

        for(var i = 0; i < params.length; i++) {
            switch (params[i].roleId) {
                case 1:
                    villagerNum = params[i].roleNum;
                    goodManList.push(1);
                    break;
                case 101:
                    wolfNum = params[i].roleNum;
                    wolfList.push(101);
                    break;
                case 102:
                    whiteWolfNum = 1;
                    wolfList.push(102);
                    break;
                case 201:
                    otherList.push(params[i].roleId);
                    break;
                default:
                    if(params[i].roleId == 202)
                        cupidNum = 1;
                    godList.push(params[i].roleId);
                    goodManList.push(params[i].roleId);
                    break;
            }
        }

        var playerString = "好人阵营×"+ (godList.length+villagerNum) +"（";
        var totalNum = villagerNum + wolfNum + whiteWolfNum + godList.length + otherList.length;
        if(otherList.length != 0)
            totalNum -= 2;
        var totalWolfNum = whiteWolfNum + wolfNum;
        var godDetailString = "";
        if(godList.length != 0) {
            playerString += "神×"+godList.length + ",";
            godDetailString += "神：";
            for (var i = 0; i < godList.length; i++){
                godDetailString += RoleMap.get(godList[i]);
                if(i != godList.length-1) {
                    godDetailString += "、";
                }
            }
            godDetailString += "\n";
        }
        playerString += "民×"+ villagerNum +"）\n" + godDetailString;
        playerString +=  "民：平民×"+ villagerNum +"\n狼人×"+ totalWolfNum + "（狼人×"+ wolfNum;
        if(whiteWolfNum != 0) {
            playerString += "，白狼王*1";
        }
        playerString += "）";
        if(otherList.length != 0) {
            playerString += "\n其他×1（盗贼）";
        }

        var defaultItemLayout1 = new ccui.Layout();
        var playerNumText = new ccui.Text("本局游戏共" + totalNum +"人，阵营分为：", "Arial", 22);
        playerNumText.setAnchorPoint(0, 1);
        defaultItemLayout1.setTouchEnabled(true);
        defaultItemLayout1.setContentSize(contentList.width, playerNumText.height + 10);
        playerNumText.setPosition(30, defaultItemLayout1.height - 5);
        defaultItemLayout1.addChild(playerNumText);
        contentList.pushBackCustomItem(defaultItemLayout1);

        var defaultItemLayour2 = new ccui.Layout();
        var playerText = new cc.LabelTTF(playerString,
            "Arial", 20);
        playerText.boundingWidth = contentList.width - 30;
        playerText.boundingHeight = 0;
        playerText.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
        playerText.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);
        playerText.setAnchorPoint(0, 1);
        defaultItemLayour2.setTouchEnabled(true);
        defaultItemLayour2.setContentSize(contentList.width, playerText.height + 15);
        playerText.setPosition(30, defaultItemLayour2.height - 5);
        defaultItemLayour2.addChild(playerText);
        contentList.pushBackCustomItem(defaultItemLayour2);

        var defaultItemLayout3 = new ccui.Layout();
        var winConditionTitleText = new ccui.Text("胜利条件：", "Arial", 22);
        winConditionTitleText.setAnchorPoint(0, 1);
        defaultItemLayout3.setTouchEnabled(true);
        defaultItemLayout3.setContentSize(contentList.width, winConditionTitleText.height + 10);
        winConditionTitleText.setPosition(30, defaultItemLayout3.height - 5);
        defaultItemLayout3.addChild(winConditionTitleText);
        contentList.pushBackCustomItem(defaultItemLayout3);

        var winConditionString = TextString.BAD_MAN_WIN_CONDITION + "\n" + TextString.GOOD_MAN_WIN_CONDITION;
        if(cupidNum != 0) {
            winConditionString += "\n" + TextString.THIRD_PART_WIN_CONDITION;
        }
        var defaultItemLayout4 = new ccui.Layout();
        var winConditionText = new cc.LabelTTF(winConditionString, "Arial", 20);
        winConditionText.boundingWidth = contentList.width - 60;
        winConditionText.boundingHeight = 0;
        winConditionText.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
        winConditionText.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);
        winConditionText.setAnchorPoint(0, 1);
        defaultItemLayout4.setTouchEnabled(true);
        defaultItemLayout4.setContentSize(contentList.width, winConditionText.height + 15);
        winConditionText.setPosition(30, defaultItemLayout4.height - 5);
        defaultItemLayout4.addChild(winConditionText);
        contentList.pushBackCustomItem(defaultItemLayout4);

        var defaultItemLayout5 = new ccui.Layout();
        var roleTitleText = new ccui.Text("规则说明：", "Arial", 22);
        roleTitleText.setAnchorPoint(0, 1);
        defaultItemLayout5.setTouchEnabled(true);
        defaultItemLayout5.setContentSize(contentList.width, roleTitleText.height + 10);
        roleTitleText.setPosition(30, defaultItemLayout5.height - 5);
        defaultItemLayout5.addChild(roleTitleText);
        contentList.pushBackCustomItem(defaultItemLayout5);

        var defaultItemLayout6 = new ccui.Layout();
        var wolfText = new ccui.Text("狼人：", "Arial", 20);
        wolfText.setAnchorPoint(0, 1);
        defaultItemLayout6.setTouchEnabled(true);
        defaultItemLayout6.setContentSize(contentList.width, wolfText.height + 5);
        wolfText.setPosition(30, defaultItemLayout6.height - 5);
        defaultItemLayout6.addChild(wolfText);
        contentList.pushBackCustomItem(defaultItemLayout6);

        for (var i = 0; i < wolfList.length; i ++) {
            var defaultItemLayout = new ccui.Layout();
            var card = new ccui.ImageView("res/" + wolfList[i] +".png");
            card.setAnchorPoint(0, 1);
            card.setScale(0.6, 0.6);
            var introText = new cc.LabelTTF(RoleIntroMap.get(wolfList[i]), "Arial", 20);
            introText.boundingWidth = contentList.width * 0.65;
            introText.boundingHeight = 0;
            introText.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
            introText.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);
            introText.setAnchorPoint(0, 1);
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(contentList.width, Math.max(introText.height, card.height*0.6) + 5);
            introText.setPosition(50 + card.width * 0.6, defaultItemLayout.height - 5);
            card.setPosition(30, defaultItemLayout.height - 5);
            defaultItemLayout.addChild(card);
            defaultItemLayout.addChild(introText);
            contentList.pushBackCustomItem(defaultItemLayout);
        }

        var defaultItemLayout7 = new ccui.Layout();
        var goodManText = new ccui.Text("好人：", "Arial", 20);
        goodManText.setAnchorPoint(0, 1);
        defaultItemLayout7.setTouchEnabled(true);
        defaultItemLayout7.setContentSize(contentList.width, goodManText.height + 5);
        goodManText.setPosition(30, defaultItemLayout7.height - 5);
        defaultItemLayout7.addChild(goodManText);
        contentList.pushBackCustomItem(defaultItemLayout7);

        for (var i = 0; i < goodManList.length; i ++) {
            var defaultItemLayout = new ccui.Layout();
            var card = new ccui.ImageView("res/" + goodManList[i] + ".png");
            card.setAnchorPoint(0, 1);
            card.setScale(0.6, 0.6);
            var introText = new cc.LabelTTF(RoleIntroMap.get(goodManList[i]), "Arial", 20);
            introText.boundingWidth = contentList.width * 0.65;
            introText.boundingHeight = 0;
            introText.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
            introText.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);
            introText.setAnchorPoint(0, 1);
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(contentList.width, Math.max(introText.height, card.height*0.6) + 5);
            introText.setPosition(50 + card.width * 0.6, defaultItemLayout.height - 5);
            card.setPosition(30, defaultItemLayout.height - 5);
            defaultItemLayout.addChild(card);
            defaultItemLayout.addChild(introText);
            contentList.pushBackCustomItem(defaultItemLayout);
        }

        if(otherList.length != 0) {
            var defaultItemLayout8 = new ccui.Layout();
            var otherText = new ccui.Text("其他：", "Arial", 20);
            otherText.setAnchorPoint(0, 1);
            defaultItemLayout8.setTouchEnabled(true);
            defaultItemLayout8.setContentSize(contentList.width, otherText.height + 5);
            otherText.setPosition(30, defaultItemLayout8.height - 5);
            defaultItemLayout8.addChild(otherText);
            contentList.pushBackCustomItem(defaultItemLayout8);

            for (var i = 0; i < otherList.length; i++) {
                var defaultItemLayout = new ccui.Layout();
                var card = new ccui.ImageView("res/" + otherList[i] + ".png");
                card.setAnchorPoint(0, 1);
                card.setScale(0.6, 0.6);
                var introText = new cc.LabelTTF(RoleIntroMap.get(otherList[i]), "Arial", 20);
                introText.boundingWidth = contentList.width * 0.65;
                introText.boundingHeight = 0;
                introText.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
                introText.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);
                introText.setAnchorPoint(0, 1);
                defaultItemLayout.setTouchEnabled(true);
                defaultItemLayout.setContentSize(contentList.width, Math.max(introText.height, card.height * 0.6) + 5);
                introText.setPosition(50 + card.width * 0.6, defaultItemLayout.height - 5);
                card.setPosition(30, defaultItemLayout.height - 5);
                defaultItemLayout.addChild(card);
                defaultItemLayout.addChild(introText);
                contentList.pushBackCustomItem(defaultItemLayout);
            }
        }

        var confirmButton = new ccui.Button(res.ConfirmButton_png, res.ConfirmButtonDown_png, "");
        confirmButton.setAnchorPoint(0.5, 0);
        confirmButton.setPosition(bg.width * 0.5, 25);
        confirmButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(confirmButton);
    },

    _initWitchChooseDialog:function (params) {
        var winSize = cc.winSize;
        var _this = this;

        var bg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        bg.setScale9Enabled(true);
        bg.setPosition(winSize.width / 2, winSize.height / 2);
        bg.setContentSize(winSize.width * 0.7, winSize.height * 0.25);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("是否使用解药", "Arial", 24);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var contentText = new ccui.Text("", "Arial", 23);
        contentText.setTextColor(cc.color(255, 192, 0));
        var seatNumber = DataManager.getInstance().getCurrentRoomData().getSeatNumber(params[0]);
        contentText.setString("昨晚" + seatNumber + "号玩家死亡，是否使用解药？");
        contentText.setAnchorPoint(0,1);
        contentText.setPosition(40, bg.height - 70);
        bg.addChild(contentText);

        var okButton = new ccui.Button(res.YesButton_png, "", "");
        okButton.setAnchorPoint(0,0);
        okButton.setPosition(40,40);
        okButton.addClickEventListener(function () {
            if(seatNumber == DataManager.getInstance().getCurrentRoomData() && DataManager.getInstance().getCurrentRoomData()._timeProcess != 2) {
                ToastUtil.showToast("女巫仅第一夜可自救", 2.0);
            } else {
                MqttHelper.getInstance().witchSelectResultRequest(1, 2, -1);
                var event = new cc.EventCustom("dialogChoose_event");
                var userData = new Object();
                userData.type = StateObject.Antidote;
                userData.userId = params[0];
                event.setUserData(userData);
                cc.eventManager.dispatchEvent(event);
                _this.hidden();
            }
        });
        bg.addChild(okButton);

        var cancelButton = new ccui.Button(res.NoButton_png, "", "");
        cancelButton.setAnchorPoint(1,0);
        cancelButton.setPosition(bg.width - 40, 40);
        cancelButton.addClickEventListener(function () {
            if(params[1]  == 2) {
                var poisonUseDialog = new ModalDialogueBox(DialogType.PoisonUse, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
                poisonUseDialog.setTag(DialogType.PoisonUse);
                poisonUseDialog.popup();
            } else {
                MqttHelper.getInstance().witchSelectResultRequest(2, 2, -1);
                ToastUtil.showToast("毒药已经用过", 2);
            }
            _this.hidden();
        });
        bg.addChild(cancelButton);

        this.setVisible(false);
    },

    _initGestureChooseDialog:function () {
        var winSize = cc.winSize;
        var _this = this;

        var selectedUserRole = -1;
        var selectedUserSeatNumber = -1;

        //背景
        var bg = new ccui.ImageView(res.CommonDialogBg_png);
        bg.setScale9Enabled(true);
        bg.setPosition(winSize.width / 2, winSize.height / 2);
        bg.setContentSize(winSize.width * 0.85, winSize.height * 0.65);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setPosition(bg.width * 0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("手势选择", "Arial", 24);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var innerBg = new ccui.ImageView(res.CommonDialogInnerBg_png);
        innerBg.setScale9Enabled(true);
        innerBg.setAnchorPoint(0.5, 1);
        innerBg.setContentSize(bg.width * 0.84, bg.height*0.43);
        innerBg.setPosition(bg.width * 0.5, bg.height - 58);
        bg.addChild(innerBg);

        var innerBg1 = new ccui.ImageView(res.CommonDialogInnerBg_png);
        innerBg1.setScale9Enabled(true);
        innerBg1.setAnchorPoint(0.5, 0);
        innerBg1.setPosition(bg.width * 0.5, 95);
        innerBg1.setContentSize(bg.width * 0.84, bg.height * 0.32);
        bg.addChild(innerBg1);

        var goodManbg = new ccui.ImageView(res.RoleBg_png);
        goodManbg.setAnchorPoint(1,1);
        goodManbg.setPosition(innerBg.width - 40, innerBg.height - 30);
        innerBg.addChild(goodManbg);

        var goodManCheckBg = new ccui.Button(res.CheckBg_png, "", "");
        goodManCheckBg.setAnchorPoint(0, 0.5);
        goodManCheckBg.setPosition(0, goodManbg.height * 0.5);
        goodManCheckBg.addClickEventListener(function () {
            if(selectedUserRole != GagSelectRole.GOOD_MAN) {
                badManCheckBg.removeChildByTag(234567);
                yuminCheckBg.removeChildByTag(234567);
                var duihao = new ccui.ImageView(res.DuiSmall_png);
                duihao.setAnchorPoint(0.5, 0.5);
                duihao.setPosition(goodManCheckBg.width * 0.5, goodManCheckBg.height * 0.5);
                duihao.setTag(234567);
                goodManCheckBg.addChild(duihao);
                selectedUserRole = GagSelectRole.GOOD_MAN;
            }
        });
        goodManbg.addChild(goodManCheckBg);

        var goodManText = new ccui.Text("好人", "Arial", 20);
        goodManText.setAnchorPoint(0.5, 0.5);
        goodManText.setPosition(goodManbg.width - 70, goodManbg.height *0.5);
        goodManbg.addChild(goodManText);

        var yuminBg = new ccui.ImageView(res.RoleBg_png);
        yuminBg.setAnchorPoint(1, 1);
        yuminBg.setPosition(innerBg.width - 40, innerBg.height - 80);
        innerBg.addChild(yuminBg);

        var yuminCheckBg = new ccui.Button(res.CheckBg_png, "", "");
        yuminCheckBg.setAnchorPoint(0, 0.5);
        yuminCheckBg.setPosition(0, yuminBg.height * 0.5);
        yuminCheckBg.addClickEventListener(function () {
            if(selectedUserRole != GagSelectRole.FOLL) {
                badManCheckBg.removeChildByTag(234567);
                goodManCheckBg.removeChildByTag(234567);
                var duihao = new ccui.ImageView(res.DuiSmall_png);
                duihao.setAnchorPoint(0.5, 0.5);
                duihao.setPosition(yuminCheckBg.width * 0.5, yuminCheckBg.height * 0.5);
                duihao.setTag(234567);
                yuminCheckBg.addChild(duihao);
                selectedUserRole = GagSelectRole.FOLL;
            }
        });
        yuminBg.addChild(yuminCheckBg);

        var yuminText = new ccui.Text("愚民", "Arial", 20);
        yuminText.setAnchorPoint(0.5, 0.5);
        yuminText.setPosition(yuminBg.width - 70, yuminBg.height *0.5);
        yuminBg.addChild(yuminText);

        var badBg = new ccui.ImageView(res.RoleBg_png);
        badBg.setAnchorPoint(1, 1);
        badBg.setPosition(innerBg.width - 40, innerBg.height - 130);
        innerBg.addChild(badBg);

        var badManCheckBg = new ccui.Button(res.CheckBg_png, "", "");
        badManCheckBg.setAnchorPoint(0, 0.5);
        badManCheckBg.setPosition(0, badBg.height * 0.5);
        badManCheckBg.addClickEventListener(function () {
            if(selectedUserRole != GagSelectRole.BAD_MAN) {
                yuminCheckBg.removeChildByTag(234567);
                goodManCheckBg.removeChildByTag(234567);
                var duihao = new ccui.ImageView(res.DuiSmall_png);
                duihao.setAnchorPoint(0.5, 0.5);
                duihao.setPosition(badManCheckBg.width * 0.5, badManCheckBg.height * 0.5);
                duihao.setTag(234567);
                badManCheckBg.addChild(duihao);
                selectedUserRole = GagSelectRole.BAD_MAN;
            }
        });
        badBg.addChild(badManCheckBg);

        var badManText = new ccui.Text("坏人", "Arial", 20);
        badManText.setAnchorPoint(0.5, 0.5);
        badManText.setPosition(badBg.width - 70, badBg.height *0.5);
        badBg.addChild(badManText);

        var selectBg = new ccui.ImageView(res.GagInnerBg_png);
        selectBg.setAnchorPoint(0, 1);
        selectBg.setPosition(40, innerBg.height - 18);
        selectBg.setScale9Enabled(true);
        selectBg.setContentSize(innerBg.width * 0.4, innerBg.height * 0.7);
        innerBg.addChild(selectBg);

        var commitButton = new ccui.Button(res.Commit_png, "", "");
        commitButton.setAnchorPoint(0.5, 0);
        commitButton.setPosition(innerBg.width * 0.5, 10);
        commitButton.addClickEventListener(function () {

            if(selectedUserRole == -1 || selectedUserSeatNumber == -1) {
                ToastUtil.showToast("请先选择", 2);
            } else {
                var defaultItemLayout = new ccui.Layout();
                defaultItemLayout.setTouchEnabled(true);
                defaultItemLayout.setContentSize(innerBg1.width, 35);

                var selectBg = new ccui.ImageView(res.GagInnerBg_png);
                selectBg.setAnchorPoint(0.5, 0.5);
                selectBg.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);
                selectBg.setScale9Enabled(true);
                selectBg.setContentSize(defaultItemLayout.width - 80, defaultItemLayout.height + 5);
                defaultItemLayout.addChild(selectBg, 0);

                var userText = new ccui.Text(selectedUserSeatNumber + "号", "Arial", 21);
                userText.setAnchorPoint(0, 0.5);
                userText.setColor(cc.color(255, 206, 111));
                userText.setName("userSeatNumber");
                userText.setTag(selectedUserSeatNumber);
                userText.setPosition(50, defaultItemLayout.height * 0.5);

                var roleString = "";
                if (selectedUserRole == GagSelectRole.GOOD_MAN) {
                    roleString = "好人";
                } else if (selectedUserRole == GagSelectRole.FOLL) {
                    roleString = "愚民";
                } else {
                    roleString = "坏人";
                }

                var roleText = new ccui.Text(roleString, "Arial", 21);
                roleText.setAnchorPoint(0.5, 0.5);
                roleText.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);
                roleText.setName("userRole");
                roleText.setTag(selectedUserRole);
                roleText.setColor(cc.color(250, 250, 202));

                defaultItemLayout.addChild(userText, 1);
                defaultItemLayout.addChild(roleText, 1);

                var cancleButton = new ccui.Button(res.Close_png);
                cancleButton.setAnchorPoint(1, 0.5);
                cancleButton.setPosition(defaultItemLayout.width - 50, defaultItemLayout.height * 0.5);
                cancleButton.setTag(selectedUserSeatNumber);
                cancleButton.addClickEventListener(function () {
                    selectedList.removeItem(selectedList.getCurSelectedIndex());
                });
                defaultItemLayout.addChild(cancleButton, 1);
                selectedList.pushBackCustomItem(defaultItemLayout);

                selectedList.jumpToBottom();
            }
        });
        innerBg.addChild(commitButton);

        var userList = new ccui.ListView();
        userList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        userList.setTouchEnabled(true);
        userList.setBounceEnabled(true);
        userList.setAnchorPoint(0.5, 0.5);
        userList.setPosition(selectBg.width*0.5, selectBg.height * 0.5);
        userList.setContentSize(cc.size(selectBg.width - 10, selectBg.height - 10));
        selectBg.addChild(userList);

        var totalPlayer = DataManager.getInstance().getCurrentRoomData()._totalPlayerNum;
        for(var i = 0; i < totalPlayer; i++) {
            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(selectBg.width - 10, 25);
            defaultItemLayout.setTag(i+1);

            var userText = new ccui.Text((i + 1) + "号", "Arial", 21);
            userText.setAnchorPoint(0.5, 0.5);
            userText.setColor(cc.color(255, 206, 111));
            userText.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);

            defaultItemLayout.addChild(userText, 1);
            userList.pushBackCustomItem(defaultItemLayout);
        }

        userList.setItemsMargin(10);
        userList.addEventListener(function (sender, type) {
            switch (type) {
                case ccui.ListView.EVENT_SELECTED_ITEM:
                    var listViewEx = sender;
                    var item = listViewEx.getItem(listViewEx.getCurSelectedIndex());
                    if(item.getTag() != selectedUserSeatNumber) {
                        var items = listViewEx.getItems();
                        for (var i = 0; i < items.length; i++) {
                            if (items[i].getChildByTag(123456) != undefined) {
                                items[i].removeChildByTag(123456);
                            }
                        }

                        var selectBg = new ccui.ImageView(res.SelectBg_png);
                        selectBg.setAnchorPoint(0.5, 0.5);
                        selectBg.setPosition(item.width * 0.5, item.height * 0.5);
                        selectBg.setScale9Enabled(true);
                        selectBg.setContentSize(item.width - 6, item.height);
                        selectBg.setTag(123456);
                        item.addChild(selectBg, 0);

                        selectedUserSeatNumber = item.getTag();
                    }
                    cc.log("select child index = " + item.getTag());
                    break;
                default:
                    break;
            }
        }, _this);

        var selectedList = new ccui.ListView();
        selectedList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        selectedList.setTouchEnabled(true);
        selectedList.setBounceEnabled(true);
        selectedList.setAnchorPoint(0.5, 0.5);
        selectedList.setPosition(innerBg1.width*0.5, innerBg1.height * 0.5);
        selectedList.setContentSize(cc.size(innerBg1.width - 30, innerBg1.height - 30));
        selectedList.setItemsMargin(10);
        innerBg1.addChild(selectedList);

        var okButton = new ccui.Button(res.ConfirmButton_png, "", "");
        okButton.setAnchorPoint(0.5,0);
        okButton.setPosition(bg.width * 0.5, 20);
        okButton.addClickEventListener(function () {
            var selectedItems = selectedList.getItems();
            var gestureList = new Array();
            for(var i = 0; i < selectedItems.length; i++) {
                var gesture = new Object();
                var selectUserSeat = selectedItems[i].getChildByName("userSeatNumber").getTag();
                gesture.targetUserId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectUserSeat).userId;
                gesture.gestureType = selectedItems[i].getChildByName("userRole").getTag();
                gestureList.push(gesture);
            }
            MqttHelper.getInstance().gestureSelectResultRequest(DataManager.getInstance().getUserData()._userId, gestureList);
            _this.hidden();
        });
        bg.addChild(okButton);

        this.setVisible(false);     //默认设置为不可见
    },

    _initYesOrNotDialog:function (dialogType, params) {
        var winSize= cc.winSize;
        var _this = this;

        var bg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        bg.setScale9Enabled(true);
        bg.setContentSize(winSize.width*0.7, winSize.height*0.25);
        bg.setPosition(winSize.width/2, winSize.height/2);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("请选择", "Arial", 24);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var contentText = new ccui.Text("", "Arial", 23);
        contentText.setTextColor(cc.color(255, 192, 0));
        if(dialogType == DialogType.StalkerChooseTarget) {
            if(params != null && params != undefined) {
                contentText.setString("昨晚你投了" + params + "号玩家，是否发动技能?");
            }
        } else if (dialogType == DialogType.PoliceCompete) {
            contentText.setString("是否参加竞选?");
        } else if (dialogType == DialogType.OrganizeSpeech) {
            contentText.setString("请警长组织发言");
        }
        contentText.setAnchorPoint(0,1);
        contentText.setPosition(40, bg.height - 70);
        bg.addChild(contentText);

        var okButton = new ccui.Button(res.YesButton_png, "", "");
        if(dialogType == DialogType.OrganizeSpeech) {
            okButton.loadTextures(res.QuickJoinRoom_png, "");
        }
        okButton.setAnchorPoint(0,0);
        okButton.setPosition(40,40);
        okButton.addClickEventListener(function () {
            if(dialogType == DialogType.StalkerChooseTarget) {
                MqttHelper.getInstance().stalkerSelectResultRequest(1);
            } else if(dialogType == DialogType.PoliceCompete) {
                MqttHelper.getInstance().policeCompeteResultRequest(1);
                var event = new cc.EventCustom("dialogChoose_event");
                var userData = new Object();
                userData.type = StateObject.Compete;
                userData.userId = DataManager.getInstance().getUserData()._userId;
                event.setUserData(userData);
                cc.eventManager.dispatchEvent(event);
            } else if(dialogType == DialogType.OrganizeSpeech) {
                MqttHelper.getInstance().organizeSpeechResultRequest(2);
            }
            _this.hidden();
        });
        bg.addChild(okButton);

        if(dialogType == DialogType.OrganizeSpeech) {
            var policeLeftLabel = new ccui.ImageView(res.PoliceLeftLabel_png);
            policeLeftLabel.setPosition(okButton.width/2, okButton.height/2);
            okButton.addChild(policeLeftLabel);
        }

        var cancelButton = new ccui.Button(res.NoButton_png, "", "");
        if(dialogType == DialogType.OrganizeSpeech) {
            cancelButton.loadTextures(res.IdJoinRoom_png, "");
        }
        cancelButton.setAnchorPoint(1,0);
        cancelButton.setPosition(bg.width - 40, 40);
        cancelButton.addClickEventListener(function () {
            if(dialogType == DialogType.StalkerChooseTarget) {
                MqttHelper.getInstance().stalkerSelectResultRequest(2);
            } else if(dialogType == DialogType.PoliceCompete) {
                MqttHelper.getInstance().policeCompeteResultRequest(2);
            } else if (dialogType == DialogType.OrganizeSpeech) {
                MqttHelper.getInstance().organizeSpeechResultRequest(1);
            }
            _this.hidden();
        });
        bg.addChild(cancelButton);

        if(dialogType == DialogType.OrganizeSpeech) {
            var policeRightLabel = new ccui.ImageView(res.PoliceRightLabel_png);
            policeRightLabel.setPosition(cancelButton.width/2, cancelButton.height/2);
            cancelButton.addChild(policeRightLabel);
        }

        this.setVisible(false);     //默认设置为不可见
    },

    _initChooseTarget:function(dialogType, params) {
        var winSize= cc.winSize;
        var _this = this;
        var col = 4;
        var hSpace = 10;
        var vSpace = 10;
        var width = 70;
        var height = 70;

        var bg = new ccui.ImageView(res.CommonDialogBg_png);
        bg.setScale9Enabled(true);
        bg.setContentSize(winSize.width*0.9, winSize.height*0.8);
        bg.setPosition(winSize.width/2, winSize.height/2);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setPosition(bg.width * 0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("请选择目标", "Arial", 28);
        if(dialogType == DialogType.WolfChooseTarget) {
            titleText.setString("狼人请杀人");
        } else if(dialogType == DialogType.WhiteWolfKingSelect) {
            titleText.setString("白狼王请带人");
        } else if(dialogType == DialogType.ChooseMvp) {
            titleText.setString("请选择MVP");
        } else if (dialogType == DialogType.Vote) {
            titleText.setString("放逐投票");
        } else if (dialogType == DialogType.PoisonUse) {
            titleText.setString("请使用毒药");
        }
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var innerTitleBg = new ccui.ImageView(res.DialogInnerTitleBg_png);
        innerTitleBg.setAnchorPoint(0, 1);
        innerTitleBg.setScaleY(1.1);
        innerTitleBg.setPosition(bg.width * 0.05, bg.height * 0.94);
        bg.addChild(innerTitleBg);

        var hintText = new ccui.Text("请选择目标", "Arial", 23);
        hintText.setTextColor(cc.color(252, 203, 110));
        hintText.setAnchorPoint(0.5, 0.5);
        hintText.setPosition(innerTitleBg.width * 0.5, innerTitleBg.height * 0.5);
        innerTitleBg.addChild(hintText);

        var innerBg= new ccui.ImageView(res.CommonDialogInnerBg_png);
        innerBg.setScale9Enabled(true);
        innerBg.setAnchorPoint(0, 1);
        innerBg.setPosition(bg.width * 0.05, bg.height*0.92 - 38);
        innerBg.setContentSize(bg.width*0.9, bg.height*0.76);
        bg.addChild(innerBg);

        if(dialogType == DialogType.VotePolice) {
            if(params[2] != null && params[2] != undefined) {
                params[2].sort(function (a, b) {
                    return DataManager.getInstance().getCurrentRoomData().getSeatNumber(a) -
                        DataManager.getInstance().getCurrentRoomData().getSeatNumber(b);
                });
            }
        }

        for (var i = 0; i < params[0]; i++) {
            var seatNumber = -1;
            if(dialogType == DialogType.VotePolice) {
                seatNumber = DataManager.getInstance().getCurrentRoomData().getSeatNumber(params[2][i]);
            } else if (dialogType == DialogType.PlaneVote) {
                seatNumber = params[2][i];
            } else {
                seatNumber = (i + 1);
            }
            var cardRes = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber).currentCard;
            var target = new ccui.Button(cardRes, cardRes);
            target.setScale9Enabled(true);
            innerBg.addChild(target);
            target.setAnchorPoint(0, 1);
            target.setUserData(true);

            if(dialogType == DialogType.ProphetChooseTarget) {
                if(cardRes == "res/1000.png" || cardRes == "res/1001.png") {
                    target.setUserData(false);
                }
            }

            if(dialogType == DialogType.VotePolice) {
                target.setTag(params[2][i]);
            } else {
                target.setTag(seatNumber);
            }

            var deathType = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber).deathType;
            if(deathType != 1 && deathType != 11 && dialogType != DialogType.ChooseMvp) {
                target.setBright(false);
                var deathStamp = new ccui.ImageView(DeathType.get(deathType));
                deathStamp.setAnchorPoint(0.5, 0.5);
                deathStamp.setPosition(target.width * 0.5, target.height * 0.5);
                target.addChild(deathStamp);
            }

            if(dialogType == DialogType.Vote) {
                if(cardRes == res.Idiot_png && deathType == 11) {
                    target.setBright(false);
                }
            }

            if( (dialogType == DialogType.ProphetChooseTarget ||
                dialogType == DialogType.WildChildChooseTarget ||
                dialogType == DialogType.PoisonUse ||
                dialogType == DialogType.TransferPolice ||
                dialogType == DialogType.ChooseMvp)
                && target.getTag() == DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
                target.setBright(false);
            }

            if(dialogType == DialogType.GuardChooseTarget &&
                target.getTag() == DataManager.getInstance().getCurrentRoomData()._guardLastSelect) {
                target.setBright(false);
            }

            if(dialogType == DialogType.GagElderChooseTarget &&
                target.getTag() == DataManager.getInstance().getCurrentRoomData()._gagLastSelect) {
                target.setBright(false);
            }

            target.setName("target" + i);
            target.setScale(0.75);
            width = target.width * 0.75;
            height = target.height * 0.75;
            target.setPosition(20 + (width + hSpace) * (i % col), innerBg.height - 20 - (height + vSpace) * (Math.floor(i / col)));
            target.addClickEventListener(function () {
                if(!this.isBright() || this.getUserData() == false) {
                    ToastUtil.showToast("不能选择该目标", 2.0);
                } else {
                    if (this.getChildByTag(CommonTag.RightTag) != undefined) {
                        this.removeChildByTag(CommonTag.RightTag);
                    } else {
                        if (params[1] == 1) {
                            _this._clearDialog(innerBg, params[0]);
                            var right = new ccui.ImageView(res.DuiBig_png);
                            right.setAnchorPoint(0.5, 0.5);
                            right.setPosition(this.width * 0.5, this.height * 0.5);
                            right.setTag(CommonTag.RightTag);
                            this.addChild(right);
                        } else {
                            if (_this._getSelectedNum(innerBg, params[0]) >= params[1]) {
                                ToastUtil.showToast("只能选择" + params[1] + "人", 2.0);
                            } else {
                                var right = new ccui.ImageView(res.DuiBig_png);
                                right.setAnchorPoint(0.5, 0.5);
                                right.setPosition(this.width * 0.5, this.height * 0.5);
                                right.setTag(CommonTag.RightTag);
                                this.addChild(right);
                            }
                        }
                    }
                }
            });

            var seatNumberBg = new ccui.ImageView(res.CardNameBg_png);
            seatNumberBg.setAnchorPoint(1,1);
            seatNumberBg.setScale9Enabled(true);
            seatNumberBg.setPosition(target.width, target.height);
            seatNumberBg.setContentSize(50, 40);
            target.addChild(seatNumberBg);

            var seatNumberText = new ccui.Text("" + seatNumber, "Arial", 28);
            seatNumberText.setAnchorPoint(0.5, 0.5);
            seatNumberText.setPosition(seatNumberBg.width*0.5, seatNumberBg.height*0.5);
            seatNumberBg.addChild(seatNumberText);

            var playerNameBg = new ccui.ImageView(res.CardNameBg_png);
            playerNameBg.setAnchorPoint(0, 0);
            playerNameBg.setPosition(0, 0);
            playerNameBg.setScale9Enabled(true);
            playerNameBg.setContentSize(target.width-5, 35);
            target.addChild(playerNameBg);

            var playerNameText = new ccui.Text("", "Arial", 28);

            playerNameText.setString(DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber).nickname);
            playerNameText.setAnchorPoint(0.5,0.5);
            playerNameText.setPosition(playerNameBg.width / 2, playerNameBg.height / 2);
            playerNameBg.addChild(playerNameText);
        }

        var okButton = new ccui.Button(res.IdJoinRoom_png, res.IdJoinRoomDown_png);
        okButton.setAnchorPoint(0.5,0);
        if(dialogType == DialogType.GagElderChooseTarget || dialogType == DialogType.GuardChooseTarget
            || dialogType == DialogType.TransferPolice
            || dialogType == DialogType.Vote || dialogType == DialogType.PlaneVote || dialogType == DialogType.VotePolice
            || dialogType == DialogType.PoliceCallVote || dialogType == DialogType.HunterKill
            || dialogType == DialogType.PoisonUse || dialogType == DialogType.WhiteWolfKingSelect) {
            okButton.setPosition(150, 20);
        } else {
            okButton.setPosition(bg.width/2, 20)
        }
        okButton.addClickEventListener(function () {
            var selectedSeat = _this._getSelectedSeat(innerBg, params[0]);
            if(selectedSeat.length == params[1]) {
                if (dialogType == DialogType.CupidChooseTarget) {
                    var userId1 = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    var userId2 = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[1]).userId;
                    MqttHelper.getInstance().cupidSelectResultRequest(userId1, userId2);
                } else if (dialogType == DialogType.ProphetChooseTarget) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().prophetSelectResultRequest(userId);
                } else if (dialogType == DialogType.GagElderChooseTarget) {
                    DataManager.getInstance().getCurrentRoomData()._gagLastSelect = selectedSeat[0];
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().gagelderSelectResultRequest(userId);
                    var event = new cc.EventCustom("dialogChoose_event");
                    var userData = new Object();
                    userData.type = StateObject.Gag;
                    userData.userId = userId;
                    event.setUserData(userData);
                    cc.eventManager.dispatchEvent(event);
                } else if (dialogType == DialogType.GuardChooseTarget) {
                    DataManager.getInstance().getCurrentRoomData()._guardLastSelect = selectedSeat[0];
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().guardSelectResultRequest(userId);
                    var event = new cc.EventCustom("dialogChoose_event");
                    var userData = new Object();
                    userData.type = StateObject.Guard;
                    userData.userId = userId;
                    event.setUserData(userData);
                    cc.eventManager.dispatchEvent(event);
                } else if (dialogType == DialogType.WildChildChooseTarget) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().wildchildSelectResultRequest(userId);
                    var event = new cc.EventCustom("dialogChoose_event");
                    var userData = new Object();
                    userData.type = StateObject.Idol;
                    userData.userId = userId;
                    event.setUserData(userData);
                    cc.eventManager.dispatchEvent(event);
                } else if (dialogType == DialogType.WolfChooseTarget) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().wolfSelectResultRequest(userId);
                } else if (dialogType == DialogType.TransferPolice) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().transferPoliceResultRequest(userId);
                } else if (dialogType == DialogType.Vote) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().voteResultRequest(userId);
                } else if (dialogType == DialogType.PlaneVote) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().voteResultRequest(userId);
                } else if (dialogType == DialogType.VotePolice) {
                    MqttHelper.getInstance().votePoliceResultRequest(selectedSeat[0]);
                } else if (dialogType == DialogType.PoliceCallVote) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().policeCallVoteSelectResultRequest(userId);
                } else if (dialogType == DialogType.HunterKill) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().hunterKillResultRequest(userId);
                    var event = new cc.EventCustom("dialogChoose_event");
                    var userData = new Object();
                    userData.type = StateObject.Hunter;
                    userData.userId = userId;
                    event.setUserData(userData);
                    cc.eventManager.dispatchEvent(event);
                } else if (dialogType == DialogType.PoisonUse) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().witchSelectResultRequest(2, 1, userId);
                    var event = new cc.EventCustom("dialogChoose_event");
                    var userData = new Object();
                    userData.type = StateObject.Poison;
                    userData.userId = userId;
                    event.setUserData(userData);
                    cc.eventManager.dispatchEvent(event);
                } else if (dialogType == DialogType.WhiteWolfKingSelect) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().whiteWolfKingSelectResultRequest(userId);
                } else if (dialogType == DialogType.ChooseMvp) {
                    var userId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(selectedSeat[0]).userId;
                    MqttHelper.getInstance().chooseMvpResultRequest(userId);
                }
                _this.hidden();
            } else {
                ToastUtil.showToastInMiddle("选取的人数不合法", 2.0);
            }
        });
        bg.addChild(okButton);

        var okLabel = new ccui.ImageView(res.CommonConfirmLabel_png);
        okLabel.setPosition(okButton.width/2, okButton.height/2);
        okButton.addChild(okLabel);

        var cancelButton = new ccui.Button(res.QuickJoinRoom_png, res.QuickJoinRoomDown_png);
        cancelButton.setAnchorPoint(0.5, 0);
        cancelButton.setPosition(bg.width - 150, 20);
        if(!(dialogType == DialogType.GagElderChooseTarget || dialogType == DialogType.GuardChooseTarget
            || dialogType == DialogType.TransferPolice
            || dialogType == DialogType.Vote || dialogType == DialogType.PlaneVote || dialogType == DialogType.VotePolice
            || dialogType == DialogType.PoliceCallVote || dialogType == DialogType.HunterKill
            || dialogType == DialogType.PoisonUse || dialogType == DialogType.WhiteWolfKingSelect)) {
            cancelButton.setVisible(false);
        }

        cancelButton.addClickEventListener(function () {
            if (dialogType == DialogType.GagElderChooseTarget) {
                MqttHelper.getInstance().gagelderSelectResultRequest(-1);
                DataManager.getInstance().getCurrentRoomData()._gagLastSelect = -1;
            } else if (dialogType == DialogType.GuardChooseTarget) {
                MqttHelper.getInstance().guardSelectResultRequest(-1);
                DataManager.getInstance().getCurrentRoomData()._guardLastSelect = -1;
            } else if (dialogType == DialogType.WolfChooseTarget) {
                MqttHelper.getInstance().wolfSelectResultRequest(-1);
            } else if (dialogType == DialogType.TransferPolice) {
                MqttHelper.getInstance().transferPoliceResultRequest(-1);
            } else if (dialogType == DialogType.Vote) {
                MqttHelper.getInstance().voteResultRequest(-1);
            } else if (dialogType == DialogType.PlaneVote) {
                MqttHelper.getInstance().voteResultRequest(-1);
            } else if (dialogType == DialogType.VotePolice) {
                MqttHelper.getInstance().votePoliceResultRequest(-1);
            } else if (dialogType == DialogType.PoliceCallVote) {
                MqttHelper.getInstance().policeCallVoteSelectResultRequest(-1);
            } else if (dialogType == DialogType.HunterKill) {
                MqttHelper.getInstance().hunterKillResultRequest(-1);
            } else if (dialogType == DialogType.PoisonUse) {
                MqttHelper.getInstance().witchSelectResultRequest(2, 2, -1);
            } else if (dialogType == DialogType.WhiteWolfKingSelect) {
                MqttHelper.getInstance().whiteWolfKingSelectResultRequest(-1);
            }
            _this.hidden();
        });
        bg.addChild(cancelButton);

        var cancelLabel = new ccui.ImageView(res.CancelLabel_png);
        cancelLabel.setPosition(cancelButton.width/2, cancelButton.height/2);
        switch (dialogType) {
            case DialogType.GagElderChooseTarget:
                cancelLabel.loadTexture(res.NotGagLabel_png);
                break;
            case DialogType.WolfChooseTarget:
                cancelLabel.loadTexture(res.NotKillLabel_png);
                break;
            case DialogType.GuardChooseTarget:
                cancelLabel.loadTexture(res.NotGuardLabel_png);
                break;
            case DialogType.PoisonUse:
                cancelLabel.loadTexture(res.NotUsePoisonLabel_png);
                break;
            case DialogType.Vote:
            case DialogType.VotePolice:
            case DialogType.PlaneVote:
                cancelLabel.loadTexture(res.NotVoteLabel_png);
                break;
            case DialogType.PoliceCallVote:
                cancelLabel.loadTexture(res.NotCallVoteLabel_png);
                break;
            case DialogType.HunterKill:
                cancelLabel.loadTexture(res.NotShootLabel_png);
                break;
        };
        cancelButton.addChild(cancelLabel);

        this.setVisible(false);     //默认设置为不可见
    },

    _clearDialog:function (bg, totalPlayerNum) {
        for(var i = 0; i < totalPlayerNum; i++){
            bg.getChildByName("target" + i).removeChildByTag(CommonTag.RightTag);
        }
    },

    _getSelectedNum:function (bg, totalPlayerNum) {
        var sum = 0;
        for(var i = 0; i < totalPlayerNum; i++){
            if(bg.getChildByName("target" + i).getChildByTag(CommonTag.RightTag) != undefined) {
                sum++;
            }
        }
        return sum;
    },

    _getSelectedSeat:function (bg, totalPlayerNum) {
        var selectedSeat = new Array();
        for(var i = 0; i < totalPlayerNum; i++){
            if(bg.getChildByName("target"+i).getChildByTag(CommonTag.RightTag) != undefined &&
                bg.getChildByName("target"+i).getChildByTag(CommonTag.RightTag) != null) {
                selectedSeat.push(bg.getChildByName("target"+i).getTag());
            }
        }
        return selectedSeat;
    },

    _initChooseRoleDialog:function (params) {
        var winSize= cc.winSize;
        var _this = this;

        var bg = new ccui.ImageView(res.CommonDialogBg_png);
        bg.setScale9Enabled(true);
        bg.setContentSize(winSize.width*0.88, winSize.height*0.62);
        bg.setPosition(winSize.width/2, winSize.height/2);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setPosition(bg.width * 0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("盗贼选择身份", "Arial", 24);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var innerTitleBg = new ccui.ImageView(res.DialogInnerTitleBg_png);
        innerTitleBg.setAnchorPoint(0, 1);
        innerTitleBg.setPosition(bg.width * 0.1, bg.height * 0.92);
        bg.addChild(innerTitleBg);

        var hintText = new ccui.Text("请选择身份", "Arial", 21);
        hintText.setTextColor(cc.color(252, 203, 110));
        hintText.setAnchorPoint(0.5, 0.5);
        hintText.setPosition(innerTitleBg.width * 0.5, innerTitleBg.height * 0.5);
        innerTitleBg.addChild(hintText);

        var innerBg= new ccui.ImageView(res.CommonDialogInnerBg_png);
        innerBg.setScale9Enabled(true);
        innerBg.setAnchorPoint(0, 1);
        innerBg.setPosition(bg.width * 0.1, bg.height*0.92 - 38);
        innerBg.setContentSize(bg.width*0.8, bg.height*0.65);
        bg.addChild(innerBg);

        var role1 = new ccui.Button("res/" + params[0] + ".png", "res/" + params[0] + ".png");
        innerBg.addChild(role1);
        role1.setScale9Enabled(true);
        role1.setPosition(65, innerBg.height - 60);
        role1.setAnchorPoint(0,1);
        role1.setTag(params[0]);
        role1.addClickEventListener(function () {
            if(((params[0] == 101 || params[0] == 102) && (params[1] != 101 && params[1] != 102)) ||
                ((params[1] == 101 || params[1] == 102) && (params[0] != 101 && params[0] != 102))) {
                ToastUtil.systemToastInMiddle("只能选择狼人", 2.0);
            } else {
                role1.setBright(true);
                role2.setBright(false);
            }
        });

        var role2 = new ccui.Button("res/" + params[1] + ".png", "res/" + params[1] + ".png");
        innerBg.addChild(role2);
        role2.setAnchorPoint(1,1);
        role2.setScale9Enabled(true);
        role2.setPosition(innerBg.width - 65, innerBg.height - 60);
        role2.setTag(params[1]);
        role2.addClickEventListener(function () {
            if(((params[0] == 101 || params[0] == 102) && (params[1] != 101 && params[1] != 102)) ||
                ((params[1] == 101 || params[1] == 102) && (params[0] != 101 && params[0] != 102))) {
                ToastUtil.systemToastInMiddle("只能选择狼人", 2.0);
            } else {
                role2.setBright(true);
                role1.setBright(false);
            }
        });

        if((params[0] == 101 || params[0] == 102) && (params[1] != 101 && params[1] != 102)) {
            role1.setBright(true);
            role2.setBright(false);
        }

        if((params[1] == 101 || params[1] == 102) && (params[0] != 101 && params[0] != 102)) {
            role2.setBright(true);
            role1.setBright(false);
        }

        var okButton = new ccui.Button(res.ConfirmButton_png, res.ConfirmButtonDown_png);
        okButton.setAnchorPoint(0.5 , 0);
        okButton.setPosition(bg.width * 0.5, 30);
        okButton.addClickEventListener(function () {
            if(role1.isBright() && role2.isBright()) {
                ToastUtil.systemToastInMiddle("请选择身份", 2.0);
            } else {
                var roleCode;
                if (role1.isBright()) {
                    roleCode = role1.getTag();
                } else {
                    roleCode = role2.getTag();
                }
                MqttHelper.getInstance().rogueSelectResultRequest(roleCode);
                var event = new cc.EventCustom("changeRole_event");
                event.setUserData(roleCode);
                cc.eventManager.dispatchEvent(event);
                _this.hidden();
            }
        });
        bg.addChild(okButton);

        this.setVisible(false);     //默认设置为不可见
    },

    //初始化对话框
    _initInputRoomIdDialog: function()
    {
        var winSize = cc.director.getVisibleSize();

        var _this = this;

        //背景
        var bg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        bg.setScale9Enabled(true);
        bg.setPosition(winSize.width * 0.5, winSize.height * 0.5);
        bg.setContentSize(winSize.width * 0.7, winSize.height * 0.25);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("请输入房间号", "Arial", 24);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var roomNumberText = new ccui.Text("房间号", "Arial", 22);
        roomNumberText.setAnchorPoint(0, 0.5);
        roomNumberText.setPosition(30, bg.height - 95);
        bg.addChild(roomNumberText);

        var normal9SpriteBg=new cc.Scale9Sprite(res.NumBg_png);
        var roomNumberEditBox = new cc.EditBox(cc.size(bg.width * 0.67, 50), normal9SpriteBg);
        roomNumberEditBox.setAnchorPoint(0, 0.5);
        roomNumberEditBox.setPosition(40 + roomNumberText.width, bg.height - 95);
        roomNumberEditBox.setFontSize(22);
        roomNumberEditBox.setMaxLength(6);
        roomNumberEditBox.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC);
        bg.addChild(roomNumberEditBox, 1);

        var okButton = new ccui.Button(res.ConfirmButton_png, res.ConfirmButtonDown_png, "");
        okButton.setAnchorPoint(0,0);
        okButton.setPosition(30, 30);
        okButton.addClickEventListener(function () {
            var roomId = roomNumberEditBox.getString();
            if(roomId.length != 6) {
                ToastUtil.systemToastInMiddle("房号不合法", 2.0);
            } else {
                var loadingDialog = new LoadingDialog();
                loadingDialog.setTag(997001);
                loadingDialog.popup();

                MqttHelper.getInstance().joinRoom(Number(roomId));
                _this.hidden();
            }
        });
        bg.addChild(okButton);

        var cancelButton = new ccui.Button(res.CancelButton_png, res.CancelButtonDown_png, "");
        cancelButton.setAnchorPoint(1,0);
        cancelButton.setPosition(bg.width - 30, 30);
        cancelButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(cancelButton);

        this.setVisible(false);     //默认设置为不可见
    },

    //初始化对话框
    _initInputPasswordDialog: function(params) {
        var winSize = cc.director.getVisibleSize();
        var _this = this;

        //背景
        var bg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        bg.setScale9Enabled(true);
        bg.setPosition(winSize.width * 0.5, winSize.height * 0.5);
        bg.setContentSize(winSize.width * 0.7, winSize.height * 0.25);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("请输入密码", "Arial", 29);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var passWordText = new ccui.Text("密码", "Arial", 28);
        passWordText.setAnchorPoint(0, 0.5);
        passWordText.setPosition(40, bg.height - 105);
        bg.addChild(passWordText);

        var normal9SpriteBg=new cc.Scale9Sprite(res.NumBg_png);
        normal9SpriteBg.setPosition(60 + passWordText.width, bg.height - 105);
        normal9SpriteBg.setAnchorPoint(0, 0.5);
        normal9SpriteBg.setContentSize(bg.width * 0.67, 50);
        bg.addChild(normal9SpriteBg);

        var passwordEdit = new cc.EditBox(cc.size(bg.width * 0.67 - 20, 50), new cc.Scale9Sprite(res.Transparency_50x50_png));
        passwordEdit.setAnchorPoint(0, 0.5);
        passwordEdit.setPosition(70 + passWordText.width, bg.height - 105);
        passwordEdit.setFontSize(28);
        passwordEdit.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC);
        passwordEdit.setMaxLength(4);
        bg.addChild(passwordEdit, 1);

        var okButton = new ccui.Button(res.ConfirmButton_png, res.ConfirmButtonDown_png, "");
        okButton.setAnchorPoint(0,0);
        okButton.setPosition(30,30);
        okButton.addClickEventListener(function () {
            var loadingDialog = new LoadingDialog();
            loadingDialog.setTag(997001);
            loadingDialog.popup();

            cc.log(passwordEdit.getString());
            var password = passwordEdit.getString();
            passwordEdit.setString("");
            verifyRoomId = params[0];

            MqttHelper.getInstance().verifyPasswordRequest(params[0], password);
            //
            // var hallApi = new HallApi();
            // hallApi.verifyPassword(params[0], password, "verifyPasswordeResponse", function (data) {
            // }, function (data) {
            // }, function (data) {
            // });
        });
        bg.addChild(okButton);

        var cancelButton = new ccui.Button(res.CancelButton_png, res.CancelButtonDown_png, "");
        cancelButton.setAnchorPoint(1,0);
        cancelButton.setPosition(bg.width - 30, 30);
        cancelButton.addClickEventListener(function () {
            _this.hidden();
        })
        bg.addChild(cancelButton);

        this.setVisible(false);     //默认设置为不可见
    },

    _initShowVoteResult:function (dialogType, params) {

        var winSize = cc.winSize;
        var _this = this;

        //背景
        var bg = new ccui.ImageView(res.CommonDialogBg_png);
        bg.setScale9Enabled(true);
        bg.setPosition(winSize.width / 2, winSize.height / 2);
        bg.setContentSize(winSize.width * 0.85, winSize.height * 0.6);
        this.addChild(bg, 0, 101);

        var closeButton = new ccui.Button(res.RedClose_png, "", "");
        closeButton.setAnchorPoint(1,1);
        closeButton.setPosition(bg.width - 5, bg.height - 5);
        closeButton.setScale(1.1);
        closeButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(closeButton);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("投票结果", "Arial", 28);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleText.setAnchorPoint(0.5, 0.5);
        titleBg.addChild(titleText);

        var innerBg = new ccui.ImageView(res.CommonDialogInnerBg_png);
        innerBg.setAnchorPoint(0.5, 0.5);
        innerBg.setPosition(bg.width*0.5, bg.height*0.5 + 50);
        innerBg.setScale9Enabled(true);
        innerBg.setContentSize(bg.width*0.85, bg.height*0.6);
        bg.addChild(innerBg);

        var innerBg1 = new ccui.ImageView(res.CommonDialogInnerBg_png);
        innerBg1.setAnchorPoint(0.5, 1);
        innerBg1.setPosition(bg.width*0.5, bg.height*0.23);
        innerBg1.setScale9Enabled(true);
        innerBg1.setContentSize(bg.width*0.85, bg.height*0.16);
        bg.addChild(innerBg1);

        var voteList = new ccui.ListView();
        voteList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        voteList.setTouchEnabled(true);
        voteList.setBounceEnabled(true);
        voteList.setAnchorPoint(0.5, 0.5);
        voteList.setPosition(innerBg.width*0.5, innerBg.height * 0.5);
        voteList.setContentSize(cc.size(innerBg.width - 30, innerBg.height - 30));
        innerBg.addChild(voteList);

        for(var i = 0; i < params[0].length; i++) {
            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(innerBg.width, Math.ceil(params[0][i].voteUserSeatNumberList.length / 4) * 30 + 35);

            var voteTitleBg = new ccui.ImageView(res.VoteResultBg_png);
            voteTitleBg.setAnchorPoint(0.5, 1);
            voteTitleBg.setPosition(defaultItemLayout.width*0.5, defaultItemLayout.height);

            var voteTitleText = new ccui.Text("", "Arial", 27);
            if(params[0][i].targetUserSeatNumber == -1) {
                voteTitleText.setString("弃票的玩家");
            } else {
                voteTitleText.setString("投" + params[0][i].targetUserSeatNumber + "号的玩家");
            }
            voteTitleText.setAnchorPoint(0.5, 0.5);
            voteTitleText.setPosition(voteTitleBg.width * 0.5, voteTitleBg.height * 0.5);
            voteTitleBg.addChild(voteTitleText);

            defaultItemLayout.addChild(voteTitleBg);

            var voteText = new ccui.Text("", "Arial", 27);
            var textContent = "";
            var k = 1;
            for(var j = 0; j < params[0][i].voteUserSeatNumberList.length; j++) {
                textContent = textContent + params[0][i].voteUserSeatNumberList[j] + "号";
                if(k == 4) {
                    k = 1;
                    textContent = textContent + "\n";
                } else {
                    if(j != params[0][i].voteUserSeatNumberList.length - 1) {
                        textContent = textContent + "            ";
                    }
                    k++;
                }
            }
            voteText.setColor(cc.color(249,187,44));
            voteText.setString(textContent);
            voteText.setAnchorPoint(0.5, 1);
            voteText.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height - 42);
            defaultItemLayout.addChild(voteText);

            voteList.pushBackCustomItem(defaultItemLayout);
        }

        voteList.setItemsMargin(10);

        var resultTitleBg = new ccui.ImageView(res.VoteResultBg_png);
        resultTitleBg.setAnchorPoint(0.5, 0.5);
        resultTitleBg.setPosition(innerBg1.width * 0.5, innerBg1.height);
        innerBg1.addChild(resultTitleBg);

        var resultTitleText = new ccui.Text("结果", "Arial", 26);
        resultTitleText.setAnchorPoint(0.5, 0.5);
        resultTitleText.setPosition(resultTitleBg.width*0.5, resultTitleBg.height*0.5);
        resultTitleBg.addChild(resultTitleText);

        var resultText = new ccui.Text(params[1], "Arial", 25);
        resultText.setColor(cc.color(255, 254, 206));
        resultText.setAnchorPoint(0.5, 0.5);
        resultText.setPosition(innerBg1.width*0.5, innerBg1.height*0.5);
        innerBg1.addChild(resultText);
    },

    _initGameResult:function (dialogType, params) {
        var winSize = cc.winSize;
        var _this = this;

        //背景
        var bg = new ccui.Layout();
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(winSize.width * 0.5, winSize.height * 0.5);
        bg.setContentSize(winSize.width, winSize.height);
        this.addChild(bg, 0, 101);

        var bgLight = new ccui.ImageView(res.BgLight_png);
        bgLight.setAnchorPoint(0.5, 0.5);
        bgLight.setPosition(bg.width * 0.5, bg.height * 0.75);
        bg.addChild(bgLight);

        var bgStart = new ccui.ImageView(res.BgStart_png);
        bgStart.setAnchorPoint(0.5, 0.5);
        bgStart.setPosition(bg.width * 0.5, bg.height * 0.9);
        bg.addChild(bgStart);

        var GameResultImage = new ccui.ImageView(res.GameWin_png);
        if(params.isWin != 1) {
            GameResultImage.loadTexture(res.GameLose_png);
        }
        GameResultImage.setName("GameResultImage");
        GameResultImage.setAnchorPoint(0.5, 0.5);
        GameResultImage.setPosition(bg.width * 0.5, bg.height * 0.75);
        bg.addChild(GameResultImage);

        var winPartImage = new ccui.ImageView(res.WolfWin_png);
        if(params.victoryCamp == 2) {
            winPartImage.loadTexture(res.GoodManWin_png);
        } else if (params.victoryCamp == 3) {
            winPartImage.loadTexture(res.ThirdPartWin_png);
        }
        winPartImage.setAnchorPoint(0.5, 0.5);
        winPartImage.setPosition(bg.width * 0.5, bg.height * 0.58);
        bg.addChild(winPartImage);

        var nikeName = new ccui.ImageView(res.GameResultNickName_png);
        nikeName.setAnchorPoint(0, 0.5);
        nikeName.setPosition(bg.width * 0.25, bg.height * 0.5);
        bg.addChild(nikeName);

        var cup = new ccui.ImageView(res.GameResultCup_png);
        cup.setAnchorPoint(0.5, 0.5);
        cup.setPosition(bg.width * 0.5, bg.height * 0.5);
        bg.addChild(cup);

        var hp = new ccui.ImageView(res.GameResultCoin_png);
        hp.setAnchorPoint(1, 0.5);
        hp.setPosition(bg.width * 0.75, bg.height * 0.5);
        bg.addChild(hp);

        var userList = new ccui.ListView();
        userList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        userList.setTouchEnabled(true);
        userList.setBounceEnabled(true);
        userList.setAnchorPoint(0.5, 0.5);
        userList.setPosition(bg.width*0.5, bg.height * 0.36);
        userList.setContentSize(cc.size(bg.width * 0.5, bg.height * 0.19));
        bg.addChild(userList);

        for(var i = 0; i < params.scoreList.length; i++) {
            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(bg.width * 0.5, 35);

            if(params.scoreList[i].seatNumber == DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
                var selfBg = new ccui.ImageView(res.GameResultSelfBg_png);
                selfBg.setAnchorPoint(0.5, 0.5);
                selfBg.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);
                selfBg.setScale9Enabled(true);
                selfBg.setContentSize(defaultItemLayout.width, defaultItemLayout.height);
                defaultItemLayout.addChild(selfBg, 0);
            }

            var nickname = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(params.scoreList[i].seatNumber).nickname;
            var nickNameText = new ccui.Text(nickname, "Arial", 21);
            nickNameText.setAnchorPoint(0, 0.5);
            nickNameText.setColor(cc.color(255, 182, 0));
            nickNameText.setPosition(0, defaultItemLayout.height * 0.5);
            defaultItemLayout.addChild(nickNameText, 1);

            var cupText = new ccui.Text("" + params.scoreList[i].cupScore, "Arial", 21);
            cupText.setColor(cc.color(245, 194, 97));
            cupText.setAnchorPoint(0.5, 0.5);
            cupText.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);
            defaultItemLayout.addChild(cupText, 1);

            var hpText = new ccui.Text("" + params.scoreList[i].hpScore, "Arial", 21);
            hpText.setColor(cc.color(245, 194, 97));
            hpText.setAnchorPoint(1, 0.5);
            hpText.setPosition(defaultItemLayout.width - 5, defaultItemLayout.height * 0.5);
            defaultItemLayout.addChild(hpText);

            userList.pushBackCustomItem(defaultItemLayout);
        }

        var confirmButton = new ccui.Button(res.ConfirmButton_png, res.ConfirmButtonDown_png, "");
        confirmButton.setAnchorPoint(0.5, 0.5);
        confirmButton.setPosition(bg.width * 0.5, bg.height * 0.17);
        confirmButton.addClickEventListener(function () {
            var event = new cc.EventCustom("do_next_event");
            cc.eventManager.dispatchEvent(event);
            _this.hidden();
        });
        bg.addChild(confirmButton);
    },

    _initShowMvp:function (dialogType, seatNumber) {
        var winSize = cc.winSize;
        var _this = this;

        //背景
        var bg = new ccui.Layout();
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(winSize.width * 0.5, winSize.height * 0.5);
        bg.setContentSize(winSize.width, winSize.height);
        this.addChild(bg, 0, 101);

        var bgLight = new ccui.ImageView(res.BgLight_png);
        bgLight.setAnchorPoint(0.5, 0.5);
        bgLight.setPosition(bg.width * 0.5, bg.height * 0.65);
        bg.addChild(bgLight);

        var bgStart = new ccui.ImageView(res.BgStart_png);
        bgStart.setAnchorPoint(0.5, 0.5);
        bgStart.setPosition(bg.width * 0.5, bg.height * 0.8);
        bg.addChild(bgStart);

        var GameResultImage = new ccui.ImageView(res.GameMvp_png);
        GameResultImage.setName("GameResultImage");
        GameResultImage.setAnchorPoint(0.5, 0.5);
        GameResultImage.setPosition(bg.width * 0.5, bg.height * 0.65);
        bg.addChild(GameResultImage);

        var winPartImage = new ccui.Text("", "Arial", 25);
        if(seatNumber == DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
            winPartImage.setString("恭喜你获得本场MVP");
        } else {
            var name = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber).nickname;
            winPartImage.setString("恭喜" + name + "获得本场MVP");
        }
        winPartImage.setAnchorPoint(0.5, 0.5);
        winPartImage.setPosition(bg.width * 0.5, bg.height * 0.48);
        bg.addChild(winPartImage);

        var confirmButton = new ccui.Button(res.ConfirmButton_png, res.ConfirmButtonDown_png, "");
        confirmButton.setAnchorPoint(0.5, 0.5);
        confirmButton.setPosition(bg.width * 0.5, bg.height * 0.17);
        confirmButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(confirmButton);
    },

    _onCallback: function()
    {
        this.hidden();
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this);
        this.setVisible(true);
        this._listener.setSwallowTouches(true);

        var bg = this.getChildByTag(101);
        bg.setScale(0);
        var scaleTo1 = new cc.ScaleTo(0.1, 1.25);
        var scaleTo2 = new cc.ScaleTo(0.1, 1);
        var actionArray = new Array();
        actionArray.push(scaleTo1);
        actionArray.push(scaleTo2);
        var sequence = new cc.Sequence(actionArray);
        bg.runAction(sequence);

        cc.log(this._dialogType);

        if(this._dialogType == DialogType.ShowVoteResult) {
            setTimeout(function () {
                if(cc.director.getRunningScene().getChildByTag(DialogType.ShowVoteResult) != null &&
                  cc.director.getRunningScene().getChildByTag(DialogType.ShowVoteResult) != undefined) {
                    cc.director.getRunningScene().removeChildByTag(DialogType.ShowVoteResult);
                }
            }, 3000);
        } else if(this._dialogType == DialogType.GameResult) {
            setTimeout(function () {
                if(cc.director.getRunningScene().getChildByTag(DialogType.GameResult) != null &&
                    cc.director.getRunningScene().getChildByTag(DialogType.GameResult) != undefined) {
                    cc.director.getRunningScene().removeChildByTag(DialogType.GameResult);
                    var event = new cc.EventCustom("do_next_event");
                    cc.eventManager.dispatchEvent(event);
                }
            }, 5000);
        } else if (this._dialogType == DialogType.ShowMvp) {
            setTimeout(function () {
                if(cc.director.getRunningScene().getChildByTag(DialogType.ShowMvp) != null &&
                    cc.director.getRunningScene().getChildByTag(DialogType.ShowMvp) != undefined) {
                    cc.director.getRunningScene().removeChildByTag(DialogType.ShowMvp);
                }
            }, 3000);
        }
    },

    //隐藏
    hidden: function()
    {
        if(this != null && this != undefined) {
            this.setVisible(false);
            this.removeFromParent(true);
        }
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        this._listener.setSwallowTouches(false);
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});