/**
 * Created by junji on 2017/2/1.
 */

var kickedUserId = -1;

var GiftCard = cc.Sprite.extend({

    _toUserId:-1,
    _giftData:[
        {
            "giftIcon":res.KickoutFlower1_png,
            "giftName":"鲜花×10",
            "giftPrice":100,
            "currencyType":2,
            "effect":"魅力值+10",
            "giftType":1
        },
        {
            "giftIcon":res.KickoutFlower2_png,
            "giftName":"鲜花×100",
            "giftPrice":1000,
            "currencyType":2,
            "effect":"魅力值+100",
            "giftType":2
        },
        {
            "giftIcon":res.KickoutFlower4_png,
            "giftName":"鲜花×110",
            "giftPrice":100,
            "currencyType":1,
            "effect":"魅力值+110",
            "giftType":14
        },
        {
            "giftIcon":res.KickoutFlower3_png,
            "giftName":"鲜花×520",
            "giftPrice":500,
            "currencyType":1,
            "effect":"魅力值+520",
            "giftType":3
        },
        {
            "giftIcon":res.KickoutEgg1_png,
            "giftName":"鸡蛋×1",
            "giftPrice":100,
            "currencyType":2,
            "effect":"魅力值-10",
            "giftType":4
        },
        {
            "giftIcon":res.KickoutChicken1_png,
            "giftName":"弱鸡×1",
            "giftPrice":1000,
            "currencyType":2,
            "effect":"魅力值-100",
            "giftType":5
        },
        {
            "giftIcon":res.KickoutPig1_png,
            "giftName":"猪头×1",
            "giftPrice":100,
            "currencyType":1,
            "effect":"魅力值-110",
            "giftType":15
        },
        {
            "giftIcon":res.KickoutBoom1_png,
            "giftName":"炸弹×1",
            "giftPrice":500,
            "currencyType":1,
            "effect":"魅力值-520",
            "giftType":6
        }
    ],

    ctor:function (index, toUserId) {
        this._super();
        var _this = this;
        this._toUserId = toUserId;
        var giftData = this._giftData[index];
        var bg = new ccui.Button(res.KickoutGiftBg_png, "");
        bg.setUserData(giftData["giftType"]);
        bg.addClickEventListener(function () {
            var giftType = this.getUserData();
            var fromSeatNumber = DataManager.getInstance().getCurrentRoomData()._mySeatNumber;
            var fromUserId = DataManager.getInstance().getUserData()._userId;
            cc.log("fromSeatNumber send aaa " + fromSeatNumber);
            if (fromSeatNumber == undefined || fromSeatNumber == null || fromSeatNumber == "") {
                fromSeatNumber = -1;
            }
            var toSeatNumber = DataManager.getInstance().getCurrentRoomData().getSeatNumber(_this._toUserId);
            MqttHelper.getInstance().roomSendGiftRequest(fromSeatNumber, toSeatNumber, giftType, fromUserId);
        });
        this.addChild(bg);

        var width = bg.width;
        var height = bg.height;

        var giftIconImage = new ccui.ImageView(giftData["giftIcon"]);
        giftIconImage.setPosition(width/2, height/2+15);
        giftIconImage.setScale(0.8);
        bg.addChild(giftIconImage);

        var giftNameText = new ccui.Text(giftData["giftName"], "Arial", 21);
        giftNameText.setPosition(width/2, height - 18);
        bg.addChild(giftNameText);

        var giftEffectText = new ccui.Text(giftData["effect"], "Arial", 20);
        giftEffectText.setPosition(width/2, 50);
        giftEffectText.setColor(cc.color(225, 228, 0));
        bg.addChild(giftEffectText);

        var giftPriceText = new ccui.Text("×" + giftData["giftPrice"], "Arial", 22);
        giftPriceText.setPosition(width/2 + 18, 23);
        giftPriceText.setColor(cc.color(82,230 ,23));
        bg.addChild(giftPriceText);

        var giftCurrencyImage = new ccui.ImageView(res.Diamond_png);
        giftCurrencyImage.setScale(0.72);
        if(giftData["currencyType"] == 2) {
            giftCurrencyImage.loadTexture(res.GoldCoin_png);
        }
        giftCurrencyImage.setPosition(width/2 - 23, 23);
        bg.addChild(giftCurrencyImage);
    }
});

var KickoutDialog = cc.LayerColor.extend({

    _listener:null,
    _data : null,

    ctor: function(data, inGame) {
        this._super(cc.color.BLACK);
        cc.log('jijun ctor kickout inGame ' + inGame);
        this.setOpacity(140);       //透明度
        this._data = data;
        this._initKickoutDialog(data, inGame);

        return true;
    },

    onEnter: function()
    {
        this._super();
        var _this = this;
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                _this.hidden();
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initKickoutDialog: function(data, inGame)
    {
        var _this = this;
        var size = cc.winSize;
        //背景
        var bg = new ccui.ImageView(res.KickoutDialogBg_png);
        bg.setAnchorPoint(0.5, 0.8);
        bg.setPosition(size.width*0.5, size.height*0.5);
        this.addChild(bg, 0, 101);

        var avatarBg = new ccui.ImageView(res.AvatarBg_png);
        avatarBg.setPosition(135, bg.height - 160);
        bg.addChild(avatarBg);

        var avatar = new ccui.ImageView(AvatarMap.get(data.avatar)[1]);
        avatar.setScale(0.9);
        avatar.setPosition(avatarBg.width/2, avatarBg.height/2);
        avatarBg.addChild(avatar);

        var vipLabel = new ccui.ImageView(res.VIPFlag_png);
        vipLabel.setPosition(125, bg.height - 240);
        bg.addChild(vipLabel);

        var vipText = new ccui.Text(data.vipLevel+"", "Arial", 26);
        vipText.setAnchorPoint(0, 0.5);
        vipText.setPosition(165, bg.height - 240);
        bg.addChild(vipText);

        var nickNameLabel = new ccui.ImageView(res.NickNameLabel_png);
        nickNameLabel.setPosition(220, bg.height - 120);
        nickNameLabel.setAnchorPoint(0, 0.5);
        bg.addChild(nickNameLabel);

        var nickNameText = new ccui.Text(data.nickName, "Arial", 26);
        nickNameText.setPosition(308, bg.height - 120);
        nickNameText.setAnchorPoint(0, 0.5);
        nickNameText.setColor(cc.color(81, 45, 31));
        bg.addChild(nickNameText);

        var rankLabel = new ccui.ImageView(res.RankLabel_png);
        rankLabel.setPosition(440, bg.height - 120);
        rankLabel.setAnchorPoint(0, 0.5);
        bg.addChild(rankLabel);

        var rankText = new ccui.Text(data.totalRank+"", "Arial", 26);
        rankText.setAnchorPoint(0, 0.5);
        rankText.setPosition(525, bg.height - 120);
        rankText.setColor(cc.color(81, 45, 31));
        bg.addChild(rankText);

        var cupLabel = new ccui.ImageView(res.CupLabel_png);
        cupLabel.setPosition(220, bg.height - 170);
        cupLabel.setAnchorPoint(0, 0.5);
        bg.addChild(cupLabel);

        var cupText = new ccui.Text(""+data.cup, "Arial", 26);
        cupText.setAnchorPoint(0, 0.5);
        cupText.setPosition(336, bg.height - 170);
        cupText.setColor(cc.color(81, 45, 31));
        bg.addChild(cupText);

        var gradeLabel = new ccui.ImageView(res.GradeLabel_png);
        gradeLabel.setPosition(440, bg.height - 170);
        gradeLabel.setAnchorPoint(0, 0.5);
        bg.addChild(gradeLabel);

        var gradeText = new ccui.Text(data.grade+"阶", "Arial", 26);
        gradeText.setPosition(525, bg.height - 170);
        gradeText.setAnchorPoint(0, 0.5);
        gradeText.setColor(cc.color(81, 45, 31));
        bg.addChild(gradeText);

        var winRateLabel = new ccui.ImageView(res.WinRateLabel_png);
        winRateLabel.setPosition(220, bg.height - 225)
        winRateLabel.setAnchorPoint(0, 0.5);
        bg.addChild(winRateLabel);

        var winRate = 0;
        if(data.totalWinTimes == 0) {
            winRate = 0;
        } else if(data.totalLoseTimes == 0) {
            winRate = 100;
        } else {
            winRate = Math.ceil(data.totalWinTimes*100/(data.totalLoseTimes+data.totalWinTimes));
        }
        var winRateText = new ccui.Text((winRate) +"%", "Arial", 26);
        winRateText.setAnchorPoint(0, 0.5);
        winRateText.setPosition(308, bg.height - 225);
        winRateText.setColor(cc.color(81, 45, 31));
        bg.addChild(winRateText);

        var combatGainsLabel = new ccui.ImageView(res.CombatGainsLabel_png);
        combatGainsLabel.setAnchorPoint(0, 0.5);
        combatGainsLabel.setPosition(440, bg.height - 225);
        bg.addChild(combatGainsLabel);

        var combatGainsText = new ccui.Text(data.totalWinTimes+"胜/"+data.totalLoseTimes+"负", "Arial", 26);
        combatGainsText.setAnchorPoint(0, 0.5);
        combatGainsText.setPosition(525, bg.height - 225);
        combatGainsText.setColor(cc.color(81, 45, 31));
        bg.addChild(combatGainsText);

        var lookupButton = new ccui.Button(res.KickoutButtonBg_png, "");
        lookupButton.setPosition(size.width/2 - 240, bg.height - 315);
        lookupButton.addClickEventListener(function () {
            var otherHomepageLayer = new OtherHomePageLayer(1, _this._data);
            otherHomepageLayer.setName("otherHomepageLayer");
            cc.director.getRunningScene().addChild(otherHomepageLayer, 15);
            _this.hidden();
        });
        bg.addChild(lookupButton);

        var lookupLabel = new ccui.ImageView(res.LookupLabel_png);
        lookupLabel.setPosition(lookupButton.width/2, lookupButton.height/2);
        lookupButton.addChild(lookupLabel);

        var addFriendButton = new ccui.Button(res.KickoutButtonBg_png, "");
        addFriendButton.setPosition(size.width/2 - 80, bg.height - 315);
        addFriendButton.addClickEventListener(function () {
            var addFriendConfirmDialog = new CommonDialog(DialogType.AddFriendConfirmDialog, data.userId);
            addFriendConfirmDialog.popup();
        });
        addFriendButton.setVisible(false);
        bg.addChild(addFriendButton);

        var addFriendLabel = new ccui.ImageView(res.KickoutAddFriendLabel_png);
        addFriendLabel.setPosition(addFriendButton.width/2, addFriendButton.height/2);
        addFriendButton.addChild(addFriendLabel);

        var deleteFriendButton = new ccui.Button(res.KickoutButtonBg_png);
        deleteFriendButton.setPosition(size.width/2 - 80, bg.height - 315);
        deleteFriendButton.addClickEventListener(function () {
            TXIMSDK_delFriendSucc = function () {
                ToastUtil.systemToastInMiddle("好友删除成功", 2.0);
            };

            TXIMSDK_delFriendFail = function () {
                ToastUtil.systemToastInMiddle("好友删除失败", 2.0);
            };

            TXIMSDK_delFriend(data.userId+"");
        });
        deleteFriendButton.setVisible(false);
        bg.addChild(deleteFriendButton);

        var deleteFriendLabel = new ccui.ImageView(res.KickoutDeleteFriendLabel_png);
        deleteFriendLabel.setPosition(deleteFriendButton.width/2, deleteFriendButton.height/2);
        deleteFriendButton.addChild(deleteFriendLabel);

        isMyFriendSucc = function () {
            cc.log("is friend");
            addFriendButton.setVisible(false);
            deleteFriendButton.setVisible(true);
        };

        isMyFriendFail = function () {
            cc.log("not friend");
            addFriendButton.setVisible(true);
            deleteFriendButton.setVisible(false);
        };

        isMyFriend(data.userId+"");

        var reportButton = new ccui.Button(res.KickoutButtonBg_png, "");
        reportButton.setPosition(size.width/2 + 80, bg.height -315);
        reportButton.addClickEventListener(function () {
            ToastUtil.showToast("即将开放，敬请期待~", 2.0);
        });
        bg.addChild(reportButton);

        var reportLabel = new ccui.ImageView(res.KickoutReportLabel_png);
        reportLabel.setPosition(reportButton.width/2, reportButton.height/2);
        reportButton.addChild(reportLabel);

        if(!inGame) {
            var kickoutButton = new ccui.Button(res.KickoutButtonBg_png, "");
            kickoutButton.setPosition(size.width/2 + 240, bg.height - 315);
            kickoutButton.addClickEventListener(function () {
                var gameProfileApi = new GameProfileApi();
                kickedUserId = _this._data.userId;
                gameProfileApi.userReadyKickout(kickedUserId, "userReadyKickoutResponse", function () {
                }, function () {
                }, function () {
                });
                _this.hidden();
            });
            bg.addChild(kickoutButton);

            var kickoutLabel = new ccui.ImageView(res.KickoutLabel_png);
            kickoutLabel.setPosition(kickoutButton.width / 2, kickoutButton.height / 2);
            kickoutButton.addChild(kickoutLabel);
        }

        for (var i = 0; i < 8; i++) {
            var giftCard = new GiftCard(i, _this._data.userId);
            giftCard.setAnchorPoint(0, 1);
            giftCard.setPosition(133 + (i%4) * 155, bg.height - 525 - Math.floor(i/4)*166);
            bg.addChild(giftCard);
        }

        var closeButton = new ccui.Button(res.RedClose_png, res.RedClose_png, "");
        closeButton.setAnchorPoint(1, 1);
        closeButton.setPosition(bg.width - 23, bg.height - 35);
        closeButton.setContentSize(90, 90);
        closeButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(closeButton);

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this, 10);
        this.setVisible(true);
        this._listener.setSwallowTouches(true);

        var bg = this.getChildByTag(101);
        bg.setScale(0);
        var scaleTo1 = new cc.ScaleTo(0.1, 1.25);
        var scaleTo2 = new cc.ScaleTo(0.1, 1);
        var actionArray = new Array();
        actionArray.push(scaleTo1);
        actionArray.push(scaleTo2);
        var sequence = new cc.Sequence(actionArray);
        bg.runAction(sequence);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});

function userReadyKickoutResponse(responseString) {
    var responseObj = JSON.parse(responseString);
    if (responseObj.retCode > 0) {
        if (responseObj.retCode == 1) {
            userReadyKickoutSuccess(responseObj.retBody);
        } else if (responseObj.retCode == 2) {
            userReadyKickoutResume(responseObj.retBody);
        }
    } else {
        userReadyKickoutFailed(responseObj.retBody);
    }
};

function userReadyKickoutSuccess(data) {
    var commonDialog = new CommonDialog(DialogType.KickoutConfirmDialog, [kickedUserId, data.cost]);
    commonDialog.setTag(DialogType.KickoutConfirmDialog);
    commonDialog.popup();
};

function userReadyKickoutFailed(data) {
    cc.log(data.message);
    ToastUtil.systemToastInMiddle(data.message, 1.5);
};

function userReadyKickoutResume(data) {
    cc.log(data);
};
