/**
 * Created by junji on 2017/1/26.
 */

var MailDialog = cc.LayerColor.extend({

    _listener:null,
    _mailInfo:null,

    ctor: function(mailInfoList) {
        this._super(cc.color.BLACK);
        cc.log('jijun ctor');
        this.setOpacity(140);       //透明度
        this._mailInfo = mailInfoList;
        this._initMailDialog(mailInfoList);

        cc.eventManager.addListener(cc.EventListener.create({
            event: cc.EventListener.CUSTOM,
            eventName: "read_mail",
            callback: this.readMail,
        }), 1);

        return true;
    },

    readMail:function (myEvent) {
        var mailId = myEvent.getUserData();
        var readOverFlag = true;
        var mailDialog = cc.director.getRunningScene().getChildByTag(DialogType.MailDialog);
        if(mailDialog != null && mailDialog != undefined) {
            var mailList = mailDialog.getChildByName("bg").getChildByName("mainList").getItems();
            for(var i = 0; i < mailList.length; i++) {
                if(mailList[i].getName() == mailId) {
                    var redCircle = mailList[i].getChildByName("mailItemBg").getChildByName("iconBg").
                    getChildByName("xinfeng").getChildByName("redCircle");
                    if(redCircle != null && redCircle != undefined) {
                        redCircle.removeFromParent();
                    }
                }
                var redCircle = mailList[i].getChildByName("mailItemBg").getChildByName("iconBg").
                getChildByName("xinfeng").getChildByName("redCircle");
                if(redCircle != null && redCircle != undefined) {
                    readOverFlag = false;
                }
            }
            if(readOverFlag) {
                var currentScene = cc.director.getRunningScene();
                if(currentScene instanceof HallScene) {
                    DataManager.getInstance().getUserData()._hasNewMail = 2;
                    currentScene.clearMailRedCircle();
                }
            }
        }
    },

    onEnter: function()
    {
        this._super();
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initMailDialog: function(mailInfoList)
    {
        var _this = this;
        //背景
        var bg = new ccui.ImageView(res.MailDialogBg_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.director.getVisibleSize().width*0.5, cc.director.getVisibleSize().height*0.5);
        bg.setName("bg");
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setScale(1.1);
        titleBg.setPosition(bg.width*0.5, bg.height - 25);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("信   箱", "Arial", 35);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var mainList = new ccui.ListView();
        bg.addChild(mainList);
        mainList.setName("mainList");
        mainList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        mainList.setContentSize(575, 740);
        mainList.setAnchorPoint(0.5, 0);
        mainList.setScrollBarEnabled(false);
        mainList.setBounceEnabled(true);
        mainList.setTouchEnabled(true);
        mainList.setPosition(bg.width/2 + 6, 150);

        for(var i = 0; i < mailInfoList.length; i++) {
            var item = _this.getMailItem(i, mailInfoList[i]);
            mainList.pushBackCustomItem(item);
        }

        var cancelButton = new ccui.Button(res.MailButton_png, "", "");
        cancelButton.setPosition(bg.width/2, 80);
        cancelButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(cancelButton);

        var cancelLabel = new ccui.ImageView(res.CloseLabel_png);
        cancelLabel.setPosition(cancelButton.width/2, cancelButton.height/2);
        cancelButton.addChild(cancelLabel);

        var closeButton = new ccui.Button(res.RedClose_png, res.RedClose_png, "");
        closeButton.setAnchorPoint(1, 1);
        closeButton.setPosition(bg.width - 20, bg.height - 20);
        closeButton.setContentSize(90, 90);
        closeButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(closeButton);

        this.setVisible(false);     //默认设置为不可见
    },

    // selectedMailItemEvent: function(sender, type) {
    //     switch (type) {
    //         case ccui.ListView.EVENT_SELECTED_ITEM:
    //             var listViewEx = sender;
    //             var item = listViewEx.getItem(listViewEx.getCurSelectedIndex());
    //             cc.log("select child index = ");
    //             break;
    //         case ccui.ListView.EVENT_SLIDEBALL_UP:
    //             cc.log("up");
    //             break;
    //         case ccui.ListView.EVENT_SLIDEBALL_DOWN:
    //             cc.log("down");
    //         default:
    //             break;
    //     }
    // },

    getMailItem:function(index, data){

        var _this = this;

        var layout = new ccui.Layout();
        layout.setTouchEnabled(true);
        layout.setName(data.mailId);

        var mailItemBg = new ccui.Button(res.MailItemBg_png, "", "");
        mailItemBg.setTag(index);
        mailItemBg.addClickEventListener(function () {
            var redCircle = mailItemBg.getChildByName("iconBg").getChildByName("xinfeng").getChildByName("redCircle");
            var readState = true;
            if(redCircle != null && redCircle != undefined) {
                readState = false;
            }
            var mailSecondDialog = new MailSecondDialog(_this._mailInfo[index], readState);
            mailSecondDialog.setTag(DialogType.MailSecondDialog);
            mailSecondDialog.popup();
        });
        layout.setContentSize(mailItemBg.getContentSize());

        mailItemBg.setPosition(layout.width/2, layout.height/2);
        mailItemBg.setName("mailItemBg");
        layout.addChild(mailItemBg);

        var iconBg = new ccui.ImageView(res.IconBg_png);
        iconBg.setAnchorPoint(0, 0.5);
        iconBg.setPosition(10, mailItemBg.height/2);
        iconBg.setName("iconBg");
        mailItemBg.addChild(iconBg);

        var xinfeng = new ccui.ImageView(res.Xinfeng_png);
        xinfeng.setPosition(iconBg.width/2, iconBg.height/2);
        xinfeng.setName("xinfeng");
        iconBg.addChild(xinfeng);

        if(data.readState == 1) {
            var redCircle = new ccui.ImageView(res.RedCircle_png);
            redCircle.setPosition(xinfeng.width - 6, xinfeng.height - 7);
            redCircle.setName("redCircle");
            xinfeng.addChild(redCircle);
        }

        var mailTitle = new ccui.Text(data.title, "Arial", 34);
        mailTitle.setAnchorPoint(0, 0.5);
        mailTitle.setColor(cc.color(85, 41, 19));
        mailTitle.setPosition(150, mailItemBg.height - 30);
        mailItemBg.addChild(mailTitle);

        var senderLabel = new ccui.Text("发件人:", "Arial", 32);
        senderLabel.setColor(cc.color(85,41,19));
        senderLabel.setAnchorPoint(0, 0.5);
        senderLabel.setPosition(170, mailItemBg.height - 70);
        mailItemBg.addChild(senderLabel);

        var sender = new ccui.Text(data.sender, "Arial", 29);
        sender.setColor(cc.color(112,25,8));
        sender.setAnchorPoint(0, 0.5);
        sender.setPosition(285, mailItemBg.height - 70);
        mailItemBg.addChild(sender);

        var date = new ccui.Text(data.date, "Arial", 29);
        date.setColor(cc.color(85, 41, 19));
        date.setAnchorPoint(0, 0.5);
        date.setPosition(150, 30);
        mailItemBg.addChild(date);

        return layout;
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this, 100);
        this.setVisible(true);
        this._listener.setSwallowTouches(true);

        var bg = this.getChildByTag(101);
        bg.setScale(0);
        var scaleTo1 = new cc.ScaleTo(0.1, 1.25);
        var scaleTo2 = new cc.ScaleTo(0.1, 1);
        var actionArray = new Array();
        actionArray.push(scaleTo1);
        actionArray.push(scaleTo2);
        var sequence = new cc.Sequence(actionArray);
        bg.runAction(sequence);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});