/**
 * Created by junji on 2017/1/26.
 */

var MailSecondDialog = cc.LayerColor.extend({

    _listener:null,

    ctor: function(data, readState) {
        this._super(cc.color.BLACK);
        cc.log('jijun ctor');
        this.setOpacity(140);//透明度

        if(data.type == 2) {
            this._initMailSecondDialog(data, readState);
        } else if (data.type == 1) {
            this._initMailWithOutAppendixSecondDialog(data);
        }

        return true;
    },

    onEnter: function()
    {
        this._super();
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initMailSecondDialog: function(data, readState)
    {
        var _this = this;
        //背景
        var bg = new ccui.ImageView(res.TutorialZhi_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.director.getVisibleSize().width*0.5, cc.director.getVisibleSize().height*0.5);
        this.addChild(bg, 0, 101);

        var letterTitle = new ccui.ImageView(res.LetterTitle_png);
        letterTitle.setPosition(bg.width/2, bg.height - 100);
        bg.addChild(letterTitle);

        var letterIcon = new ccui.ImageView(res.LetterIcon_png);
        letterIcon.setAnchorPoint(0, 0.5);
        letterIcon.setPosition(-10, letterTitle.height/2);
        letterTitle.addChild(letterIcon);

        var letterTitleLabel = new ccui.Text(data.title,"Arial",35);
        letterTitleLabel.setPosition(letterTitle.width/2, letterTitle.height/2);
        letterTitleLabel.setColor(cc.color(101,29,6));
        letterTitle.addChild(letterTitleLabel);

        var messageLayout = new ccui.Layout();

        var messageContent = new cc.LabelTTF(data.content, "Arial", 32);
        messageContent.boundingWidth = bg.width * 0.8;
        messageContent.boundingHeight = 0;
        messageContent.setColor(cc.color(58, 16, 7));
        messageContent.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
        messageContent.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);
        messageContent.setAnchorPoint(0.5,0.5);
        messageLayout.setContentSize(messageContent.getContentSize());
        messageContent.setPosition(messageLayout.width/2 + 30, messageLayout.height/2);
        messageLayout.addChild(messageContent);

        var messageList = new ccui.ListView();
        bg.addChild(messageList);
        messageList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        messageList.setContentSize(bg.width - 80, 320);
        messageList.setAnchorPoint(0.5, 1);
        messageList.setScrollBarEnabled(false);
        messageList.setBounceEnabled(true);
        messageList.setTouchEnabled(true);
        messageList.setPosition(bg.width/2, bg.height - 180);

        messageList.pushBackCustomItem(messageLayout);

        var senderText = new ccui.Text(data.sender, "Arial", 30);
        senderText.setColor(cc.color(101,29,6));
        senderText.setAnchorPoint(1, 1);
        senderText.setPosition(bg.width - 90 , bg.height - 520);
        bg.addChild(senderText);

        var divider = new ccui.ImageView(res.TutorialSlide_png);
        divider.setPosition(bg.width/2, bg.height - 570);
        bg.addChild(divider);

        var appendixLabel = new ccui.Text("附件:", "Arial", 32);
        appendixLabel.setColor(cc.color(58,16,7));
        appendixLabel.setAnchorPoint(0, 1);
        appendixLabel.setPosition(80, bg.height - 610);
        bg.addChild(appendixLabel);

        for (var i = 0; i < data.appendixList.length; i++) {
            var rewardIcon = new ccui.ImageView(res.diamond_png);
            if(data.appendixList[i].rewardType == 5) {
                rewardIcon.loadTexture(res.GoldCoin_png);
                rewardIcon.setScale(1.2);
            } else if (data.appendixList[i].rewardType == 3) {
                rewardIcon.loadTexture(res.AwardBox3_png);
            } else if (data.appendixList[i].rewardType == 2) {
                rewardIcon.loadTexture(res.AwardBox2_png);
            } else if (data.appendixList[i].rewardType == 1) {
                rewardIcon.loadTexture(res.AwardBox1_png);
            }
            rewardIcon.setPosition(150, bg.height - (685+60*i));
            bg.addChild(rewardIcon);
            var rewardText = new ccui.Text("× " + data.appendixList[i].rewardAmount,"Arial",32);
            rewardText.setPosition(220, bg.height - (687+62*i));
            rewardText.setColor(cc.color(58,16,7));
            bg.addChild(rewardText);
        }

        if(readState == false) {
            var getButton = new ccui.Button(res.MailButton_png, "", "");
            getButton.setPosition(bg.width / 2, 82);
            getButton.addClickEventListener(function () {
                var mailApi = new MailApi();
                mailApi.readMail(data.mailId, "readMailResponse", function () {
                }, function () {
                }, function () {
                });
            });
            bg.addChild(getButton);

            var getLabel = new ccui.ImageView(res.GetLabel_png);
            getLabel.setPosition(getButton.width / 2, getButton.height / 2);
            getButton.addChild(getLabel);
        } else {
            var gettedLabel = new ccui.ImageView(res.GettedLabel_png);
            gettedLabel.setPosition(bg.width / 2, 82);
            bg.addChild(gettedLabel);
        }

        var closeButton = new ccui.Button(res.RedClose_png, res.RedClose_png, "");
        closeButton.setAnchorPoint(1, 1);
        closeButton.setPosition(bg.width - 20, bg.height - 20);
        closeButton.setContentSize(90, 90);
        closeButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(closeButton);

        this.setVisible(false);     //默认设置为不可见
    },

    //初始化对话框
    _initMailWithOutAppendixSecondDialog: function(data)
    {
        var _this = this;
        //背景
        var bg = new ccui.ImageView(res.TutorialZhi_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.director.getVisibleSize().width*0.5, cc.director.getVisibleSize().height*0.5);
        this.addChild(bg, 0, 101);

        var letterTitle = new ccui.ImageView(res.LetterTitle_png);
        letterTitle.setPosition(bg.width/2, bg.height - 100);
        bg.addChild(letterTitle);

        var letterIcon = new ccui.ImageView(res.LetterIcon_png);
        letterIcon.setAnchorPoint(0, 0.5);
        letterIcon.setPosition(-10, letterTitle.height/2);
        letterTitle.addChild(letterIcon);

        var letterTitleLabel = new ccui.Text(data.title,"Arial",35);
        letterTitleLabel.setPosition(letterTitle.width/2, letterTitle.height/2);
        letterTitleLabel.setColor(cc.color(101,29,6));
        letterTitle.addChild(letterTitleLabel);

        var messageLayout = new ccui.Layout();

        var messageContent = new cc.LabelTTF(data.content, "Arial", 32);
        messageContent.boundingWidth = bg.width * 0.8;
        messageContent.boundingHeight = 0;
        messageContent.setColor(cc.color(58, 16, 7));
        messageContent.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
        messageContent.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);
        messageContent.setAnchorPoint(0.5,0.5);
        messageLayout.setContentSize(messageContent.getContentSize());
        messageContent.setPosition(messageLayout.width/2 + 30, messageLayout.height/2);
        messageLayout.addChild(messageContent);

        var messageList = new ccui.ListView();
        bg.addChild(messageList);
        messageList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        messageList.setContentSize(bg.width - 80, 600);
        messageList.setAnchorPoint(0.5, 1);
        messageList.setScrollBarEnabled(false);
        messageList.setBounceEnabled(true);
        messageList.setTouchEnabled(true);
        messageList.setPosition(bg.width/2, bg.height - 180);

        messageList.pushBackCustomItem(messageLayout);

        var senderText = new ccui.Text(data.sender, "Arial", 30);
        senderText.setColor(cc.color(101,29,6));
        senderText.setAnchorPoint(1, 1);
        senderText.setPosition(bg.width - 90 , 180);
        bg.addChild(senderText);

        // var divider = new ccui.ImageView(res.TutorialSlide_png);
        // divider.setPosition(bg.width/2, bg.height - 570);
        // bg.addChild(divider);

        // var appendixLabel = new ccui.Text("附件:", "Arial", 32);
        // appendixLabel.setColor(cc.color(58,16,7));
        // appendixLabel.setAnchorPoint(0, 1);
        // appendixLabel.setPosition(80, bg.height - 610);
        // bg.addChild(appendixLabel);
        //
        // for (var i = 0; i < data.appendixList.length; i++) {
        //     var rewardIcon = new ccui.ImageView(res.diamond_png);
        //     if(data.appendixList[i].rewardType == 5) {
        //         rewardIcon.loadTexture(res.GoldCoin_png);
        //         rewardIcon.setScale(1.2);
        //     } else if (data.appendixList[i].rewardType == 3) {
        //         rewardIcon.loadTexture(res.AwardBox3_png);
        //     } else if (data.appendixList[i].rewardType == 2) {
        //         rewardIcon.loadTexture(res.AwardBox2_png);
        //     } else if (data.appendixList[i].rewardType == 1) {
        //         rewardIcon.loadTexture(res.AwardBox1_png);
        //     }
        //     rewardIcon.setPosition(150, bg.height - (685+60*i));
        //     bg.addChild(rewardIcon);
        //     var rewardText = new ccui.Text("× " + data.appendixList[i].rewardAmount,"Arial",32);
        //     rewardText.setPosition(220, bg.height - (687+62*i));
        //     rewardText.setColor(cc.color(58,16,7));
        //     bg.addChild(rewardText);
        // }

        var getButton = new ccui.Button(res.MailButton_png, "", "");
        getButton.setPosition(bg.width/2, 82);
        bg.addChild(getButton);

        var getLabel = new ccui.ImageView(res.CloseLabel_png);
        getLabel.setPosition(getButton.width/2, getButton.height/2);
        getButton.addChild(getLabel);

        var closeButton = new ccui.Button(res.RedClose_png, res.RedClose_png, "");
        closeButton.setAnchorPoint(1, 1);
        closeButton.setPosition(bg.width - 20, bg.height - 20);
        closeButton.setContentSize(90, 90);
        closeButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(closeButton);

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this, 100);
        this.setVisible(true);
        this._listener.setSwallowTouches(true);

        var bg = this.getChildByTag(101);
        bg.setScale(0);
        var scaleTo1 = new cc.ScaleTo(0.1, 1.25);
        var scaleTo2 = new cc.ScaleTo(0.1, 1);
        var actionArray = new Array();
        actionArray.push(scaleTo1);
        actionArray.push(scaleTo2);
        var sequence = new cc.Sequence(actionArray);
        bg.runAction(sequence);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});

function readMailResponse(responseString) {
    var responseObj = JSON.parse(responseString);
    if (responseObj.retCode > 0) {
        if (responseObj.retCode == 1) {
            readMailSuccess(responseObj.retBody);
        } else if (responseObj.retCode == 2) {
            readMailResume(responseObj.retBody);
        }
    } else {
        readMailFailed(responseObj.retCode);
    }
};

function readMailSuccess(data) {
    var rewardList = data.rewardList;
    if(rewardList != null && rewardList != undefined) {
        var rewardArray = new Array();
        for(var i = 0; i < rewardList.length; i++) {
            var content = "";
            if(rewardList[i].rewardType == 4) {
                content+="钻石";
                DataManager.getInstance().getUserData()._diamond+=rewardList[i].rewardNum;
            } else if (rewardList[i].rewardType == 5) {
                content+="金币";
                DataManager.getInstance().getUserData()._goldenCoin+=rewardList[i].rewardNum;
            }
            content+= (" × " +rewardList[i].rewardNum);
            rewardArray.push(content);
        }
        var rewardDialog = new BuyResultDialog("获得奖励",rewardArray);
        rewardDialog.popup();
        var currentScene = cc.director.getRunningScene();
        if(currentScene instanceof HallScene) {
            currentScene.updateDiamondAndCoin();
        }
    }

    var event = new cc.EventCustom("read_mail");
    event.setUserData(data.mailId);
    cc.eventManager.dispatchEvent(event);

    cc.director.getRunningScene().removeChildByTag(DialogType.MailSecondDialog);
};

function readMailFailed(data) {
    cc.log(data);
    ToastUtil.showToast("领取错误", 2);
};

function readMailResume(data) {
    cc.log(data);
};