/**
 * Created by junji on 2017/3/31.
 */

var ReportDialog = cc.LayerColor.extend({

    _listener:null,

    ctor: function() {
        this._super(cc.color.BLACK);
        cc.log('jijun ctor');
        this.setOpacity(140);       //透明度
        this._initReportDialog();

        return true;
    },

    onEnter: function() {
        this._super();
        var _this = this;
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initReportDialog: function() {
        var _this = this;
        //背景
        var bg = new ccui.ImageView(res.CommonDialogBg_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.winSize.width*0.5, cc.winSize.height*0.5);
        bg.setScale9Enabled(true);
        bg.setContentSize(640, 870);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setScale(1.1);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("举报玩家", "Arial", 30);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var innerBg = new ccui.ImageView(res.CommonDialogInnerBg_png);
        innerBg.setScale9Enabled(true);
        innerBg.setContentSize(560, 670);
        innerBg.setAnchorPoint(0.5, 1);
        innerBg.setPosition(bg.width/2, bg.height - 70);
        bg.addChild(innerBg);

        var avatarBg = new ccui.ImageView(res.AvatarBg_png);
        avatarBg.setPosition(50, innerBg.height - 40);
        avatarBg.setAnchorPoint(0, 1);
        avatarBg.setScale(1.1);
        innerBg.addChild(avatarBg);

        var avatar = new ccui.ImageView(res.WolfFemaleAvatar_png);
        avatar.setPosition(avatarBg.width/2, avatarBg.height/2);
        avatar.setScale(0.9);
        avatarBg.addChild(avatar);

        var nickNameText = new ccui.Text("wodeming", "Arial", 28);
        nickNameText.setPosition(50, innerBg.height - 180);
        nickNameText.setAnchorPoint(0, 0.5);
        innerBg.addChild(nickNameText);

        var selectTitle = new ccui.ImageView(res.ReportSelectTitle_png);
        selectTitle.setPosition(210, innerBg.height - 40);
        selectTitle.setScale9Enabled(true);
        selectTitle.setContentSize(300, 52);
        selectTitle.setAnchorPoint(0, 1);
        innerBg.addChild(selectTitle);

        var titleText = new ccui.Text("请选择一个类别", "Arial", 28);
        titleText.setPosition(selectTitle.width/2, selectTitle.height/2);
        titleText.setColor(cc.color(221, 190, 157));
        selectTitle.addChild(titleText);

        var pullBg = new ccui.ImageView(res.ReportPullBg_png);
        pullBg.setAnchorPoint(0, 1);
        pullBg.setScale9Enabled(true);
        pullBg.setContentSize(300, 215);
        pullBg.setPosition(210, innerBg.height - 91);
        innerBg.addChild(pullBg);

        var listView = new ccui.ListView();
        listView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        listView.setTouchEnabled(true);
        listView.setBounceEnabled(true);
        listView.setAnchorPoint(0.5, 0.5);
        listView.setPosition(pullBg.width*0.5, pullBg.height * 0.5);
        listView.setContentSize(cc.size(pullBg.width - 10, pullBg.height - 10));
        pullBg.addChild(listView);

        var itemArray = ["骂人", "贴脸", "消极", "离线"];
        for(var i = 0; i < itemArray.length; i++) {
            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(listView.width, 47);
            defaultItemLayout.setTag(i+1);

            var itemText = new ccui.Text(itemArray[i], "Arial", 30);
            itemText.setAnchorPoint(0.5, 0.5);
            itemText.setColor(cc.color(255, 206, 111));
            itemText.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);

            defaultItemLayout.addChild(itemText, 1);
            listView.pushBackCustomItem(defaultItemLayout);
        }

        var inputLabel = new ccui.Text("更多信息：", "Arial", 30);
        inputLabel.setAnchorPoint(0, 0.5);
        inputLabel.setColor(cc.color(221, 190, 157));
        inputLabel.setPosition(50, innerBg.height - 340);
        innerBg.addChild(inputLabel);

        var inputBg = new ccui.ImageView(res.ReportInputBg_png);
        inputBg.setPosition(40, innerBg.height - 365);
        inputBg.setScale9Enabled(true);
        inputBg.setContentSize(480, 220);
        inputBg.setAnchorPoint(0, 1);
        innerBg.addChild(inputBg);

        var remainderCountText = new ccui.Text("今日剩余举报次数：5", "Arial", 25);
        remainderCountText.setPosition(innerBg.width/2, 60);
        remainderCountText.setColor(cc.color(255,210,0));
        innerBg.addChild(remainderCountText);

        var commitCountText = new ccui.Text("今日已举报次数：5", "Arial", 25);
        commitCountText.setPosition(innerBg.width/2, 25);
        commitCountText.setColor(cc.color(255,210,0));
        innerBg.addChild(commitCountText);

        var confirmButton = new ccui.Button(res.ReportDialogButtonBg_png, "", "");
        confirmButton.setPosition(bg.width/2 - 120, 70);
        confirmButton.addClickEventListener(function () {

        });
        bg.addChild(confirmButton);

        var confirmLabel = new ccui.ImageView(res.ReportLabel_png);
        confirmLabel.setPosition(confirmButton.width/2, confirmButton.height/2);
        confirmButton.addChild(confirmLabel);

        var cancelButton = new ccui.Button(res.ReportDialogButtonBg_png, "", "");
        cancelButton.setPosition(bg.width/2 + 120, 70);
        cancelButton.addClickEventListener(function () {

        });
        bg.addChild(cancelButton);

        var cancelLabel = new ccui.ImageView(res.ReportCancelLabel_png);
        cancelLabel.setPosition(cancelButton.width/2, cancelButton.height/2);
        cancelButton.addChild(cancelLabel);

        var closeButton = new ccui.Button(res.RedClose_png, res.RedClose_png);
        closeButton.setPosition(bg.width - 30, bg.height - 30);
        bg.addChild(closeButton);
        closeButton.addClickEventListener(function () {
            _this.hidden();
        });

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function() {
        cc.director.getRunningScene().addChild(this);
        this._listener.setSwallowTouches(true);
        this.setVisible(true);
    },

    //隐藏
    hidden: function() {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function() {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});