
var RoleIntroDialog = cc.LayerColor.extend({

    _listener:null,

    ctor: function(roleId) {
        this._super(cc.color.BLACK);
        cc.log('jijun ctor');
        this.setOpacity(140);       //透明度
        this._initDialog(roleId);

        return true;
    },

    onEnter: function()
    {
        this._super();
        var _this = this;
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                _this.hidden();
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initDialog: function(roleId)
    {
        //背景
        var bg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.director.getVisibleSize().width*0.5, cc.director.getVisibleSize().height*0.5);
        bg.setScale9Enabled(true);
        bg.setContentSize(cc.director.getVisibleSize().width*0.8, cc.director.getVisibleSize().height*0.3);
        this.addChild(bg, 0, 101);

        var card = new ccui.ImageView("res/"+ roleId + ".png");
        card.setAnchorPoint(0, 0.5);
        card.setScale(0.9, 0.9);
        card.setPosition(30, bg.height * 0.5);
        bg.addChild(card);

        var messageContent = new cc.LabelTTF("","Arial", 25);
        messageContent.boundingWidth = cc.director.getVisibleSize().width * 0.5;
        messageContent.boundingHeight = 0;
        messageContent.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
        messageContent.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);
        messageContent.setAnchorPoint(1, 0.5);
        messageContent.setPosition(bg.width - 30, bg.height * 0.5);
        messageContent.setString(RoleIntroMap.get(roleId));
        bg.addChild(messageContent);

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this);
        this._listener.setSwallowTouches(true);
        this.setVisible(true);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});