/**
 * Created by junji on 2017/2/1.
 */

var SettingDialog = cc.LayerColor.extend({

    _listener:null,

    ctor: function() {
        this._super(cc.color.BLACK);
        cc.log('jijun ctor');
        this.setOpacity(140);       //透明度
        this._initSettingDialog();

        return true;
    },

    onEnter: function() {
        this._super();
        var _this = this;
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                _this.hidden();
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initSettingDialog: function() {
        var _this = this;
        //背景
        var bg = new ccui.ImageView(res.CommonDialogBg_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.director.getVisibleSize().width*0.5, cc.director.getVisibleSize().height*0.5);
        bg.setScale9Enabled(true);
        bg.setContentSize(555, 740);
        this.addChild(bg, 0, 101);

        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setAnchorPoint(0.5, 0.5);
        titleBg.setScale(1.1);
        titleBg.setPosition(bg.width*0.5, bg.height);
        bg.addChild(titleBg);

        var titleText = new ccui.Text("设置", "Arial", 30);
        titleText.setTextColor(cc.color(251, 228, 178));
        titleText.setAnchorPoint(0.5, 0.5);
        titleText.setPosition(titleBg.width*0.5, titleBg.height*0.5);
        titleBg.addChild(titleText);

        var innerBg = new ccui.ImageView(res.CommonDialogInnerBg_png);
        innerBg.setScale9Enabled(true);
        innerBg.setContentSize(460, 300);
        innerBg.setAnchorPoint(0.5, 1);
        innerBg.setPosition(bg.width/2, bg.height - 70);
        bg.addChild(innerBg);

        var content = new ccui.Text("客服QQ:3454303381\nQQ交流群:542640823\n微信公众号:quanminsha\n版本号:"+Config.VERSION, "Arial", 28);
        content.setPosition(innerBg.width/2, innerBg.height/2);
        content.setColor(cc.color(255, 192, 0));
        innerBg.addChild(content);

        var shareButton = new ccui.Button(res.SettingButton_png, res.SettingButton_png);
        shareButton.setPosition(bg.width/2, 190);
        shareButton.addClickEventListener(function () {
            inviteFriend("全民狼人杀语音Online", "史上最专业最走心的狼人杀app，一起来玩吧!");
        });
        bg.addChild(shareButton);

        var shareLabel = new ccui.ImageView(res.ShareLabel_png);
        shareLabel.setPosition(shareButton.width/2, shareButton.height/2);
        shareButton.addChild(shareLabel);

        var logoutButton = new ccui.Button(res.SettingButton_png, res.SettingButton_png);
        logoutButton.setPosition(bg.width/2, 85);
        logoutButton.addClickEventListener(function () {
            TXIMSDK_logoutSucc = function(){
                cc.sys.localStorage.setItem("signinState", -1);
                cc.sys.localStorage.setItem("openId", "");
                cc.sys.localStorage.setItem("unionId", "");
                cc.sys.localStorage.setItem("userName", "");
                cc.sys.localStorage.setItem("passWord", "");
                DataManager.getInstance().getUserData().clear();
                DataManager.getInstance().getWorldMessageData().clear();
                DataManager.getInstance().getCurrentRoomData().clear();
                cc.director.runScene(new SigninScene());
            };
            TXIMSDK_logoutFail = function(code, msg){
                ToastUtil.systemToastInMiddle("登出失败：" + code.toString() + "->" + msg, 2.0);
            };
            TXIMSDK_logout();
        });
        bg.addChild(logoutButton);

        var logoutLabel = new ccui.ImageView(res.LogoutLabel_png);
        logoutLabel.setPosition(logoutButton.width/2, logoutButton.height/2);
        logoutButton.addChild(logoutLabel);

        var policyButton = new ccui.Button(res.SettingButton_png, "");
        policyButton.setPosition(bg.width/2, 295);
        policyButton.addClickEventListener(function () {
            var policyDialog = new PolicyDialog();
            policyDialog.popup();
        });
        bg.addChild(policyButton);

        var policyLabel = new ccui.ImageView(res.PolicyLabel_png);
        policyLabel.setPosition(policyButton.width/2, policyButton.height/2);
        policyButton.addChild(policyLabel);

        var closeButton = new ccui.Button(res.RedClose_png, res.RedClose_png);
        closeButton.setContentSize(90, 90);
        closeButton.setPosition(bg.width - 5, bg.height - 5);
        closeButton.setAnchorPoint(1, 1);
        closeButton.addClickEventListener(function () {
            _this.hidden();
        });
        bg.addChild(closeButton);

        this.setVisible(false);     //默认设置为不可见
    },

    //弹出
    popup: function() {
        cc.director.getRunningScene().addChild(this);
        this._listener.setSwallowTouches(true);
        this.setVisible(true);
    },

    //隐藏
    hidden: function() {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function() {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});