/**
 * Created by junji on 2017/2/1.
 */

var TaskItem = cc.Sprite.extend({

    ctor: function (taskTitle, taskContent, awardType, awardNum, gainState) {
        this._super();

        // 一些参数
        var _task_title = taskTitle;
        var _task_content = taskContent;
        var _task_pregress = "";
        var _task_award = ""+awardNum;
        var _task_awardType = awardType;
        var _task_gainState = gainState;

        // 添加任务项背景
        var bg = new ccui.ImageView(res.Task_item_back_png);
        bg.setName("bg");
        this.addChild(bg);

        // 获取任务项背景长宽
        var width = bg.getContentSize().width;
        var height = bg.getContentSize().height;

        // 添加任务LOGO
        var img_back = ccui.ImageView(res.Task_img_back_png);
        img_back.setPosition(90, height / 2);
        bg.addChild(img_back);

        var yueka = ccui.ImageView(res.Yueka_png);
        yueka.setPosition(90, height / 2);
        bg.addChild(yueka);

        // 添加任务标题
        var title = new cc.LabelTTF(_task_title, "Arial", 30);
        title.setAnchorPoint(0, 0.5);
        title.setColor(cc.color(85, 33, 19));
        title.setPosition(160, 116);
        bg.addChild(title);

        // 添加任务内容
        var content = new cc.LabelTTF(_task_content, "Arial", 20);
        content.setAnchorPoint(0, 0.5);
        content.setColor(cc.color(77, 30, 0));
        content.setPosition(160, 75);
        bg.addChild(content);

        // 添加任务进度
        var progress = new cc.LabelTTF(_task_pregress, "Arial", 20);
        progress.setAnchorPoint(1, 0.5);
        progress.setColor(cc.color(156, 100, 59));
        progress.setPosition(600, 116);
        bg.addChild(progress);

        // 添加任务奖励
        var jiangli = ccui.ImageView(res.Task_word_jiangli_png);
        jiangli.setAnchorPoint(0, 0.5);
        jiangli.setPosition(160, 40);
        bg.addChild(jiangli);

        var exp_back = ccui.ImageView(res.Task_exp_back_png);
        exp_back.setPosition(350, 40);
        bg.addChild(exp_back);

        var exp = ccui.ImageView(res.Diamond_png);
        if(_task_awardType == 1) {
            exp.loadTexture(res.AwardBox1_png);
        } else if(_task_awardType == 2) {
            exp.loadTexture(res.AwardBox2_png);
        } else if(_task_awardType == 3) {
            exp.loadTexture(res.AwardBox3_png);
        } else if(_task_awardType == 5) {
            exp.loadTexture(res.GoldCoin_png);
        }
        exp.setPosition(270, 40);
        bg.addChild(exp);

        var ratio = new cc.LabelTTF("x " + _task_award, "Arial", 20);
        ratio.setAnchorPoint(0, 0.5);
        ratio.setColor(cc.color(255, 255, 255));
        ratio.setPosition(320, 40);
        bg.addChild(ratio);

        // 添加前往任务具体界面按钮
        var button = new ccui.Button(res.Task_button_on_png, res.Task_button_down_png);
        button.setPosition(width - 100, 50);
        button.setName("getButton");
        button.addClickEventListener(function () {
            cc.log("ziaoang: hello world");
            // button.setVisible(false);
            // gettedLabel.setVisible(true);
            var taskApi = new TaskApi();
            taskApi.getMonthCard("getMonthCardResponse", function (data) {
            },function (data) {
            },function (data) {
            });
        });
        bg.addChild(button);

        var qianwang = ccui.ImageView(res.GetLabel_png);
        qianwang.setPosition(button.width/2, button.height/2);
        button.addChild(qianwang);

        var gettedLabel = new ccui.ImageView(res.GettedLabel_png);
        gettedLabel.setPosition(width - 100, 80);
        gettedLabel.setName("gettedLabel");
        bg.addChild(gettedLabel);

        if(_task_gainState == 1) {
            button.setVisible(true);
            gettedLabel.setVisible(false);
        } else {
            button.setVisible(false);
            gettedLabel.setVisible(true);
        }
    },

    changeGetState:function () {
        this.getChildByName("bg").getChildByName("getButton").setVisible(false);
        this.getChildByName("bg").getChildByName("gettedLabel").setVisible(true);
    },
});

var TaskDialog = cc.LayerColor.extend({

    _listener:null,

    _taskInfo:null,

    _task_list : null,
    _active_tab : 1,
    _bg : null,
    _width : 720,
    _height : 1160,

    ctor: function(taskInfo) {
        this._super(cc.color.BLACK);
        cc.log('jijun ctor');
        this.setOpacity(140);       //透明度
        this._taskInfo = taskInfo;
        this._initTaskDialog();

        return true;
    },

    onEnter: function()
    {
        this._super();
        //监听器
        cc.log("jijun onenter");
        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        //添加触摸监听
        cc.eventManager.addListener(this._listener, this);
    },

    //初始化对话框
    _initTaskDialog: function(voiceId)
    {
        var that = this;

        // 添加弹窗整体背景
        this._bg = new ccui.ImageView(res.CommonDialogBg_png);
        this._bg.setScale9Enabled(true);
        this._bg.setPosition(cc.winSize.width / 2, cc.winSize.height / 2);
        this._bg.setContentSize(this._width, this._height);
        this.addChild(this._bg, 0, 101);

        // 添加背景表头
        var bgTitle = new ccui.ImageView(res.DialogTitle2_png);
        bgTitle.setScale(1.1);
        bgTitle.setPosition(this._width / 2, this._height);
        this._bg.addChild(bgTitle);

        var titleText = new ccui.ImageView(res.Task_word_renwu_png);
        titleText.setPosition(bgTitle.width / 2, bgTitle.height / 2 + 20);
        bgTitle.addChild(titleText);

        // 添加关闭按钮
        var close = new ccui.Button(res.RedClose_png, res.RedClose_png);
        close.setAnchorPoint(1, 1);
        close.setContentSize(90, 90);
        close.setPosition(this._width, this._height);
        close.addClickEventListener(function(){
            that.hidden();
        });
        this._bg.addChild(close);

        // 添加TAB标签栏背景
        var top = new ccui.ImageView(res.Task_top_back_png);
        top.setAnchorPoint(0.5, 1);
        top.setPosition(this._width / 2, this._height - 70);
        this._bg.addChild(top);

        // 添加TAB标签栏内容
        var tab1 = new ccui.Button(res.Task_tab1_png, res.Task_tab1_png);
        tab1.setPosition(top.getContentSize().width / 2 - 200, top.getContentSize().height / 2);
        tab1.addClickEventListener(function(){
            //that.switchToTab(1);
        });
        top.addChild(tab1);

        var tab_title1 = new cc.LabelTTF("活动", "Arial", 28);
        tab_title1.setPosition(tab1.getContentSize().width / 2, 20);
        tab1.addChild(tab_title1);

        var tab2 = new ccui.Button(res.Task_tab2_png, res.Task_tab2_png);
        tab2.setPosition(top.getContentSize().width / 2, top.getContentSize().height / 2);
        tab2.addClickEventListener(function(){
            //that.switchToTab(2);
            ToastUtil.showToast("敬请期待...", 1.5);
        });
        top.addChild(tab2);

        var tab_title2 = new cc.LabelTTF("奖励", "Arial", 28);
        tab_title2.setPosition(tab2.getContentSize().width / 2, 20);
        tab2.addChild(tab_title2);

        var tab3 = new ccui.Button(res.Task_tab3_png, res.Task_tab3_png);
        tab3.setPosition(top.getContentSize().width / 2 + 200, top.getContentSize().height / 2);
        tab3.addClickEventListener(function(){
            //that.switchToTab(3);
            ToastUtil.showToast("敬请期待...", 1.5);
        });
        top.addChild(tab3);

        var tab_title3 = new cc.LabelTTF("任务", "Arial", 28);
        tab_title3.setPosition(tab3.getContentSize().width / 2, 20);
        tab3.addChild(tab_title3);

        this.switchToTab(this._active_tab);

        this.setVisible(false);     //默认设置为不可见
    },

    switchToTab: function (tabId) {

        if (this._task_list != null) {
            this._task_list.removeFromParent();
        }

        // 添加任务列表
        this._task_list = new ccui.ListView();
        this._task_list.setDirection(ccui.ScrollView.DIR_VERTICAL);
        this._task_list.setTouchEnabled(true);
        this._task_list.setBounceEnabled(true);
        this._task_list.setAnchorPoint(0.5, 1);
        this._task_list.setPosition(this._width / 2, this._height - 270);
        this._task_list.setContentSize(cc.size(this._width - 10, 850));

        // set size = 3 * tabId for test
        for(var i = 0; i < this._taskInfo.length; i ++) {

            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(this._width - 10, 153);
            defaultItemLayout.setTag(i + 1);

            var item = new TaskItem(this._taskInfo[i].title, this._taskInfo[i].detail,
                this._taskInfo[i].rewardList[0].rewardType, this._taskInfo[i].rewardList[0].rewardAmount,
                this._taskInfo[i].gainState);
            item.setAnchorPoint(0.5, 0.5);
            item.setName("item");
            item.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);
            defaultItemLayout.addChild(item);
            this._task_list.pushBackCustomItem(defaultItemLayout);
        }
        this._bg.addChild(this._task_list);
        this._active_tab = tabId;
    },

    changeGetState:function () {
        var itemList = this._task_list.getItems();
        for (var i = 0; i < itemList.length; i++) {
            itemList[i].getChildByName("item").changeGetState();
        }
        var currentScene = cc.director.getRunningScene();
        if(currentScene instanceof HallScene) {
            DataManager.getInstance().getUserData()._hasNewTask = 2;
            currentScene.clearTaskRedCircle();
        }
    },

    //弹出
    popup: function()
    {
        cc.director.getRunningScene().addChild(this, 100);
        this.setVisible(true);
        this._listener.setSwallowTouches(true);

        var bg = this.getChildByTag(101);
        bg.setScale(0);
        var scaleTo1 = new cc.ScaleTo(0.1, 1.25);
        var scaleTo2 = new cc.ScaleTo(0.1, 1);
        var actionArray = new Array();
        actionArray.push(scaleTo1);
        actionArray.push(scaleTo2);
        var sequence = new cc.Sequence(actionArray);
        bg.runAction(sequence);
    },

    //隐藏
    hidden: function()
    {
        this.setVisible(false);
        this._listener.setSwallowTouches(false);
        this.removeFromParent(true);
    },

    onExit: function()
    {
        this._super();
        cc.log("onexit");
        //移除触摸监听
        cc.eventManager.removeListener(this._listener);
    },

    cleanup:function () {
        this._super();
        cc.log("cleanup");
    },
});

function getMonthCardResponse(responseString) {
    var responseObj = JSON.parse(responseString);
    if (responseObj.retCode > 0) {
        if (responseObj.retCode == 1) {
            getMonthCardSuccess(responseObj.retBody);
        } else if (responseObj.retCode == 2) {
            getMonthCardResume(responseObj.retBody);
        }
    } else {
        getMonthCardFailed(responseObj.retCode);
    }
};

function getMonthCardSuccess(data) {
    var rewardArray = new Array();
    rewardArray.push("月卡剩余" + data.remainDays + "天");
    rewardArray.push("钻石 × " + data.diamond);
    DataManager.getInstance().getUserData()._diamond = data.totalDiamond;

    var taskDialog = cc.director.getRunningScene().getChildByTag(DialogType.TaskDialog);
    if(taskDialog != null && taskDialog != undefined) {
        taskDialog.changeGetState();
    }

    var currentScene = cc.director.getRunningScene();
    if(currentScene instanceof HallScene) {
        currentScene.updateDiamondAndCoin();
    }

    var rewardDialog = new BuyResultDialog("获得奖励",rewardArray);
    rewardDialog.popup();
};

function getMonthCardFailed(data) {
    cc.log(data);
};

function getMonthCardResume(data) {
    cc.log(data);
};