/*
 *  PropsSpineSprite
 *  Created by Lee on 2017-04-03
 */
var PropsSpineSprite =
{
    convertToWorldSpaceWithNodeCenterPos:function(node)
    {
        var worldPos = node.convertToWorldSpace(cc.p(node.getContentSize().width * 0.5,
                                                     node.getContentSize().height * 0.5));
        return worldPos;
    },

    playAninWithNode:function (propsID, srcNode, desNode, actEndCallBack)
    {
        var srcWorldPos = this.convertToWorldSpaceWithNodeCenterPos(srcNode);
        var desWorldPos = this.convertToWorldSpaceWithNodeCenterPos(desNode);
        this.playAninWithPos(propsID, srcWorldPos, desWorldPos, actEndCallBack);
    },

    playAninWithPos:function (propsID, srcWorldPos, desWorldPos, actEndCallBack)
    {
        var curScene = cc.Director.getInstance().getRunningScene();
        var spineRes = SpineResMap.get(propsID);
        var spriteImg = spineRes[0];
        var spineJson = spineRes[1];
        var altasFile = spineJson.substr(0, spineJson.lastIndexOf(".")) + ".atlas";
        var spineDefaultAnimName = spineRes[2];
        var desStr = spineRes[3];
        var desDiffWolrdPosY = spineRes[4];
        var propsSprite = new cc.Sprite(spriteImg);
        propsSprite.setScale(0);
        // propsSprite.setOpacity(0);
        var moveCall = function()
        {
            var spineFlower = new sp.SkeletonAnimation(spineJson, altasFile, 1.0);
            spineFlower.setPosition(desWorldPos.x, desWorldPos.y + desDiffWolrdPosY);
            spineFlower.setAnchorPoint(0.5, 0.5);
            spineFlower.setAnimation(0, spineDefaultAnimName, false);
            curScene.addChild(spineFlower);
            spineFlower.setEndListener(function(traceIndex)
            {
                var pNodeLab =  new cc.LabelBMFont(desStr, res.default_fnt);
                pNodeLab.setAnchorPoint(cc.p(0.5, 0.5));
                pNodeLab.setPosition(desWorldPos);
                pNodeLab.setString(desStr);
                pNodeLab.setScale(0.4);
                curScene.addChild(pNodeLab);
                pNodeLab.runAction(cc.Sequence(cc.MoveTo(1.0, cc.p(desWorldPos.x, desWorldPos.y + 100)),
                                                   cc.FadeOut(0.1), cc.callFunc(function ()
                                                   {
                                                        pNodeLab.removeFromParent()
                                                   })));
                spineFlower.runAction(cc.callFunc(function()
                {
                    spineFlower.removeFromParent();
                    if (actEndCallBack)
                    {
                        actEndCallBack();
                    }
                }))
            });
            propsSprite.removeFromParent();
        };
        var time = 0.002 * cc.pDistance(srcWorldPos, desWorldPos);
        propsSprite.setPosition(srcWorldPos);
        propsSprite.runAction(cc.Sequence(cc.Spawn(cc.ScaleTo(time / 2, 1), cc.MoveTo(time / 2, cc.p(desWorldPos.x * 2 / 3, desWorldPos.y))),
                                          cc.Spawn(cc.FadeOut(time / 2), cc.ScaleTo(time / 2, 0.2), cc.MoveTo(time / 3, cc.p(desWorldPos.x, desWorldPos.y))),
                                          cc.callFunc(moveCall)));

        curScene.addChild(propsSprite);
    }
}