/**
 * Created by junji on 2016/11/24.
 */
var CurrentRoomData = cc.Class.extend({

    _currentRoomData: null,

    _onLookerNum:0,
    _roomId:0,
    _roomName:"",
    _password:null,
    _roleConf:null,
    _totalPlayerNum:0,
    _currentPlayerMap:new Map(),
    _myRole:-1,
    _mySeatNumber:-1,
    _timeProcess:1,
    _roomState:2,

    _guardLastSelect:-1,
    _gagLastSelect:-1,

    _isOnLooker:true,

    ctor:function () {
        this._roleConf = new Array();
        this._currentPlayerMap = new Map();
    },

    parseFromObj:function (obj) {
        this._currentRoomData = obj;
        this._roomId = obj.roomId;
        this._roomName = obj.roomName;
        this._totalPlayerNum = obj.totalPlayerNum;
        this._onLookerNum = obj.onLookerNum;
        this._roleConf = obj.roleConf;
        this._roomState = obj.roomState;
        this._currentPlayerMap.clear();
        this._password = obj.password;
        for(var i = 0; i < obj.currentPlayerList.length; i++) {
            var playerInfo = obj.currentPlayerList[i];
            playerInfo.currentCard = res.Beimian_png;
            playerInfo.deathType = 1;
            if(DataManager.getInstance().getUserData()._userId == playerInfo.userId) {
                this._mySeatNumber = playerInfo.seatNumber;
                this._isOnLooker = false;
            }
            this._currentPlayerMap.put(obj.currentPlayerList[i].seatNumber, obj.currentPlayerList[i]);
        }
    },

    getSeatNumber:function (userId) {
        var elements = this._currentPlayerMap.elements;
        for(var i = 0; i < elements.length; i++) {
            if(elements[i].value.userId == userId) {
                return elements[i].key;
            }
        }
        return -1;
    },

    clear:function () {
        this._currentRoomData = null;
        this._onLookerNum = 0;
        this._roomId = 0;
        this._roomName = "";
        this._roleConf = new Array();
        this._totalPlayerNum = 0;
        this._currentPlayerMap.clear();
        this._myRole = -1;
        this._mySeatNumber = -1;
        this._timeProcess=1;
        this._guardLastSelect=-1;
        this._gagLastSelect=-1;
        this._isOnLooker = true;
        this._password = null;
    },

    gameReset:function (offlineUserSeatNumber) {
        for(var i = 1; i <= this._totalPlayerNum; i++) {
            if(this._currentPlayerMap.get(i) != null) {
                this._currentPlayerMap.get(i).currentCard = res.CardBg_png;
                this._currentPlayerMap.get(i).deathType = 1;
            }
        }
        for(var i = 0; i < offlineUserSeatNumber.length; i++) {
            this._currentPlayerMap.remove(offlineUserSeatNumber[i]);
        }
        this._guardLastSelect=-1;
        this._gagLastSelect=-1;
        this._timeProcess=1;
    },
});

CurrentRoomData.share = null;
CurrentRoomData.first = true;

CurrentRoomData.getInstance = function () {

    if (CurrentRoomData.first) {
        CurrentRoomData.first = false;
        CurrentRoomData.share = new CurrentRoomData();
    }
    return CurrentRoomData.share;
};