/**
 * Created by gexiao on 2016/11/3.
 */

var MqttClient = cc.Class.extend({

    _mqttClient:null,
    _mqttReconnectTimeout:2000,
    _mqttHost:"",
    _mqttPort:80,
    _mqttClientId:"",
    _mqttUserName:"",
    _mqttPassWord:"",
    _mqttRootTopic:"",
    _mqttCallbackMap:null,
    _mqttIsInit:false,
    _mqttMessageQueue:null,
    _mqttFirstSend:true,
    _currentTopicList:null,
    _isExcuteFinish:true,
    _lastMessage:"",
    _lastTopic:"",
    _lastSequenceId:-1,

    ctor:function () {
        this._mqttInit();
    },

     _mqttCallbackRegister:function(cmd, callback, target) {
        if(this._mqttIsInit == false) {
            cc.log("mqtt is not init");
            return ;
        }
        this._mqttCallbackMap.put(cmd,[callback, target]);
    },

    clearMqttMessageQueue:function(){
        MqttClient.getInstance()._mqttMessageQueue.clear();
        MqttClient.getInstance()._isExcuteFinish = true;
    },

    clearMqttCallBackMap:function () {
        MqttClient.getInstance()._mqttCallbackMap.clear();
    },

    _mqttCallbackUnRegister:function(cmd) {
        this._mqttCallbackMap.remove(cmd);
    },

    _mqttCallbackClear:function() {
        this._mqttCallbackMap.clear();
    },

    _onMqttConnectionLost:function(response) {
        // cc.log(new Date().getTime() + response.errorMessage);
        // setTimeout(MqttClient.getInstance()._processConnectLost(), MqttClient.getInstance()._mqttReconnectTimeout);
    },

    _processConnectLost:function () {
        var currentScene = cc.director.getRunningScene();
        if(currentScene instanceof HallScene) {
            MqttClient.getInstance()._mqttConnect();
        } else {
            cc.director.runScene(new HallScene("网络异常，请稍后重试..."));
            ToastUtil.showToastInMiddle("网络异常，正在重连", 2.0);
        }
    },

    _onMqttMessageArrived:function(messageTopic, messagePayload) {
        // var topic = message.destinationName;
        // var payload = message.payloadString;

        //防止消息到达两遍
        if(MqttClient.getInstance()._lastTopic == messageTopic && MqttClient.getInstance()._lastMessage == messagePayload) {
            return;
        } else {
            MqttClient.getInstance()._lastTopic = messageTopic;
            MqttClient.getInstance()._lastMessage = messagePayload;
        }

        var topic = messageTopic;
        var payload = messagePayload;
        cc.log(new Date().getTime() + " recv msg: " + topic + " " + payload);
        sendAliLog("message", "info", "recv msg: " + topic + " " + payload);
        var payloadObj = JSON.parse(payload);
        cc.log(new Date().getTime() + " parse over");
        sendAliLog("message", "info", " parse over");
        if(topic == (MqttClient.getInstance()._mqttRootTopic + "/world/")) {
            if(payloadObj instanceof  Array) {
                for(var i = 0; i < payloadObj.length; i++) {
                    MqttClient.getInstance()._mqttExcuteMessage(payloadObj[i]);
                }
            }
        } else {
            if (payloadObj instanceof Array) {
                for (var i = 0; i < payloadObj.length; i++) {
                    for (var j = 0; j < PriorityChange.length; j++) {
                        if (PriorityChange[j] == payloadObj[i].cmd)
                            payloadObj[i].priority = -1;
                    }
                    cc.log(new Date().getTime() + " change priority over");
                    sendAliLog("message", "info", "change priority over");

                    if (MqttClient.getInstance()._isLegal(topic, payloadObj[i])) {
                        cc.log(new Date().getTime() + " legal message");
                        sendAliLog("message", "info", "legal message");
                        if (payloadObj[i].priority == -1) { //消息不排队
                            MqttClient.getInstance()._mqttExcuteMessage(payloadObj  [i]);
                        } else { //消息排队
                            MqttClient.getInstance()._mqttMessageQueue.push(payloadObj[i]);
                            cc.log(new Date().getTime() + " push message over");
                            sendAliLog("message", "info", "push message over");

                            if (MqttClient.getInstance()._isExcuteFinish) {
                                MqttClient.getInstance()._isExcuteFinish = false;
                                MqttClient.getInstance()._mqttExcuteQueueMessage();
                            } else {
                                cc.log(new Date().getTime() + "message not finish");
                                sendAliLog("message", "info", "message not finish");
                            }
                        }
                    } else {
                        cc.log(new Date().getTime() + "illegal message");
                        sendAliLog("message", "info", "illegal message");
                    }
                }
            } else {
                cc.log(new Date().getTime() + " error message");
                sendAliLog("message", "info", "error message");
            }
        }
    },

    _mqttExcuteQueueMessage:function() {
        cc.log("appActivity _mqttExcteQueueMessage");
        var tmpPayloadObj = MqttClient.getInstance()._mqttMessageQueue.shift();
        if(tmpPayloadObj != null && tmpPayloadObj != undefined) {
            MqttClient.getInstance()._mqttExcuteMessage(tmpPayloadObj);
        } else {
            MqttClient.getInstance()._isExcuteFinish = true;
            cc.log("excute finish");
            sendAliLog("message", "info", "excute finish" );
        }
    },

    _mqttExcuteMessage:function(payloadObj) {
        if(payloadObj.sequenceId != (MqttClient.getInstance()._lastSequenceId + 1)) {
            if(payloadObj.cmd == GameCmd.RESUME_PUSH) {
                MqttClient.getInstance()._lastSequenceId = payloadObj.sequenceId;
            } else {
                //TODO 报警
//                ToastUtil.systemToastInMiddle("网络异常，消息遗漏...", 2.0);
            }
        }

        if(payloadObj.cmd == "worldMessagePush" && !(cc.director.getRunningScene() instanceof RoomScene)
            && !(cc.director.getRunningScene() instanceof HallScene)) {
            DataManager.getInstance().getWorldMessageData().addMessage(payloadObj);
        } else {
            if(payloadObj.cmd == GameCmd.RESUME_PUSH ||
                payloadObj.cmd == GameCmd.JOINROOM_RESPONSE ||
                payloadObj.cmd == GameCmd.REQUEST_RESUME_FAILED_RESPONSE) {
                resumeRequestSendFlag = false;
            }
            if(resumeRequestSendFlag) {
                cc.log(new Date().getTime() + "wait for resumeResponse");
                var event = new cc.EventCustom("do_next_event");
                cc.eventManager.dispatchEvent(event);
            } else {
                var payloadRoomId = payloadObj.roomId;
                var currentRoomId = DataManager.getInstance().getCurrentRoomData()._roomId;
                if(payloadRoomId != null && payloadRoomId != undefined && currentRoomId != null
                    && currentRoomId != undefined && currentRoomId != -1 &&
                    currentRoomId != payloadRoomId && payloadObj.cmd != GameCmd.JOINROOM_RESPONSE &&
                    payloadObj.cmd != GameCmd.RESUME_PUSH && payloadObj.cmd != GameCmd.JOINROOM_FAILED_RESPONSE &&
                    payloadObj.cmd != GameCmd.JOINROOM_WITH_PASSWORD_RESPONSE &&
                    payloadObj.cmd != GameCmd.QUICKJOINROOM_FAILED_RESPONSE && payloadObj.cmd != GameCmd.CREATE_ROOM_FAILED_RESPONSE) {
                    cc.log("message roomId error");
                    var event = new cc.EventCustom("do_next_event");
                    cc.eventManager.dispatchEvent(event);
                } else {
                    var param = MqttClient.getInstance()._mqttCallbackMap.get(payloadObj.cmd);
                    if (param != undefined && param != null) {
                        var call = param[0];
                        cc.log(new Date().getTime() + "excute " + payloadObj.cmd);
                        sendAliLog("message", "info", " cmd excute " + payloadObj.cmd);
                        call(payloadObj, param[1]);
                    } else {
                        cc.error(new Date().getTime() + " cmd not excute " + payloadObj.cmd);
                        sendAliLog("message", "error", " cmd not excute " + payloadObj.cmd);
                        var event = new cc.EventCustom("do_next_event");
                        cc.eventManager.dispatchEvent(event);
                    }
                }
            }
        }
    },

    _onMqttMessageDelivered:function(message) {
        if(MqttClient.getInstance()._mqttFirstSend)
            MqttClient.getInstance()._mqttFirstSend = false;
        cc.log(new Date().getTime() + "delivered msg : " + message.destinationName + " " + message.payloadString);
        sendAliLog("message", "info", "delivered msg : " + message.destinationName + " " + message.payloadString);
    },

    _mqttInit:function() {
       // this._mqttClientId = "CID_DISPATCHER@@@ClientID_" + userId;
       // if(SoftVersion == VersionConfig.RELEASE || 1) {
       //     this._mqttClientId = "GID_Dispatcher@@@ClientID_" + userId;
       // }

       // cc.log("mqtt client Id: " + this._mqttClientId);

        // this._mqttClient = new Paho.MQTT.Client(
        //     this._mqttHost,//MQTT域名
        //     this._mqttPort,//WebSocket端口
        //     this._mqttClientId//客户端ClientId
        // );

        //this._mqttClient.onMessageArrived = this._onMqttMessageArrived;
        //this._mqttClient.onMessageDelivered = this._onMqttMessageDelivered;
        //this._mqttClient.onConnectionLost = this._onMqttConnectionLost;
        this._mqttCallbackMap = new Map();
        this._mqttMessageQueue = new Queue();
        this._currentTopicList = new Array();
        this._mqttIsInit = true;
        cc.eventManager.addListener(cc.EventListener.create({
            event: cc.EventListener.CUSTOM,
            eventName: "do_next_event",
            callback: this._mqttExcuteQueueMessage,
        }), 1);
    },

    _mqttIsConnected:function() {
        // if(MqttClient.getInstance()._mqttClient != null && MqttClient.getInstance()._mqttClient.isConnected())
        //     return true;
        // else
        //     return false;
    },

    _onMqttConnect:function(invocationContext){
        // // Connection succeeded; subscribe to our topic
        // cc.log("mqtt connect success");
        // sendAliLog("message", "info", "mqtt connect success");
        // cc.log(MqttClient.getInstance()._mqttRootTopic + "/p2p/" + MqttClient.getInstance()._mqttClientId);
        // if(MqttClient.getInstance()._mqttClientId != null) {
        //     cc.log("mqtt subscribe");
        //     cc.log(MqttClient.getInstance()._mqttRootTopic
        //         + "/p2p/" + MqttClient.getInstance()._mqttClientId + "/");
        //     MqttClient.getInstance()._mqttClient.subscribe(MqttClient.getInstance()._mqttRootTopic
        //         + "/p2p/" + MqttClient.getInstance()._mqttClientId,
        //         {
        //             qos: 2,
        //             onSuccess:function (response) {
        //                 cc.log("init p2p topic success");
        //                 sendAliLog("message", "info", "init p2p topic " + MqttClient.getInstance()._mqttRootTopic
        //                     + "/p2p/" + MqttClient.getInstance()._mqttClientId + "/" + "success");
        //                 MqttClient.getInstance()._addCurrentTopic(MqttClient.getInstance()._mqttRootTopic
        //                     + "/p2p/" + MqttClient.getInstance()._mqttClientId + "/");
        //             },
        //             onFailure:function (response) {
        //                 cc.log("init p2p topic failed");
        //                 sendAliLog("message", "info", "init p2p topic " + MqttClient.getInstance()._mqttRootTopic
        //                     + "/p2p/" + MqttClient.getInstance()._mqttClientId + "/" + " failed");
        //             }
        //         });
        //
        //     MqttClient.getInstance()._mqttClient.subscribe(MqttClient.getInstance()._mqttRootTopic
        //         + "/world/",
        //         {
        //             qos: 2,
        //             onSuccess:function (response) {
        //                 cc.log("init world topic success");
        //                 sendAliLog("message", "info", "init world topic " + MqttClient.getInstance()._mqttRootTopic
        //                     + "/world/" + " success");
        //                 MqttClient.getInstance()._addCurrentTopic(MqttClient.getInstance()._mqttRootTopic
        //                     + "/world/");
        //             },
        //             onFailure:function (response) {
        //                 cc.log("init world topic failed");
        //                 sendAliLog("message", "info", "init world topic " + MqttClient.getInstance()._mqttRootTopic
        //                     + "/world/" + " failed");
        //             }
        //         });
        // }
    },

    _isLegal:function(topic, payloadObj) {
        // var isLegalTopic = false;
        // for(var i = 0; i < this._currentTopicList.length; i++) {
        //     if(this._currentTopicList[i] == topic) {
        //         isLegalTopic = true;
        //         break;
        //     }
        // }
        // if(!isLegalTopic)
        //     return false;
        // if(payloadObj.sequenceId < (new Date().getTime() - 120000))
        //     return false;
        // if(MqttClient.getInstance()._mqttFirstSend)
        //     return false;

        return true;
    },

    _mqttConnect:function() {
        // var _this = this;
        // var options = {
        //     timeout: 3,
        //     onSuccess: MqttClient.getInstance()._onMqttConnect,
        //     onFailure: MqttClient.getInstance()._onMqttConnectionLost,
        //     userName: MqttClient.getInstance()._mqttUserName,
        //     password: MqttClient.getInstance()._mqttPassWord,
        // };
        // MqttClient.getInstance()._mqttClient.connect(options);
    },

    _addCurrentTopic:function (topic) {
        MqttClient.getInstance()._currentTopicList.push(topic);
    },

    _removeCurrentTopic:function (topic) {
        var bln = false;
        try {
            for (var i = 0; i < this._currentTopicList.length; i++) {
                if (this._currentTopicList[i] == topic) {
                    this._currentTopicList.splice(i, 1);
                    return true;
                }
            }
        } catch (e) {
            bln = false;
        }
        return bln;
    },

    // _subscribeMqttTopic:function(topic, onSuccess, onFailed) {
    //     var option = {
    //         qos:2,
    //         onSuccess:onSuccess,
    //         onFailure:onFailed
    //     };
    //     //MqttClient.getInstance()._mqttClient.subscribe(MqttClient.getInstance()._mqttRootTopic + topic, option);
    // },

    // _unsubscribeMqttTopic:function(topic, onSuccess, onFailed) {
    //     var option = {
    //         onSuccess:onSuccess,
    //         onFailure:onFailed
    //     };
    //     MqttClient.getInstance()._mqttClient.unsubscribe(MqttClient.getInstance()._mqttRootTopic + topic, option);
    // },

    _sendMqttMessage:function(messageContent) {
        // var message = new Paho.MQTT.Message(messageContent);//set body
        // message.destinationName = MqttClient.getInstance()._mqttRootTopic+"/notice/";// set topic
        // MqttClient.getInstance()._mqttClient.send(message);

        if(cc.sys.os === cc.sys.OS_ANDROID) {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "sendMqttMessage", "(Ljava/lang/String;)V", messageContent);
        } else if(cc.sys.os === cc.sys.OS_IOS)  {
            //TODO IOS mqttSend
            cc.log("游戏进入前台3");
            jsb.reflection.callStaticMethod("MqttSDK", "sendWithMessage:", messageContent);
        }
    }
});

function connectionLost() {
    if(_gcloudvoice != null && _gcloudvoice != undefined) {
        _gcloudvoice.closeSpeaker();
        _gcloudvoice.closeMic();
    }

    if(cc.director.getRunningScene() instanceof RoomScene) {
        cc.director.runScene(new ResumeLoadingScene());
    }
};

MqttClient.shared = null;
MqttClient.first = true;

MqttClient.getInstance = function () {
    if (MqttClient.first) {
        MqttClient.first = false;
        MqttClient.shared = new MqttClient();
    }
    return MqttClient.shared;
};
