/**
 * Created by junji on 2016/11/19.
 */
var MqttHelper = cc.Class.extend({
    ctor: function () {
    },

    getCommonParams:function () {
        var params = new Object();
        params.clientVersion = "v1.0";
        params.protocalVersion = "v1.0";
        params.userId = DataManager.getInstance().getUserData()._userId;
        return params;
    },

    createRoom: function (roomName, totalPlayerNum , roleList, isEncrypted, password, roomclassid) {
        createRoomSendFlag = true;
        createRoomSendTime = new Date().getTime();

        var params = this.getCommonParams();
        params.cmd = "createRoomRequest";
        params.totalPlayerNum = totalPlayerNum;
        params.roomName = roomName;
        params.maxEscapeRate = 100;
        params.minCupNum = 0;
        params.isEncrypted = isEncrypted;
        params.roomPassword = password;
        params.hallRoomStandard = 10;
        params.speechTime = 60;
        params.witchSaveConfig = 1;
        params.roleList = roleList;
        params.roomclassid = roomclassid;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));

        var lastRoomId = cc.sys.localStorage.getItem("lastRoomId");
        if(lastRoomId != null && lastRoomId != undefined && lastRoomId != -1) {
            _gcloudvoice.quitTeamRoom("channel" +  lastRoomId, 5000);
        }
    },

    quickJoinRoom: function () {
        quickJoinRoomSendFlag = true;
        quickJoinRoomSendTime = new Date().getTime();

        var params = this.getCommonParams();
        params.cmd = "quickJoinRoomRequest";

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));

        var lastRoomId = cc.sys.localStorage.getItem("lastRoomId");
        if(lastRoomId != null && lastRoomId != undefined && lastRoomId != -1) {
            _gcloudvoice.quitTeamRoom("channel" +  lastRoomId, 5000);
        }
    },

    joinRoom: function (roomId) {
        joinRoomSendFlag = true;
        joinRoomSendTime = new Date().getTime();

        var params = this.getCommonParams();
        params.cmd = "joinRoomRequest";
        params.roomId = roomId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));

        var lastRoomId = cc.sys.localStorage.getItem("lastRoomId");
        if(lastRoomId != null && lastRoomId != undefined && lastRoomId != -1) {
            _gcloudvoice.quitTeamRoom("channel" +  lastRoomId, 5000);
        } else {
            cc.log("last room id error");
        }
    },

    prepareRequest: function (roomId) {
        var params = this.getCommonParams();
        params.cmd = "prepareRequest";
        params.roomId = roomId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));

        readySendFlag = true;
        readySendTime = new Date().getTime();
    },

    cancelPrepareRequest: function (roomId) {
        var params = this.getCommonParams();
        params.cmd = "cancelPrepareRequest";
        params.roomId = roomId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));

        cancelReadySendFlag = true;
        cancelReadySendTime = new Date().getTime();
    },

    rogueSelectResultRequest : function (role) {
        var params = this.getCommonParams();
        params.cmd = "rogueSelectResultRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.role = role;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    cupidSelectResultRequest:function (userId1, userId2) {
        var params = this.getCommonParams();
        params.cmd = "cupidSelectResultRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.targetUserId1 = userId1;
        params.targetUserId2 = userId2;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    stalkerSelectResultRequest:function (useSkill) {
        var params =  this.getCommonParams();
        params.cmd = "stalkerSelectResultRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.useSkill = useSkill;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    policeCompeteResultRequest:function (isCompete) {
        var params = this.getCommonParams();
        params.cmd = "policeCompeteResultRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.isCompete = isCompete;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    witchSelectResultRequest:function (useAntidote, usePoison, targetUserId) {
        var params = this.getCommonParams();
        params.cmd = "witchSelectResultRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.useAntidote = useAntidote;
        params.usePoison = usePoison;
        params.targetUserId =targetUserId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    organizeSpeechResultRequest:function (speechOrder) {
        var params = this.getCommonParams();
        params.cmd = "organizeSpeechResultRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.speechOrder = speechOrder;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    finishSpeechRequest:function () {
        var params = this.getCommonParams();
        params.cmd = "finishSpeechRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    quitRoomRequest:function () {
        var params = this.getCommonParams();
        params.cmd = "quitRoomRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));

        quitRoomSendFlag = true;
        quitRoomSendTime = new Date().getTime();
    },

    textSpeechRequest:function (speechText) {
        var params = this.getCommonParams();
        params.cmd = "textSpeechRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.speechText = speechText;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    worldMessageRequest:function (message) {
        var params = this.getCommonParams();
        params.cmd = "worldMessageRequest";
        params.nickName = DataManager.getInstance().getUserData()._nickname;
        params.userAvatar = DataManager.getInstance().getUserData()._currentSkin;
        params.messageText = message;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    quitPoliceCompeteRequest:function () {
        var params = this.getCommonParams();
        params.cmd = "quitPoliceCompeteRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    resumeRequest:function () {
        var params = this.getCommonParams();
        params.cmd = "resumeRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    voiceMemberIdRequest:function (voiceMemberId) {
        var params = this.getCommonParams();
        params.cmd = "voiceMemberIdRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.voiceMemberId = voiceMemberId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    inSeatRequest:function () {
        var params = this.getCommonParams();
        params.cmd = "inSeatRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    transferPoliceResultRequest:function (userId) {
        this.commonChooseTarget("transferPoliceResultRequest", userId);
    },

    votePoliceResultRequest:function (userId) {
        this.commonChooseTarget("votePoliceResultRequest", userId);
    },

    wolfSelectResultRequest:function (userId) {
        this.commonChooseTarget("wolfSelectResultRequest", userId);
    },

    prophetSelectResultRequest:function (userId) {
        this.commonChooseTarget("prophetSelectResultRequest", userId);
    },

    wildchildSelectResultRequest:function (userId) {
        this.commonChooseTarget("wildchildSelectResultRequest", userId);
    },

    guardSelectResultRequest:function (userId) {
        this.commonChooseTarget("guardSelectResultRequest", userId);
    },

    gagelderSelectResultRequest:function (userId) {
        this.commonChooseTarget("gagelderSelectResultRequest", userId);
    },

    voteResultRequest:function (userId) {
        this.commonChooseTarget("voteResultRequest", userId);
    },

    policeCallVoteSelectResultRequest:function (userId) {
        this.commonChooseTarget("policeCallVoteSelectResultRequest", userId);
    },

    hunterKillResultRequest:function (userId) {
        this.commonChooseTarget("hunterKillResultRequest", userId);
    },

    whiteWolfKingSelectResultRequest:function (userId) {
        this.commonChooseTarget("whiteWolfKingSelectResultRequest", userId);
    },

    planeVoteResultRequest:function (userId) {
        this.commonChooseTarget("planeVoteResultRequest", userId);
    },

    chooseMvpResultRequest:function (userId) {
        this.commonChooseTarget("chooseMvpResultRequest", userId);
    },

    userKickOutRequest:function (userId) {
        this.commonChooseTarget("userKickOutRequest", userId);
    },

    userGagRequest:function (userId) {
        this.commonChooseTarget("userGagRequest", userId);
    },

    gestureSelectResultRequest:function (userId, gestureList) {
        var params = this.getCommonParams();
        params.cmd = "gestureSelectResultRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.gestureList = gestureList;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    explodeRequest:function (role) {
        var params = this.getCommonParams();
        params.cmd = "explodeRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.role = role;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    verifyPasswordRequest:function (hallRoomId, password) {
        var params = this.getCommonParams();
        params.cmd = "verifyPasswordRequest";
        params.roomId = hallRoomId;
        params.password = password;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    commonChooseTarget:function (cmd, userId) {
        var params = this.getCommonParams();
        params.cmd = cmd;
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.targetUserId = userId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    roomSendGiftRequest:function (fromUserSeatNumber, toUserSeatNumber, giftType, fromUserId) {
        var params = this.getCommonParams();
        params.cmd = "roomSendGiftRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.toSeatNumber = toUserSeatNumber;
        params.fromSeatNumber = fromUserSeatNumber;
        params.giftType = giftType;
        params.fromUserId = fromUserId;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },

    roomAddFriendRequest:function (fromUserSeatNumber, toUserSeatNumber) {
        var params = this.getCommonParams();
        params.cmd = "roomAddFriendRequest";
        params.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
        params.toSeatNumber = toUserSeatNumber;
        params.fromSeatNumber = fromUserSeatNumber;

        MqttClient.getInstance()._sendMqttMessage(JSON.stringify(params));
    },
});

MqttHelper.shared = null;
MqttHelper.first = true;

MqttHelper.getInstance = function () {
    if (MqttHelper.first) {
        MqttHelper.first = false;
        MqttHelper.shared = new MqttHelper();
    }
    return MqttHelper.shared;
};