/**
 * Created by junji on 2017/3/15.
 */

var ResumeLoadingLayer = cc.LayerColor.extend({
    ctor: function () {
        this._super();

        cc.log("resumeloading layer ctor");
        this.setOpacity(140);       //透明度

        this.initUI();
    },

    initUI:function () {
        var bg = new ccui.ImageView(res.LoadingOut_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.winSize.width*0.5, cc.winSize.height*0.5);
        this.addChild(bg, 0, 101);

        var inner = new ccui.ImageView(res.LoadingIn_png);
        inner.setAnchorPoint(0.5, 0.5);
        inner.setPosition(bg.width * 0.5, bg.height * 0.5);
        bg.addChild(inner);
    }
});

var ResumeLoadingScene = cc.Scene.extend({

    roomResumePush:function (payloadObj) {
        resumeRequestSendFlag = false;

        cc.log("resumeloading roomResumePush");
        DataManager.getInstance().getCurrentRoomData().clear();
        DataManager.getInstance().getResumeData().parseData(payloadObj);

        notifySceneShow();

        cc.director.runScene(new RoomScene(true));
    },

    requestResumeFailedResponse:function (payloadObj) {
        resumeRequestSendFlag = false;
        cc.log("resumeloading requestResumeFailedResponse");
        //quitTecentRoom(false, payloadObj.message);
        _gcloudvoice.quitTeamRoom(getChannelName(), 5000);
        DataManager.getInstance().getCurrentRoomData().clear();
        cc.director.runScene(new HallScene());
    },

    roomJoinRoomResponse:function (payloadObj) {
        resumeRequestSendFlag = false;
        cc.log("resumeloading roomJoinRoomResponse");
        DataManager.getInstance().getCurrentRoomData().clear();
        DataManager.getInstance().getCurrentRoomData().parseFromObj(payloadObj);

        notifySceneShow();

        cc.director.runScene(new RoomScene(false));
    },

    ctor:function () {
        this._super();
        cc.log("resumeloading ctor");

        var layer = new ResumeLoadingLayer();
        this.addChild(layer);

        MqttClient.getInstance().clearMqttCallBackMap();

        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.RESUME_PUSH, this.roomResumePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.REQUEST_RESUME_FAILED_RESPONSE, this.requestResumeFailedResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.JOINROOM_RESPONSE, this.roomJoinRoomResponse);
    },

    onEnter: function () {
        this._super();
        cc.log("resumeloading onEnter");

        this.scheduleUpdate();
    },

    update:function (delta) {
        if(cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
            if(_gcloudvoice != null && _gcloudvoice != undefined) {
                _gcloudvoice.poll();
            } else {
                cc.director.runScene(new HallScene("语音发生异常，请稍后重试..."));
            }
        }
    }
});