/**
 * Created by junji on 2016/11/20.
 */

var roomBgLayer;
var roomCardLayer;
var roomMenuLayer;
var slideDialog;

var userGagId = -1;

var inGameFlag = false;
var showMicIconEnable = true;
var isInTecentRoom = false;
var gameState = -1;

var joinInTecentRoomFailedTimes = 0;
var quitTecentRoomFailedTimes = 0;

var _lastShowMicIconTime = null;

var readySendFlag = false;
var cancelReadySendFlag = false;
var quitRoomSendFlag = false;
var readySendTime = 0;
var cancelReadySendTime = 0;
var quitRoomSendTime = 0;

var myTecentMemberId = -1;

var _isResume = false;

var tecentErrorMessage = null;
var isInCountDownProcess = false;

function openSpeaker(showToastFlag) {
    if(_gcloudvoice != null) {
        var result = _gcloudvoice.openSpeaker();
        if (result != 0) {
            if(showToastFlag || showToastFlag == null || showToastFlag == undefined) {
                ToastUtil.systemToastInMiddle("打开听筒失败，请退出房间重试...", 2.0);
                sendAliLog("speech", "info", "openSpeaker error " + result +
                    " roomId: " + DataManager.getInstance().getCurrentRoomData()._roomId);
            }
        }
    }
};

function openMic(showToastFlag) {
    if(_gcloudvoice != null) {
        var result = _gcloudvoice.openMic();
        if (result != 0) {
            if(showToastFlag || showToastFlag == null || showToastFlag == undefined) {
                ToastUtil.systemToastInMiddle("打开话筒失败，请退出房间重试...", 2.0);
                sendAliLog("speech", "info", "openMic error " + result +
                    " roomId: " + DataManager.getInstance().getCurrentRoomData()._roomId);
            }
        } else {
            var speechButton = roomMenuLayer.getChildByName("speechButton");
            if (speechButton != null && speechButton != undefined && !speechButton.isVisible()) {
                ToastUtil.systemToastInMiddle("连麦成功，您可直接说话", 2.0);
            }
        }
    }
};

function closeSpeaker(showToastFlag) {
    if(_gcloudvoice != null) {
        var result = _gcloudvoice.closeSpeaker();
        if (result != 0) {
            if(showToastFlag || showToastFlag == null || showToastFlag == undefined) {
                ToastUtil.systemToastInMiddle("关闭听筒失败，请退出房间重试...", 2.0);
                sendAliLog("speech", "info", "closeSpeaker error " + result +
                    " roomId: " + DataManager.getInstance().getCurrentRoomData()._roomId);
            }
        }
    }
};

function closeMic(showToastFlag) {
    if(_gcloudvoice != null) {
        var result = _gcloudvoice.closeMic();
        if (result != 0) {
            if(showToastFlag || showToastFlag == null || showToastFlag == undefined) {
                ToastUtil.systemToastInMiddle("关闭话筒失败，请退出房间重试...", 2.0);
                sendAliLog("speech", "info", "closeMic error " + result +
                    " roomId: " + DataManager.getInstance().getCurrentRoomData()._roomId);
            }
        }
    }
};

function quitTecentRoom(sendQuitMessageFlag, message) {
    if(sendQuitMessageFlag) {
        if(isMqttConnected()) {
            MqttHelper.getInstance().quitRoomRequest();
        }
    }

    if(isInTecentRoom) {
        tecentErrorMessage = message;
        _gcloudvoice.quitTeamRoom(getChannelName(), 5000);
    } else {
        DataManager.getInstance().getCurrentRoomData().clear();
        cc.director.runScene(new HallScene(message));
    }
};

var RoomBgLayer = cc.Layer.extend({
    ctor:function () {
        this._super();

        var bg = new ccui.ImageView(res.BigRoomBg_png);
        bg.setAnchorPoint(0.5, 0.5);
        bg.setPosition(cc.winSize.width/2, cc.winSize.height/2);
        this.addChild(bg);

        var bottomBar = new ccui.ImageView(res.RoomBottomBar_PNG);
        bottomBar.setAnchorPoint(0,0);
        bottomBar.setPosition(0,0);
        this.addChild(bottomBar);

        var topMask = new cc.LayerColor(cc.color(0, 0, 0, 120));
        topMask.ignoreAnchor = false;
        topMask.setContentSize(BaseWindowConf.WIDTH, 140);
        topMask.x = 0;
        topMask.y = cc.winSize.height - 140;
        this.addChild(topMask);

        var topBar = new ccui.ImageView(res.RoomTopBar_png);
        topBar.setAnchorPoint(0,1);
        topBar.setPosition(0,cc.winSize.height);
        this.addChild(topBar);
    },
});

var RoomCardLayer = cc.Layer.extend({

    _listener1:null,
    _listener2:null,

    ctor:function () {
        this._super();

        this.generateCard(4,4, cc.winSize.width*0.96, cc.winSize.height*0.75);

        this._listener1 = cc.eventManager.addListener(cc.EventListener.create({
            event: cc.EventListener.CUSTOM,
            eventName: "changeRole_event",
            callback: this.flipCard,
        }), 1);

        this._listener2 = cc.eventManager.addListener(cc.EventListener.create({
            event: cc.EventListener.CUSTOM,
            eventName: "dialogChoose_event",
            callback: this.dialogChoose,
        }), 1);
    },

    onExit:function () {
        this._super();
        cc.eventManager.removeListener(this._listener1);
        cc.eventManager.removeListener(this._listener2);
    },

    generateCard: function (row, col, width, height) {
        var totalPlayerNum = DataManager.getInstance().getCurrentRoomData()._totalPlayerNum;
        cc.log("jijun generateCard" + totalPlayerNum);
        for(var i = 0; i < row; i++) {
            for (var j = 0; j < col; j++) {
                if (i * col + j + 1 > totalPlayerNum)
                    break;

                var cardBg = new ccui.Button(res.CardBg_png, res.CardBg_png, "");
                cardBg.setName("cardOut");
                cardBg.setScale9Enabled(true);
                cardBg.setAnchorPoint(0.5, 0);
                cardBg.setTag(i * col + j + 1);
                cardBg.setPosition(cardBg.width / 2, 0);
                cardBg.addClickEventListener(function () {
                    var seatNumber = this.getTag();
                    var playerInfo = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber);
                    if (playerInfo != undefined && playerInfo != null) {
                        var myRole = DataManager.getInstance().getCurrentRoomData()._myRole;
                        if(myRole != -1 && playerInfo.userId == DataManager.getInstance().getUserData()._userId) {
                            var roleIntroDialog = new RoleIntroDialog(myRole);
                            roleIntroDialog.popup();
                        } else {
                            otherHomePageResponse = function (responseString) {
                                if(responseString == null || responseString == "" || responseString == undefined) {
                                    ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
                                } else {
                                    var responseObj = JSON.parse(responseString);
                                    if (responseObj.retCode > 0) {
                                        if (responseObj.retCode == 1) {
                                            otherHomePageSuccess(responseObj.retBody);
                                        } else if (responseObj.retCode == 2) {
                                            otherHomePageResume(responseObj.retBody);
                                        }
                                    } else {
                                        otherHomePageFailed(responseObj.retCode);
                                    }
                                }
                            };
                            var personalPageApi = new PersonalPageApi();
                            personalPageApi.getPersonInfo(playerInfo.userId, "otherHomePageResponse", function () {
                            }, function () {
                            }, function () {
                            });
                        }
                    }
                });

                var hSpace = (width - cardBg.width * col) / (col - 1);
                var vSpace = (height - cardBg.height * row) / (row - 1);

                var cardLayout = new ccui.Layout();
                cardLayout.setLayoutType(ccui.Layout.ABSOLUTE);
                cardLayout.setAnchorPoint(0, 1);
                cardLayout.setName("card" + (i * col + j + 1));
                cardLayout.setContentSize(cardBg.width, cardBg.height);
                cardLayout.setPosition(cardBg.width * j + (cc.winSize.width - width) / 2 + j * hSpace,
                    cardBg.height * (row - i) + (cc.winSize.height - height) / 2 + (row - 1 - i) * vSpace + 25);
                this.addChild(cardLayout);
                cc.log("spineMic1 --- --- zbf");
                var spineMic1 = new sp.SkeletonAnimation('res/spine/maikefeng.json', 'res/spine/maikefeng.atlas', 1.0);
                spineMic1.setPosition(cardLayout.x + cardLayout.width * 0.18, cardLayout.y - cardLayout.height * 0.7);
                spineMic1.setScale(0.45,0.45);
                spineMic1.setAnchorPoint(0.5, 0.5);
                spineMic1.setAnimation(0, 'maikefeng', true);
                spineMic1.setVisible(false);
                spineMic1.setName("spineMic" + (i * col + j + 1));
                this.addChild(spineMic1, 100);

                var cardIn = new ccui.Button(res.Beimian_png, res.Beimian_png, "");
                cardLayout.addChild(cardIn);
                cardLayout.addChild(cardBg);
                cardIn.setName("cardIn");
                cardIn.setScale9Enabled(true);
                cardIn.setAnchorPoint(0.5, 0);
                cardIn.setTag(i * col + j + 1);
                cardIn.setPosition(cardBg.width / 2, 0);
                cardIn.setScaleX(0);
                cardIn.addClickEventListener(function () {
                    // var roleIntroDialog = new RoleIntroDialog(101);
                    // roleIntroDialog.popup();
                    var seatNumber = this.getTag();
                    var playerInfo = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber);
                    if (playerInfo != undefined && playerInfo != null) {
                        if(playerInfo.userId != DataManager.getInstance().getUserData()._userId) {
                            otherHomePageResponse = function (responseString) {
                                if(responseString == null || responseString == "" || responseString == undefined) {
                                    ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
                                } else {
                                    var responseObj = JSON.parse(responseString);
                                    if (responseObj.retCode > 0) {
                                        if (responseObj.retCode == 1) {
                                            otherHomePageSuccess(responseObj.retBody);
                                        } else if (responseObj.retCode == 2) {
                                            otherHomePageResume(responseObj.retBody);
                                        }
                                    } else {
                                        otherHomePageFailed(responseObj.retCode);
                                    }
                                }
                            };
                            var personalPageApi = new PersonalPageApi();
                            personalPageApi.getPersonInfo(playerInfo.userId, "otherHomePageResponse", function () {
                            }, function () {
                            }, function () {
                            });
                        } else {
                            var myRole = DataManager.getInstance().getCurrentRoomData()._myRole;
                            if(myRole != -1) {
                                var roleIntroDialog = new RoleIntroDialog(myRole);
                                roleIntroDialog.popup();
                            }
                        }
                    }
                });

                //var cupBg = new ccui.ImageView(res.CupBg_png);
                //cupBg.setAnchorPoint(0.5, 1);
                //cupBg.setPosition(cardBg.width / 2, cardBg.height - 3);
                //cupBg.setName("cupBg");
                //cardLayout.addChild(cupBg);

                var cup = new ccui.ImageView(res.Cup_png);
                cup.setAnchorPoint(0.5, 1);
                cup.setPosition(cardBg.width / 2 - 33, cardBg.height - 4);
                cup.setName("cup");
                cup.setScale(0.5);
                cardLayout.addChild(cup);

                var cupText = new ccui.Text("", "Verdana-Bold", 18);
                cupText.setAnchorPoint(0.5, 1);
                cupText.setPosition(cardBg.width / 2 + 2, cardBg.height - 2);
                cupText.setTextColor(new cc.Color(69, 31, 22));
                cupText.setName("cupText");
                cardLayout.addChild(cupText);

                var peopleBg = new ccui.Button(res.PeopleBg_png,res.PeopleBg_png,"");
                peopleBg.setTouchEnabled(false);
                peopleBg.setAnchorPoint(0.5, 1);
                peopleBg.setName("peopleBg");
                peopleBg.setLocalZOrder(-1);
                peopleBg.setPosition(cardBg.width / 2, cardBg.height - 14);
                cardLayout.addChild(peopleBg);

                //var peopleSeat = new ccui.ImageView(res.PeopleSeat_png);
                //peopleSeat.setScale(0);
                //peopleSeat.setAnchorPoint(0.5, 0);
                //peopleSeat.setPosition(cardBg.width / 2, cardBg.height - cupBg.height - peopleBg.height - 20);
                //peopleSeat.setName("peopleSeat");
                //peopleSeat.setVisible(false);
                //cardLayout.addChild(peopleSeat);

                var people = new ccui.Button(res.NormalFemale_png,res.NormalFemale_png,"");
                people.setTouchEnabled(false);
                people.setScale(0.5);
                people.setAnchorPoint(0.5, 0);
                people.setPosition(cardBg.width / 2, cardBg.height - 13 - peopleBg.height);
                people.setName("people");
                people.setVisible(false);
                people.setLocalZOrder(-1);
                cardLayout.addChild(people);

                var rightIcon = new ccui.ImageView(res.EmptyIcon_png);
                rightIcon.setAnchorPoint(1, 1);
                rightIcon.setPosition(cardLayout.width, cardLayout.height);
                rightIcon.setScale(0.7, 0.7);
                rightIcon.setVisible(false);
                rightIcon.setName("rightIcon");
                cardLayout.addChild(rightIcon);

                var leftIcon = new ccui.ImageView(res.EmptyIcon_png);
                leftIcon.setAnchorPoint(0, 1);
                leftIcon.setPosition(0, cardLayout.height);
                leftIcon.setScale(0.7, 0.7);
                leftIcon.setVisible(true);
                leftIcon.setName("leftIcon");
                cardLayout.addChild(leftIcon);

                //var nameBg = new ccui.ImageView(res.NameBg_png);
                //nameBg.setAnchorPoint(0.5, 0);
                //nameBg.setPosition(cardBg.width / 2, -1);
                //cardLayout.addChild(nameBg);

                var iconList = new ccui.ListView();
                iconList.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
                iconList.setTouchEnabled(true);
                iconList.setBounceEnabled(true);
                iconList.setScrollBarEnabled(false);
                iconList.setVisible(true);
                iconList.setName("iconList");
                iconList.setAnchorPoint(0.5, 0);
                iconList.setPosition(cardLayout.width * 0.5, 31);
                iconList.setContentSize(cc.size(cardLayout.width - 30, 32));
                cardLayout.addChild(iconList);

                var nameText = new ccui.Text("", "Verdana-Bold", 18);
                nameText.setAnchorPoint(0.5, 0.5);
                nameText.setName("nameText");
                nameText.setPosition(cardBg.width / 2 - 10, 15);
                nameText.setTextColor(new cc.Color(69, 31, 22));
                cardLayout.addChild(nameText);

                var seatNumber = new ccui.ImageView(res.SeatNumber_png);
                seatNumber.setAnchorPoint(1, 0);
                seatNumber.setPosition(cardBg.width + 3, -2);
                cardLayout.addChild(seatNumber);

                var prepareIcon = new ccui.ImageView(res.Prepared_png);
                prepareIcon.setAnchorPoint(1, 1);
                prepareIcon.setPosition(cardBg.width - 2, cardBg.height - 1);
                prepareIcon.setName("prepareIcon");
                prepareIcon.setVisible(false);
                cardLayout.addChild(prepareIcon);

                var seatNumberText = new ccui.Text((i * col + j + 1) + "", "Arial", 20);
                seatNumberText.setAnchorPoint(0.5, 0.5);
                seatNumberText.setPosition(cardBg.width - 16, 18);
                seatNumberText.setTextColor(new cc.Color(0, 0, 0));
                //seatNumberText.setName("seatNumberText");
                cardLayout.addChild(seatNumberText);

                var gagButton = new ccui.Button(res.GagButtonBg_png, "");
                gagButton.setAnchorPoint(0.5, 0);
                gagButton.setPosition(cardBg.width / 2, 30);
                gagButton.setVisible(false);
                gagButton.setTag(i * col + j + 1);
                gagButton.setName("gagButton");
                gagButton.addClickEventListener(function () {
                    var gameProfileApi = new GameProfileApi();
                    var targetUserId = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(this.getTag()).userId;
                    userGagId = targetUserId;
                    gameProfileApi.userReadyGag(targetUserId, "userGagResponse", function () {
                    }, function () {
                    }, function () {
                    });
                });
                cardLayout.addChild(gagButton);

                var gagLabel = new ccui.ImageView(res.GagLabel_png);
                gagLabel.setPosition(gagButton.width/2, gagButton.height/2);
                gagButton.addChild(gagLabel);

                var offlineStamp = new ccui.ImageView(res.OfflineTag_png);
                offlineStamp.setPosition(cardLayout.width/2, cardLayout.height/2);
                offlineStamp.setName("offlineStamp");
                offlineStamp.setVisible(false);
                cardLayout.addChild(offlineStamp);

                var deathStamp = new ccui.ImageView(res.DeathTagDeaded_png);
                deathStamp.setPosition(cardLayout.width/2, cardLayout.height/2);
                deathStamp.setName("deathStamp");
                deathStamp.setVisible(false);
                cardLayout.addChild(deathStamp);
            }
        }

        for (var i = 0; i < DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
            var playerInfo = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(i + 1);
            if (playerInfo != null && playerInfo != undefined) {
                var card = this.getChildByName("card" + (playerInfo.seatNumber));
                card.getChildByName("nameText").setString(playerInfo.nickname);
                card.getChildByName("cupText").setString(playerInfo.cup + "");
                if(playerInfo.userId == DataManager.getInstance().getUserData()._userId) {
                    card.getChildByName("cupText").setTextColor(new cc.Color(85, 0, 150));
                    card.getChildByName("nameText").setTextColor(new cc.Color(85, 0, 150));
                } else  {
                    card.getChildByName("cupText").setTextColor(new cc.Color(69, 31, 22));
                    card.getChildByName("nameText").setTextColor(new cc.Color(69, 31, 22));
                }
                card.getChildByName("people").setVisible(true);
                var playerSkinInfo = SkinMap.get(playerInfo.skin);
                var skinTexture;
                if(playerSkinInfo != null && playerSkinInfo != undefined) {
                    skinTexture = playerSkinInfo[0];
                } else {
                    if(playerInfo.sex == 1) {
                        skinTexture = res.NormalMale_png;
                    } else {
                        skinTexture = res.NormalFemale_png;
                    }
                }
                card.getChildByName("people").loadTextureNormal(skinTexture);
                card.getChildByName("people").loadTexturePressed(skinTexture);
                //card.getChildByName("peopleSeat").setVisible(true);
                if (playerInfo.prepareState == 1) {
                    card.getChildByName("prepareIcon").setVisible(true);
                } else {
                    card.getChildByName("prepareIcon").setVisible(false);
                }
            }
        }
    },

    flipCard:function (myEvent) {
        var roleId = myEvent.getUserData();
        var seatNumber =  DataManager.getInstance().getCurrentRoomData().getSeatNumber(DataManager.getInstance().getUserData()._userId);
        roomMenuLayer.getChildByName("selfCard").loadTexture("res/roleold/"+roleId+".png");
        roomCardLayer.flipCardWithSeatNumber(roleId, seatNumber);
    },

    dialogChoose:function (myEvent) {
        var userData = myEvent.getUserData();
        var userId = userData.userId;
        var type = userData.type;
        var seatNumber = DataManager.getInstance().getCurrentRoomData().getSeatNumber(userId);
        if(type == StateObject.Compete) {
            var card = roomCardLayer.getChildByName("card" + seatNumber);
            card.getChildByName("leftIcon").loadTexture(res.CompeteIcon_png);
            card.getChildByName("leftIcon").setUserData(null);
        } else if (type == StateObject.Antidote) {
            var card = roomCardLayer.getChildByName("card" + seatNumber);

            if (cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
                var spineBoy = new sp.SkeletonAnimation('res/spine/jieyao.json', 'res/spine/jieyao.atlas', 1.0);
                spineBoy.setPosition(card.width * 0.5, card.height * 0.5);
                spineBoy.setAnchorPoint(0.5, 0.5);
                spineBoy.setAnimation(0, 'jieyao', false);
                card.addChild(spineBoy, 1);
            }

            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(32, 32);

            var stateIcon = new ccui.ImageView(res.AntidoteIcon_png);
            stateIcon.setPosition(defaultItemLayout.width*0.5, defaultItemLayout.height*0.5);
            stateIcon.setAnchorPoint(0.5, 0.5);
            stateIcon.setScale(0.65, 0.65);
            defaultItemLayout.addChild(stateIcon, 1);
            card.getChildByName("iconList").pushBackCustomItem(defaultItemLayout);
        } else if (type == StateObject.Poison) {
            var card = roomCardLayer.getChildByName("card" + seatNumber);

            if (cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
                var spineBoy = new sp.SkeletonAnimation('res/spine/duyao.json', 'res/spine/duyao.atlas', 1.0);
                spineBoy.setPosition(card.width * 0.5, card.height * 0.5);
                spineBoy.setAnchorPoint(0.5, 0.5);
                spineBoy.setAnimation(0, 'duyao', false);
                card.addChild(spineBoy, 1);
            }

            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(32, 32);

            var stateIcon = new ccui.ImageView(res.PoisonIcon_png);
            stateIcon.setPosition(defaultItemLayout.width*0.5, defaultItemLayout.height*0.5);
            stateIcon.setAnchorPoint(0.5, 0.5);
            stateIcon.setScale(0.65, 0.65);
            defaultItemLayout.addChild(stateIcon, 1);
            card.getChildByName("iconList").pushBackCustomItem(defaultItemLayout);
        } else if (type == StateObject.Idol) {
            var card = roomCardLayer.getChildByName("card" + seatNumber);

            if (cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
                var spineBoy = new sp.SkeletonAnimation('res/spine/ouxiang.json', 'res/spine/ouxiang.atlas', 1.0);
                spineBoy.setPosition(card.width * 0.5, card.height * 0.5);
                spineBoy.setAnchorPoint(0.5, 0.5);
                spineBoy.setAnimation(0, 'ouxiang', false);
                card.addChild(spineBoy, 1);
            }

            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(32, 32);

            var stateIcon = new ccui.ImageView(res.IdolIcon_png);
            stateIcon.setPosition(defaultItemLayout.width*0.5, defaultItemLayout.height*0.5);
            stateIcon.setAnchorPoint(0.5, 0.5);
            stateIcon.setScale(0.65, 0.65);
            defaultItemLayout.addChild(stateIcon, 1);
            card.getChildByName("iconList").pushBackCustomItem(defaultItemLayout);
        } else if (type == StateObject.Gag) {
            if (cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
                var card = roomCardLayer.getChildByName("card" + seatNumber);
                var spineBoy = new sp.SkeletonAnimation('res/spine/jinyan.json', 'res/spine/jinyan.atlas', 1.0);
                spineBoy.setPosition(card.width * 0.5, card.height * 0.5);
                spineBoy.setAnchorPoint(0.5, 0.5);
                spineBoy.setAnimation(0, 'jinyan', false);
                card.addChild(spineBoy, 1);
            }
        } else if (type == StateObject.Guard) {
            if (cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
                var card = roomCardLayer.getChildByName("card" + seatNumber);
                var spineBoy = new sp.SkeletonAnimation('res/spine/dunpai.json', 'res/spine/dunpai.atlas', 1.0);
                spineBoy.setPosition(card.width * 0.5, card.height * 0.5);
                spineBoy.setAnchorPoint(0.5, 0.5);
                spineBoy.setAnimation(0, 'dunpai', false);
                card.addChild(spineBoy, 1);
            }
        } else if (type == StateObject.Hunter) {
            if (cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
                var card = roomCardLayer.getChildByName("card" + seatNumber);
                var spineBoy = new sp.SkeletonAnimation('res/spine/qiangji.json', 'res/spine/qiangji.atlas', 1.0);
                spineBoy.setPosition(card.width * 0.5, card.height * 0.5);
                spineBoy.setAnchorPoint(0.5, 0.5);
                spineBoy.setAnimation(0, 'qiangji', false);
                card.addChild(spineBoy, 1);
            }
        }
    },

    flipCardWithSeatNumber:function (roleId, seatNumber) {
        DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber).currentCard = "res/"+ roleId + ".png";
        var card = roomCardLayer.getChildByName("card" + seatNumber);
        var cardIn = card.getChildByName("cardIn");
        var cardOut = card.getChildByName("cardOut");
        card.getChildByName("cupText").setVisible(false);
        card.getChildByName("people").setVisible(false);
        //card.getChildByName("peopleSeat").setVisible(false);
        card.getChildByName("prepareIcon").setVisible(false);
        card.getChildByName("peopleBg").setVisible(false);
        card.getChildByName("cup").setVisible(false);
        //card.getChildByName("cupBg").setVisible(false);
        card.getChildByName("rightIcon").setVisible(true);
        card.getChildByName("leftIcon").setVisible(true);
        card.getChildByName("iconList").setVisible(true);
        card.getChildByName("nameText").setVisible(true);
        var duration = 0.8;
        var openAnimIn = new cc.Sequence(new cc.DelayTime(duration*0.5), new cc.Show(),
            cc.scaleTo(duration * 0.5, 1, 1));
        var openAnimOut = new cc.Sequence(cc.scaleTo(duration * 0.5, 0, 1),
            new cc.Hide());
        if(cardIn.getScaleX() == 1) {
            cardOut.loadTextureNormal("res/" + roleId + ".png");
            cardOut.loadTexturePressed("res/" + roleId + ".png");
            cardOut.runAction(openAnimIn);
            cardIn.runAction(openAnimOut);
        } else {
            cardIn.loadTextureNormal("res/" + roleId + ".png");
            cardIn.loadTexturePressed("res/" + roleId + ".png");
            cardIn.runAction(openAnimIn);
            cardOut.runAction(openAnimOut);
        }
    },

    gameReset:function (offlineUserSeatNumber) {
        for(var i = 0; i < DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
            var card = roomCardLayer.getChildByName("card" + (i+1));
            card.getChildByName("cupText").setVisible(true);
            card.getChildByName("people").setVisible(true);
            //card.getChildByName("peopleSeat").setVisible(true);
            card.getChildByName("prepareIcon").setVisible(false);
            card.getChildByName("peopleBg").setVisible(true);
            card.getChildByName("cup").setVisible(true);
            //card.getChildByName("cupBg").setVisible(true);
            card.getChildByName("rightIcon").loadTexture(res.EmptyIcon_png);
            card.getChildByName("leftIcon").loadTexture(res.EmptyIcon_png);
            card.getChildByName("leftIcon").setUserData(null);
            card.getChildByName("iconList").removeAllChildren();
            card.getChildByName("rightIcon").setVisible(false);
            card.getChildByName("leftIcon").setVisible(false);
            card.getChildByName("iconList").setVisible(false);
            card.getChildByName("gagButton").setVisible(false);
            card.getChildByName("deathStamp").setVisible(false);
            card.getChildByName("offlineStamp").setVisible(false);
            var cardIn = card.getChildByName("cardIn");
            var cardOut = card.getChildByName("cardOut");
            cardIn.setBright(true);
            cardOut.setBright(true);
            card.getChildByName("people").setBright(true);
            card.getChildByName("peopleBg").setBright(true);
            var duration = 0.8;
            var openAnimIn = new cc.Sequence(new cc.DelayTime(duration*0.5), new cc.Show(),
                cc.scaleTo(duration * 0.5, 1, 1));
            var openAnimOut = new cc.Sequence(cc.scaleTo(duration * 0.5, 0, 1),
                new cc.Hide());
            if(cardIn.getScaleX() == 1) {
                cardOut.loadTextureNormal(res.CardBg_png);
                cardOut.loadTexturePressed(res.CardBg_png);
                cardOut.runAction(openAnimIn);
                cardIn.runAction(openAnimOut);
            } else {
                cardIn.loadTextureNormal(res.CardBg_png);
                cardIn.loadTexturePressed(res.CardBg_png);
                cardIn.runAction(openAnimIn);
                cardOut.runAction(openAnimOut);
            }
        }

        for(var i = 0; i < offlineUserSeatNumber.length; i++) {
            roomCardLayer.cancelPlayer(offlineUserSeatNumber[i]);
        }
    },

    setGagButtonVisible:function (isVisible) {
        for(var i = 0; i < DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
            var card = roomCardLayer.getChildByName("card" + (i + 1));
            if(isVisible == true) {
                if((i+1) != DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
                    card.getChildByName("gagButton").setVisible(true);
                }
            } else {
                card.getChildByName("gagButton").setVisible(false);
            }
        }
    },

    unflipAllCard:function() {
        var playerNumber = DataManager.getInstance().getCurrentRoomData()._totalPlayerNum;
        for(var i = 0; i < playerNumber; i++) {
            var card = roomCardLayer.getChildByName("card" + (i + 1));
            card.getChildByName("cupText").setVisible(true);
            card.getChildByName("people").setVisible(true);
            //card.getChildByName("peopleSeat").setVisible(true);
            card.getChildByName("peopleBg").setVisible(true);
            card.getChildByName("prepareIcon").setVisible(false);
            card.getChildByName("cup").setVisible(true);
            //card.getChildByName("cupBg").setVisible(true);
            card.getChildByName("rightIcon").setVisible(false);
            // card.getChildByName("leftIcon").setVisible(false);
            // card.getChildByName("iconList").setVisible(false);
            var cardIn = card.getChildByName("cardIn");
            var cardOut = card.getChildByName("cardOut");
            var duration = 0.8;
            var openAnimIn = new cc.Sequence(new cc.DelayTime(duration*0.5), new cc.Show(),
                cc.scaleTo(duration * 0.5, 1, 1));
            var openAnimOut = new cc.Sequence(cc.scaleTo(duration * 0.5, 0, 1),
                new cc.Hide());
            // var playerInfo = null;
            // playerInfo = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(i+1);
            // var currentCard = res.Beimian_png;
            // if(playerInfo != null) {
            //     currentCard = playerInfo.currentCard;
            // }
           if(cardOut.getScaleX() == 1) {
               cardOut.loadTextureNormal(res.CardBg_png);
               cardOut.loadTexturePressed(res.CardBg_png);
               cardOut.runAction(openAnimOut);
               cardIn.runAction(openAnimIn);
           } else {
               cardIn.loadTextureNormal(res.CardBg_png);
               cardIn.loadTexturePressed(res.CardBg_png);
               cardIn.runAction(openAnimOut);
               cardOut.runAction(openAnimIn);
           }
        }
    },

    flipAllCard:function() {
        var playerNumber = DataManager.getInstance().getCurrentRoomData()._totalPlayerNum;
        for(var i = 0; i < playerNumber; i++) {
            var card = roomCardLayer.getChildByName("card" + (i + 1));
            card.getChildByName("cupText").setVisible(false);
            card.getChildByName("people").setVisible(false);
            //card.getChildByName("peopleSeat").setVisible(false);
            card.getChildByName("prepareIcon").setVisible(false);
            card.getChildByName("peopleBg").setVisible(false);
            card.getChildByName("cup").setVisible(false);
            //card.getChildByName("cupBg").setVisible(false);
            card.getChildByName("rightIcon").setVisible(true);
            card.getChildByName("leftIcon").setVisible(true);
            card.getChildByName("iconList").setVisible(true);
            var cardIn = card.getChildByName("cardIn");
            var cardOut = card.getChildByName("cardOut");
            var duration = 0.8;
            var openAnimIn = new cc.Sequence(new cc.DelayTime(duration*0.5), new cc.Show(),
                cc.scaleTo(duration * 0.5, 1, 1));
            var openAnimOut = new cc.Sequence(cc.scaleTo(duration * 0.5, 0, 1),
                new cc.Hide());
            var playerInfo = null;
            playerInfo = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(i+1);
            var currentCard = res.Beimian_png;
            if(playerInfo != null) {
                currentCard = playerInfo.currentCard;
            }
           if(cardIn.getScaleX() == 1) {
                cardOut.loadTextureNormal(currentCard);
                cardOut.loadTexturePressed(currentCard);
                cardOut.runAction(openAnimIn);
                cardIn.runAction(openAnimOut);
           } else {
               cardIn.loadTextureNormal(currentCard);
               cardIn.loadTexturePressed(currentCard);
               cardIn.runAction(openAnimIn);
               cardOut.runAction(openAnimOut);
           }
        }
    },

    setInCardRes:function(roleId, seatNumber) {
        DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber).currentCard = "res/" + roleId + ".png";
        roomCardLayer.getChildByName("card" + seatNumber).getChildByName("cardIn").loadTextureNormal("res/"+roleId+".png");
        roomCardLayer.getChildByName("card" + seatNumber).getChildByName("cardIn").loadTexturePressed("res/"+roleId+".png");
    },

    drawPlayer:function (seatNumber) {
        var playerInfo = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber);
        cc.log(playerInfo);
        var card = roomCardLayer.getChildByName("card"+seatNumber);
        card.getChildByName("nameText").setVisible(true);
        card.getChildByName("cupText").setVisible(true);
        card.getChildByName("nameText").setString(playerInfo.nickname);
        card.getChildByName("cupText").setString(playerInfo.cup+"");
        card.getChildByName("people").setVisible(true);
        card.getChildByName("people").loadTextureNormal(SkinMap.get(playerInfo.skin)[0]);
        card.getChildByName("people").loadTexturePressed(SkinMap.get(playerInfo.skin)[0]);
        //card.getChildByName("peopleSeat").setVisible(true);
        if(playerInfo.userId == DataManager.getInstance().getUserData()._userId) {
            card.getChildByName("cupText").setTextColor(new cc.Color(85, 0, 150));
            card.getChildByName("nameText").setTextColor(new cc.Color(85, 0, 150));
        } else  {
            card.getChildByName("cupText").setTextColor(new cc.Color(69, 31, 22));
            card.getChildByName("nameText").setTextColor(new cc.Color(69, 31, 22));
        }
    },

    cancelPlayer:function (seatNumber) {
        var card = roomCardLayer.getChildByName("card"+seatNumber);
        if(card != null && card != undefined) {
            card.getChildByName("nameText").setString("");
            card.getChildByName("cupText").setString("");
            card.getChildByName("people").setVisible(false);
            //card.getChildByName("peopleSeat").setVisible(false);
            card.getChildByName("prepareIcon").setVisible(false);
        }
    },

    drawPrepare:function (seatNumber) {
        cc.log("preapare " + seatNumber);
        roomCardLayer.getChildByName("card"+seatNumber).getChildByName("prepareIcon").setVisible(true);
    },

    cancelPrepare:function (seatNumber) {
        roomCardLayer.getChildByName("card"+seatNumber).getChildByName("prepareIcon").setVisible(false);
    },

    drawPrepare:function (seatNumber) {
        cc.log("preapare " + seatNumber);
        roomCardLayer.getChildByName("card"+seatNumber).getChildByName("prepareIcon").setVisible(true);
    },
});

var RoomMenuLayer = cc.Layer.extend({
    _countDownTime:0,

    scheduleTimeCountDown:function(time, message) {
        cc.log("scheduleTimeCountDown");
        if (time > 0) {
            roomMenuLayer._countDownTime = time;
            roomMenuLayer.schedule(roomMenuLayer.countDownTime, 1/*, cc.RepeatForever, 0, "timeCountDown"*/);
        }
        roomMenuLayer.getChildByName("actionHint").setString(message);
    },

    ctor:function() {
        this._super();

        var _this = this;
        var secondBg = new ccui.ImageView(res.SecondBg_png);
        secondBg.setAnchorPoint(0.5, 0.5);
        secondBg.setPosition( cc.winSize.width * 0.92, cc.winSize.height - 112);
        secondBg.setName("secondBg");
        secondBg.setVisible(false);
        this.addChild(secondBg);

        var countDownText = new ccui.Text("90", "Arial", 35);
        countDownText.setTextColor(new cc.Color(255,255,255));
        countDownText.setAnchorPoint(1, 0.5);
        countDownText.setName("clock");
        countDownText.setVisible(false);
        countDownText.setPosition(cc.winSize.width*0.88, cc.winSize.height - 112);
        this.addChild(countDownText);

        var actionHint = new ccui.Text("请准备，否则会被系统踢出", "Arial", 30);
        actionHint.setTextColor(cc.color(255, 224, 141));
        actionHint.setAnchorPoint(0.5, 0.5);
        actionHint.setName("actionHint");
        actionHint.setVisible(false);
        actionHint.setPosition(cc.winSize.width*0.5, cc.winSize.height - 112);
        this.addChild(actionHint);

        var trumpet = new ccui.ImageView(res.Trumpet_png);
        trumpet.setAnchorPoint(0.5, 0.5);
        trumpet.setPosition(cc.winSize.width*0.08, cc.winSize.height - 112);
        trumpet.setName("trumpet");
        trumpet.setVisible(false);
        this.addChild(trumpet);

        var roomNumberText = new ccui.Text("房号:" + DataManager.getInstance().getCurrentRoomData()._roomId, "Arial", 25);
        roomNumberText.setAnchorPoint(0, 0.5);
        roomNumberText.setName("roomNumberText");
        roomNumberText.setPosition(30, cc.winSize.height - 112);
        this.addChild(roomNumberText);

        var readyButton = new ccui.Button(res.PrepareButton_png, res.PrepareButtonDown_png, "");
        readyButton.setAnchorPoint(0.5, 0.5);
        readyButton.setScale9Enabled(true);
        readyButton.setScale(0.94, 0.94);
        readyButton.setPosition(cc.winSize.width*0.27, 130);
        readyButton.setName("prepareButton");
        if(DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
            readyButton.setVisible(false);
        }
        readyButton.addClickEventListener(function () {
            MqttHelper.getInstance().prepareRequest(DataManager.getInstance().getCurrentRoomData()._roomId);
        });
        this.addChild(readyButton);

        var readyButtonText = new ccui.ImageView(res.PrepareButtonText_png);
        readyButtonText.setAnchorPoint(0.5, 0.5);
        readyButtonText.setScale(1.05);
        readyButtonText.setPosition(readyButton.width * 0.5 - 5, readyButton.height * 0.5 + 5);
        readyButton.addChild(readyButtonText);

        var cancelReadyButton = new ccui.Button(res.PrepareButton_png, res.PrepareButtonDown_png, "");
        cancelReadyButton.setAnchorPoint(0.5,0.5);
        cancelReadyButton.setScale9Enabled(true);
        cancelReadyButton.setScale(0.94, 0.94);
        cancelReadyButton.setPosition(cc.winSize.width*0.27, 130);
        if(DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
            cancelReadyButton.setVisible(false);
        }
        cancelReadyButton.addClickEventListener(function () {
            MqttHelper.getInstance().cancelPrepareRequest(DataManager.getInstance().getCurrentRoomData()._roomId);
        });
        cancelReadyButton.setName("cancelPrepareButton");
        cancelReadyButton.setVisible(false);
        this.addChild(cancelReadyButton);

        var CancelReadyButtonText = new ccui.ImageView(res.CancelPrepareText_png);
        CancelReadyButtonText.setAnchorPoint(0.5, 0.5);
        CancelReadyButtonText.setPosition(cancelReadyButton.width * 0.5 - 5, cancelReadyButton.height * 0.5 + 5);
        cancelReadyButton.addChild(CancelReadyButtonText);

        var spineBoy = new sp.SkeletonAnimation('res/spine/bowen.json', 'res/spine/bowen.atlas', 1.0);
        spineBoy.setPosition(cc.winSize.width/2, 130);
        spineBoy.setAnchorPoint(0.5, 0.5);
        spineBoy.setAnimation(0, 'bowen', true);
        spineBoy.setName("bowen");
        spineBoy.setVisible(false);
        this.addChild(spineBoy);

        var onSeatButton = new ccui.Button(res.PrepareButton_png, res.PrepareButtonDown_png);
        onSeatButton.setPosition(cc.winSize.width/2, 130);
        onSeatButton.setScale(0.94, 0.94);
        onSeatButton.setName("onSeatButton");
        if(!DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
            onSeatButton.setVisible(false);
        }
        onSeatButton.addClickEventListener(function () {
            MqttHelper.getInstance().inSeatRequest();
        });
        this.addChild(onSeatButton);

        var onSeatLabel = new ccui.ImageView(res.OnSeatLabel_png);
        onSeatLabel.setPosition(onSeatButton.width/2 -5, onSeatButton.height/2 + 5);
        onSeatButton.addChild(onSeatLabel);

        var speechButton = new ccui.Button(res.RoomSpeechButton_png, res.RoomSpeechButtonDown_png, "");
        speechButton.setAnchorPoint(0.5, 0.5);
        speechButton.setScale9Enabled(true);
        speechButton.setPosition(cc.winSize.width/2, 130);
        speechButton.setScale(0.83, 0.83);
        speechButton.setName("speechButton");
        speechButton.setTouchEnabled(true);
        if(DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
            speechButton.setVisible(false);
        }
        speechButton.addTouchEventListener(function (sender, type) {
            switch (type) {
                case ccui.Widget.TOUCH_BEGAN:
                    // roomCardLayer.flipAllCard();
                    cc.log("touch began");
                    openMic();
                    spineBoy.setVisible(true);
                    roomCardLayer.getChildByName("spineMic"+DataManager.getInstance().getCurrentRoomData()._mySeatNumber).setVisible(true);
                    break;
                case ccui.Widget.TOUCH_MOVED:
                    break;
                case ccui.Widget.TOUCH_ENDED:
                    // roomCardLayer.unflipAllCard();
                    closeMic();
                    spineBoy.setVisible(false);
                    roomCardLayer.getChildByName("spineMic"+DataManager.getInstance().getCurrentRoomData()._mySeatNumber).setVisible(false);
                    cc.log("touch ended");
                    break;
                case ccui.Widget.TOUCH_CANCELED:
                    closeMic();
                    spineBoy.setVisible(false);
                    roomCardLayer.getChildByName("spineMic"+DataManager.getInstance().getCurrentRoomData()._mySeatNumber).setVisible(false);
                    cc.log("touch canceled");
                    break;
            }
        },this);
        this.addChild(speechButton);

        var speechButtonLabel = new ccui.ImageView(res.SpeechLabel_png);
        speechButtonLabel.setAnchorPoint(0.5, 0.5);
        speechButton.setScale9Enabled(true);
        speechButtonLabel.setScale(0.9, 0.9);
        speechButtonLabel.setName("speechButtonLabel");
        speechButtonLabel.setPosition(speechButton.width/2, speechButton.height/2);
        speechButton.addChild(speechButtonLabel);

        var that = this;
        var inviteButton = new ccui.Button(res.InviteButtonBg_png, res.InviteButtonBgDown_png, "");
        inviteButton.setAnchorPoint(0.5, 0.5);
        inviteButton.setPosition(cc.winSize.width*0.73, 130);
        inviteButton.setScale(0.94, 0.94);
        if(DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
            inviteButton.setVisible(false);
        }
        inviteButton.setName("inviteButton");
        inviteButton.addClickEventListener(function () {
            that.addChild(new FriendInviteLayer(), 3);
        });
        this.addChild(inviteButton);

        var inviteButtonLabel = new ccui.ImageView(res.InviteButtonLabel_png);
        inviteButtonLabel.setAnchorPoint(0.5, 0.5);
        inviteButtonLabel.setPosition(inviteButton.width/2 - 5, inviteButton.height/2 + 5);
        inviteButton.addChild(inviteButtonLabel);

        //var locationImage = new ccui.ImageView(res.SelfLocation_png);
        //locationImage.setAnchorPoint(0.5, 0.5);
        //locationImage.setPosition(cc.winSize.width * 0.88, 100);
        //locationImage.setName("locationImage");
        //this.addChild(locationImage);

        //var locationText = new ccui.Text(DataManager.getInstance().getCurrentRoomData()._mySeatNumber, "Arial", 22);
        //locationText.setAnchorPoint(0, 0.5);
        //locationText.setName("locationText");
        //locationText.setPosition(cc.winSize.width * 0.93, 100);
        //this.addChild(locationText);

        //var youAraOnlooker = new ccui.ImageView(res.YouAraOnLooker_png);
        //youAraOnlooker.setPosition(cc.winSize.width * 0.9, 100);
        //youAraOnlooker.setName("youAraOnlooker");
        //youAraOnlooker.setVisible(false);
        //this.addChild(youAraOnlooker);

        var selfCard = new ccui.ImageView(res.BeimianOld_png);
        selfCard.setAnchorPoint(0.5, 0.5);
        selfCard.setName("selfCard");
        selfCard.setScale(0.5);
        selfCard.setPosition(cc.winSize.width * 0.9, 133);
        this.addChild(selfCard);

        var explodeButton = new ccui.Button(res.InviteButtonBg_png, res.InviteButtonBgDown_png, "");
        explodeButton.setAnchorPoint(0.5, 0.5);
        explodeButton.setScale9Enabled(true);
        explodeButton.setScale(0.94, 0.94);
        explodeButton.setPosition(cc.winSize.width*0.73, 130);
        explodeButton.setVisible(false);
        explodeButton.setName("explodeButton");
        explodeButton.addClickEventListener(function () {
            var explodeDialog = new CommonDialog(DialogType.ExplodeConfirmDialog);
            explodeDialog.setTag(DialogType.ExplodeConfirmDialog);
            explodeDialog.popup();
        });
        this.addChild(explodeButton);

        var explodeText = new ccui.ImageView(res.ExplodeLabel_png);
        explodeText.setAnchorPoint(0.5, 0.5);
        explodeText.setPosition(explodeButton.width/2 - 5, explodeButton.height/2 + 5);
        explodeButton.addChild(explodeText);

        // var cancelGagButton = new ccui.Button(res.PrepareButton_png, res.PrepareButtonDown_png);
        // cancelGagButton.setPosition(cc.winSize.width*0.73, 157);
        // cancelGagButton.setName("cancelGagButton");
        // cancelGagButton.setVisible(false);
        // cancelGagButton.addClickEventListener(function () {
        //
        // });
        // this.addChild(cancelGagButton);
        //
        // var cancelGagLabel = new ccui.ImageView(res.RemoveGagLabel_png);
        // cancelGagLabel.setPosition(cancelGagButton.width/2, cancelGagButton.height/2);
        // cancelGagButton.addChild(cancelGagLabel);

        var quitCompeteButton = new ccui.Button(res.InviteButtonBg_png, res.InviteButtonBgDown_png, "");
        quitCompeteButton.setAnchorPoint(0.5, 0.5);
        quitCompeteButton.setScale9Enabled(true);
        quitCompeteButton.setPosition(cc.winSize.width*0.27, 130);
        quitCompeteButton.setVisible(false);
        quitCompeteButton.setScale(0.94, 0.94);
        quitCompeteButton.setName("quitCompeteButton");
        quitCompeteButton.addClickEventListener(function () {
            MqttHelper.getInstance().quitPoliceCompeteRequest();
            this.setVisible(false);
        });
        this.addChild(quitCompeteButton);

        var quitCompeteText = new ccui.ImageView(res.QuiteCompeteLabel_png);
        quitCompeteText.setAnchorPoint(0.5, 0.5);
        quitCompeteText.setPosition(quitCompeteButton.width/2 - 5, quitCompeteButton.height/2 + 5);
        quitCompeteButton.addChild(quitCompeteText);

        var endSpeechButton = new ccui.Button(res.PrepareButton_png, res.PrepareButtonDown_png, "");
        endSpeechButton.setAnchorPoint(0.5, 0.5);
        endSpeechButton.setScale9Enabled(true);
        endSpeechButton.setPosition(cc.winSize.width / 2, 130);
        endSpeechButton.setScale(0.94, 0.94);
        endSpeechButton.setName("endSpeechButton");
        endSpeechButton.setVisible(false);
        endSpeechButton.addClickEventListener(function () {
            MqttHelper.getInstance().finishSpeechRequest();
            this.setVisible(false);
            if (cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
                closeSpeaker();
                sendAliLog("speech", "info", "closeSpeaker");
                closeMic();
                sendAliLog("speech", "info", "closeMic");
            }
        });
        this.addChild(endSpeechButton);

        var endSpeechButtonText = new ccui.ImageView(res.EndSpeechLabel_png);
        endSpeechButtonText.setAnchorPoint(0.5, 0.5);
        endSpeechButtonText.setPosition(endSpeechButton.width * 0.5 - 5, endSpeechButton.height * 0.5 + 5);
        endSpeechButton.addChild(endSpeechButtonText, 1);

        var chatEditBoxBg =new cc.Scale9Sprite(res.SignInputBg_png);
        chatEditBoxBg.setContentSize(cc.size(510,60));
        chatEditBoxBg.setPosition(35,39);
        chatEditBoxBg.setAnchorPoint(0, 0.5);
        this.addChild(chatEditBoxBg);

        var chatEditBox = new cc.EditBox(cc.size(490, 50), new cc.Scale9Sprite(res.Transparency_50x50_png));
        chatEditBox.setAnchorPoint(0,0.5);
        chatEditBox.setPosition(45, 39);
        chatEditBox.setFontSize(30);
        chatEditBox.setPlaceHolder("在此输入你想说的话");
        chatEditBox.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
        chatEditBox.setMaxLength(1000);
        chatEditBox.setFontColor(cc.color(168, 149, 99));
        chatEditBox.setPlaceholderFontColor(cc.color(168, 149, 99));
        chatEditBox.setPlaceholderFontSize(30);
        this.addChild(chatEditBox, 2);

        var sendMessageButton = new ccui.Button(res.SendMessageButton_png, res.SendMessageButtonDown_png, "");
        sendMessageButton.setAnchorPoint(0.5, 0.5);
        sendMessageButton.setPosition(cc.winSize.width*0.893, 37);
        sendMessageButton.setScale9Enabled(true);
        sendMessageButton.setName("sendMessageButton");
        sendMessageButton.addClickEventListener(function () {
            var content = chatEditBox.getString();
            if(content != null && content != undefined && content != "") {
                MqttHelper.getInstance().textSpeechRequest(content);
                chatEditBox.setString("");
            } else {
                ToastUtil.showToast("输入的消息不能为空", 2.0);
            }
        });
        this.addChild(sendMessageButton);

        var sendButtonText = new ccui.ImageView(res.SendButtonText_png);
        sendButtonText.setAnchorPoint(0.5, 0.5);
        sendButtonText.setPosition(sendMessageButton.width * 0.5, sendMessageButton.height * 0.5);
        sendMessageButton.addChild(sendButtonText);

        var exitButton = new ccui.Button(res.TopLeftButtonBg_png, "", "");
        exitButton.setAnchorPoint(0,1);
        exitButton.setPosition(0, cc.winSize.height);
        exitButton.addClickEventListener(function () {
            if(isInCountDownProcess) {
                ToastUtil.systemToastInMiddle("开始倒计时阶段不可退出房间", 2.0);
            }else {
                var quitRoomConfirmDialog = new CommonDialog(DialogType.QuitRoomConfirmDialog, -1);
                quitRoomConfirmDialog.setTag(DialogType.QuitRoomConfirmDialog);
                quitRoomConfirmDialog.popup();
            }
        });
        this.addChild(exitButton);

        var exitButtonText = new ccui.ImageView(res.ExitButtonText_png);
        exitButtonText.setAnchorPoint(0.5, 0.5);
        exitButtonText.setPosition(exitButton.width*0.5 - 3, exitButton.height * 0.5);
        exitButton.addChild(exitButtonText);

        var roomConfButton = new ccui.Button(res.TopRightButtonBg_png, "", "");
        roomConfButton.setAnchorPoint(1,1);
        roomConfButton.setPosition(cc.winSize.width, cc.winSize.height);
        roomConfButton.addClickEventListener(function () {
            if(cc.sys.os === cc.sys.OS_ANDROID) {
                //  jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/AgoraUtil", "setEnableSpeakerphone", "(Z)V", true);
            }
            var test = new ModalDialogueBox(DialogType.RoomConf, DataManager.getInstance().getCurrentRoomData()._roleConf);
            test.popup();
        });
        this.addChild(roomConfButton);

        var roomConfButtonText = new ccui.ImageView(res.RoomConfButtonText_png);
        roomConfButtonText.setAnchorPoint(0.5, 0.5);
        roomConfButtonText.setPosition(roomConfButton.width*0.5 + 3, roomConfButton.height * 0.5);
        roomConfButton.addChild(roomConfButtonText);

        var roomNameText = new ccui.Text("", "Arial", 30);
        roomNameText.setTextColor(cc.color(56, 26, 18));
        roomNameText.setAnchorPoint(0.5, 0.5);
        roomNameText.setPosition(cc.winSize.width * 0.5, cc.winSize.height - 45);
        roomNameText.setString(DataManager.getInstance().getCurrentRoomData()._roomName);
        this.addChild(roomNameText);

        // var arrow = new ccui.Button(res.Arrow_png, "", "");
        // arrow.setAnchorPoint(1, 0.5);
        // arrow.setPosition(cc.winSize.width, cc.winSize.height/2 + 15);
        // arrow.addClickEventListener(function () {
        //     cc.log("jijun popup1");
        //     slideDialog.popup();
        //     cc.log("jijun popup2");
        // });
        // this.addChild(arrow);

        var roleConf = DataManager.getInstance().getCurrentRoomData()._roleConf;
        var roleList = new ccui.ListView();
        roleList.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
        roleList.setAnchorPoint(0.5, 1);
        roleList.setPosition(cc.director.getVisibleSize().width * 0.5, cc.director.getVisibleSize().height - 88);
        roleList.setBounceEnabled(true);
        roleList.setTouchEnabled(true);
        roleList.setName("roleList");
        roleList.setScrollBarEnabled(false);
        var tempCard = new ccui.ImageView(res.Little_WolfCard_png);
        roleList.setContentSize(Math.min(tempCard.width * 1 * roleConf.length + 5 * (roleConf.length-1), 370), tempCard.height * 1);

        for (var i = 0; i < roleConf.length; i++) {
            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setTag(i+1);
            var littleCard = new ccui.Button("res/role/" + roleConf[i].roleId + ".png", "", "");
            littleCard.setAnchorPoint(0.5, 0.5);
            littleCard.setScale(1, 1);
            littleCard.setTag(roleConf[i].roleId);
            var defaultItemWidth = littleCard.width * 1;
            if(i != roleConf.length-1) {
                defaultItemWidth += 5;
            }
            defaultItemLayout.setContentSize(defaultItemWidth, 60);
            littleCard.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);
            littleCard.addClickEventListener(function () {
                var roleIntroDialog = new RoleIntroDialog(this.getTag());
                roleIntroDialog.popup();
            });
            if(roleConf[i].roleNum > 1) {
                var numBg = new ccui.ImageView(res.SeatNumber_png);
                numBg.setAnchorPoint(1, 0);
                numBg.setPosition(littleCard.width, littleCard.height - 30);
                numBg.setScale(0.8, 0.8);
                var numText = new ccui.Text(roleConf[i].roleNum, "Arial", 18);
                numText.setAnchorPoint(0.5, 0.5);
                numText.setPosition(numBg.width * 0.5, numBg.height * 0.5);
                numText.setTextColor(new cc.Color(0, 0, 0));
                numBg.addChild(numText);
                littleCard.addChild(numBg);
            }
            defaultItemLayout.addChild(littleCard, 1);

            roleList.pushBackCustomItem(defaultItemLayout);
        }

        this.addChild(roleList);
    },

    gameReset:function () {
        roomMenuLayer.getChildByName("explodeButton").setVisible(false);
        roomMenuLayer.getChildByName("quitCompeteButton").setVisible(false);
        roomMenuLayer.getChildByName("cancelPrepareButton").setVisible(false);
        roomMenuLayer.getChildByName("endSpeechButton").setVisible(false);
        roomMenuLayer.getChildByName("roomNumberText").setVisible(true);
        roomMenuLayer.getChildByName("trumpet").setVisible(false);
        roomMenuLayer.getChildByName("selfCard").loadTexture(res.BeimianOld_png);
        roomMenuLayer.getChildByName("roleList").setVisible(true);
        roomMenuLayer.getChildByName("actionHint").setVisible(false);
        hideSendMessageButton();
        if(!DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
            showSendMessageButton();
            roomMenuLayer.getChildByName("prepareButton").setVisible(true);
            roomMenuLayer.getChildByName("speechButton").setVisible(true);
            roomMenuLayer.getChildByName("speechButton").setBright(true);
            roomMenuLayer.getChildByName("speechButton").setEnabled(true);
            roomMenuLayer.getChildByName("inviteButton").setVisible(true);
            roomMenuLayer.getChildByName("speechButton").getChildByName("speechButtonLabel").loadTexture(res.SpeechLabel_png);
        }
    },

    cancelCountTime:function (message) {
        roomMenuLayer.unschedule(roomMenuLayer.countDownTime);
        roomMenuLayer.getChildByName("actionHint").setString(message);
        roomMenuLayer.getChildByName("clock").setString("0");
    },

    countDownTime:function(delta) {
        roomMenuLayer._countDownTime -= delta;
        roomMenuLayer.getChildByName("clock").setString(Math.ceil(this._countDownTime));
        if(roomMenuLayer._countDownTime <= 0)
            roomMenuLayer.unschedule(roomMenuLayer.countDownTime);
    },

    enableEndSpeechButton:function (isEnable) {
        if(isEnable) {
            if(!DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
                roomMenuLayer.getChildByName("endSpeechButton").setVisible(true);
            }
        } else {
            roomMenuLayer.getChildByName("endSpeechButton").setVisible(false);
        }
    },

    enableCancleReadyButton:function (isEnable) {
        if(isEnable) {
            if(!DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
                roomMenuLayer.getChildByName("cancelPrepareButton").setVisible(true);
            }
        } else {
            roomMenuLayer.getChildByName("cancelPrepareButton").setVisible(false);
        }
    },
});

function otherHomePageResponse(responseString) {
};

function otherHomePageSuccess(data) {
    var kickOutDialog = new KickoutDialog(data, inGameFlag);
    kickOutDialog.setTag(DialogType.KickoutDialog);
    kickOutDialog.popup();
};

function otherHomePageFailed(data) {
    cc.log(data);
};

function otherHomePageResume(data) {
    cc.log(data);
};

var RoomScene = cc.Scene.extend({
    systemKickout:function (payloadObj) {
        if(payloadObj.userId == DataManager.getInstance().getUserData()._userId) {
            quitTecentRoom(false, "您因超时未准备被踢出房间");
        } else {
            ToastUtil.systemToastInMiddle(payloadObj.seatNumber+"号玩家因超时未准备被踢出房间",2);
            DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.remove(payloadObj.seatNumber);
            roomCardLayer.cancelPlayer(payloadObj.seatNumber);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    clockCountDown:function (payloadObj) {
        roomMenuLayer.scheduleTimeCountDown(payloadObj.countDownTime, payloadObj.textHint);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    countDownToStart:function (payloadObj) {
        isInCountDownProcess = true;
        roomMenuLayer.scheduleTimeCountDown(payloadObj.countDownTime, "游戏即将开始");
        roomMenuLayer.enableCancleReadyButton(false);
        roomMenuLayer.getChildByName("roleList").setVisible(false);
        roomMenuLayer.getChildByName("actionHint").setVisible(true);
        roomMenuLayer.getChildByName("trumpet").setVisible(true);
        roomMenuLayer.getChildByName("secondBg").setVisible(true);
        roomMenuLayer.getChildByName("clock").setVisible(true);
        roomMenuLayer.getChildByName("prepareButton").setVisible(false);
        roomMenuLayer.getChildByName("cancelPrepareButton").setVisible(false);
        roomMenuLayer.getChildByName("inviteButton").setVisible(false);
        roomMenuLayer.getChildByName("roomNumberText").setVisible(false);
        DataManager.getInstance().getCurrentRoomData()._timeProcess = 1;
        inGameFlag = true;
        showMicIconEnable = false;
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    playerJoin:function (payloadObj) {
        var joinPlayer = payloadObj.player;
        joinPlayer.currentCard = res.Beimian_png;
        joinPlayer.deathType = 1;
        DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.put(joinPlayer.seatNumber, joinPlayer);
        roomCardLayer.drawPlayer(joinPlayer.seatNumber);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    playerOnlinePush:function (payloadObj) {
        var card = roomCardLayer.getChildByName("card"+payloadObj.seatNumber);
        card.getChildByName("offlineStamp").setVisible(false);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    playerPrepare:function (payloadObj) {
        readySendFlag = false;
        roomCardLayer.drawPrepare(payloadObj.seatNumber);
        if(payloadObj.userId == DataManager.getInstance().getUserData()._userId) {
            roomMenuLayer.getChildByName("prepareButton").setVisible(false);
            roomMenuLayer.getChildByName("cancelPrepareButton").setVisible(true);
            roomMenuLayer.cancelCountTime("请等待其他玩家");
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    playerCancelPrepare:function (payloadObj) {
        cancelReadySendFlag = false;
        roomCardLayer.cancelPrepare(payloadObj.seatNumber);
        if(payloadObj.userId == DataManager.getInstance().getUserData()._userId) {
            roomMenuLayer.getChildByName("prepareButton").setVisible(true);
            roomMenuLayer.getChildByName("cancelPrepareButton").setVisible(false);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    playNarrator:function (payloadObj) {
        if(payloadObj.narratorCode == 1001) {
            for(var i = 1; i <= DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
                var card = roomCardLayer.getChildByName("card" + i);
                card.getChildByName("rightIcon").loadTexture(res.EmptyIcon_png);
            }
            DataManager.getInstance().getCurrentRoomData()._timeProcess++;
            roomMenuLayer.getChildByName("explodeButton").setVisible(false);

            hideSendMessageButton();

            var nightNum = Math.floor(DataManager.getInstance().getCurrentRoomData()._timeProcess/2);
            cc.audioEngine.playMusic(BgmArray[nightNum%6], true);
            cc.audioEngine.setMusicVolume(0.01);

            var myRole = DataManager.getInstance().getCurrentRoomData()._myRole;
            if(myRole != 101 && myRole != 102 && myRole != 204) {
                if(myRole == 201) {
                    var seatNumber = DataManager.getInstance().getCurrentRoomData()._mySeatNumber;
                    var currentCard = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber).currentCard;
                    if(currentCard != res.Wolf_png && currentCard != res.Whitewolfking_png) {
                        closeSpeaker();
                        closeMic();
                    }
                } else {
                    closeSpeaker();
                    closeMic();
                }
            }
            //天黑了
            roomCardLayer.flipAllCard();
        }

        if(payloadObj.narratorCode == 1012) {
            DataManager.getInstance().getCurrentRoomData()._timeProcess++;
            cc.audioEngine.stopMusic(true);
            //天亮了
            roomCardLayer.unflipAllCard();
        }

        if(payloadObj.narratorCode == 1015) {
            for(var i = 1; i <= DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
                var myCard = roomCardLayer.getChildByName("card" + i);
                if(myCard != null && myCard != undefined) {
                    myCard.getChildByName("leftIcon").loadTexture(res.EmptyIcon_png);
                    myCard.getChildByName("leftIcon").setUserData(null);
                }
            }
            roomMenuLayer.getChildByName("quitCompeteButton").setVisible(false);
            roomMenuLayer.getChildByName("explodeButton").setVisible(false);
        }

        if(payloadObj.narratorCode == 1022 || payloadObj.narratorCode == 1036
            || payloadObj.narratorCode == 1044 || payloadObj.narratorCode == 1020 || payloadObj.narratorCode == 1023){
            roomMenuLayer.getChildByName("explodeButton").setVisible(false);
        }

        //(payloadObj.narratorCode >= 2501 && payloadObj.narratorCode <= 2516) || payloadObj.narratorCode == 1033
        //|| payloadObj.narratorCode == 1040 ||

        if((payloadObj.narratorCode >= 2001 && payloadObj.narratorCode <= 2016) ||
            (payloadObj.narratorCode >= 2401 && payloadObj.narratorCode <= 2416)) {
            if((DataManager.getInstance().getCurrentRoomData()._myRole == 102 ||
                DataManager.getInstance().getCurrentRoomData()._myRole == 101) &&
                (DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.
                get(DataManager.getInstance().getCurrentRoomData()._mySeatNumber).deathType == 1)) {
                roomMenuLayer.getChildByName("explodeButton").setVisible(true);
            }
        }

        if(payloadObj.narratorCode == 1014 || payloadObj.narratorCode == 1042 || payloadObj.narratorCode == 1030) {
            for(var i = 1; i <= DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
                var myCard = roomCardLayer.getChildByName("card" + i);
                if(myCard != null && myCard != undefined) {
                    myCard.getChildByName("leftIcon").loadTexture(res.EmptyIcon_png);
                    myCard.getChildByName("leftIcon").setUserData(null);
                }
            }
            roomMenuLayer.getChildByName("quitCompeteButton").setVisible(false);
        }

        if(payloadObj.narratorCode == 1034) {
            roomMenuLayer.getChildByName("explodeButton").setVisible(false);
        }

        if(payloadObj.narratorCode == 1038) {
            showMicIconEnable = true;
            gameState = -1;
            if(!DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
                roomMenuLayer.getChildByName("speechButton").setVisible(true);
                roomCardLayer.setGagButtonVisible(true);
                showSendMessageButton();
            }
            closeMic();
        }

        if(payloadObj.narratorCode >= 2601 && payloadObj.narratorCode <= 2616) {
            closeMic();
            for(var i = 1; i <= DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
                var myCard = roomCardLayer.getChildByName("card" + i);
                if(myCard != null && myCard != undefined) {
                    myCard.removeChildByName("spineLizi");
                }
                var leftIcon = myCard.getChildByName("leftIcon");
                if(leftIcon.getUserData() != res.PoliceIcon_png) {
                    leftIcon.loadTexture(res.EmptyIcon_png);
                    leftIcon.setUserData(null);
                }
            }
            roomMenuLayer.getChildByName("endSpeechButton").setVisible(false);
            roomMenuLayer.getChildByName("speechButton").setVisible(false);
            roomMenuLayer.getChildByName("explodeButton").setVisible(false);
            roomMenuLayer.getChildByName("quitCompeteButton").setVisible(false);
        }

        AudioPlayer.playEffect(payloadObj.narratorCode, false, function(audioId) {
            var event = new cc.EventCustom("do_next_event");
            cc.eventManager.dispatchEvent(event);
        });
    },

    playEffect:function (payloadObj) {
        //TODO effect
        cc.log("effect " + payloadObj.effectCode);
        //此处不能取下一条
        // var event = new cc.EventCustom("do_next_event");
        // cc.eventManager.dispatchEvent(event);
    },

    assignRolePush:function (payloadObj) {
        isInCountDownProcess = false;
        roomMenuLayer.getChildByName("speechButton").setVisible(false);
        roomMenuLayer.getChildByName("bowen").setVisible(false);

        for (var i = 1; i <= DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
            if (DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(i) != null) {
                DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(i).currentCard = res.Beimian_png;
            }
        }
        if(DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
            // roomCardLayer.flipAllCard();
        } else {
            var myUserId = DataManager.getInstance().getUserData()._userId;
            DataManager.getInstance().getCurrentRoomData()._myRole = payloadObj.role;
            DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(DataManager.getInstance().getCurrentRoomData().getSeatNumber(myUserId))
                .currentCard = "res/" + payloadObj.role + ".png";
            // roomCardLayer.flipAllCard();
            roomMenuLayer.getChildByName("selfCard").loadTexture("res/roleold/" + payloadObj.role + ".png");
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    rogueSelect:function (payloadObj) {
        var rogueSelectDialog = new ModalDialogueBox(DialogType.RougueChooseRole, [payloadObj.role1, payloadObj.role2]);
        rogueSelectDialog.setTag(DialogType.RougueChooseRole);
        rogueSelectDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    rogueSelectTimeout:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.RougueChooseRole);
        roomCardLayer.flipCardWithSeatNumber(payloadObj.role, DataManager.getInstance().getCurrentRoomData()._mySeatNumber);
        roomMenuLayer.getChildByName("selfCard").loadTexture("res/roleold/"+payloadObj.role+".png");
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    cupidSelectPush: function (payloadObj) {
        var cupidSelectDialog = new ModalDialogueBox(DialogType.CupidChooseTarget, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum ,2]);
        cupidSelectDialog.setTag(DialogType.CupidChooseTarget);
        cupidSelectDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    cupidSelectTimeoutPush: function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.CupidChooseTarget);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    quitRoomPush:function (payloadObj) {
        if(payloadObj.seatNumber == DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
            quitRoomSendFlag = false;
            cc.director.getRunningScene().removeChildByTag(997001);
            quitTecentRoom(false, "");
        } else {
            if (payloadObj.gameState == 1 || isInCountDownProcess == true) {
                cc.log("quit push ");
                var card = roomCardLayer.getChildByName("card" + payloadObj.seatNumber);
                if(DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(payloadObj.seatNumber).deathType == 1) {
                    card.getChildByName("offlineStamp").setVisible(true);
                }
            } else {
                ToastUtil.showToast(payloadObj.message, 2);
                DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.remove(payloadObj.seatNumber);
                roomCardLayer.cancelPlayer(payloadObj.seatNumber);
            }
        }

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    voiceControlPush:function (payloadObj) {
        cc.log(payloadObj.microphoneEnable + payloadObj.earphoneEnable);
        if(cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
            if(payloadObj.microphoneEnable == true) {
                openMic();
                sendAliLog("speech", "info", "openMic");
                showSendMessageButton();
            } else {
                closeMic();
                sendAliLog("speech", "info", "closeMic");
                var speechButton = roomMenuLayer.getChildByName("speechButton");
                if(speechButton != null && ((!speechButton.isVisible()) || (!speechButton.isBright()))) {
                    hideSendMessageButton();
                }
            }

            if(payloadObj.earphoneEnable == true) {
                openSpeaker();
                sendAliLog("speech", "info", "openSpeaker");
            } else {
                closeSpeaker();
                sendAliLog("speech", "info", "closeSpeaker");
            }
        }
        if(payloadObj.microphoneEnable == true) {
            roomMenuLayer.enableEndSpeechButton(true);
            vibrate();
        } else {
            roomMenuLayer.enableEndSpeechButton(false);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    wolfSelectPush:function (payloadObj) {
        var wolfSelectPushDialog = new ModalDialogueBox(DialogType.WolfChooseTarget, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        wolfSelectPushDialog.setTag(DialogType.WolfChooseTarget);
        wolfSelectPushDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    wolfSelectTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.WolfChooseTarget);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    prophetSelectPush:function (payloadObj) {
        var prophetSelectPushDialog = new ModalDialogueBox(DialogType.ProphetChooseTarget, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        prophetSelectPushDialog.setTag(DialogType.ProphetChooseTarget);
        prophetSelectPushDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    prophetSelectTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.ProphetChooseTarget);
        var seatNumber = DataManager.getInstance().getCurrentRoomData().getSeatNumber(payloadObj.targetUserId);
        if(payloadObj.verificationResult == 1) {
            roomCardLayer.flipCardWithSeatNumber(1001, seatNumber);
        } else if (payloadObj.verificationResult == 2) {
            roomCardLayer.flipCardWithSeatNumber(1000, seatNumber);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    wildchildSelectPush:function (payloadObj) {
        cc.log("wildchild choose ");
        var wildChildSelectPushDialog = new ModalDialogueBox(DialogType.WildChildChooseTarget, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        wildChildSelectPushDialog.setTag(DialogType.WildChildChooseTarget);
        wildChildSelectPushDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    wildchildSelectTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.WildChildChooseTarget);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    guardSelectPush:function (payloadObj) {
        var guardSelectPushDialog = new ModalDialogueBox(DialogType.GuardChooseTarget, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        guardSelectPushDialog.setTag(DialogType.GuardChooseTarget);
        guardSelectPushDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    guardSelectTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.GuardChooseTarget);
        DataManager.getInstance().getCurrentRoomData()._guardLastSelect = -1;
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    stalkerSelectPush:function (payloadObj) {
        var stalkerSelectPushDialog = new ModalDialogueBox(DialogType.StalkerChooseTarget, payloadObj.targetSeatNumber);
        stalkerSelectPushDialog.setTag(DialogType.StalkerChooseTarget);
        stalkerSelectPushDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    stalkerSelectTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.StalkerChooseTarget);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    witchSelectPush:function (payloadObj) {
        cc.log("witchSelectPush " + payloadObj.isAntidoteUsed + " " + payloadObj.isPoisonUsed + " " + payloadObj.deadUserId);
        if(payloadObj.isAntidoteUsed == 1 || payloadObj.deadUserId == -1) {
            if(payloadObj.isPoisonUsed == 1) {
                if(payloadObj.isAntidoteUsed == 1) {
                    ToastUtil.showToast("解药和毒药均已使用", 2);
                } else {
                    ToastUtil.showToast("没有玩家被猎杀，毒药已使用", 2);
                }
            } else {
                if(payloadObj.isAntidoteUsed == 1) {
                    ToastUtil.showToast("解药已经用过", 2);
                } else {
                    ToastUtil.showToast("没有玩家被猎杀", 2);
                }
                var poisonUseDialog = new ModalDialogueBox(DialogType.PoisonUse, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
                poisonUseDialog.setTag(DialogType.PoisonUse);
                poisonUseDialog.popup();
            }
        } else if (payloadObj.isAntidoteUsed != 1 && payloadObj.deadUserId == DataManager.getInstance().getUserData()._userId
            && DataManager.getInstance().getCurrentRoomData()._timeProcess != 2) {
            if(payloadObj.isPoisonUsed == 1) {
                ToastUtil.showToast("女巫仅第一晚可自救，毒药已经用过", 2);
            } else {
                var poisonUseDialog = new ModalDialogueBox(DialogType.PoisonUse, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
                poisonUseDialog.setTag(DialogType.PoisonUse);
                poisonUseDialog.popup();
            }
        } else {
            var antidoteUseDialog = new ModalDialogueBox(DialogType.WitchChooseTarget, [payloadObj.deadUserId, payloadObj.isPoisonUsed]);
            antidoteUseDialog.setTag(DialogType.WitchChooseTarget);
            antidoteUseDialog.popup();
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    witchSelectTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.WitchChooseTarget);
        cc.director.getRunningScene().removeChildByTag(DialogType.PoisonUse);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    policeCompetePush:function (payloadObj) {
        var policeCompeteDialog = new ModalDialogueBox(DialogType.PoliceCompete);
        policeCompeteDialog.setTag(DialogType.PoliceCompete);
        policeCompeteDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    policeCompeteSelectTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.PoliceCompete);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    speechTimeoutPush:function (payloadObj) {
        cc.log(payloadObj.cmd);
        closeMic();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    votePolicePush:function(payloadObj) {
        var candidateList = payloadObj.candidateList;
        var votePoliceDialog = new ModalDialogueBox(DialogType.VotePolice ,[candidateList.length, 1, candidateList]);
        votePoliceDialog.setTag(DialogType.VotePolice);
        votePoliceDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    votePoliceTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.VotePolice);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    quitPoliceCompetePush:function (payloadObj) {
        var seatNumber = DataManager.getInstance().getCurrentRoomData().getSeatNumber(payloadObj.userId);
        var card = roomCardLayer.getChildByName("card" + seatNumber);
        if(card != null && card != undefined) {
            card.getChildByName("leftIcon").loadTexture(res.CompeteQuitIcon_png);
            card.getChildByName("leftIcon").setUserData(null);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    coupleRolePush:function (payloadObj) {
        cc.log("couple list " + payloadObj.coupleList);
        for(var i = 0; i < payloadObj.coupleList.length; i++) {
            var seatNumber = DataManager.getInstance().getCurrentRoomData().getSeatNumber(payloadObj.coupleList[i]);
            var card = roomCardLayer.getChildByName("card"+seatNumber);

            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(32, 32);

            var stateIcon = new ccui.ImageView(res.CupidIcon_png);
            stateIcon.setPosition(defaultItemLayout.width*0.5, defaultItemLayout.height*0.5);
            stateIcon.setAnchorPoint(0.5, 0.5);
            stateIcon.setScale(0.65, 0.65);
            defaultItemLayout.addChild(stateIcon, 1);
            card.getChildByName("iconList").pushBackCustomItem(defaultItemLayout);
        }

        if (cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
            var spineBoy = new sp.SkeletonAnimation('res/spine/chuanxin.json', 'res/spine/chuanxin.atlas', 1.0);
            spineBoy.setPosition(cc.director.getVisibleSize().width * 0.5, cc.director.getVisibleSize().height * 0.5);
            spineBoy.setAnchorPoint(0.5, 0.5);
            spineBoy.setAnimation(0, 'chuanxin', false);
            roomMenuLayer.addChild(spineBoy, 4);
        }

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    wolfRolePush:function (payloadObj) {
        for(var i = 0; i < payloadObj.wolfList.length; i++) {
            var wolfUser = payloadObj.wolfList[i];
            var mySeatNumber = DataManager.getInstance().getCurrentRoomData().getSeatNumber(DataManager.getInstance().getUserData()._userId);
            if(mySeatNumber != wolfUser.seatNumber) {
                roomCardLayer.flipCardWithSeatNumber(wolfUser.roleId, wolfUser.seatNumber);
            }
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    systemMessagePush:function (payloadObj) {
        cc.log("system message " + payloadObj.messageContent);
        ToastUtil.showToast(payloadObj.messageContent ,2.0);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    competeUserPush:function (payloadObj) {
        cc.log("police candidate list " + payloadObj.candidateList);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    policeElectionPush:function (payloadObj) {
        cc.log("police election push ok");

        for(var i = 1; i <= DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
            var myCard = roomCardLayer.getChildByName("card" + i);
            if(myCard != null && myCard != undefined) {
                myCard.getChildByName("leftIcon").loadTexture(res.EmptyIcon_png);
                myCard.getChildByName("leftIcon").setUserData(null);
            }
        }
        roomMenuLayer.getChildByName("quitCompeteButton").setVisible(false);

        var card = roomCardLayer.getChildByName("card" + payloadObj.policeSeatNumber);
        card.getChildByName("leftIcon").loadTexture(res.PoliceIcon_png);
        card.getChildByName("leftIcon").setUserData(res.PoliceIcon_png);

        if (cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
            var spineBoy = new sp.SkeletonAnimation('res/spine/jinghui.json', 'res/spine/jinghui.atlas', 1.0);
            spineBoy.setPosition(card.width * 0.5, card.height * 0.5);
            spineBoy.setAnchorPoint(0.5, 0.5);
            spineBoy.setAnimation(0, 'jinghui', false);
            card.addChild(spineBoy, 4);
        }

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    drawSpeakIconPush:function (payloadObj) {
        for (var i = 1; i <= DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
            var card = roomCardLayer.getChildByName("card" + i);
            if(card != null) {
                card.removeChildByName("spineLizi");
            }
        }
        var seatNumber = DataManager.getInstance().getCurrentRoomData().getSeatNumber(payloadObj.userId);
        if(seatNumber != DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
            hideSendMessageButton();
        }
        var card = roomCardLayer.getChildByName("card"+seatNumber);
        var spineLizi = new sp.SkeletonAnimation('res/spine/lizi.json', 'res/spine/lizi.atlas', 1.0);
        spineLizi.setPosition(card.width / 2, card.height / 2);
        spineLizi.setScale(1.2, 1.2);
        spineLizi.setAnchorPoint(0.5, 0.5);
        spineLizi.setAnimation(0, 'lizi', true);
        spineLizi.setName("spineLizi");
        card.addChild(spineLizi, 1);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    cancelSpeakIconPush:function (payloadObj) {
        for (var i = 1; i <= DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
            var card = roomCardLayer.getChildByName("card" + i);
            if(card != null) {
                card.removeChildByName("spineLizi");
            }
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    showVoteResultPush:function (payloadObj) {
        var showVoteResultDialog = new ModalDialogueBox(DialogType.ShowVoteResult, [payloadObj.voteResultList, payloadObj.result]);
        showVoteResultDialog.setTag(DialogType.ShowVoteResult);
        showVoteResultDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    deathMessagePush:function (payloadObj) {
        var seatNumber = payloadObj.deadUserSeatNumber;
        DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber).deathType = payloadObj.deathType;
        var card = roomCardLayer.getChildByName("card" + seatNumber);
        var cardIn = card.getChildByName("cardIn");
        var cardOut = card.getChildByName("cardOut");
        card.removeChildByName("spineLizi");

        card.getChildByName("peopleBg").setBright(false);
        card.getChildByName("people").setBright(false);

        cardIn.setBright(false);
        cardOut.setBright(false);

        var deathStamp = card.getChildByName("deathStamp");
        if(deathStamp != null && deathStamp != undefined) {
            deathStamp.loadTexture(DeathType.get(payloadObj.deathType));
            deathStamp.setVisible(true);
        }

        if(payloadObj.deadUserSeatNumber == DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
            closeMic();
            roomMenuLayer.getChildByName("endSpeechButton").setVisible(false);
            roomMenuLayer.getChildByName("speechButton").setVisible(false);
            roomMenuLayer.getChildByName("explodeButton").setVisible(false);
            roomMenuLayer.getChildByName("quitCompeteButton").setVisible(false);
        }

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    cancelCountToStartPush:function (payloadObj) {
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    transferPolicePush:function (payloadObj) {
        cc.log("transferPolicePush");
        var votePoliceDialog = new ModalDialogueBox(DialogType.TransferPolice ,[DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        votePoliceDialog.setTag(DialogType.TransferPolice);
                                votePoliceDialog.popup();
                                cc.log("transferPolicePush2");

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    transferPoliceTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.TransferPolice);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    transferPoliceResultPush:function (payloadObj) {
        for(var i = 1; i <= DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
            var myCard = roomCardLayer.getChildByName("card" + i);
            if(myCard != null && myCard != undefined) {
                if (i != payloadObj.targetUserSeatNumber) {
                    myCard.getChildByName("leftIcon").loadTexture(res.EmptyIcon_png);
                    myCard.getChildByName("leftIcon").setUserData(null);
                } else {
                    var spineBoy = new sp.SkeletonAnimation('res/spine/jinghui.json', 'res/spine/jinghui.atlas', 1.0);
                    spineBoy.setPosition(myCard.width * 0.5, myCard.height * 0.5);
                    spineBoy.setAnchorPoint(0.5, 0.5);
                    spineBoy.setAnimation(0, 'jinghui', false);
                    myCard.addChild(spineBoy, 4);
                    myCard.getChildByName("leftIcon").loadTexture(res.PoliceIcon_png);
                    myCard.getChildByName("leftIcon").setUserData(res.PoliceIcon_png);
                }
            }
        }

        // if((DataManager.getInstance().getCurrentRoomData()._myRole == 102 ||
        //     DataManager.getInstance().getCurrentRoomData()._myRole == 101) &&
        //     (DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.
        //     get(DataManager.getInstance().getCurrentRoomData()._mySeatNumber).deathType == 1)) {
        //     roomMenuLayer.getChildByName("explodeButton").setVisible(true);
        // }

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    organizeSpeechPush:function (payloadObj) {
        var organizeSpeechDialog = new ModalDialogueBox(DialogType.OrganizeSpeech);
        organizeSpeechDialog.setTag(DialogType.OrganizeSpeech);
        organizeSpeechDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    organizeSpeechTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.OrganizeSpeech);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    votePush:function (payloadObj) {
        var voteDialog = new ModalDialogueBox(DialogType.Vote, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        voteDialog.setTag(DialogType.Vote);
        voteDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    voteTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.Vote);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    policeCallVotePush:function (payloadObj) {
        var policeCallVoteDialog = new ModalDialogueBox(DialogType.PoliceCallVote, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        policeCallVoteDialog.setTag(DialogType.PoliceCallVote);
        policeCallVoteDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    policeCallVoteTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.PoliceCallVote);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    hunterFlopPush:function (payloadObj) {
        if(payloadObj.hunterSeatNumber != DataManager.getInstance().getCurrentRoomData().getSeatNumber(DataManager.getInstance().getUserData()._userId)) {
            roomCardLayer.flipCardWithSeatNumber(210, payloadObj.hunterSeatNumber);
        }

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    hunterKillResultPush:function (payloadObj) {
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    hunterKillPush:function (payloadObj) {
        var hunterKillDialog = new ModalDialogueBox(DialogType.HunterKill, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        hunterKillDialog.setTag(DialogType.HunterKill);
        hunterKillDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    hunterKillTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.HunterKill);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    showIdiotPush:function (payloadObj) {
        if(payloadObj.idiotSeatNumber != DataManager.getInstance().getCurrentRoomData().getSeatNumber(DataManager.getInstance().getUserData()._userId)) {
            roomCardLayer.flipCardWithSeatNumber(211, payloadObj.idiotSeatNumber);
        }
        DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(payloadObj.idiotSeatNumber).deathType = 11;
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    prophetSelectResponse:function (payloadObj) {
        var seatNumber = DataManager.getInstance().getCurrentRoomData().getSeatNumber(payloadObj.targetUserId);
        if(payloadObj.verificationResult == 1) {
            roomCardLayer.flipCardWithSeatNumber(1001, seatNumber);
        } else {
            roomCardLayer.flipCardWithSeatNumber(1000, seatNumber);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    gestureSelectPush:function (payloadObj) {
        var gestureChooseDialog = new ModalDialogueBox(DialogType.GestureChoose);
        gestureChooseDialog.setTag(DialogType.GestureChoose);
        gestureChooseDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    gestureSelectTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.GestureChoose);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    gestureSelectResultPush:function (payloadObj) {
        var gestureList = payloadObj.gestureList;
        var gestureString = "";
        for(var i = 0; i < gestureList.length; i++) {
            gestureString = gestureString + DataManager.getInstance().getCurrentRoomData().getSeatNumber(gestureList[i].targetUserId)
                + "号玩家是";
            if(gestureList[i].gestureType == 1) {
                gestureString = gestureString + "好人";
            } else if (gestureList[i].gestureType == 2) {
                gestureString = gestureString + "愚民";
            } else {
                gestureString = gestureString + "坏人";
            }
            if(i != gestureList.length - 1) {
                gestureString+="\n";
            }
        }
        slideDialog.addSystemMessage(gestureString);
        ToastUtil.showToast(gestureString, 3.0);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    gagelderSelectPush:function (payloadObj) {
        var gagelderSelectDialog = new ModalDialogueBox(DialogType.GagElderChooseTarget, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        gagelderSelectDialog.setTag(DialogType.GagElderChooseTarget);
        gagelderSelectDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    gagelderSelectTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.GagElderChooseTarget);
        DataManager.getInstance().getCurrentRoomData()._gagLastSelect = -1;
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    explodeFailedResponse:function (payloadObj) {
        ToastUtil.showToast("当前有人正在自爆，自爆失败", 2);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    wolfExplodedPush:function (payloadObj) {
        for(var i = 999001; i <= 999028; i++) {
            if(cc.director.getRunningScene().getChildByTag(i) != null) {
                cc.director.getRunningScene().removeChildByTag(i);
            }
        }
        if(cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
            // jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/AgoraUtil", "muteLocalAudioStream", "(Z)V", true);
            // jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/AgoraUtil", "muteAllRemoteAudioStreams", "(Z)V", true);
            closeMic();
            sendAliLog("speech", "info", "closeMic");
            closeSpeaker();
            sendAliLog("speech", "info", "closeSpeaker");
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    whiteWolfKingSelectPush:function (payloadObj) {
        var whiteWolfKingSelectDialog = new ModalDialogueBox(DialogType.WhiteWolfKingSelect, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        whiteWolfKingSelectDialog.setTag(DialogType.WhiteWolfKingSelect);
        whiteWolfKingSelectDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    whiteWolfKingSelectTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.WhiteWolfKingSelect);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    planeVotePush:function (payloadObj) {
        var planeUserSeatNumberList = payloadObj.planeUserSeatNumberList;
        var planeVoteDialog = new ModalDialogueBox(DialogType.PlaneVote, [planeUserSeatNumberList.length, 1, planeUserSeatNumberList]);
        planeVoteDialog.setTag(DialogType.PlaneVote);
        planeVoteDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    planeVoteTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.PlaneVote);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    gameResultPush:function (payloadObj) {
        var gameResultDialog = new ModalDialogueBox(DialogType.GameResult, payloadObj);
        gameResultDialog.setTag(DialogType.GameResult);
        gameResultDialog.popup();
        roomMenuLayer.getChildByName("explodeButton").setVisible(false);
        //此处不用直接取下一条
    },

    chooseMvpPush:function (payloadObj) {
        var chooseMvpDialog = new ModalDialogueBox(DialogType.ChooseMvp, [DataManager.getInstance().getCurrentRoomData()._totalPlayerNum, 1]);
        chooseMvpDialog.setTag(DialogType.ChooseMvp);
        chooseMvpDialog.popup();
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    chooseMvpTimeoutPush:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(DialogType.ChooseMvp);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    mvpResultPush:function (payloadObj) {
        if(payloadObj.targetUserSeatNumber != -1) {
            var mvpDialog = new ModalDialogueBox(DialogType.ShowMvp, payloadObj.targetUserSeatNumber);
            mvpDialog.setTag(DialogType.ShowMvp);
            mvpDialog.popup();
        } else {
            ToastUtil.showToast("本局无MVP", 2.0);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    gagelderEffectPush:function (payloadObj) {
        var card = roomCardLayer.getChildByName("card" + payloadObj.targetUserSeatNumber);
        card.getChildByName("rightIcon").loadTexture(res.GagIcon_png);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    userCompetePolicePush:function (payloadObj) {
        for(var i = 0; i < payloadObj.seatNumberList.length; i++) {
            var card = roomCardLayer.getChildByName("card" + payloadObj.seatNumberList[i]);
            card.getChildByName("leftIcon").loadTexture(res.CompeteIcon_png);
            card.getChildByName("leftIcon").setUserData(null);

            if(payloadObj.seatNumberList[i] == DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
                if(payloadObj.seatNumberList.length != DataManager.getInstance().getCurrentRoomData()._totalPlayerNum) {
                    var quitCompeteButton = roomMenuLayer.getChildByName("quitCompeteButton");
                    quitCompeteButton.setVisible(true);
                }
            }
        }

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    showRolePush:function (payloadObj) {
        var myRoleList = payloadObj.roleList;
        for(var i = 0; i < myRoleList.length; i++) {
            roomCardLayer.flipCardWithSeatNumber(myRoleList[i].roleId, myRoleList[i].seatNumber);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    worldMessageFailedResponse:function (payloadObj) {
        ToastUtil.showToast(payloadObj.message, 2);
    },

    worldMessagePush:function (payloadObj) {
        slideDialog.addWorldMessage(payloadObj.messageText, payloadObj.nickName, payloadObj.userAvatar, payloadObj.userId);
        DataManager.getInstance().getWorldMessageData().addMessage(payloadObj);
    },

    gameResetPush:function (payloadObj) {
        DataManager.getInstance().getCurrentRoomData().gameReset(payloadObj.offlineUserSeatNumberList);
        roomCardLayer.gameReset(payloadObj.offlineUserSeatNumberList);
        roomMenuLayer.gameReset();
        slideDialog.clearSystemMessage();
        closeMic();
        inGameFlag = false;
        isInCountDownProcess = false;
        for(var i = 999001; i <= 999028; i++) {
            if(cc.director.getRunningScene().getChildByTag(i) != null) {
                cc.director.getRunningScene().removeChildByTag(i);
            }
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    noPassVoiceControlPush:function (payloadObj) {
        roomMenuLayer.enableEndSpeechButton(false);
        vibrate();

        openMic();
        openSpeaker();

        showSendMessageButton();

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    delayPush:function (payloadObj) {
        setTimeout(function () {
            var event = new cc.EventCustom("do_next_event");
            cc.eventManager.dispatchEvent(event);
        }, payloadObj.delayTime);
    },

    textSpeechPush:function (payloadObj) {
        ToastUtil.showToastInMiddle(payloadObj.speechUserSeatNumber+"号玩家:"+payloadObj.speechText, 2.0);
        var userInfo = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(payloadObj.speechUserSeatNumber);
        if(userInfo != null && userInfo != undefined) {
            slideDialog.addSystemMessage(payloadObj.speechText, userInfo.nickname, userInfo.skin);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    userKickOutPush:function (payloadObj) {
        if(payloadObj.targetSeatNumber == DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
            quitTecentRoom(false, payloadObj.sourceSeatNumber+"号玩家踢出了您");
        } else {
            ToastUtil.showToast(payloadObj.sourceSeatNumber+"号玩家踢出了"+payloadObj.targetSeatNumber+"号玩家", 2);
            DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.remove(payloadObj.targetSeatNumber);
            roomCardLayer.cancelPlayer(payloadObj.targetSeatNumber);
            var event = new cc.EventCustom("do_next_event");
            cc.eventManager.dispatchEvent(event);
        }
    },

    userKickOutFailedResponse:function (payloadObj) {
        if (payloadObj.message != null && payloadObj.message != undefined && payloadObj.message != "") {
             ToastUtil.systemToastInMiddle(payloadObj.message + "", 2);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    voiceMemberIdPush:function (payloadObj) {
        var voiceMemberIdList = payloadObj.voiceMemberIdList;
        VoiceMemberIdMap.clear();
        for(var i = 0; i < voiceMemberIdList.length; i++) {
            cc.log("jijun voice :" + voiceMemberIdList[i].voiceMemberId + " " + voiceMemberIdList[i].seatNumber);
            VoiceMemberIdMap.put(voiceMemberIdList[i].voiceMemberId, voiceMemberIdList[i].seatNumber);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    userGagPush:function (payloadObj) {
        var card = roomCardLayer.getChildByName("card"+payloadObj.targetSeatNumber);
        if(card != null && card != undefined) {
            card.getChildByName("gagButton").setVisible(false);
        }
        if(payloadObj.targetSeatNumber == DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
            var speechButton = roomMenuLayer.getChildByName("speechButton");
            speechButton.getChildByName("speechButtonLabel").loadTexture(res.GagSpeechLabel_png);
            speechButton.setEnabled(false);
            speechButton.setBright(false);
            roomMenuLayer.getChildByName("bowen").setVisible(false);
            closeMic();
        } else {
            ToastUtil.showToastInMiddle(payloadObj.sourceSeatNumber+"号玩家禁言了"+payloadObj.targetSeatNumber+"号玩家",2.0);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    slideBarSystemMessagePush:function (payloadObj) {
        slideDialog.addPeriodSystemMessage(payloadObj);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    inSeatPush:function (payloadObj) {
        var joinPlayer = payloadObj.player;
        joinPlayer.currentCard = res.Beimian_png;
        joinPlayer.deathType = 1;
        DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.put(joinPlayer.seatNumber, joinPlayer);
        roomCardLayer.drawPlayer(joinPlayer.seatNumber);

        if(joinPlayer.userId == DataManager.getInstance().getUserData()._userId) {
            DataManager.getInstance().getCurrentRoomData()._isOnLooker = false;
            roomMenuLayer.getChildByName("onSeatButton").setVisible(false);
            roomMenuLayer.getChildByName("speechButton").setVisible(true);
            roomMenuLayer.getChildByName("inviteButton").setVisible(true);
            roomMenuLayer.getChildByName("prepareButton").setVisible(true);
            DataManager.getInstance().getCurrentRoomData()._mySeatNumber = joinPlayer.seatNumber;
            //roomMenuLayer.getChildByName("locationText").setString(joinPlayer.seatNumber);
            //roomMenuLayer.getChildByName("locationText").setVisible(true);
            //roomMenuLayer.getChildByName("locationImage").setVisible(true);
            //roomMenuLayer.getChildByName("youAraOnlooker").setVisible(false);
            MqttHelper.getInstance().voiceMemberIdRequest(myTecentMemberId);
        }

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    audienceQuitRoomPush:function (payloadObj) {
        quitTecentRoom(false, "");
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    idolDeadToWildchildPush:function (payloadObj) {
        var wolfList = payloadObj.wolfList;
        for (var i = 0; i < wolfList.length; i++) {
            roomCardLayer.flipCardWithSeatNumber(wolfList[i].wolfRoleId, wolfList[i].wolfSeatNumber);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    idolDeadToWolfPush:function (payloadObj) {
        roomCardLayer.flipCardWithSeatNumber(204, payloadObj.wildchildSeatNumber);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    inSeatFailedResponse:function (payloadObj) {
        ToastUtil.systemToastInMiddle(payloadObj.message, 2.0);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    roomJoinRoomResponse:function (payloadObj) {
        cc.log("in join room response ");
        resumeRequestSendFlag = false;
        DataManager.getInstance().getCurrentRoomData().clear();
        DataManager.getInstance().getCurrentRoomData().parseFromObj(payloadObj);

        if(DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
            roomMenuLayer.getChildByName("onSeatButton").setVisible(true);
            roomMenuLayer.getChildByName("inviteButton").setVisible(false);
            roomMenuLayer.getChildByName("speechButton").setVisible(false);
            roomMenuLayer.getChildByName("speechButton").setBright(true);
            roomMenuLayer.getChildByName("speechButton").setEnabled(true);
        } else {
            roomMenuLayer.getChildByName("onSeatButton").setVisible(false);
            roomMenuLayer.getChildByName("inviteButton").setVisible(true);
            roomMenuLayer.getChildByName("speechButton").setVisible(true);
            roomMenuLayer.getChildByName("speechButton").setBright(true);
            roomMenuLayer.getChildByName("speechButton").setEnabled(true);
        }

        showMicIconEnable = true;
        gameState = -1;
        inGameFlag = false;

        for (var i = 0; i < DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
            roomCardLayer.cancelPlayer(i+1);
            var cardLayout = roomCardLayer.getChildByName("card" + (i+1));
            cardLayout.getChildByName("deathStamp").setVisible(false);
            cardLayout.getChildByName("offlineStamp").setVisible(false);
            var cardIn = cardLayout.getChildByName("cardIn");
            var cardOut = cardLayout.getChildByName("cardOut");
            cardIn.setBright(true);
            cardOut.setBright(true);
            cardIn.loadTextureNormal(res.CardBg_png);
            cardIn.loadTexturePressed(res.CardBg_png);
            cardOut.loadTextureNormal(res.CardBg_png);
            cardOut.loadTexturePressed(res.CardBg_png);
            cardLayout.getChildByName("peopleBg").setVisible(true);
            cardLayout.getChildByName("cup").setVisible(true);
            //cardLayout.getChildByName("cupBg").setVisible(true);
            cardLayout.getChildByName("rightIcon").loadTexture(res.EmptyIcon_png);
            cardLayout.getChildByName("leftIcon").loadTexture(res.EmptyIcon_png);
            cardLayout.getChildByName("leftIcon").setUserData(null);
            cardLayout.getChildByName("iconList").removeAllChildren();
            cardLayout.getChildByName("iconList").setVisible(false);
            cardLayout.getChildByName("gagButton").setVisible(false);
            cardLayout.getChildByName("nameText").setVisible(true);
            cardLayout.getChildByName("nameText").setString("");
            cardLayout.getChildByName("cupText").setVisible(true);
            cardLayout.getChildByName("cupText").setString("");
            var playerInfo = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(i + 1);
            if (playerInfo != null && playerInfo != undefined) {
                var card = roomCardLayer.getChildByName("card" + (playerInfo.seatNumber));
                card.getChildByName("nameText").setVisible(true);
                card.getChildByName("nameText").setString(playerInfo.nickname);
                card.getChildByName("cupText").setVisible(true);
                card.getChildByName("cupText").setString(playerInfo.cup + "");
                card.getChildByName("people").setVisible(true);
                card.getChildByName("people").loadTextureNormal(SkinMap.get(playerInfo.skin)[0]);
                card.getChildByName("people").loadTexturePressed(SkinMap.get(playerInfo.skin)[0]);
                //card.getChildByName("peopleSeat").setVisible(true);
                if (playerInfo.prepareState == 1) {
                    card.getChildByName("prepareIcon").setVisible(true);
                    if((i+1) == DataManager.getInstance().getUserData()._userId) {
                        roomMenuLayer.getChildByName("prepareButton").setVisible(false);
                        roomMenuLayer.getChildByName("cancelPrepareButton").setVisible(true);
                    }
                } else {
                    card.getChildByName("prepareIcon").setVisible(false);
                    if((i+1) == DataManager.getInstance().getUserData()._userId) {
                        roomMenuLayer.getChildByName("prepareButton").setVisible(true);
                        roomMenuLayer.getChildByName("cancelPrepareButton").setVisible(false);
                    }
                }
            }
        }

        notifySceneShow();

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    requestResumeFailedResponse:function (payloadObj) {
        resumeRequestSendFlag = false;
        quitTecentRoom(false, payloadObj.message);
    },

    roomResumePush:function (payloadObj) {
        resumeRequestSendFlag = false;
        DataManager.getInstance().getCurrentRoomData().clear();
        DataManager.getInstance().getResumeData().parseData(payloadObj);

        notifySceneShow();

        cc.director.runScene(new RoomScene(true));
    },

    rogueSelectWolfToRoguePush:function (payload) {
        var wolfList = payload.wolfList;
        for (var i = 0; i < wolfList.length; i++) {
            roomCardLayer.flipCardWithSeatNumber(wolfList[i].wolfRoleId, wolfList[i].wolfSeatNumber);
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    rogueSelectWolfToWolfPush:function (payload) {
        roomCardLayer.flipCardWithSeatNumber(payload.roleId, payload.rogueSeatNumber);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    roomSendGiftFailedResponse:function (payload) {
        ToastUtil.systemToastInMiddle(payload.message, 2.0);
    },

    roomAddFriendFailedResponse:function (payload) {
        ToastUtil.systemToastInMiddle(payload.message, 2.0);
    },

    roomAddFriendPush:function (payload) {
        ToastUtil.systemToastInMiddle("添加成功", 2.0);
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    roomSendGiftPush:function (payload) {
        var giftName = "";
        switch (payload.giftType) {
            case 1:
                giftName = "10朵鲜花";
                break;
            case 2:
                giftName = "100朵鲜花";
                break;
            case 3:
                giftName = "520朵鲜花";
                break;
            case 4:
                giftName = "1枚鸡蛋";
                break;
            case 5:
                giftName = "1只弱鸡";
                break;
            case 6:
                giftName = "1颗炸弹";
                break;
            case 14:
                giftName = "110朵鲜花";
                break;
            case 15:
                giftName = "1个猪头";
                break;
        }

        var fromSeatName = payload.fromSeatNumber + "号";
        if (fromSeatName == "-1号") {
            fromSeatName = "旁观";
        }

        ToastUtil.systemToastInMiddle(fromSeatName + "玩家送给" + payload.toSeatNumber + "号玩家" + giftName, 2.0);
        cc.log("payload.fromSeatNumber : " + payload.fromSeatNumber);
        var nodeFrom = roomCardLayer.getChildByName("card" + payload.fromSeatNumber);
        if (nodeFrom == undefined || nodeFrom == null || nodeFrom == "") {
            nodeFrom = roomMenuLayer.getChildByName("selfCard");
        }
        var nodeTo = roomCardLayer.getChildByName("card" + payload.toSeatNumber);
        PropsSpineSprite.playAninWithNode(payload.giftType, nodeFrom, nodeTo, function () {
        });
        if(payload.giftType == 3 || payload.giftType == 6) {
            ClickRecod("DiamondUseType", UMengStatistics.get(payload.giftType));
        } else if(payload.giftType == 1 || payload.giftType == 2 ||
            payload.giftType == 4 || payload.giftType == 5) {
            ClickRecod("GoldUseType", UMengStatistics.get(payload.giftType));
        }
        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    _backListener:null,

    ctor:function (isResume) {
        this._super();

        cc.log("roomScene ctor");

        _isResume = isResume;
        this._backListener = cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if(keyCode == cc.KEY.back) {
                    cc.log("jijun android back");
                    if(cc.director.getRunningScene().getChildByName("otherHomepageLayer") != null
                        && cc.director.getRunningScene().getChildByName("otherHomepageLayer") != undefined) {
                        cc.director.getRunningScene().removeChildByName("otherHomepageLayer");
                    } else {
                        var quitAppConfirmDialog = new CommonDialog(DialogType.QuitRoomConfirmDialog, -1);
                        quitAppConfirmDialog.setTag(DialogType.QuitRoomConfirmDialog);
                        quitAppConfirmDialog.popup();
                    }
                } else if(keyCode == cc.KEY.menu) {
                    cc.log("jijun android menu");
                }
            }
        }, this);
    },

    onEnter: function () {
        this._super();

        cc.log("roomScene onEnter");

        var _this = this;

        inGameFlag = false;
        showMicIconEnable = true;
        gameState = -1;

        readySendFlag = false;
        cancelReadySendFlag = false;
        quitRoomSendFlag = false;
        readySendTime = 0;
        cancelReadySendTime = 0;
        quitRoomSendTime = 0;
        myTecentMemberId = -1;

        roomBgLayer = new RoomBgLayer();
        roomBgLayer.setName("roomBgLayer");
        roomBgLayer.retain();
        this.addChild(roomBgLayer);

        roomCardLayer = new RoomCardLayer();
        roomCardLayer.setName("roomCardLayer");
        roomCardLayer.retain();
        this.addChild(roomCardLayer);

        roomMenuLayer = new RoomMenuLayer();
        roomMenuLayer.setName("roomMenuLayer");
        roomMenuLayer.retain();
        this.addChild(roomMenuLayer);

        slideDialog = new SlideDialogLayer(DialogType.RoomSlideDialog);
        slideDialog.setName("slideDialogLayer");
        slideDialog.loadWorldMessage();
        slideDialog.retain();
        this.addChild(slideDialog, 10);

        sendAliLog("system", "info", "roomScene onEnter");

        joinInTecentRoomFailedTimes = 0;
        quitTecentRoomFailedTimes = 0;

        _lastShowMicIconTime = new Map();

        if(cc.sys.os === cc.sys.OS_IOS || cc.sys.os === cc.sys.OS_ANDROID) {
            _gcloudvoice.joinTeamRoom(getChannelName(), 5000);

            _gcloudvoice.onJoinRoomSucc = function (memberId) {
                cc.log("join room success " + memberId);
                sendAliLog("speech", "info", "join teamRoom success");
                isInTecentRoom = true;
                myTecentMemberId = memberId;

                cc.sys.localStorage.setItem("lastRoomId", DataManager.getInstance().getCurrentRoomData()._roomId);

                if(!DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
                    MqttHelper.getInstance().voiceMemberIdRequest(memberId);
                }

                if(_isResume) {
                    if (DataManager.getInstance().getResumeData()._resume.microphoneEnable == 1) {
                        openMic();
                        showSendMessageButton();
                    } else {
                        closeMic();
                        var speechButton = roomMenuLayer.getChildByName("speechButton");
                        if(speechButton != null && ((!speechButton.isVisible()) || (!speechButton.isBright()))) {
                            hideSendMessageButton();
                        }
                    }

                    if (DataManager.getInstance().getResumeData()._resume.earphoneEnable == 1) {
                        openSpeaker();
                    } else {
                        closeSpeaker();
                    }
                } else {
                    openSpeaker();
                    closeMic();
                }

                sendAliLog("speech", "info", "openSpeaker");
            };

            _gcloudvoice.onJoinRoomError = function (memberId) {
                cc.log("join tecent room error");
                isInTecentRoom = false;
                if(joinInTecentRoomFailedTimes < 2) {
                    joinInTecentRoomFailedTimes++;
                    setTimeout(function () {
                        _gcloudvoice.joinTeamRoom(getChannelName(), 5000);
                    },500);
                } else {
                    joinInTecentRoomFailedTimes = 0;
                    if(isMqttConnected()) {
                        MqttHelper.getInstance().quitRoomRequest();
                    }
                    cc.director.runScene(new HallScene("加入语音房间失败，请稍后重试..."));
                }
                sendAliLog("speech", "error", "join teamRoom error");
            };

            _gcloudvoice.onQuitRoomSucc = function (roomName) {
                cc.log("quit room success " + roomName);
                isInTecentRoom = false;
                cc.sys.localStorage.setItem("lastRoomId", -1);
                sendAliLog("speech", "info", "quit teamRoom success");
                if(roomName == getChannelName()) {
                    cc.audioEngine.stopMusic(true);
                    if (!(cc.director.getRunningScene() instanceof HallScene)) {
                        DataManager.getInstance().getCurrentRoomData().clear();
                        cc.director.runScene(new HallScene(tecentErrorMessage));
                    }
                }
            };

            _gcloudvoice.onQuitRoomError = function (roomName) {
                cc.log("quit room failed " + roomName);
                sendAliLog("speech", "error", "quit teamRoom success");
                cc.audioEngine.stopMusic(true);
                if(quitTecentRoomFailedTimes < 2) {
                    quitTecentRoomFailedTimes++;
                    setTimeout(function () {
                        _gcloudvoice.quitTeamRoom(getChannelName(), 5000);
                    }, 500);
                } else {
                    quitTecentRoomFailedTimes = 0;
                    if(!(cc.director.getRunningScene() instanceof HallScene)) {
                        cc.director.runScene(new HallScene("退出语音房间异常,请重启APP..."));
                    }
                }
            };

            //test
            _gcloudvoice.onMemberVoice = function (message) {
                // cc.log("on Member voice change");
                // cc.log(message);
                var pairs = message.split('#');
                // cc.log("onMemberVoice Length" + pairs.length);
                // resume之后 其他玩家能听到狼人说话的防护
                // if(gameState != null && gameState != undefined) {
                //     if(gameState == 1) {
                //         if (pairs.length > 1) {
                //             var myRole = DataManager.getInstance().getCurrentRoomData()._myRole;
                //             if (myRole != 101 && myRole != 102 && myRole != 204) {
                //                 // 不是狼人及野孩子
                //                 if (myRole == 201) {
                //                     // 是盗贼
                //                     var seatNumber = DataManager.getInstance().getCurrentRoomData()._mySeatNumber;
                //                     var currentCard = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(seatNumber).currentCard;
                //                     if (currentCard != null && currentCard != undefined) {
                //                         if (currentCard != res.Wolf_png && currentCard != res.Whitewolfking_png) {
                //                             closeSpeaker();
                //                             closeMic();
                //                         }
                //                     }
                //                 } else {
                //                     // 不是盗贼
                //                     closeSpeaker();
                //                     closeMic();
                //                 }
                //             }
                //         }
                //     }
                // }

                if(showMicIconEnable) {
                    for (var i = 0; i < pairs.length; i++) {
                        var pair = pairs[i].split(':');
                        // cc.log(pair[0] + "," + pair[1]);
                        var seatNumber = VoiceMemberIdMap.get(pair[0]);
                        // cc.log("on Member voice change " + seatNumber);
                        if (seatNumber != null && seatNumber != undefined && seatNumber > 0 && seatNumber <= 16) {
                            if(roomCardLayer != null && roomCardLayer != undefined) {
                                if(roomCardLayer instanceof RoomCardLayer) {
                                    var card = roomCardLayer.getChildByName("card" + seatNumber);
                                    if (card != undefined && card != null) {
                                        card.getChildByName("offlineStamp").setVisible(false);
                                    }
                                    if (pair[1] == 1) {
                                        roomCardLayer.getChildByName("spineMic" + seatNumber).setVisible(true);
                                        _lastShowMicIconTime.put(seatNumber, new Date().getTime());
                                    } else if (pair[1] == 2) {
                                        _lastShowMicIconTime.put(seatNumber, new Date().getTime());
                                    } else if (pair[1] == 0) {
                                        roomCardLayer.getChildByName("spineMic" + seatNumber).setVisible(false);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        MqttClient.getInstance().clearMqttCallBackMap();
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.CLOCK_COUNTDOWN_PUSH, this.clockCountDown);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.SYSTEM_KICKOUT_PUSH, this.systemKickout);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.PLAYER_JOINROOM_PUSH, this.playerJoin);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.PREPARE_PUSH, this.playerPrepare);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.CANCEL_PREPARE_PUSH, this.playerCancelPrepare);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.PLAY_NARRATOR_PUSH, this.playNarrator);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ASSIGN_ROLE_PUSH, this.assignRolePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ROGUE_SELECT_PUSH, this.rogueSelect);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ROGUE_SELECT_TIMEOUT_PUSH, this.rogueSelectTimeout);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.QUiT_ROOM_PUSH, this.quitRoomPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.VOICE_CONTROL_PUSH, this.voiceControlPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.COUNT_TO_START_PUSH, this.countDownToStart);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.PLAY_EFFECT_PUSH, this.playEffect);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.CUPID_SELECT_PUSH, this.cupidSelectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.CUPID_SELECT_TIMEOUT_PUSH,this.cupidSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WOLF_SELECT_PUSH, this.wolfSelectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WOLF_SELECT_TIMEOUT_PUSH, this.wolfSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.PROPHET_SELECT_PUSH, this.prophetSelectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.PROPHET_SELECT_TIMEOUT_PUSH, this.prophetSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WILDCHILD_SELECT_PUSH, this.wildchildSelectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WILDCHILD_SELECT_TIMEOUT_PUSH, this.wildchildSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.GUARD_SELECT_PUSH, this.guardSelectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.GUARD_SELECT_TIMEOUT_PUSH, this.guardSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.STALKER_SELECT_PUSH, this.stalkerSelectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.STALKER_SELECT_TIMEOUT_PUSH, this.stalkerSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WITCH_SELECT_PUSH, this.witchSelectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WITCH_SELECT_TIMEOUT_PUSH, this.witchSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.POLICE_COMPETE_PUSH, this.policeCompetePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.POLICE_COMPETE_TIMEOUT_PUSH, this.policeCompeteSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.SPEECH_TIMEOUT_PUSH, this.speechTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.VOTE_POLICE_PUSH, this.votePolicePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.VOTE_POLICE_TIMEOUT_PUSH, this.votePoliceTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.QUIT_POLICE_COMPETE_PUSH, this.quitPoliceCompetePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.COUPLE_ROLE_PUSH, this.coupleRolePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WOLF_ROLE_PUSH, this.wolfRolePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.SYSTEM_MESSAGE_PUSH, this.systemMessagePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.COMPETE_USER_PUSH, this.competeUserPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.POLICE_ELECTION_PUSH, this.policeElectionPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.DRAW_SPEAK_ICON_PUSH, this.drawSpeakIconPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.CANCEL_SPEAK_ICON_PUSH, this.cancelSpeakIconPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.SHOW_VOTE_RESULT_PUSH, this.showVoteResultPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.DEATH_MESSAGE_PUSH, this.deathMessagePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.CANCEL_COUNT_TO_START_PUSH, this.cancelCountToStartPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.TRANSFER_POLICE_PUSH, this.transferPolicePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.TRANSFER_POLICE_TIMEOUT_PUSH, this.transferPoliceTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.TRANSFER_POLICE_RESULT_PUSH, this.transferPoliceResultPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ORGANIZE_SPEECH_PUSH, this.organizeSpeechPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ORGANIZE_SPEECH_TIMEOUT_PUSH, this.organizeSpeechTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.VOTE_PUSH, this.votePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.VOTE_TIMEOUT_PUSH, this.voteTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.POLICE_CALL_VOTE_PUSH, this.policeCallVotePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.POLICE_CALL_VOTE_TIMEOUT_PUSH, this.policeCallVoteTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.HUNTER_FLOP_PUSH, this.hunterFlopPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.HUNTER_KILL_PUSH, this.hunterKillPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.HUNTER_KILL_RESULT_PUSH, this.hunterKillResultPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.HUNTER_KILL_TIMEOUT_PUSH, this.hunterKillTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.SHOW_IDIOT_PUSH, this.showIdiotPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.PROPHET_SELECT_RESPONSE, this.prophetSelectResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.GESTURE_SELECT_PUSH, this.gestureSelectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.GESTURE_SELECT_TIMEOUT_PUSH, this.gestureSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.GESTURE_SELECT_RESULT_PUSH, this.gestureSelectResultPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.GAGELDER_SELECT_PUSH, this.gagelderSelectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.GAGELDER_SELECT_TIMEOUT_PUSH, this.gagelderSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.EXPLODE_FAILED_RESPONSE, this.explodeFailedResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WOLF_EXPLODED_PUSH, this.wolfExplodedPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WHITE_WOLF_KING_SELECT_PUSH, this.whiteWolfKingSelectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WHITE_WOLF_KING_SELECT_TIMEOUT_PUSH, this.whiteWolfKingSelectTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.PLANE_VOTE_PUSH, this.planeVotePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.PLANE_VOTE_TIMEOUT_PUSN, this.planeVoteTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.GAME_RESULT_PUSH, this.gameResultPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.CHOOSE_MVP_PUSH, this.chooseMvpPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.CHOOSE_MVP_TIMEOUT_PUSH, this.chooseMvpTimeoutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.MVP_RESULT_PUSH, this.mvpResultPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.GAGELDER_EFFECT_PUSH, this.gagelderEffectPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.USER_COMPETE_POLICE_PUSH, this.userCompetePolicePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.SHOW_ROLE_PUSH, this.showRolePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.GAME_RESET_PUSH, this.gameResetPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WORLD_MESSAGE_FAILED_REPONSE, this.worldMessageFailedResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.WORLD_MESSAGE_PUSH, this.worldMessagePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.NOPASS_VOICE_CONTROL_PUSH, this.noPassVoiceControlPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.DELAY_PUSH, this.delayPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.USER_KICKOUT_PUSH, this.userKickOutPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.USER_KICK_OUT_FAILED_RESPONSE, this.userKickOutFailedResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.TEXT_SPEECH_PUSH, this.textSpeechPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.USER_GAG_PUSH, this.userGagPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.SLIDEBAR_SYSTEM_MESSAGE_PUSH, this.slideBarSystemMessagePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.VOICE_MEMBER_ID_PUSH, this.voiceMemberIdPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.InSeat_Push, this.inSeatPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.AUDIENCE_QUITROOM_PUSH, this.audienceQuitRoomPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.IDOL_DEAD_TO_WILDCHILD_PUSH, this.idolDeadToWildchildPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.IDOL_DEAD_TO_WOLF_PUSH, this.idolDeadToWolfPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.INSEAT_FAILED_RESPONSE, this.inSeatFailedResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.PLAYER_ONLINE_PUSH, this.playerOnlinePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.RESUME_PUSH, this.roomResumePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.REQUEST_RESUME_FAILED_RESPONSE, this.requestResumeFailedResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.JOINROOM_RESPONSE, this.roomJoinRoomResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ROGUE_SELECT_WOLF_TO_ROGUE_PUSH, this.rogueSelectWolfToRoguePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ROGUE_SELECT_WOLF_TO_WOLF_PUSH, this.rogueSelectWolfToWolfPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ROOM_ADD_FRIEND_FAILED_RESPONSE, this.roomAddFriendFailedResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ROOM_SEND_GIFT_FAILED_RESPONSE, this.roomSendGiftFailedResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ROOM_ADD_FRIEND_PUSH, this.roomAddFriendPush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.ROOM_Send_Gift_PUSH, this.roomSendGiftPush);

        if(DataManager.getInstance().getCurrentRoomData()._isOnLooker){
            roomMenuLayer.getChildByName("onSeatButton").setVisible(true);

            roomMenuLayer.getChildByName("bowen").setVisible(false);

            //roomMenuLayer.getChildByName("locationText").setVisible(false);
            //roomMenuLayer.getChildByName("locationImage").setVisible(false);
            //roomMenuLayer.getChildByName("youAraOnlooker").setVisible(true);
        } else {
            roomMenuLayer.getChildByName("onSeatButton").setVisible(false);
        }

        openSpeaker(false);

        if(_isResume) {


            if(DataManager.getInstance().getCurrentRoomData()._timeProcess % 2 == 0) {
                roomCardLayer.flipAllCard();
            }

            roomMenuLayer.getChildByName("prepareButton").setVisible(false);
            roomMenuLayer.getChildByName("cancelPrepareButton").setVisible(false);

            if(DataManager.getInstance().getResumeData()._resume.buttonState.explodeButtonState == 1) {
                roomMenuLayer.getChildByName("explodeButton").setVisible(true);
            } else {
                roomMenuLayer.getChildByName("explodeButton").setVisible(false);
            }

            if(DataManager.getInstance().getResumeData()._resume.buttonState.quitCompeteButtonState == 1) {
                roomMenuLayer.getChildByName("quitCompeteButton").setVisible(true);
            } else {
                roomMenuLayer.getChildByName("quitCompeteButton").setVisible(false);
            }

            if(DataManager.getInstance().getResumeData()._resume.buttonState.endSpeechButtonState == 1) {
                roomMenuLayer.getChildByName("endSpeechButton").setVisible(true);
            } else {
                roomMenuLayer.getChildByName("endSpeechButton").setVisible(false);
            }

            if(DataManager.getInstance().getResumeData()._resume.buttonState.inviteButtonState == 1) {
                roomMenuLayer.getChildByName("inviteButton").setVisible(true);
            } else {
                roomMenuLayer.getChildByName("inviteButton").setVisible(false);
            }

            if(DataManager.getInstance().getResumeData()._resume.buttonState.speechButtonState == 1) {
                roomMenuLayer.getChildByName("speechButton").setVisible(true);
                roomMenuLayer.getChildByName("speechButton").setBright(true);
                roomMenuLayer.getChildByName("speechButton").setEnabled(true);
                showSendMessageButton();
            } else if (DataManager.getInstance().getResumeData()._resume.buttonState.speechButtonState == 2){
                roomMenuLayer.getChildByName("speechButton").setVisible(false);
                roomMenuLayer.getChildByName("speechButton").setBright(true);
                roomMenuLayer.getChildByName("speechButton").setEnabled(true);
                hideSendMessageButton();
            } else {
                roomMenuLayer.getChildByName("speechButton").setVisible(true);
                roomMenuLayer.getChildByName("speechButton").setBright(false);
                roomMenuLayer.getChildByName("speechButton").setEnabled(false);
                hideSendMessageButton();
                roomMenuLayer.getChildByName("speechButton").getChildByName("speechButtonLabel").loadTexture(res.GagSpeechLabel_png);
            }

            roomMenuLayer.getChildByName("roleList").setVisible(false);
            roomMenuLayer.getChildByName("actionHint").setVisible(true);
            roomMenuLayer.getChildByName("actionHint").setString(DataManager.getInstance().getResumeData()._resume.roomTextHint);
            roomMenuLayer.getChildByName("trumpet").setVisible(true);
            roomMenuLayer.getChildByName("secondBg").setVisible(true);
            roomMenuLayer.getChildByName("clock").setVisible(true);
            roomMenuLayer.getChildByName("inviteButton").setVisible(false);
            roomMenuLayer.getChildByName("roomNumberText").setVisible(false);

            inGameFlag = true;
            showMicIconEnable = false;
            gameState = DataManager.getInstance().getResumeData()._resume.gameState;
            isInCountDownProcess = false;

            roomMenuLayer.getChildByName("selfCard").loadTexture("res/roleold/"+DataManager.getInstance().getCurrentRoomData()._myRole+".png");

            var systemMessageList = DataManager.getInstance().getResumeData()._resume.systemMessageList;
            for(var i = 0; i < systemMessageList.length; i++) {
                slideDialog.addPeriodSystemMessage(systemMessageList[i]);
            }

            if (DataManager.getInstance().getResumeData()._resume.microphoneEnable == 1) {
                openMic(false);
                showSendMessageButton();
            } else {
                closeMic(false);
                var speechButton = roomMenuLayer.getChildByName("speechButton");
                if(speechButton != null && ((!speechButton.isVisible()) || (!speechButton.isBright()))) {
                    hideSendMessageButton();
                }
            }

            if (DataManager.getInstance().getResumeData()._resume.earphoneEnable == 1) {
                openSpeaker(false);
            } else {
                closeSpeaker(false);
            }

            for(var i = 1; i <= DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
                var playerInfo = DataManager.getInstance().getCurrentRoomData()._currentPlayerMap.get(i);
                var card = roomCardLayer.getChildByName("card"+i);
                card.getChildByName("prepareIcon").setVisible(false);
                if(playerInfo.deathType != 1) {
                    if(playerInfo.deathType != 11) {
                        var cardIn = card.getChildByName("cardIn");
                        var cardOut = card.getChildByName("cardOut");
                        card.removeChildByName("spineLizi");

                        cardIn.setBright(false);
                        cardOut.setBright(false);
                        card.getChildByName("people").setBright(false);
                        card.getChildByName("peopleBg").setBright(false);

                        var deathStamp = card.getChildByName("deathStamp");
                        if(deathStamp != null && deathStamp != undefined) {
                            deathStamp.loadTexture(DeathType.get(playerInfo.deathType));
                            deathStamp.setVisible(true);
                        }
                    }
                } else {
                    if(playerInfo.offlineState == 2) {
                        card.getChildByName("offlineStamp").setVisible(true);
                    }
                }

                if(playerInfo.isSpeaking == 1) {
                    var spineLizi = new sp.SkeletonAnimation('res/spine/lizi.json', 'res/spine/lizi.atlas', 1.0);
                    spineLizi.setPosition(card.width / 2, card.height / 2);
                    spineLizi.setScale(1.2, 1.2);
                    spineLizi.setAnchorPoint(0.5, 0.5);
                    spineLizi.setAnimation(0, 'lizi', true);
                    spineLizi.setName("spineLizi");
                    card.addChild(spineLizi, 1);
                }

                //绘制 iconList
                var iconList = playerInfo.stateIconList;
                if(iconList != null && iconList != undefined) {
                    var list = card.getChildByName("iconList");
                    if(list != null && list != undefined) {
                        list.setVisible(true);
                        for (var j = 0; j < iconList.length; j++) {
                            if(iconList[j] == 1) {
                                var defaultItemLayout = new ccui.Layout();
                                defaultItemLayout.setTouchEnabled(true);
                                defaultItemLayout.setContentSize(32, 32);

                                var stateIcon = new ccui.ImageView(res.AntidoteIcon_png);
                                stateIcon.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);
                                stateIcon.setAnchorPoint(0.5, 0.5);
                                stateIcon.setScale(0.65, 0.65);
                                defaultItemLayout.addChild(stateIcon, 1);
                                list.pushBackCustomItem(defaultItemLayout);
                            } else if (iconList[j] == 2) {
                                var defaultItemLayout = new ccui.Layout();
                                defaultItemLayout.setTouchEnabled(true);
                                defaultItemLayout.setContentSize(32, 32);

                                var stateIcon = new ccui.ImageView(res.PoisonIcon_png);
                                stateIcon.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);
                                stateIcon.setAnchorPoint(0.5, 0.5);
                                stateIcon.setScale(0.65, 0.65);
                                defaultItemLayout.addChild(stateIcon, 1);
                                list.pushBackCustomItem(defaultItemLayout);
                            } else if (iconList[j] == 3) {
                                card.getChildByName("leftIcon").loadTexture(res.CompeteIcon_png);
                            } else if (iconList[j] == 4) {
                                card.getChildByName("leftIcon").loadTexture(res.CompeteQuitIcon_png);
                            } else if (iconList[j] == 5) {
                                var defaultItemLayout = new ccui.Layout();
                                defaultItemLayout.setTouchEnabled(true);
                                defaultItemLayout.setContentSize(32, 32);

                                var stateIcon = new ccui.ImageView(res.CupidIcon_png);
                                stateIcon.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);
                                stateIcon.setAnchorPoint(0.5, 0.5);
                                stateIcon.setScale(0.65, 0.65);
                                defaultItemLayout.addChild(stateIcon, 1);
                                list.pushBackCustomItem(defaultItemLayout);
                            } else if(iconList[j] == 6) {
                                card.getChildByName("rightIcon").loadTexture(res.GagIcon_png);
                            } else if(iconList[j] == 7) {
                                var defaultItemLayout = new ccui.Layout();
                                defaultItemLayout.setTouchEnabled(true);
                                defaultItemLayout.setContentSize(32, 32);

                                var stateIcon = new ccui.ImageView(res.IdolIcon_png);
                                stateIcon.setPosition(defaultItemLayout.width * 0.5, defaultItemLayout.height * 0.5);
                                stateIcon.setAnchorPoint(0.5, 0.5);
                                stateIcon.setScale(0.65, 0.65);
                                defaultItemLayout.addChild(stateIcon, 1);
                                list.pushBackCustomItem(defaultItemLayout);
                            } else if (iconList[j] == 8) {
                                card.getChildByName("leftIcon").loadTexture(res.PoliceIcon_png);
                            }
                        }
                    }
                }
            }
            cc.log("dialog ");
            var dialogObj = DataManager.getInstance().getResumeData()._resume.dialog;
            cc.log("dialog " + dialogObj.cmd);
            if(dialogObj != null && dialogObj != undefined) {
                if(dialogObj.cmd != "noneDialogPush") {
                    MqttClient.getInstance()._mqttExcuteMessage(dialogObj);
                }
            }

        }

        this.scheduleUpdate();

        var event = new cc.EventCustom("do_next_event");
        cc.eventManager.dispatchEvent(event);
    },

    update:function (delta) {
        var currentDateTime = new Date().getTime();
        if(readySendFlag == true) {
            if(currentDateTime - readySendTime > 8000) {
                readySendFlag = false;
                quitTecentRoom(true, "网络超时，请检查网络...");
            }
        }

        if(cancelReadySendFlag == true) {
            if(currentDateTime - cancelReadySendTime > 8000) {
                cancelReadySendFlag = false;
                quitTecentRoom(true, "网络超时，请检查网络...");
            }
        }

        if(quitRoomSendFlag == true) {
            if(!DataManager.getInstance().getCurrentRoomData()._isOnLooker) {
                if (currentDateTime - quitRoomSendTime > 8000) {
                    quitRoomSendFlag = false;
                    quitTecentRoom(false, "网络超时，请检查网络...");
                    var currentScene = cc.director.getRunningScene();
                    if(currentScene != null && currentScene != undefined) {
                        var loading = currentScene.getChildByTag(997001);
                        if(loading != null && loading != undefined) {
                            loading.removeFromParent(true);
                        }
                    }
                }
            }
        }

        if(resumeRequestSendFlag == true) {
            if(currentDateTime - resumeRequestSendTime > 8000) {
                resumeRequestSendFlag = false;
                quitTecentRoom(false, "恢复房间失败...");
            }
        }

        if(cc.sys.os === cc.sys.OS_ANDROID || cc.sys.os === cc.sys.OS_IOS) {
            if(_gcloudvoice != null && _gcloudvoice != undefined) {
                _gcloudvoice.poll();
            } else {
                cc.director.runScene(new HallScene("语音发生异常，请稍后重试..."));
            }
        }

        for (var i = 0; i < DataManager.getInstance().getCurrentRoomData()._totalPlayerNum; i++) {
            if((i+1) != DataManager.getInstance().getCurrentRoomData()._mySeatNumber) {
                if(_lastShowMicIconTime != null && _lastShowMicIconTime != undefined) {
                    var lastShowTime = _lastShowMicIconTime.get(i + 1);
                    if (lastShowTime == null || lastShowTime == undefined || currentDateTime - lastShowTime > 1000) {
                        if (roomCardLayer != null && roomCardLayer != undefined) {
                            var spineMic = roomCardLayer.getChildByName("spineMic" + (i + 1));
                            if (spineMic != null && spineMic != undefined) {
                                spineMic.setVisible(false);
                            }
                        }
                    }
                }
            }
        }
    },

    onExit:function () {
        this._super();
        cc.log("roomScene onExit");
        if(roomBgLayer != null && roomBgLayer != undefined) {
            roomBgLayer.release();
        }
        if(roomCardLayer != null && roomCardLayer != undefined) {
            roomCardLayer.release();
        }
        if(roomMenuLayer != null && roomMenuLayer != undefined) {
            roomMenuLayer.release();
        }
        if(slideDialog != null && slideDialog != undefined) {
            slideDialog.release();
        }
        cc.eventManager.removeListener(this._backListener);
    },

    cleanup:function () {
        this._super();
        cc.log("roomScene cleanup");
    },
});

function userGagResponse(responseString) {
    if(responseString == null || responseString == "" || responseString == undefined) {
        ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                userGagSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                userGagResume(responseObj.retBody);
            }
        } else {
            userGagFailed(responseObj.retBody);
        }
    }
};

function userGagSuccess(data) {
    var commonDialog = new CommonDialog(DialogType.GagConfirmDialog, [userGagId, data.cost]);
    commonDialog.setTag(DialogType.GagConfirmDialog);
    commonDialog.popup();
};

function userGagFailed(data) {
    cc.log(data.message);
    ToastUtil.showToast(data.message, 2.0);
};

function userGagResume(data) {
    cc.log(data);
};

function hideSendMessageButton() {
    roomMenuLayer.getChildByName("sendMessageButton").setBright(false);
    roomMenuLayer.getChildByName("sendMessageButton").setEnabled(false);
};

function showSendMessageButton() {
    cc.log("showSendMessageButton " + DataManager.getInstance().getCurrentRoomData()._timeProcess);
    if(DataManager.getInstance().getCurrentRoomData()._timeProcess % 2 != 0) {
        roomMenuLayer.getChildByName("sendMessageButton").setBright(true);
        roomMenuLayer.getChildByName("sendMessageButton").setEnabled(true);
    }
};
