/**
 * Created by junji on 2016/11/12.
 */

var SigninBackgroundLayer  = cc.Layer.extend({

    ctor:function () {
        this._super();
        this.loadBackground();
        return true;
    },

    loadBackground:function () {
        var node = new cc.Sprite(res.SingnBg_png);
        node.setPosition(cc.winSize.width/2, cc.winSize.height/2);

        this.addChild(node);
       // node.setPosition(cc.winSize.width/2, cc.winSize.height/2);
    }
});

var SigninMenuLayer = cc.Layer.extend({
    ctor:function () {
        this._super();

        var size = cc.director.getVisibleSize();

        var phoneTextFieldBg =new cc.Scale9Sprite(res.SignInputBg_png);
        phoneTextFieldBg.setContentSize(cc.size(365, 65));
        phoneTextFieldBg.setPosition(cc.director.getVisibleSize().width * 0.5, cc.director.getVisibleSize().height * 0.55);
        phoneTextFieldBg.setAnchorPoint(0.5, 0.5);
        this.addChild(phoneTextFieldBg);

        var phoneTextField = new cc.EditBox(cc.size(345, 55), new cc.Scale9Sprite(res.Transparency_50x50_png));
        phoneTextField.setPosition(cc.director.getVisibleSize().width * 0.5, cc.director.getVisibleSize().height * 0.55);
        phoneTextField.setAnchorPoint(0.5, 0.5);
        phoneTextField.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC);
        phoneTextField.setPlaceHolder("电话号码");
        phoneTextField.setMaxLength(11);
        this.addChild(phoneTextField);

        var passwordTextFieldBg =new cc.Scale9Sprite(res.SignInputBg_png);
        passwordTextFieldBg.setContentSize(cc.size(365, 65));
        passwordTextFieldBg.setPosition(cc.director.getVisibleSize().width * 0.5, cc.director.getVisibleSize().height * 0.45);
        passwordTextFieldBg.setAnchorPoint(0.5, 0.5);
        this.addChild(passwordTextFieldBg);

        var passwordTextField = new cc.EditBox(cc.size(345,55), new cc.Scale9Sprite(res.Transparency_50x50_png));
        passwordTextField.setPosition(cc.director.getVisibleSize().width * 0.5, cc.director.getVisibleSize().height * 0.45);
        passwordTextField.setAnchorPoint(0.5, 0.5);
        passwordTextField.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
        passwordTextField.setPlaceHolder("密码");
        passwordTextField.setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD);
        passwordTextField.setMaxLength(16);
        this.addChild(passwordTextField);

        var signinNode = new ccui.Button(res.SignInButtonBg_png, res.SignInButtonBgDown_png);
        this.addChild(signinNode);
        signinNode.setPosition(size.width * 0.35, size.height * 0.34);
        signinNode.addClickEventListener(function () {
            var phoneNumber = phoneTextField.getString();
            var password = passwordTextField.getString();
            if(phoneNumber == null || phoneNumber == undefined || phoneNumber.length != 11) {
                ToastUtil.showToast("请输入合法手机号", 2.0);
            } else if (password == null || password == undefined || password.length < 6) {
                ToastUtil.showToast("请输入合法密码", 2.0);
            } else {
                sendAliLog("signin", "info", phoneTextField.getString() + "$$" + passwordTextField.getString());
                var userApi = new UserApi();
                DataManager.getInstance().getUserData()._userName = phoneTextField.getString();
                DataManager.getInstance().getUserData()._password = passwordTextField.getString();
                userApi.signin(phoneNumber, password, "signinResponse", function (retBody) {
                }, function (retBody) {
                }, function (retBody) {
                });
                var loadingDialog = new LoadingDialog();
                loadingDialog.setTag(997001);
                loadingDialog.popup();
            }
        });

        var signinLabel = new ccui.ImageView(res.SignInLabel_png);
        signinLabel.setPosition(signinNode.width/2, signinNode.height/2 + 3);
        signinNode.addChild(signinLabel);

        var signupNode = new ccui.Button(res.SignUpButtonBg_png, res.SignUpButtonBgDown_png);
        this.addChild(signupNode);
        signupNode.setPosition(size.width*0.65, size.height*0.34);
        signupNode.addClickEventListener(function(){
            cc.director.pushScene(new SignupScene());
        });

        var signupLabel = new ccui.ImageView(res.SignUpLabel_png);
        signupLabel.setPosition(signupNode.width/2, signupNode.height/2 + 3);
        signupNode.addChild(signupLabel);

        var wechatSigninButton = new ccui.Button(res.WechatSignInButtonBg_png, res.WechatSignInButtonBgDown_png);
        wechatSigninButton.setPosition(cc.winSize.width/2, cc.winSize.height*0.24);
        wechatSigninButton.addClickEventListener(function () {
            if(cc.sys.os === cc.sys.OS_ANDROID) {
                jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "WXLoginWithState", "()V");
            } else if(cc.sys.os === cc.sys.OS_IOS) {
                jsb.reflection.callStaticMethod("WXLoginUtil", "WXLoginWithState");
            }
        });
        this.addChild(wechatSigninButton);

        var wechatSigninLabel = new ccui.ImageView(res.WechatSignInLabel_png);
        wechatSigninLabel.setPosition(wechatSigninButton.width/2 + 30, wechatSigninButton.height/2);
        wechatSigninButton.addChild(wechatSigninLabel);

        var wechatSigninLogo = new ccui.ImageView(res.WechatSignInButtonLogo_png);
        wechatSigninLogo.setPosition(wechatSigninButton.width/2 - 60, wechatSigninButton.height/2);
        wechatSigninButton.addChild(wechatSigninLogo);

        if(!isWXAppInstalled()) {
            wechatSigninButton.setVisible(false);
        }

        return true;
    }
});

function signinSuccess(retBody) {
    cc.log("signinSuccess：" + retBody);
    DataManager.getInstance().getUserData().parseFromObj(retBody);
    initMqtt();
    TXIMSDK_initSDK();
    TXIMSDK_loginSucc = function(){
        TXIMSDK_setNickName(DataManager.getInstance().getUserData()._nickname);
        cc.director.runScene(new HallScene());
        if(cc.sys.os === cc.sys.OS_ANDROID) {
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity",
                "configOfflinePush",
                "()V");
        }
    };
    TXIMSDK_loginFail = function(code, msg){
    };
    TXIMSDK_login(DataManager.getInstance().getUserData()._userId.toString(), DataManager.getInstance().getUserData()._tencentIMSig);

    cc.sys.localStorage.setItem("signinState", 1);
    var userName = cc.sys.localStorage.getItem("userName");
    if(userName == "" || userName == null || userName == undefined) {
        cc.sys.localStorage.setItem("userName", DataManager.getInstance().getUserData()._userName);
    }
    var passWord = cc.sys.localStorage.getItem("passWord");
    if(passWord == "" || passWord == null || passWord == undefined) {
        cc.sys.localStorage.setItem("passWord", DataManager.getInstance().getUserData()._password);
    }
};

function signinFailed(retCode) {
    cc.log("signinFailed：" + retCode);
    var errorString = "未知错误";
    if(retCode == -2000) {
        errorString = "用户名不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "用户名已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    } else if (retCode == -2014) {
        errorString = "不能重复登录";
    }
    ToastUtil.showToast(errorString, 2.0);
};

function signinResume(retBody) {
    cc.log(retBody);
};

function signinResponse(responseString) {
    cc.log("signinResponse：" + responseString);
    //sendAliLog("signinResponse", "info", responseString);
    cc.director.getRunningScene().removeChildByTag(997001);
    if(responseString == null || responseString == "" || responseString == undefined) {
        ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                signinSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                signinResume(responseObj.retBody);
            }
        } else {
            signinFailed(responseObj.retCode);
        }
    }
};

function thirdPartyLoginOpenId(openId, unionId) {
    if(openId == "" || openId == null || openId ==undefined) {
        ToastUtil.showToast("登录失败，请稍后再试", 2.0);
    } else {
        DataManager.getInstance().getUserData()._openId = openId;
        DataManager.getInstance().getUserData()._unionId = unionId;
        var userApi = new UserApi();
        userApi.thirdPartyLogin(openId, unionId,"thirdPartyLoginResponse", function () {
        },function () {
        },function () {
        });
    }
};

function thirdPartyLoginSuccess(retBody) {
    cc.log(retBody);
    cc.sys.localStorage.setItem("signinState", 2);
    var openId = cc.sys.localStorage.getItem("openId");
    if(openId == null || openId == "" || openId == undefined) {
        cc.sys.localStorage.setItem("openId", DataManager.getInstance().getUserData()._openId);
    }
    var unionId = cc.sys.localStorage.getItem("unionId");
    if(unionId == "" || unionId == undefined || unionId == null) {
        cc.sys.localStorage.setItem("unionId", DataManager.getInstance().getUserData()._unionId);
    }
    DataManager.getInstance().getUserData().parseFromObj(retBody);
    initMqtt();
    TXIMSDK_initSDK();
    TXIMSDK_loginSucc = function(){
        TXIMSDK_setNickName(DataManager.getInstance().getUserData()._nickname);
        cc.director.runScene(new HallScene());
    };
    TXIMSDK_loginFail = function(code, msg){

    };
    TXIMSDK_login(DataManager.getInstance().getUserData()._userId.toString(), DataManager.getInstance().getUserData()._tencentIMSig);
};

function thirdPartyLoginFailed(retCode) {
    cc.log("thirdPartyLoginFailed：" + retCode);
    var errorString = "未知错误";
    if(retCode == -2000) {
        errorString = "用户名不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "用户名已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    } else if (retCode == -2009) {
        errorString = "请完善信息";
        var completeInfoDialog = new CompleteInfoDialog();
        completeInfoDialog.popup();
    } else if (retCode == -2014) {
        errorString = "不能重复登录";
    }
    ToastUtil.showToast(errorString, 2.0);
};

function thirdPartyLoginResume(retBody) {
    cc.log(retBody);
};

function thirdPartyLoginResponse(responseString) {
    if(responseString == null || responseString == "" || responseString == undefined) {
        ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                thirdPartyLoginSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                thirdPartyLoginResume(responseObj.retBody);
            }
        } else {
            thirdPartyLoginFailed(responseObj.retCode);
        }
    }
};

function signupByThirdPartySuccess(retBody) {
    cc.log(retBody);
    cc.sys.localStorage.setItem("signinState", 2);
    var openId = cc.sys.localStorage.getItem("openId");
    if(openId == null || openId == "" || openId == undefined) {
        cc.sys.localStorage.setItem("openId", DataManager.getInstance().getUserData()._openId);
    }
    var unionId = cc.sys.localStorage.getItem("unionId");
    if(unionId == "" || unionId == undefined || unionId == null) {
        cc.sys.localStorage.setItem("unionId", DataManager.getInstance().getUserData()._unionId);
    }
    DataManager.getInstance().getUserData().parseFromObj(retBody);
    initMqtt();
    TXIMSDK_initSDK();
    TXIMSDK_loginSucc = function(){
        TXIMSDK_setNickName(DataManager.getInstance().getUserData()._nickname);
        cc.director.runScene(new HallScene());
    };
    TXIMSDK_loginFail = function(code, msg){

    };
    TXIMSDK_login(DataManager.getInstance().getUserData()._userId.toString(), DataManager.getInstance().getUserData()._tencentIMSig);
};

function signupByThirdPartyFailed(retCode) {
    cc.log("signupByThirdPartyFailed：" + retCode);
    var errorString = "未知错误";
    if(retCode == -2000) {
        errorString = "手机号不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "手机号已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    } else if (retCode == -2009) {
        errorString = "请完善信息";
        var completeInfoDialog = new CompleteInfoDialog();
        completeInfoDialog.popup();
    } else if (retCode == -2014) {
        errorString = "不能重复登录";
    } else if (retCode == -2008) {
        errorString = "昵称已经被占用";
    } else if (retCode == -1001) {
        errorString = "参数错误，请重试....";
        cc.sys.localStorage.setItem("signinState", 0);
        cc.sys.localStorage.setItem("openId", "");
        cc.sys.localStorage.setItem("unionId", "");
        cc.sys.localStorage.setItem("userName", "");
        cc.sys.localStorage.setItem("passWord", "");
    }
    ToastUtil.showToast(errorString, 2.0);
};

function signupByThirdPartyResume(retBody) {
    cc.log(retBody);
};

function signupByThirdPartyResponse(responseString) {
    if(responseString == "" || responseString == null || responseString == undefined) {
        ToastUtil.systemToastInMiddle("请求超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                signupByThirdPartySuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                signupByThirdPartyResume(responseObj.retBody);
            }
        } else {
            signupByThirdPartyFailed(responseObj.retCode);
        }
    }
};

var SigninScene = cc.Scene.extend({

    _backListener : null,

    ctor:function () {
        this._super();

        this._backListener = cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if(keyCode == cc.KEY.back) {
                    cc.log("jijun android back");
                    var quitAppConfirmDialog = new CommonDialog(DialogType.QuitAppConfrimDialog, -1);
                    quitAppConfirmDialog.setTag(DialogType.QuitAppConfrimDialog);
                    quitAppConfirmDialog.popup();
                } else if(keyCode == cc.KEY.menu) {
                    cc.log("jijun android menu");
                }
            }
        }, this);
    },

    onExit:function () {
        this._super();
        if(this._backListener != null) {
            cc.eventManager.removeListener(this._backListener);
        }
    },

    onEnter: function () {
        this._super();
        var bgLayer = new SigninBackgroundLayer();
        this.addChild(bgLayer);

        var menuLayer = new SigninMenuLayer();
        this.addChild(menuLayer);
        cc.log("signinState " + cc.sys.localStorage.getItem("signinState"));
        if(cc.sys.localStorage.getItem("signinState") == 1) {
            var userApi = new UserApi();
            var loadingDialog = new LoadingDialog();
            loadingDialog.setTag(997001);
            loadingDialog.popup();
            userApi.signin(cc.sys.localStorage.getItem("userName"), cc.sys.localStorage.getItem("passWord"), "signinResponse",function () {
            },function () {
            },function () {
            });
        } else if (cc.sys.localStorage.getItem("signinState") == 2) {
            var userApi = new UserApi();
            var loadingDialog = new LoadingDialog();
            loadingDialog.setTag(997001);
            loadingDialog.popup();
            userApi.thirdPartyLogin(cc.sys.localStorage.getItem("openId"), cc.sys.localStorage.getItem("unionId"), "thirdPartyLoginResponse", function () {
            },function () {
            },function () {
            });
        }
    }
});
