/**
 * Created by junji on 2016/11/14.
 */
var signupMenuLayer;

var SignupBackgroundLayer = cc.Layer.extend({

    ctor:function(){
        this._super();
        this.loadBackground();
        return true;
    },

    loadBackground:function () {
        var node = new cc.Sprite(res.SingnBg_png);
        this.addChild(node);
        node.setPosition(cc.winSize.width/2, cc.winSize.height/2);
    }
});

var SignupMenuLayer = cc.Layer.extend({

    _countDownTime:60,

    ctor:function () {
        this._super();

        var gender = -1;

        var nickNameFieldBg = new cc.Scale9Sprite(res.SignUpInputBg_png);
        nickNameFieldBg.setContentSize(cc.size(365, 65));
        nickNameFieldBg.setPosition(cc.winSize.width * 0.5, cc.winSize.height * 0.6);
        nickNameFieldBg.setAnchorPoint(0.5, 0.5);
        this.addChild(nickNameFieldBg);

        var nicknameTextField = new cc.EditBox(cc.size(345, 55), new cc.Scale9Sprite(res.Transparency_50x50_png));
        nicknameTextField.setPosition(cc.winSize.width * 0.5, cc.winSize.height * 0.6);
        nicknameTextField.setAnchorPoint(0.5, 0.5);
        nicknameTextField.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
        nicknameTextField.setPlaceHolder("请设置昵称");
        nicknameTextField.setMaxLength(6);
        this.addChild(nicknameTextField);

        if(cc.sys.os === cc.sys.OS_IOS) {
            var optionText = new ccui.Text("(选填)", "Arial", 28);
            optionText.setPosition(cc.winSize.width * 0.5 - 230, cc.winSize.height * 0.53);
            this.addChild(optionText);
        }

        var maleButton = new ccui.Button(res.MaleLabel_png, "");
        maleButton.setScale9Enabled(true);
        maleButton.setAnchorPoint(0.5, 0.5);
        maleButton.setPosition(cc.winSize.width * 0.5 - 100, cc.winSize.height * 0.53);
        maleButton.addClickEventListener(function () {
            femaleButton.loadTextureNormal(res.FemaleLabel_png);
            maleButton.loadTextureNormal(res.MaleLabelDown_png);
            gender = 1;
        });
        this.addChild(maleButton);

        var femaleButton = new ccui.Button(res.FemaleLabel_png, "");
        femaleButton.setScale9Enabled(true);
        femaleButton.setAnchorPoint(0.5, 0.5);
        femaleButton.setPosition(cc.winSize.width * 0.5 + 100, cc.winSize.height * 0.53);
        femaleButton.addClickEventListener(function () {
            maleButton.loadTextureNormal(res.MaleLabel_png);
            femaleButton.loadTextureNormal(res.FemaleLabelDown_png);
            gender = 2;
        });
        this.addChild(femaleButton);

        var phoneTextFieldBg = new cc.Scale9Sprite(res.SignUpInputBg_png);
        phoneTextFieldBg.setContentSize(cc.size(365, 65));
        phoneTextFieldBg.setPosition(cc.winSize.width * 0.5, cc.winSize.height * 0.46);
        phoneTextFieldBg.setAnchorPoint(0.5, 0.5);
        this.addChild(phoneTextFieldBg);

        var phoneTextField = new cc.EditBox(cc.size(345, 55), new cc.Scale9Sprite(res.Transparency_50x50_png));
        phoneTextField.setPosition(cc.winSize.width * 0.5, cc.winSize.height * 0.46);
        phoneTextField.setAnchorPoint(0.5, 0.5);
        phoneTextField.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC);
        phoneTextField.setPlaceHolder("手机号码");
        phoneTextField.setMaxLength(11);
        this.addChild(phoneTextField);

        var verifyCodeBg = new cc.Scale9Sprite(res.SignUpInputBg_png);
        verifyCodeBg.setContentSize(cc.size(365, 65));
        verifyCodeBg.setPosition(cc.winSize.width * 0.5, cc.winSize.height * 0.37);
        verifyCodeBg.setAnchorPoint(0.5, 0.5);
        this.addChild(verifyCodeBg);

        var verifyCodeTextField = new cc.EditBox(cc.size(345, 55), new cc.Scale9Sprite(res.Transparency_50x50_png));
        verifyCodeTextField.setPosition(cc.winSize.width * 0.5, cc.winSize.height * 0.37);
        verifyCodeTextField.setAnchorPoint(0.5, 0.5);
        verifyCodeTextField.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC);
        verifyCodeTextField.setPlaceHolder("验证码");
        verifyCodeTextField.setMaxLength(4);
        this.addChild(verifyCodeTextField);

        var getVerifyCodeButton = new ccui.Button(res.GetVerifyCodeLabel_png, res.GetVerifyCodeLabelDown_png);
        getVerifyCodeButton.setPosition(cc.winSize.width * 0.5 + 125, cc.winSize.height * 0.37);
        getVerifyCodeButton.setScale9Enabled(true);
        getVerifyCodeButton.setName("getVerifyCodeButton");
        getVerifyCodeButton.addClickEventListener(function () {
            var phoneNumber = phoneTextField.getString();
            if(phoneNumber.length != 11 || phoneNumber == null || phoneNumber == undefined) {
                ToastUtil.showToast("请输入合法手机号", 2.0);
            } else {
                var userApi = new UserApi();
                userApi.sendVerificationCode(phoneNumber,"sendVerificationCodeResponse", function () {
                },function () {
                },function () {
                });
            }
        });
        this.addChild(getVerifyCodeButton);

        var countDownText = new ccui.Text("", "Arial", 30);
        countDownText.setPosition(cc.winSize.width * 0.5 + 125, cc.winSize.height * 0.37 - 5);
        countDownText.setName("countDownText");
        this.addChild(countDownText);

        var passwordTextFieldBg = new cc.Scale9Sprite(res.SignUpInputBg_png);
        passwordTextFieldBg.setContentSize(cc.size(365, 65));
        passwordTextFieldBg.setPosition(cc.winSize.width * 0.5, cc.winSize.height * 0.28);
        passwordTextFieldBg.setAnchorPoint(0.5, 0.5);
        this.addChild(passwordTextFieldBg);

        var passwordTextField = new cc.EditBox(cc.size(345, 55), new cc.Scale9Sprite(res.Transparency_50x50_png));
        passwordTextField.setPosition(cc.winSize.width * 0.5, cc.winSize.height * 0.28);
        passwordTextField.setAnchorPoint(0.5, 0.5);
        passwordTextField.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
        passwordTextField.setPlaceHolder("密码");
        passwordTextField.setMaxLength(16);
        passwordTextField.setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD);
        this.addChild(passwordTextField);

        var passWordPattern = new RegExp("^[a-zA-Z0-9!@#$%^&*?]+$");
        var nickNamePattern = new RegExp("^[\u4E00-\u9FA5\uF900-\uFA2D]{6}$");
        var nickNamePattern1 = new RegExp("^[\u4E00-\u9FA5\uF900-\uFA2D\u0800-\u4E00\x3130-\x318F\xAC00-\xD7A3a-zA-Z0-9!@#$%^&*?]+$");

        var confirmButton = new ccui.Button(res.SignUpConfirm_png, "", "");
        this.addChild(confirmButton);
        confirmButton.setPosition(cc.winSize.width * 0.5 - 100, cc.winSize.height * 0.19);
        confirmButton.addClickEventListener(function () {
            var phoneNumber = phoneTextField.getString();
            var passWord = passwordTextField.getString();
            var verifyCode = verifyCodeTextField.getString();
            var nickName = nicknameTextField.getString();
            if(phoneNumber == "" || phoneNumber == null || phoneNumber == undefined || phoneNumber.length != 11) {
                ToastUtil.systemToastInMiddle("电话号码不合法", 2.0);
            } else if (gender == -1 && cc.sys.os === cc.sys.OS_ANDROID) {
                ToastUtil.systemToastInMiddle("请选择性别", 2.0);
            } else if (verifyCode == "" || verifyCode == null || verifyCode == undefined || verifyCode.length != 4) {
                ToastUtil.systemToastInMiddle("验证码不合法", 2.0);
            } else if (nickName == "" || nickName == null || nickName == undefined || !nickNamePattern1.test(nickName)) {
                ToastUtil.systemToastInMiddle("昵称不能为空，不能包含非法字符", 2.0);
            } else if (nickNamePattern.test(nickName)) {
                ToastUtil.systemToastInMiddle("昵称最多只能5个汉字哦～", 2.0);
            } else if (passWord.length < 6) {
                ToastUtil.systemToastInMiddle("密码不能少于6位", 2.0);
            } else if (!passWordPattern.test(passWord)) {
                ToastUtil.systemToastInMiddle("密码包含非法字符", 2.0);
            } else {
                if(cc.sys.os === cc.sys.OS_IOS) {
                    if(gender == -1) {
                        gender = 1;
                    }
                }
                DataManager.getInstance().getUserData()._userName = phoneNumber;
                DataManager.getInstance().getUserData()._password = passWord;
                var userApi = new UserApi();
                userApi.signup(phoneNumber,
                    passWord,
                    nickName,
                    gender,
                    verifyCode, "signupResponse", function (data) {
                    }, function (data) {
                    }, function (data) {
                    });
            }
        });

        var cancelButton = new ccui.Button(res.SignUpCancel_png, "", "");
        this.addChild(cancelButton);
        cancelButton.setPosition(cc.winSize.width * 0.5 + 100, cc.winSize.height * 0.19);
        cancelButton.addClickEventListener(function(){
            cc.director.popScene();
        });

        return true;
    },

    countDownTime:function (delta) {
        signupMenuLayer._countDownTime-=delta;
        signupMenuLayer.getChildByName("countDownText").setString(""+Math.ceil(signupMenuLayer._countDownTime));
        if(signupMenuLayer._countDownTime<=0) {
            signupMenuLayer.unschedule(signupMenuLayer.countDownTime);
            signupMenuLayer.getChildByName("getVerifyCodeButton").setVisible(true);
            signupMenuLayer.getChildByName("countDownText").setVisible(false);
        }

    },
});

function signupSuccess(data) {
    cc.log(data);

    cc.sys.localStorage.setItem("signinState", 1);
    var userName = cc.sys.localStorage.getItem("userName");
    if(userName == "" || userName == null || userName == undefined) {
        cc.sys.localStorage.setItem("userName", DataManager.getInstance().getUserData()._userName);
    }
    var passWord = cc.sys.localStorage.getItem("passWord");
    if(passWord == "" || passWord == null || passWord == undefined) {
        cc.sys.localStorage.setItem("passWord", DataManager.getInstance().getUserData()._password);
    }

    DataManager.getInstance().getUserData().parseFromObj(data);
    initMqtt();
    TXIMSDK_initSDK();
    TXIMSDK_loginSucc = function(){
        TXIMSDK_setNickName(DataManager.getInstance().getUserData()._nickname);
        cc.director.runScene(new HallScene());
    };
    TXIMSDK_loginFail = function(code, msg){

    };
    TXIMSDK_login(DataManager.getInstance().getUserData()._userId.toString(), DataManager.getInstance().getUserData()._tencentIMSig);
};

function signupFailed(retCode) {
    var errorString = "未知错误";
    if(retCode == -2000) {
        errorString = "手机号不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "手机号已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    } else if (retCode == -2007) {
        errorString = "验证码错误";
    } else if (retCode == -2008) {
        errorString = "昵称已经被占用";
    }
    ToastUtil.showToast(errorString, 2.0);
};

function signupResume(data) {
    cc.log(data);
};

function signupResponse(responseString) {
    if(responseString == null || responseString == "" || responseString == undefined) {
        ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                signupSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                signupResume(responseObj.retBody);
            }
        } else {
            signupFailed(responseObj.retCode);
        }
    }
};

function sendVerificationCodeResponse(responseString) {
    if(responseString == null || responseString == "" || responseString == undefined) {
        ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                sendVerificationCodeSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                sendVerificationCodeResume(responseObj.retBody);
            }
        } else {
            sendVerificationCodeFailed(responseObj.retCode);
        }
    }
}

function sendVerificationCodeSuccess(retBody) {
    signupMenuLayer.getChildByName("countDownText").setVisible(true);
    signupMenuLayer.getChildByName("getVerifyCodeButton").setVisible(false);
    signupMenuLayer._countDownTime = 60;
    signupMenuLayer.schedule(signupMenuLayer.countDownTime, 1/*, cc.RepeatForever, 0, "timeCountDown"*/);
    ToastUtil.showToast("验证码已发送，请注意查收", 2.0);
};

function sendVerificationCodeFailed(retCode) {
    cc.log(retCode);
    var errorString = "未知错误";
    if(retCode == -2000) {
        errorString = "手机号不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "手机号已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    }
    ToastUtil.showToast(errorString, 2.0);
};

function sendVerificationCodeResume(retBody) {
    cc.log(retBody);
};

var SignupScene = cc.Scene.extend({

    _backListener : null,

    ctor:function () {
        this._super();
        this._backListener = cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if(keyCode == cc.KEY.back) {
                    cc.log("jijun android back");
                    cc.director.popScene();
                } else if(keyCode == cc.KEY.menu) {
                    cc.log("jijun android menu");
                }
            }
        }, this);
    },

    onEnter: function () {
        this._super();
        var bgLayer = new SignupBackgroundLayer();
        this.addChild(bgLayer);

        signupMenuLayer = new SignupMenuLayer();
        signupMenuLayer.retain();
        this.addChild(signupMenuLayer);
    },

    onExit:function () {
        this._super();
        signupMenuLayer.release();
        cc.eventManager.removeListener(this._backListener);
    }
});
