/**
 * Created by fanfeifan on 2017/1/14.
 */

var TabMenuLayer = cc.Layer.extend({

    ctor: function () {
        this._super();

        this.initBackground();
        this.setContentSize(cc.size(cc.winSize.width,cc.winSize.height));
        return true;
    },

    initBackground: function() {
        var bottomBar = new ccui.ImageView(res.BottomBar_png);
        bottomBar.setScale9Enabled(true);
        this.addChild(bottomBar);
        bottomBar.setPosition(cc.winSize.width/2, 0);
        bottomBar.setAnchorPoint(0.5, 0);
        bottomBar.setContentSize(BaseWindowConf.WIDTH, 87);

        var shopButton = new ccui.Button(res.Shop_png, "", "");
        this.addChild(shopButton);
        // if(Config.WITH_SHOP == true) {
            shopButton.setPosition(cc.winSize.width / 2 - 300, 67);
            shopButton.setVisible(true);
        // } else {
        //     shopButton.setVisible(false);
        // }
        shopButton.addClickEventListener(function () {
            cc.director.runScene(new ShopScene(ShopType.Diamond));
        });
        shopButton.setName("shopButton");

        var rankButton = new ccui.Button(res.Rank_png, "", "");
        this.addChild(rankButton);
        // if(Config.WITH_SHOP == true) {
            rankButton.setPosition(cc.winSize.width / 2 - 150, 67);
        // } else {
        //     rankButton.setPosition(cc.winSize.width / 2 - 85, 67);
        // }
        rankButton.addClickEventListener(function () {
            cc.director.runScene(new RankScene());
        });
        rankButton.setName("rankButton");

        var hallButton = new ccui.Button(res.Hall_png, "", "");
        this.addChild(hallButton);
        hallButton.addClickEventListener(function () {
            cc.director.runScene(new HallScene());
        });
        // if(Config.WITH_SHOP == true) {
            hallButton.setPosition(cc.winSize.width / 2, 67);
        // } else {
        //     hallButton.setPosition(cc.winSize.width/2 - 255, 67);
        // }
        hallButton.setName("hallButton");

        if (!(cc.director.getRunningScene() instanceof FriendMessageScene)) {
            this.getAllUnreadCnt();
        }

        this.socialButton = new ccui.Button(res.Social_png, "", "");
        this.addChild(this.socialButton);
        // if(Config.WITH_SHOP == true) {
            this.socialButton.setPosition(cc.winSize.width / 2 + 150, 67);
        // } else {
        //     this.socialButton.setPosition(cc.winSize.width / 2 + 85, 67);
        // }
        this.socialButton.addClickEventListener(function () {
            cc.director.runScene(new FriendMessageScene());
        });
        this.socialButton.setName("socialButton");

        var personButton = new ccui.Button(res.Person_png, "", "");
        this.addChild(personButton);
        // if(Config.WITH_SHOP == true) {
            personButton.setPosition(cc.winSize.width / 2 + 300, 67);
        // } else {
        //     personButton.setPosition(cc.winSize.width / 2 + 255, 67);
        // }
        personButton.addClickEventListener(function () {
            cc.director.runScene(new HomeScene());
        });
        personButton.setName("personButton");

    },

    addRedDot: function(allUnreadCnt) {
        if (allUnreadCnt <= 0) return;

        var reddot = new ccui.ImageView(res.FriendReddot_png);
        reddot.setPosition(this.socialButton.width - 25, this.socialButton.height - 25);
        this.socialButton.addChild(reddot);

        if (allUnreadCnt > 9) {
            var unReadCntLabel = cc.LabelTTF("9+", "Arial", 20);
            unReadCntLabel.setPosition(reddot.width / 2, reddot.height / 2);
            reddot.addChild(unReadCntLabel);
        }
        else {
            var unReadCntLabel = cc.LabelTTF(allUnreadCnt.toString(), "Arial", 20);
            unReadCntLabel.setPosition(reddot.width / 2, reddot.height / 2);
            reddot.addChild(unReadCntLabel);
        }
    },

    getAllUnreadCnt: function() {
        var that = this;
        TXIMSDK_getAllConversationSucc = function(jsonStr){
            var allUnreadCnt = 0;
            var obj = JSON.parse(jsonStr);
            for (var i = 0; i < obj.length; i ++) {
                allUnreadCnt += obj[i]['unreadCnt'];
            }
            that.addRedDot(allUnreadCnt);
        };

        TXIMSDK_getAllConversationFail = function(code, msg){
            ToastUtil.systemToastInMiddle(code.toString() + "->" + msg, 2.0);
        };
        TXIMSDK_getAllConversation();
    }

})