var ChildLayer = cc.Layer.extend({
    ctor: function (parent) {
        this._super();

        var size = cc.winSize;

        var that = this;

        var button = new ccui.Button(res.QuickJoinRoom_png, res.QuickJoinRoomDown_png);
        button.setTitleText("按钮");
        button.setPosition(size.width / 2, size.height / 2 - 200);
        button.addClickEventListener(function(){

            that.parent.callback();

            var url = "https://www.baidu.com";
            var title = "这是分享的标题";
            var description = "这是分享的描述";
            var image = "res/1.png"; 
            WXShareWebpageToTimeline(url, title, description, image);
            //WXShareWebpageToFriend(url, title, description, image);

            // 手机震动
            vibrate();

        });
        this.addChild(button);
    },
});

var DemoLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        
        cc.audioEngine.playEffect(res.IntroduceMengMeiZi_mp3, true);

        var size = cc.winSize;

        this.sprite = new ccui.ImageView(res.TopBar_png);
        this.sprite.setPosition(size.width / 2, size.height / 2);
        this.addChild(this.sprite);      

        this.childLayer = new ChildLayer(this);
        this.childLayer.setPosition(0, 0);
        this.addChild(this.childLayer);

        this.time = 0;

        this.timeTTF = cc.LabelTTF(this.time.toFixed(2).toString(), "Arial", 30);
        this.timeTTF.setPosition(size.width / 2, size.height / 2 + 200);
        this.addChild(this.timeTTF );


        this.scheduleOnce(this.once, 5.0, "name");


        //this.scheduleUpdate();
    },

    once: function() {

        this.timeTTF.setString("once");
    },

    callback: function() {

        var size = cc.winSize;

        if (this.sprite != null) {
            this.sprite.removeFromParent();
            this.sprite = null;
        }
        else {
            this.sprite = new ccui.ImageView(res.TopBar_png);
            this.sprite.setPosition(size.width / 2, size.height / 2);
            this.addChild(this.sprite);     
        }
    },

    update: function(dt) {

        this.time += dt;

        this.timeTTF.setString(this.time.toFixed(2).toString());

    },

});

var DemoScene = cc.Scene.extend({
    onEnter: function () {
        this._super();
        var demoLayer = new DemoLayer();
        this.addChild(demoLayer);
    }
});


