var FriendAddLayer = cc.LayerColor.extend({
    _width : 640,
    _height : 400,
    _listener : null,
    ctor: function () {
        this._super(cc.color.BLACK);
        this.setOpacity(153);

        var size = cc.winSize;

        // 弹窗背景
        var alterBg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        alterBg.setScale9Enabled(true);
        alterBg.setCapInsets(cc.rect(30, 30, 499 - 60, 281 - 60));
        alterBg.width = this._width;
        alterBg.height = this._height;
        alterBg.setPosition(size.width / 2, size.height / 2);
        this.addChild(alterBg);

        // 弹窗标题
        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setPosition(this._width / 2, this._height);
        alterBg.addChild(titleBg);

        var title = new ccui.ImageView(res.FriendSearchfriend_png);
        title.setPosition(this._width / 2, this._height);
        alterBg.addChild(title);

        var that = this;
        var closeButton = new ccui.Button(res.RedClose_png, "");
        closeButton.setPosition(this._width - 20, this._height - 20);
        closeButton.addClickEventListener(function () {
            that.removeFromParent();
        });
        alterBg.addChild(closeButton);

        // 弹窗内容
        var infoTTF = new cc.LabelTTF("输入对方ID号", "Arial", 30);
        infoTTF.setColor(cc.color(235, 227, 134));
        infoTTF.setPosition(this._width / 2, this._height / 2 + 80);
        alterBg.addChild(infoTTF);

        var searchBg =new ccui.ImageView(res.FriendSearchback2_png);
        searchBg.setPosition(this._width / 2, this._height / 2);
        alterBg.addChild(searchBg);

        var searchEditBox = new cc.EditBox(cc.size(searchBg.width - 10, searchBg.height - 6), new cc.Scale9Sprite(res.Transparency_50x50_png));
        searchEditBox.setPosition(this._width / 2, this._height / 2);
        searchEditBox.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC);
        searchEditBox.setMaxLength(20);
        alterBg.addChild(searchEditBox);

        var confirmButton = new ccui.Button(res.IdJoinRoom_png, res.IdJoinRoomDown_png);
        confirmButton.setPosition(this._width / 2, this._height / 2 - 100);
        confirmButton.addClickEventListener(function () {
            var identifier = searchEditBox.getString();
            if (identifier != "") {
                if (identifier == DataManager.getInstance().getUserData()._userId.toString()) {
                    ToastUtil.systemToastInMiddle("无法添加自己为好友", 2.0);
                }
                else {
                    TXIMSDK_getUsersProfileSucc = function(jsonStr){
                        cc.log(jsonStr);
                        var data = JSON.parse(jsonStr);
                        if (data.length == 1) {
                            that.removeFromParent();
                            var layer = new OtherHomePageLayer(2, identifier);
                            cc.director.getRunningScene().addChild(layer, 100);
                        }
                        else {
                            ToastUtil.systemToastInMiddle("该用户不存在或没有更新到最新版本", 2.0);
                        }
                    };

                    TXIMSDK_getUsersProfileFail = function(code, msg){
                        ToastUtil.systemToastInMiddle("该用户不存在或没有更新到最新版本", 2.0);
                    };
                    TXIMSDK_getUsersProfile(identifier);
                }
            }
        });
        alterBg.addChild(confirmButton);

        var buttonTitle = new ccui.ImageView(res.CommonConfirmLabel_png);
        buttonTitle.setPosition(this._width / 2, this._height / 2 - 100);
        alterBg.addChild(buttonTitle);
    },

    onEnter: function()
    {
        cc.log("ziaoang -> onEnter");
        this._super();

        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        cc.eventManager.addListener(this._listener, this);
    },

    onExit: function()
    {
        cc.log("ziaoang -> onExit");
        this._super();

        cc.eventManager.removeListener(this._listener);
    },
});


