var lastTimeStamp = null;

var ChatMessageItem = ccui.Layout.extend({
    ctor: function (avatar, messageContent, sendFlag) {
        this._super();

        var _message_avatar = avatar;
        var _message_messageContent = messageContent;
        var _message_sendFlag = sendFlag;

        var messageContentTextField = new cc.LabelTTF(_message_messageContent,"Arial", 28);
        messageContentTextField.boundingWidth = 410;
        messageContentTextField.boundingHeight = 0;
        messageContentTextField.setColor(cc.color(115, 69, 49));
        messageContentTextField.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
        messageContentTextField.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);

        this.setTouchEnabled(true);
        this.setContentSize(cc.winSize.width, Math.max(messageContentTextField.height + 45, 85));

        var avatarImage = new ccui.ImageView(AvatarMap.get(_message_avatar)[1]);
        avatarImage.setScale(0.75);
        if(!_message_sendFlag) {
            avatarImage.setAnchorPoint(0, 1);
            avatarImage.setPosition(40, this.height);
        } else {
            avatarImage.setAnchorPoint(1, 1);
            avatarImage.setPosition(this.width - 40, this.height);
        }
        this.addChild(avatarImage);

        var messageBg = new ccui.ImageView(res.FriendMessageBgOther_png);
        if(!_message_sendFlag) {
            messageBg.setAnchorPoint(0, 1);
            messageBg.setCapInsets(cc.rect(35, 50, 3, 2));
            messageBg.setScale9Enabled(true);
            messageBg.setPosition(avatarImage.width + 22, this.height);
        } else {
            messageBg.loadTexture(res.FriendMessageBgMe_png);
            messageBg.setAnchorPoint(1, 1);
            messageBg.setCapInsets(cc.rect(35, 50, 3, 2));
            messageBg.setScale9Enabled(true);
            messageBg.setPosition(this.width - 22 - avatarImage.width, this.height);
        }
        messageBg.setContentSize(this.width - avatarImage.width - 200, this.height);
        this.addChild(messageBg, 0);

        if(!_message_sendFlag) {
            messageContentTextField.setAnchorPoint(0, 1);
            messageContentTextField.setPosition(25, messageBg.height - 22);
        } else {
            messageContentTextField.setAnchorPoint(1, 1);
            messageContentTextField.setPosition(messageBg.width - 25, messageBg.height - 22);
        }
        messageBg.addChild(messageContentTextField);
    }
});

var ChatInviteCardItem = ccui.Layout.extend({
    ctor: function (avatar, messageContent, sendFlag, roomId, passwd) {
        this._super();

        var _message_avatar = avatar;
        var _message_messageContent = messageContent;
        var _message_sendFlag = sendFlag;
        var _message_roomId = roomId;
        var _message_passwd = passwd;

        var messageContentTextField = new cc.LabelTTF(_message_messageContent,"Arial", 26);
        messageContentTextField.boundingWidth = 300;
        messageContentTextField.boundingHeight = 0;
        messageContentTextField.setColor(cc.color(115, 69, 49));
        messageContentTextField.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT);
        messageContentTextField.setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);

        this.setTouchEnabled(true);
        this.setContentSize(cc.winSize.width, 130);

        var avatarImage = new ccui.ImageView(AvatarMap.get(_message_avatar)[1]);
        avatarImage.setScale(0.75);
        if(!_message_sendFlag) {
            avatarImage.setAnchorPoint(0, 1);
            avatarImage.setPosition(40, this.height);
        } else {
            avatarImage.setAnchorPoint(1, 1);
            avatarImage.setPosition(this.width - 40, this.height);
        }
        this.addChild(avatarImage);

        var messageBg = new ccui.Button(res.FriendMessageBgOther_png, res.FriendMessageBgOther_png);
        if(!_message_sendFlag) {
            messageBg.setAnchorPoint(0, 1);
            messageBg.setCapInsets(cc.rect(35, 50, 3, 2));
            messageBg.setScale9Enabled(true);
            messageBg.setPosition(avatarImage.width + 22, this.height);
        } else {
            messageBg.loadTextures(res.FriendMessageBgMe_png, res.FriendMessageBgMe_png);
            messageBg.setAnchorPoint(1, 1);
            messageBg.setCapInsets(cc.rect(35, 50, 3, 2));
            messageBg.setScale9Enabled(true);
            messageBg.setPosition(this.width - 22 - avatarImage.width, this.height);
        }

        messageBg.addClickEventListener(function () {
            var loadingDialog = new LoadingDialog();
            loadingDialog.setTag(997001);
            loadingDialog.popup();

            if(_message_passwd != null && _message_passwd != "" && _message_passwd != undefined) {
                MqttHelper.getInstance().verifyPasswordRequest(Number(_message_roomId), _message_passwd + "");
            } else {
                MqttHelper.getInstance().joinRoom(Number(_message_roomId));
            }
        });
        messageBg.setContentSize(this.width - avatarImage.width - 200, 130);
        this.addChild(messageBg, 0);

        messageContentTextField.setAnchorPoint(1, 1);
        messageContentTextField.setPosition(messageBg.width - 25, messageBg.height - 15);
        messageBg.addChild(messageContentTextField);

        var icon = new ccui.ImageView("res/AppIcon.png");
        icon.setAnchorPoint(0, 0.5);
        icon.setScale(1.1);
        icon.setPosition(25, messageBg.height/2);
        messageBg.addChild(icon);
    }
});

var ChatGiftCardItem = ccui.Layout.extend({
    ctor: function (avatar, giftType, sendFlag) {
        this._super();

        var _message_avatar = avatar;
        var _message_giftType = giftType+"";
        var _message_sendFlag = sendFlag;

        this.setTouchEnabled(true);
        this.setContentSize(cc.winSize.width, 180);

        var avatarImage = new ccui.ImageView(AvatarMap.get(_message_avatar)[1]);
        avatarImage.setScale(0.75);
        if(!_message_sendFlag) {
            avatarImage.setAnchorPoint(0, 1);
            avatarImage.setPosition(40, this.height);
        } else {
            avatarImage.setAnchorPoint(1, 1);
            avatarImage.setPosition(this.width - 40, this.height);
        }
        this.addChild(avatarImage);

        var messageBg = new ccui.ImageView(res.FriendMessageBgOther_png);
        if(!_message_sendFlag) {
            messageBg.setAnchorPoint(0, 1);
            messageBg.setCapInsets(cc.rect(35, 50, 3, 2));
            messageBg.setScale9Enabled(true);
            messageBg.setPosition(avatarImage.width + 22, this.height);
        } else {
            messageBg.loadTexture(res.FriendMessageBgMe_png);
            messageBg.setAnchorPoint(1, 1);
            messageBg.setCapInsets(cc.rect(35, 50, 3, 2));
            messageBg.setScale9Enabled(true);
            messageBg.setPosition(this.width - 22 - avatarImage.width, this.height);
        }
        messageBg.setContentSize(this.width - avatarImage.width - 250, 180);
        this.addChild(messageBg, 0);

        var giftDic = {
            "8":[res.ChatSendGiftFlower1_png, "+3魅力值", "玫瑰花×3"],
            "9":[res.ChatSendGiftFlower2_png, "+52魅力值", "玫瑰花×52"],
            "10":[res.ChatSendGiftFlower3_png, "+125魅力值", "玫瑰花×125"],
            "11":[res.ChatSendGiftFlower4_png, "+365魅力值", "玫瑰花×365"],
            "12":[res.ChatSendGiftFlower5_png, "+1314魅力值", "玫瑰花×1314"],
            "13":[res.ChatSendGiftFlower6_png, "+9999魅力值", "玫瑰花×9999"]
        };
        var giftIcon = new ccui.ImageView(giftDic[_message_giftType][0]);
        giftIcon.setPosition(20, messageBg.height/2);
        giftIcon.setAnchorPoint(0, 0.5);
        messageBg.addChild(giftIcon);

        var giftNameText = new ccui.Text(giftDic[_message_giftType][2], "Arial", 30);
        giftNameText.setPosition(180, messageBg.height - 50);
        giftNameText.setAnchorPoint(0, 0.5);
        giftNameText.setColor(cc.color(115, 69, 49));
        messageBg.addChild(giftNameText);

        var giftEffectText = new ccui.Text(giftDic[_message_giftType][1], "Arial", 27);
        giftEffectText.setPosition(180, 50);
        giftEffectText.setAnchorPoint(0, 0.5);
        giftEffectText.setColor(cc.color(115, 69, 49));
        messageBg.addChild(giftEffectText);
    }
});

var DateItem  = ccui.Layout.extend({
    ctor:function (date) {
        this._super();
        var dateText = new ccui.Text(date, "Arial", 28);
        this.setContentSize(cc.winSize.width, dateText.height);
        dateText.setPosition(this.width/2, this.height/2);
        this.addChild(dateText);
    }
});

var FriendChatLayer = cc.Layer.extend({
    _identifier: null, // 对方 string userid
    _nickname: null, // string
    _avatar: null, // 对方avatar
    _data: null, // list<>
    ctor: function (identifier) {
        this._super();
        this._identifier = identifier;

        var that = this;
        var userList = new Array(identifier);
        getUserListConfigCallback = function(jsonStr) {
            var responseObj = JSON.parse(jsonStr);
            if (responseObj.retCode == 1) {
                if (responseObj.retBody.friendInfoList.length == 1) {
                    that._nickname = responseObj.retBody.friendInfoList[0]["nickName"];
                    that._avatar = responseObj.retBody.friendInfoList[0]["avatar"];
                    that.initBg();
                    that.loadData();
                }
                else {
                    TXIMSDK_alert("获取用户个人信息失败");
                }
            } else {
                TXIMSDK_alert("获取用户个人信息失败");
            }

        };
        getUserListConfig(userList);
    },

    initBg: function() {
        var size = cc.winSize;

        // 整体背景
        var bgLayer = new ccui.ImageView(res.homeTopBg_png);
        bgLayer.setScale9Enabled(true);
        bgLayer.setCapInsets(cc.rect(300, 270, 3, 3));
        bgLayer.width = size.width;
        bgLayer.height = size.height;
        bgLayer.setPosition(size.width / 2, size.height / 2);
        this.addChild(bgLayer);

        // 标题栏
        var topBar = new ccui.ImageView(res.RoomTopBar_png);
        topBar.setAnchorPoint(0.5, 1);
        topBar.setPosition(size.width / 2, size.height);
        this.addChild(topBar);

        var pageLabel = cc.LabelTTF(this._nickname, "Arial", 30);
        pageLabel.setColor(cc.color(58, 26, 18));
        pageLabel.setPosition(size.width / 2, size.height - 46);
        this.addChild(pageLabel);

        // 左上角跳转按钮
        var leftTopButtonBg = new ccui.Button(res.TopLeftButtonBg_png, "");
        leftTopButtonBg.setPosition(0, size.height);
        leftTopButtonBg.setAnchorPoint(0, 1);
        leftTopButtonBg.addClickEventListener(function () {
            cc.director.runScene(new FriendMessageScene());
        });
        this.addChild(leftTopButtonBg);

        var leftTopLabel = new ccui.ImageView(res.FriendBackarrow_png);
        leftTopLabel.setPosition(leftTopButtonBg.width / 2 - 5, leftTopButtonBg.height / 2);
        leftTopButtonBg.addChild(leftTopLabel);

        // 右上角跳转按钮
        var that = this;
        var rightTopButtonBg = new ccui.Button(res.TopRightButtonBg_png, "");
        rightTopButtonBg.setPosition(cc.winSize.width, cc.winSize.height);
        rightTopButtonBg.setAnchorPoint(1, 1);
        rightTopButtonBg.addClickEventListener(function () {
            that.addChild(new FriendSettingLayer(that._identifier), 10);
        });
        this.addChild(rightTopButtonBg);

        var bagLabel = new ccui.ImageView(res.FriendInfoIcon_png);
        bagLabel.setPosition(rightTopButtonBg.width/2 + 5, rightTopButtonBg.height/2);
        rightTopButtonBg.addChild(bagLabel);

        // 下部输入框
        var bottomBarBg = new ccui.ImageView(res.RoomBottomBar_PNG);
        bottomBarBg.setAnchorPoint(0.5, 0);
        bottomBarBg.setPosition(size.width / 2, 0);
        this.addChild(bottomBarBg);

        var chatEditBoxBg = new cc.Scale9Sprite(res.SignInputBg_png);
        chatEditBoxBg.setContentSize(510, 60);
        chatEditBoxBg.setPosition(35, 39);
        chatEditBoxBg.setAnchorPoint(0, 0.5);
        this.addChild(chatEditBoxBg);

        var chatEditBox = new cc.EditBox(cc.size(490, 50), new cc.Scale9Sprite(res.Transparency_50x50_png));
        chatEditBox.setAnchorPoint(0, 0.5);
        chatEditBox.setPosition(45, 39);
        chatEditBox.setPlaceHolder("在此输入你想说的话");
        chatEditBox.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
        chatEditBox.setMaxLength(100);
        chatEditBox.setFontColor(cc.color(168, 149, 99));
        chatEditBox.setPlaceholderFontColor(cc.color(168, 149, 99));
        this.addChild(chatEditBox);

        var that = this;
        var sendMessageButton = new ccui.Button(res.SendMessageButton_png, res.SendMessageButtonDown_png);
        sendMessageButton.setPosition(size.width / 2 + 280, 37);
        sendMessageButton.addClickEventListener(function () {
            var content = chatEditBox.getString();
            if(content != "") {
                TXIMSDK_sendTextMessagetoClient(content, that._identifier);
                chatEditBox.setString("");
                var date = new Date();
                var _timestamp = date.getFullYear() + "-" + date.getMonth() + "-" + date.getDate() + " "
                    + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
                cc.log(_timestamp);
                if(lastTimeStamp == null) {
                    var item = new DateItem(formatTimestampWithHour(_timestamp));
                    that.chartMessageList.pushBackCustomItem(item);
                    that.chartMessageList.jumpToBottom();
                    lastTimeStamp = _timestamp;
                } else {
                    if(getMillisecondDiff(lastTimeStamp, _timestamp) > 10 * 60 * 1000) {
                        var item = new DateItem(formatTimestampWithHour(_timestamp));
                        that.chartMessageList.pushBackCustomItem(item);
                        that.chartMessageList.jumpToBottom();
                        lastTimeStamp = _timestamp;
                    }
                }
                var item = new ChatMessageItem(DataManager.getInstance().getUserData()._currentSkin, content, true);
                that.chartMessageList.pushBackCustomItem(item);
                that.chartMessageList.jumpToBottom();
            } else {
                ToastUtil.showToast("输入的消息不能为空", 2.0);
            }

        });
        this.addChild(sendMessageButton);

        var sendButtonText = new ccui.ImageView(res.SendButtonText_png);
        sendButtonText.setPosition(sendMessageButton.width / 2, sendMessageButton.height / 2);
        sendMessageButton.addChild(sendButtonText);

        // 送礼物
        var sendGiftButton = new ccui.Button(res.FriendSendGift_png, "");
        sendGiftButton.setPosition(size.width / 2 + 280, 150);
        sendGiftButton.addClickEventListener(function () {
            var sendGiftDialog = new ChatSendGiftDialog(Number(that._identifier));
            sendGiftDialog.popup();
        });
        this.addChild(sendGiftButton, 10);
    },

    loadData: function() {
        var that = this;
        TXIMSDK_getLocalMessageForClientSucc = function(jsonStr) {
            that._data = JSON.parse(jsonStr);

            that.renderData();
        };

        TXIMSDK_getLocalMessageForClientFail = function(code, msg) {

        };

        TXIMSDK_initGetLocalMessageForClient(this._identifier);
        TXIMSDK_getLocalMessageForClient(this._identifier);
    },

    renderData: function(){
        var size = cc.winSize;

        this.chartMessageList = new ccui.ListView();
        this.chartMessageList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        this.chartMessageList.setScrollBarEnabled(false);
        this.chartMessageList.setBounceEnabled(true);
        this.chartMessageList.setTouchEnabled(true);
        this.chartMessageList.setContentSize(size.width, 1130);
        this.chartMessageList.setItemsMargin(30);
        this.chartMessageList.setAnchorPoint(0.5, 1);
        this.chartMessageList.setPosition(size.width / 2, size.height - 100);

        for (var i = this._data.length - 1; i >= 0; i--) {
            var _sender = this._data[i]["sender"]; // userid(string)
            var _timestamp = this._data[i]["timestamp"]; //yyyy-MM-dd hh:mm:ss
            if(lastTimeStamp == null) {
                var item = new DateItem(formatTimestampWithHour(_timestamp));
                this.chartMessageList.pushBackCustomItem(item);
                lastTimeStamp = _timestamp;
            } else {
                if(getMillisecondDiff(lastTimeStamp, _timestamp) > 10 * 60 * 1000) {
                    var item = new DateItem(formatTimestampWithHour(_timestamp));
                    this.chartMessageList.pushBackCustomItem(item);
                    lastTimeStamp = _timestamp;
                }
            }
            var _type = this._data[i]["type"];  // custom text  string
            var _data = this._data[i]["data"];
            var item = null;
            if(_type == "text") {
                if (_sender == DataManager.getInstance().getUserData()._userId) {
                    item = new ChatMessageItem(DataManager.getInstance().getUserData()._currentSkin, _data, true);
                } else {
                    item = new ChatMessageItem(this._avatar, _data, false);
                }
            } else {
                var obj = JSON.parse(_data);
                if(obj.type == "invite") {
                    if (_sender == DataManager.getInstance().getUserData()._userId) {
                        item = new ChatInviteCardItem(DataManager.getInstance().getUserData()._currentSkin,
                            "我在"+ obj.roomId +"房间，快来和我一起玩吧!", true, obj.roomId, obj.roomPassWd);
                    } else {
                        item = new ChatInviteCardItem(this._avatar, "我在"+ obj.roomId +"房间，快来和我一起玩吧!", false, obj.roomId, obj.roomPassWd);
                    }
                } else if (obj.type == "gift") {
                    if (_sender == DataManager.getInstance().getUserData()._userId) {
                        item = new ChatGiftCardItem(DataManager.getInstance().getUserData()._currentSkin, obj.giftType, true);
                    } else {
                        item = new ChatGiftCardItem(this._avatar, obj.giftType, false);
                    }
                }
            }
            if(item != null) {
                this.chartMessageList.pushBackCustomItem(item);
            }
        }
        this.chartMessageList.jumpToBottom();

        this.addChild(this.chartMessageList);

        // TXIMSDK_getLocalMessageForClientSucc = function(jsonStr) {
        //     that._data = JSON.parse(jsonStr);
        //
        //     that.renderData();
        // };
        //
        // TXIMSDK_getLocalMessageForClientFail = function(code, msg) {
        //
        // };
        //
        //
        // TXIMSDK_getLocalMessageForClient(this._identifier);
    },

    onNewMessage:function(jsonStr) {
        var obj = JSON.parse(jsonStr);
        var _sender = obj["sender"]; // userid(string)
        var _timestamp = obj["timestamp"]; //yyyy-MM-dd hh:mm:ss
        if(lastTimeStamp == null) {
            var item = new DateItem(formatTimestampWithHour(_timestamp));
            this.chartMessageList.pushBackCustomItem(item);
            lastTimeStamp = _timestamp;
        } else {
            if(getMillisecondDiff(lastTimeStamp, _timestamp) > 10 * 60 * 1000) {
                var item = new DateItem(formatTimestampWithHour(_timestamp));
                this.chartMessageList.pushBackCustomItem(item);
                lastTimeStamp = _timestamp;
            }
        }
        var _type = obj["type"];  //custom text
        var _data = obj["data"];
        cc.log("ziaoang->" + _sender);
        cc.log("ziaoang->" + this._identifier);
        if(_sender == this._identifier) {
            var item = null;
            if(_type == "text") {
                if (_sender == DataManager.getInstance().getUserData()._userId) {
                    item = new ChatMessageItem(DataManager.getInstance().getUserData()._currentSkin, _data, true);
                } else {
                    item = new ChatMessageItem(this._avatar, _data, false);
                }
            } else {
                var obj = JSON.parse(_data);
                if(obj.type == "invite") {
                    if (_sender == DataManager.getInstance().getUserData()._userId) {
                        item = new ChatInviteCardItem(DataManager.getInstance().getUserData()._currentSkin,
                            "我在"+ obj.roomId +"房间，快来和我一起玩吧!", true, obj.roomId), obj.roomPassWd;
                    } else {
                        item = new ChatInviteCardItem(this._avatar, "我在"+ obj.roomId +"房间，快来和我一起玩吧!", false, obj.roomId, obj.roomPassWd);
                    }
                } else if (obj.type == "gift") {
                    if (_sender == DataManager.getInstance().getUserData()._userId) {
                        item = new ChatGiftCardItem(DataManager.getInstance().getUserData()._currentSkin, obj.giftType, true);
                    } else {
                        item = new ChatGiftCardItem(this._avatar, obj.giftType, false);
                    }
                    PropsSpineSprite.playAninWithPos(obj.giftType, cc.p(cc.winSize.width/2, 50), cc.p(cc.winSize.width/2, cc.winSize.height - 150), function () {
                    });
                }
            }
            if(item != null) {
                this.chartMessageList.pushBackCustomItem(item);
                this.chartMessageList.jumpToBottom();
            }
        }
    },

    addGiftCard:function (giftType) {
        var item = new ChatGiftCardItem(DataManager.getInstance().getUserData()._currentSkin, giftType, true);
        this.chartMessageList.pushBackCustomItem(item);
        this.chartMessageList.jumpToBottom();
    },
});

var FriendChatScene = cc.Scene.extend({

    _identifier:null,

    joinRoom:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(997001);
        joinRoomSendFlag = false;
        quickJoinRoomSendFlag = false;
        createRoomSendFlag = false;
        DataManager.getInstance().getCurrentRoomData().clear();
        DataManager.getInstance().getCurrentRoomData().parseFromObj(payloadObj);
        cc.director.runScene(new RoomScene(false));
    },

    joinRoomFailed:function (payloadObj) {
        joinRoomSendFlag = false;
        quickJoinRoomSendFlag = false;
        cc.director.getRunningScene().removeChildByTag(997001);
        var lastRoomId = payloadObj.roomId;
        if(lastRoomId == null || lastRoomId == undefined || lastRoomId == -1) {
            ToastUtil.systemToastInMiddle(payloadObj.message, 2.0);
        } else {
            var resumeConfirmDialog = new CommonDialog(DialogType.ResumeConfirmDialog, lastRoomId);
            resumeConfirmDialog.popup();
        }
    },

    resumePush:function (payloadObj) {
        joinRoomSendFlag = false;
        quickJoinRoomSendFlag = false;
        createRoomSendFlag = false;
        DataManager.getInstance().getCurrentRoomData().clear();
        DataManager.getInstance().getResumeData().parseData(payloadObj);
        cc.director.runScene(new RoomScene(true));
    },

    joinRoomWithPasswordResponse:function(payloadObj) {
        joinRoomSendFlag = false;
        quickJoinRoomSendFlag = false;
        createRoomSendFlag = false;
        cc.director.getRunningScene().removeChildByTag(997001);
        var passwordDialog = new ModalDialogueBox(DialogType.InputPassword, [payloadObj.hallRoomId]);
        passwordDialog.popup();
    },

    verifyPasswordFailedResponse:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(997001);
        ToastUtil.systemToastInMiddle(payloadObj.message, 2.0);
    },

    _backListener:null,

    ctor: function (identifier) {
        this._super();
        this.friendChatLayer = new FriendChatLayer(identifier);
        this.addChild(this.friendChatLayer);

        this._identifier = identifier;

        this._backListener = cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if(keyCode == cc.KEY.back) {
                    cc.log("jijun android back");
                    cc.director.runScene(new FriendMessageScene());
                } else if(keyCode == cc.KEY.menu) {
                    cc.log("jijun android menu");
                }
            }
        }, this);

        lastTimeStamp = null;

        TXIMSDK_uploadClientRead(identifier);

        MqttClient.getInstance().clearMqttMessageQueue();
        MqttClient.getInstance().clearMqttCallBackMap();

        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.JOINROOM_RESPONSE, this.joinRoom);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.JOINROOM_FAILED_RESPONSE, this.joinRoomFailed);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.RESUME_PUSH, this.resumePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.JOINROOM_WITH_PASSWORD_RESPONSE, this.joinRoomWithPasswordResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.VERIFY_PASSWORD_FAILED_RESPONSE, this.verifyPasswordFailedResponse);
    },

    onNewMessage: function(jsonStr) {
        this.friendChatLayer.onNewMessage(jsonStr);
    },

    addGiftCard:function (giftType) {
        this.friendChatLayer.addGiftCard(giftType);
    },

    onExit:function () {
        this._super();
        cc.eventManager.removeListener(this._backListener);
        TXIMSDK_uploadClientRead(this._identifier);
    },

});
