var FriendInviteLayer = cc.LayerColor.extend({

    _width : 640,
    _height : 400,
    _listener : null,
    _alterBg: null,
    _task_list : null,
    _data : null,

    ctor: function () {
        this._super(cc.color.BLACK);
        this.setOpacity(153);

        this.initBg();
    },

    initBg: function() {
        var size = cc.winSize;

        // 弹窗长宽
        this._width = 640;
        this._height = 400;

        // 弹窗背景
        this._alterBg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        this._alterBg.setScale9Enabled(true);
        this._alterBg.setCapInsets(cc.rect(30, 30, 499 - 60, 281 - 60));
        this._alterBg.width = this._width;
        this._alterBg.height = this._height;
        this._alterBg.setPosition(size.width / 2, size.height / 2);
        this.addChild(this._alterBg);

        // 弹窗标题
        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setPosition(this._width / 2, this._height);
        this._alterBg.addChild(titleBg);

        var title = new ccui.ImageView(res.FriendInvitefriend_png);
        title.setPosition(this._width / 2, this._height);
        this._alterBg.addChild(title);

        var that = this;
        var closeButton = new ccui.Button(res.RedClose_png, "");
        closeButton.setPosition(this._width-20, this._height-20);
        closeButton.addClickEventListener(function () {
            that.removeFromParent();
        });
        this._alterBg.addChild(closeButton);

        var myfriendButton = new ccui.Button(res.FriendMyfriend_png, res.FriendMyfrienddown_png);
        if(isWXAppInstalled()) {
            myfriendButton.setPosition(this._width / 2 - 130, this._height / 2);
        } else {
            myfriendButton.setPosition(this._width / 2, this._height / 2);
        }
        myfriendButton.addClickEventListener(function () {
            that.inviteMyFriend();
        });
        this._alterBg.addChild(myfriendButton);

        var WXButton = new ccui.Button(res.FriendWX_png, res.FriendWXdown_png);
        WXButton.setPosition(this._width / 2 + 130, this._height / 2);
        WXButton.addClickEventListener(function () {
            that.inviteWXFriend();
        });
        this._alterBg.addChild(WXButton);

        if(isWXAppInstalled()) {
            WXButton.setVisible(true);
        } else {
            WXButton.setVisible(false);
        }
    },

    inviteMyFriend: function(){
        cc.log("邀请我的好友");
        this._alterBg.removeFromParent();
        this._alterBg = null;

        this.initBg2();
        this.loadData();
    },

    inviteWXFriend: function(){
        cc.log("邀请微信好友");
        this._alterBg.removeFromParent();
        this._alterBg = null;
        
        var content = "全民狼人杀~我在" + DataManager.getInstance().getCurrentRoomData()._roomId + "号房，";
        var password = DataManager.getInstance().getCurrentRoomData()._password;
        if(password != null && password != "") {
            content += "房间密码:" + password+"";
        }
        content += "一起来玩吧!";
        inviteFriend(content,content);
    },

    initBg2: function() {
        var size = cc.winSize;

        this._width = 720;
        this._height = 948;

        // 整体背景
        this._alterBg = new ccui.ImageView(res.homeTopBg_png);
        this._alterBg.setScale9Enabled(true);
        this._alterBg.setCapInsets(cc.rect(300, 270, 3, 3));
        this._alterBg.width = size.width;
        this._alterBg.height = size.height;
        this._alterBg.setPosition(size.width / 2, size.height / 2);
        this.addChild(this._alterBg);

        // 标题栏
        var titleBar = new ccui.ImageView(res.RoomTopBar_png);
        titleBar.setAnchorPoint(0.5, 1);
        titleBar.setPosition(size.width / 2, size.height);
        this._alterBg.addChild(titleBar);

        var title = new ccui.ImageView(res.FriendSelectFriend_png);
        title.setPosition(size.width / 2, size.height - 46);
        this._alterBg.addChild(title);

        // 左上角跳转按钮
        var that = this;
        var leftTopButtonBg = new ccui.Button(res.TopLeftButtonBg_png, "");
        leftTopButtonBg.setPosition(0, cc.winSize.height);
        leftTopButtonBg.setAnchorPoint(0, 1);
        leftTopButtonBg.addClickEventListener(function () {
            that.removeFromParent();
        });
        this._alterBg.addChild(leftTopButtonBg);

        var leftTopLabel = new ccui.ImageView(res.FriendBackarrow_png);
        leftTopLabel.setPosition(leftTopButtonBg.width / 2 - 5, leftTopButtonBg.height / 2);
        leftTopButtonBg.addChild(leftTopLabel);

        // 搜索框
        var searchBg =new ccui.ImageView(res.FriendSearchback_png);
        searchBg.setPosition(size.width / 2 - 40, 1150);
        this._alterBg.addChild(searchBg);

        var searchEditBox = new cc.EditBox(cc.size(searchBg.width - 10, searchBg.height - 6), new cc.Scale9Sprite(res.Transparency_50x50_png));
        searchEditBox.setPosition(size.width / 2 - 40, 1150);
        searchEditBox.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
        searchEditBox.setPlaceHolder("搜索好友");
        searchEditBox.setMaxLength(20);
        this._alterBg.addChild(searchEditBox);

        // 搜索按钮
        var searchBtn = new ccui.Button(res.FriendSearchbutton_png, "");
        searchBtn.setPosition(size.width / 2 + 270, 1150);
        searchBtn.addClickEventListener(function() {
            var keyword = searchEditBox.getString();
            if (keyword.length > 0 && that._data != null) {
                for (var i = 0; i < that._data.length; i ++) {
                    if (containsSubSequence(that._data[i]['nickName'], keyword)) {
                        that._data[i]['visiable'] = true;
                    }
                    else {
                        that._data[i]['visiable'] = false;
                    }
                }
            }
            that.renderData();
        });
        this._alterBg.addChild(searchBtn);

        // 好友列表背景
        var border = new ccui.ImageView(res.FriendBorder_png);
        border.setAnchorPoint(0.5, 1.0);
        border.setScale9Enabled(true);
        border.setCapInsets(cc.rect(30, 30, 148 - 60, 148 - 60));
        border.setContentSize(this._width, this._height);
        border.setPosition(cc.winSize.width / 2, cc.winSize.height - 240);
        this._alterBg.addChild(border);

        // 确认按钮
        var succBtn = new ccui.Button(res.followBtnBg_png, "");
        succBtn.setPosition(size.width/2 - 150, 80);
        succBtn.addClickEventListener(function () {
            for (var i = 0; i < that._data.length; i ++) {
                if (that._data[i]["visiable"] && that._data[i]["selected"]) {
                    var obj = new Object();
                    obj.type = "invite";
                    obj.desc = "[好友邀请]";
                    obj.roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
                    obj.roomPassWd = DataManager.getInstance().getCurrentRoomData()._password;
                    cc.log("inviteFriend " + JSON.stringify(obj) + " " + DataManager.getInstance().getCurrentRoomData().roomId + " " +
                        DataManager.getInstance().getCurrentRoomData().roomPassWd +" " + that._data[i]["userId"]);
                    TXIMSDK_sendCustomMessagetoClient(JSON.stringify(obj), that._data[i]["userId"]+"");
                }
            }
            ToastUtil.systemToastInMiddle("已发送好友邀请", 2.0);
            that.removeFromParent();
        });
        this._alterBg.addChild(succBtn);

        var succLabel = new ccui.ImageView(res.CommonConfirmLabel_png);
        succLabel.setScale(1.4);
        succLabel.setPosition(succBtn.width/2, succBtn.height/2);
        succBtn.addChild(succLabel);

        // 取消按钮
        var failBtn = new ccui.Button(res.fanBtnBg_png, "");
        failBtn.setPosition(size.width/2 + 150, 80);
        failBtn.addClickEventListener(function () {
            that.removeFromParent();
        });
        this._alterBg.addChild(failBtn);

        var failLabel = new ccui.ImageView(res.CancelLabel_png);
        failLabel.setScale(1.4);
        failLabel.setPosition(failBtn.width/2, failBtn.height/2);
        failBtn.addChild(failLabel);
    },

    loadData: function(){
        var that = this;
        TXIMSDK_getLocalFriendProfileListCallback = function(jsonStr){
            var obj = JSON.parse(jsonStr);
            var userList = new Array();
            for (var i = 0; i < obj.length; i ++) {
                var identifier = obj[i]['identifier'];
                userList.push(parseInt(identifier));
            }

            getUserListConfigCallback = function(jsonStr) {
                var responseObj = JSON.parse(jsonStr);
                if (responseObj.retCode == 1) {
                    that._data = responseObj.retBody.friendInfoList;
                    for (var i = 0; i < that._data.length; i ++) {
                        that._data[i]["visiable"] = true;
                        that._data[i]["selected"] = false;
                        that._data[i]["selected_sprite"] = null;
                    }
                    that.renderData();
                } else {
                    TXIMSDK_alert("获取用户个人信息失败");
                }
            };
            getUserListConfig(userList);
        };

        TXIMSDK_getLocalFriendProfileList();
    },

    renderData: function(){
        if (this._task_list != null) {
            this._task_list.removeFromParent();
            this._task_list = null;
        }

        var size = cc.winSize;

        this._task_list = new ccui.ListView();
        this._task_list.setDirection(ccui.ScrollView.DIR_VERTICAL);
        this._task_list.setTouchEnabled(true);
        this._task_list.setBounceEnabled(true);
        this._task_list.setAnchorPoint(0.5, 1.0);
        this._task_list.setContentSize(cc.size(this._width - 12, this._height - 50));
        this._task_list.setPosition(cc.winSize.width / 2, cc.winSize.height - 267);

        for (var i = 0; i < this._data.length; i ++) {
            var _visiable = this._data[i]['visiable'];
            if (!_visiable) continue;

            var _selected = this._data[i]['selected'];

            var _identifier = this._data[i]['userId'];
            var _nickname = this._data[i]['nickName'];
            var _avatar = this._data[i]['avatar'];
            var _vipLvl = this._data[i]['vipLevel'];
            var _awardscore = this._data[i]['cup'];
            var _winrate = this._data[i]['winningProbability'];

            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(this._width - 12, 120);
            defaultItemLayout.setTag(i + 1);

            var that = this;
            var itemback = new ccui.Button(res.FriendItemback_png, res.FriendItemback_png);
            itemback.setPosition(defaultItemLayout.width / 2, defaultItemLayout.height / 2);
            itemback.name = i;
            itemback.addClickEventListener(function(sender, type) {
                if (that._data[sender.name]["selected"] == true) {
                    that._data[sender.name]["selected"] = false;
                }
                else {
                    that._data[sender.name]["selected"] = true;
                }
                that._data[sender.name]['selected_sprite'].setVisible(that._data[sender.name]["selected"]);
            });
            defaultItemLayout.addChild(itemback);

            var selectBack = new ccui.ImageView(res.FriendSelectback_png);
            selectBack.setPosition(50, itemback.height / 2);
            itemback.addChild(selectBack);

            var select = new ccui.ImageView(res.DuiSmall_png);
            select.setPosition(50, itemback.height / 2);
            select.setVisible(_selected);
            itemback.addChild(select);
            this._data[i]['selected_sprite'] = select;

            var avatarBg = new ccui.ImageView(res.AvatarBg_png);
            avatarBg.setScale(0.9);
            avatarBg.setPosition(80 + 70, itemback.height / 2);
            itemback.addChild(avatarBg);

            var avatar = new ccui.ImageView(AvatarMap.get(_avatar)[1]);
            avatar.setPosition(avatarBg.width / 2, avatarBg.height / 2);
            avatar.setScale(0.8);
            avatarBg.addChild(avatar);

            var nickname = cc.LabelTTF(_nickname, "Arial", 28);
            nickname.setColor(cc.color(255, 250, 214));
            nickname.setAnchorPoint(0, 0.5);
            nickname.setPosition(160 + 70, 95);
            itemback.addChild(nickname);

            var awardLabel = cc.LabelTTF(_awardscore.toString(), "Arial", 28);
            awardLabel.setColor(cc.color(255, 250, 214));
            awardLabel.setAnchorPoint(0, 0.5);
            awardLabel.setPosition(210 + 70, 40);
            itemback.addChild(awardLabel);

            var awardCup = new ccui.ImageView(res.awardCup_png);
            awardCup.setAnchorPoint(0, 0.5);
            awardCup.setScale(0.8);
            awardCup.setPosition(160 + 70, 40);
            itemback.addChild(awardCup);

            var winrateLabel = cc.LabelTTF("胜率：", "Arial", 26);
            winrateLabel.setColor(cc.color(235, 139, 68));
            winrateLabel.setAnchorPoint(0, 0.5);
            winrateLabel.setPosition(310 + 70, 40);
            itemback.addChild(winrateLabel);

            var winrateValue = cc.LabelTTF(parseInt(_winrate*100).toString() + "%", "Arial", 26);
            winrateValue.setColor(cc.color(1, 255, 130));
            winrateValue.setAnchorPoint(0, 0.5);
            winrateValue.setPosition(390 + 70, 40);
            itemback.addChild(winrateValue);

            this._task_list.pushBackCustomItem(defaultItemLayout);
        }

        this._alterBg.addChild(this._task_list);
    },

    onEnter: function() {
        this._super();

        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        cc.eventManager.addListener(this._listener, this);
    },

    onExit: function() {
        this._super();

        cc.eventManager.removeListener(this._listener);
    }

});


