var FriendListLayer = cc.Layer.extend({
    _width : 720,
    _height : 948,
    _data: null,
    _task_list: null,
    ctor: function () {
        this._super();
        this.initBg();
        this.loadData();
    },

    initBg: function() {
        var size = cc.winSize;

        // 整体背景
        var bgLayer = new ccui.ImageView(res.homeTopBg_png);
        bgLayer.setScale9Enabled(true);
        bgLayer.setCapInsets(cc.rect(300, 270, 3, 3));
        bgLayer.setContentSize(size);
        bgLayer.setPosition(size.width / 2, size.height / 2);
        this.addChild(bgLayer);

        // 标题栏
        var titleBar = new ccui.ImageView(res.RoomTopBar_png);
        titleBar.setAnchorPoint(0.5, 1);
        titleBar.setPosition(size.width / 2, size.height);
        this.addChild(titleBar);

        var titleLabel = new ccui.ImageView(res.FriendList_png);
        titleLabel.setPosition(size.width / 2, size.height - 46);
        this.addChild(titleLabel);

        // 左上角跳转按钮
        var leftTopButtonBg = new ccui.Button(res.TopLeftButtonBg_png, "");
        leftTopButtonBg.setPosition(0, size.height);
        leftTopButtonBg.setAnchorPoint(0, 1);
        leftTopButtonBg.addClickEventListener(function () {
            cc.director.runScene(new FriendMessageScene());
        });
        this.addChild(leftTopButtonBg);

        var leftTopLabel = new ccui.ImageView(res.FriendBackarrow_png);
        leftTopLabel.setPosition(leftTopButtonBg.width / 2 - 5, leftTopButtonBg.height / 2);
        leftTopButtonBg.addChild(leftTopLabel);

        // 下部导航栏
        var tabMenuLayer = new TabMenuLayer();
        tabMenuLayer.setAnchorPoint(0, 0);
        tabMenuLayer.setPosition(0, 0);
        tabMenuLayer.getChildByName("socialButton").setScale(1.1);
        this.addChild(tabMenuLayer);

        // 搜索框
        var searchBg =new ccui.ImageView(res.FriendSearchback_png);
        searchBg.setPosition(size.width / 2 - 40, 1150);
        this.addChild(searchBg);

        var searchEditBox = new cc.EditBox(cc.size(510, 60), new cc.Scale9Sprite(res.Transparency_50x50_png));
        searchEditBox.setPosition(size.width / 2 - 40, 1150);
        searchEditBox.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
        searchEditBox.setPlaceHolder("搜索好友");
        searchEditBox.setMaxLength(20);
        this.addChild(searchEditBox);

        // 搜索按钮
        var that = this;
        var searchBtn = new ccui.Button(res.FriendSearchbutton_png, "");
        searchBtn.setPosition(size.width / 2 + 270, 1150);
        searchBtn.addClickEventListener(function() {
            var keyword = searchEditBox.getString();
            if (that._data != null) {
                for (var i = 0; i < that._data.length; i ++) {
                    if (containsSubSequence(that._data[i]['nickName'], keyword)) {
                        that._data[i]['visiable'] = true;
                    }
                    else {
                        that._data[i]['visiable'] = false;
                    }
                }
            }
            that.renderData();
        });
        this.addChild(searchBtn);

        // 好友列表背景
        var border = new ccui.ImageView(res.FriendBorder_png);
        border.setAnchorPoint(0.5, 1.0);
        border.setScale9Enabled(true);
        border.setCapInsets(cc.rect(30, 30, 148 - 60, 148 - 60));
        border.setContentSize(this._width, this._height);
        border.setPosition(size.width / 2, size.height - 240);
        this.addChild(border);
    },

    loadData: function(){
        var that = this;
        TXIMSDK_getLocalFriendProfileListCallback = function(jsonStr){
            var obj = JSON.parse(jsonStr);
            var userList = new Array();
            for (var i = 0; i < obj.length; i ++) {
                var identifier = obj[i]['identifier'];
                userList.push(parseInt(identifier));
            }

            getUserListConfigCallback = function(jsonStr) {
                var responseObj = JSON.parse(jsonStr);
                if (responseObj.retCode == 1) {
                    that._data = responseObj.retBody.friendInfoList;
                    for (var i = 0; i < that._data.length; i ++) {
                        that._data[i]["visiable"] = true;
                    }
                    that.renderData();
                } else {
                    TXIMSDK_alert("获取用户个人信息失败");
                }
            };
            getUserListConfig(userList);
        };

        TXIMSDK_getLocalFriendProfileList();
    },

    renderData: function(){
        if (this._task_list != null) {
            this._task_list.removeFromParent();
            this._task_list = null;
        }

        var size = cc.winSize;

        this._task_list = new ccui.ListView();
        this._task_list.setDirection(ccui.ScrollView.DIR_VERTICAL);
        this._task_list.setTouchEnabled(true);
        this._task_list.setBounceEnabled(true);
        this._task_list.setAnchorPoint(0.5, 1);
        this._task_list.setContentSize(this._width - 12, this._height - 50);
        this._task_list.setPosition(size.width / 2, size.height - 267);

        for (var i = 0; i < this._data.length; i ++) {
            var _visiable = this._data[i]['visiable'];
            if (!_visiable) continue;

            var _identifier = this._data[i]['userId'];
            var _nickname = this._data[i]['nickName'];
            var _avatar = this._data[i]['avatar'];
            var _vipLvl = this._data[i]['vipLevel'];
            var _awardscore = this._data[i]['cup'];
            var _winrate = this._data[i]['winningProbability'];

            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(this._width - 12, 120);
            defaultItemLayout.setTag(i + 1);

            var itemback = new ccui.Button(res.FriendItemback_png, res.FriendItemback_png);
            itemback.setPosition(defaultItemLayout.width / 2, defaultItemLayout.height / 2);
            itemback.name = _identifier;
            itemback.addClickEventListener(function(sender, type) {
                cc.director.runScene(new FriendChatScene(sender.name));
            });
            defaultItemLayout.addChild(itemback);

            var avatarBg = new ccui.ImageView(res.AvatarBg_png);
            avatarBg.setScale(0.9);
            avatarBg.setPosition(80, itemback.height / 2);
            itemback.addChild(avatarBg);

            var avatar = new ccui.ImageView(AvatarMap.get(_avatar)[1]);
            avatar.setPosition(avatarBg.width / 2, avatarBg.height / 2);
            avatar.setScale(0.8);
            avatarBg.addChild(avatar);

            var nickname = cc.LabelTTF(_nickname, "Arial", 28);
            nickname.setColor(cc.color(255, 250, 214));
            nickname.setAnchorPoint(0, 0.5);
            nickname.setPosition(160, 95);
            itemback.addChild(nickname);

            var vipImage = new ccui.ImageView(res.HomepageVIPLabel_png);
            vipImage.setAnchorPoint(0, 0.5);
            vipImage.setScale(0.8);
            vipImage.setPosition(310, 95);
            itemback.addChild(vipImage);

            var vipLabel = cc.LabelTTF(_vipLvl.toString(), "Arial", 28);
            vipLabel.setColor(cc.color(255, 250, 214));
            vipLabel.setAnchorPoint(0, 0.5);
            vipLabel.setPosition(390, 95);
            itemback.addChild(vipLabel);

            var awardCup = new ccui.ImageView(res.awardCup_png);
            awardCup.setAnchorPoint(0, 0.5);
            awardCup.setScale(0.8);
            awardCup.setPosition(160, 40);
            itemback.addChild(awardCup);

            var awardLabel = cc.LabelTTF(_awardscore.toString(), "Arial", 28);
            awardLabel.setColor(cc.color(255, 250, 214));
            awardLabel.setAnchorPoint(0, 0.5);
            awardLabel.setPosition(210, 40);
            itemback.addChild(awardLabel);

            var winrateLabel = cc.LabelTTF("胜率：", "Arial", 26);
            winrateLabel.setColor(cc.color(235, 139, 68));
            winrateLabel.setAnchorPoint(0, 0.5);
            winrateLabel.setPosition(310, 40);
            itemback.addChild(winrateLabel);

            var winrateValue = cc.LabelTTF(parseInt(_winrate*100).toString() + "%", "Arial", 26);
            winrateValue.setColor(cc.color(1, 255, 130));
            winrateValue.setAnchorPoint(0, 0.5);
            winrateValue.setPosition(390, 40);
            itemback.addChild(winrateValue);

            this._task_list.pushBackCustomItem(defaultItemLayout);
        }

        this.addChild(this._task_list);
    }
});

var FriendListScene = cc.Scene.extend({

    _backListener : null,

    ctor: function () {
        this._super();
        var friendListLayer = new FriendListLayer();
        this.addChild(friendListLayer);

        this._backListener = cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if(keyCode == cc.KEY.back) {
                    cc.log("jijun android back");
                    cc.director.runScene(new FriendMessageScene());
                } else if(keyCode == cc.KEY.menu) {
                    cc.log("jijun android menu");
                }
            }
        }, this);
    },

    onExit:function () {
        this._super();
        cc.eventManager.removeListener(this._backListener);
    },
});


