var FriendMessageLayer = cc.Layer.extend({
    _width : 720,
    _height : 1068,
    _data: null,
    _persondata: null,
    _toplist: new Array(),
    _friendlist: null,
    ctor: function () {
        this._super();
        this.initBg();
        this.loadData();
    },

    initBg: function() {
        var that = this;
        
        // 整体背景
        var bgLayer = new ccui.ImageView(res.homeTopBg_png);
        bgLayer.setScale9Enabled(true);
        bgLayer.setCapInsets(cc.rect(300, 270, 3, 3));
        bgLayer.width = cc.winSize.width;
        bgLayer.height = cc.winSize.height;
        bgLayer.setPosition(cc.winSize.width/2,cc.winSize.height/2);
        this.addChild(bgLayer);
        
        var topBar = new ccui.ImageView(res.RoomTopBar_png);
        topBar.setScale9Enabled(true);
        topBar.setPosition(cc.winSize.width/2,cc.winSize.height-topBar.height/2);
        this.addChild(topBar);

        // 标题栏
        var pageLabel = new ccui.ImageView(res.FriendMessage_png);
        pageLabel.setPosition(cc.winSize.width/2,cc.winSize.height-pageLabel.height/2-cc.winSize.height*0.02);
        this.addChild(pageLabel);

        // 左上角跳转按钮
        var leftTopButtonBg = new ccui.Button(res.TopLeftButtonBg_png, "");
        leftTopButtonBg.setPosition(0, cc.winSize.height);
        leftTopButtonBg.setAnchorPoint(0, 1);
        leftTopButtonBg.addClickEventListener(function () {
            that.addChild(new FriendAddLayer());
        });
        this.addChild(leftTopButtonBg);

        var leftTopLabel = new ccui.ImageView(res.FriendAddfriend_png);
        leftTopLabel.setPosition(leftTopButtonBg.width/2 - 5, leftTopButtonBg.height/2);
        leftTopButtonBg.addChild(leftTopLabel);

        // 右上角跳转按钮
        var rightTopButtonBg = new ccui.Button(res.TopRightButtonBg_png, "");
        rightTopButtonBg.setPosition(cc.winSize.width, cc.winSize.height);
        rightTopButtonBg.setAnchorPoint(1, 1);
        rightTopButtonBg.addClickEventListener(function () {
            cc.director.runScene(new FriendListScene());
        });
        this.addChild(rightTopButtonBg);

        var bagLabel = new ccui.ImageView(res.FriendListfriend_png);
        bagLabel.setPosition(rightTopButtonBg.width/2 + 5, rightTopButtonBg.height/2);
        rightTopButtonBg.addChild(bagLabel);

        // 消息列表背景
        var border = new ccui.ImageView(res.FriendBorder_png);
        border.setAnchorPoint(0.5, 1.0);
        border.setScale9Enabled(true);
        border.setCapInsets(cc.rect(30, 30, 148 - 60, 148 - 60));
        border.setContentSize(this._width, this._height);
        border.setPosition(cc.winSize.width / 2, cc.winSize.height - 120);
        this.addChild(border);

        // 下部导航栏
        this.tabMenuLayer = new TabMenuLayer();
        this.tabMenuLayer.setAnchorPoint(cc.p(0,0));
        this.tabMenuLayer.setPosition(0, 0);
        this.addChild(this.tabMenuLayer);
        this.tabMenuLayer.getChildByName("socialButton").setScale(1.1);
    },

    loadData: function(){
        // 加载本地置顶聊天列表
        var toplistJsonStr = cc.sys.localStorage.getItem("toplist");
        if (toplistJsonStr != null) {
            var obj = JSON.parse(toplistJsonStr);
            for (var i = 0; i < obj.length; i ++) {
                this._toplist[obj[i]] = true;
            }
        }
        cc.log("当前置顶聊天列表" + toplistJsonStr);

        // 加载好友列表
        var that = this;
        TXIMSDK_getLocalFriendProfileListCallback = function(jsonStr){
            that._friendlist = new Array();
            var obj = JSON.parse(jsonStr);
            for (var i = 0; i < obj.length; i ++) {
                var identifier = obj[i]['identifier'];
                that._friendlist[identifier] = true;
            }

            TXIMSDK_getAllConversationSucc = function(jsonStr){
                // 最后一次对话时间排序
                var tmp = JSON.parse(jsonStr);
                function sortFunc(a, b) {
                    var timestamp1 = a["timestamp"].replace(/-/g, "/");
                    var datetime1 = new Date(Date.parse(timestamp1));
                    var timestamp2 = b["timestamp"].replace(/-/g, "/");
                    var datetime2 = new Date(Date.parse(timestamp2));
                    return datetime2 - datetime1;
                }
                tmp.sort(sortFunc);

                // 置顶聊天排序
                that._data = new Array();
                for (var i = 0; i < tmp.length; i ++) {
                    var identifier = tmp[i]['identifier'];
                    if (that._friendlist.hasOwnProperty(identifier)) {
                        if (that._toplist.hasOwnProperty(identifier)) {
                            that._data.push(tmp[i]);
                        }
                    }
                    else {
                        TXIMSDK_deleteConversationAndMessagesForClient(identifier);
                    }
                }
                for (var i = 0; i < tmp.length; i ++) {
                    var identifier = tmp[i]['identifier'];
                    if (that._friendlist.hasOwnProperty(identifier)) {
                        if (!that._toplist.hasOwnProperty(identifier)) {
                            that._data.push(tmp[i]);
                        }
                    }
                    else {
                        TXIMSDK_deleteConversationAndMessagesForClient(identifier);
                    }
                }

                var userList = [];
                for (var i = 0; i < that._data.length; i ++) {
                    userList.push(parseInt(that._data[i]['identifier']));
                }

                getUserListConfigCallback = function(jsonStr) {
                    var responseObj = JSON.parse(jsonStr);
                    if (responseObj.retCode == 1) {
                        that._persondata = {};
                        for (var i = 0; i < responseObj.retBody.friendInfoList.length; i ++) {
                            var now = responseObj.retBody.friendInfoList[i];
                            that._persondata[now["userId"].toString()] = now;
                        }
                        that.renderData();
                    } else {
                        ToastUtil.systemToastInMiddle("获取用户个人信息失败", 2.0);
                    }
                };
                getUserListConfig(userList);

                var allUnreadCnt = 0;
                for (var i = 0; i < that._data.length; i ++) {
                    allUnreadCnt += that._data[i]['unreadCnt'];
                }
                that.tabMenuLayer.addRedDot(allUnreadCnt);
            };

            TXIMSDK_getAllConversationFail = function(code, msg){
                ToastUtil.systemToastInMiddle(code.toString() + "->" + msg, 2.0);
            };

            TXIMSDK_getAllConversation();
        };

        TXIMSDK_getLocalFriendProfileList();
    },

    renderData: function(){
        if (this._task_list != null) {
            this._task_list.removeFromParent();
            this._task_list = null;
        }

        var size = cc.winSize;

        this._task_list = new ccui.ListView();
        this._task_list.setDirection(ccui.ScrollView.DIR_VERTICAL);
        this._task_list.setTouchEnabled(true);
        this._task_list.setBounceEnabled(true);
        this._task_list.setAnchorPoint(0.5, 1.0);
        this._task_list.setContentSize(cc.size(this._width - 12, this._height - 50));
        this._task_list.setPosition(size.width / 2, size.height - 147);

        for (var i = 0; i < this._data.length; i ++) {
            var _identifier        = this._data[i]['identifier'];
            if (!(_identifier in this._persondata)) continue;

            var _type              = this._data[i]['type'];
            var _data              = this._data[i]['data'];
            var _timestamp         = this._data[i]['timestamp'];
            var _unreadCnt         = this._data[i]['unreadCnt'];

            var _nickname          = this._persondata[_identifier]['nickName'];
            var _avatar            = this._persondata[_identifier]['avatar'];
            var _awardscore        = this._persondata[_identifier]['cup'];
            var _currentGameRoomId = this._persondata[_identifier]['currentGameRoomId'];

            var defaultItemLayout = new ccui.Layout();
            defaultItemLayout.setTouchEnabled(true);
            defaultItemLayout.setContentSize(this._width - 12, 120);
            defaultItemLayout.setTag(i + 1);

            var imgSrc = this._toplist.hasOwnProperty(_identifier) ? res.FriendItemback3_png : res.FriendItemback_png;
            var itemback = new ccui.Button(imgSrc, imgSrc);
            itemback.setPosition(defaultItemLayout.width / 2, defaultItemLayout.height / 2);
            itemback.name = _identifier;
            itemback.addClickEventListener(function(sender, type) {
                cc.director.runScene(new FriendChatScene(sender.name));
            });
            defaultItemLayout.addChild(itemback);

            var avatarBg = new ccui.ImageView(res.AvatarBg_png);
            avatarBg.setScale(0.9);
            avatarBg.setPosition(cc.p(80, itemback.height / 2));
            itemback.addChild(avatarBg);

            var avatar = new ccui.ImageView(AvatarMap.get(_avatar)[1]);
            avatar.setPosition(avatarBg.width / 2, avatarBg.height / 2);
            avatar.setScale(0.8);
            avatarBg.addChild(avatar);

            if (_unreadCnt > 0) {
                var reddot = new ccui.ImageView(res.FriendReddot_png);
                reddot.setPosition(avatarBg.width - 5, avatarBg.height - 5);
                avatarBg.addChild(reddot);

                if (_unreadCnt > 9) {
                    var unReadCntLabel = cc.LabelTTF("9+", "Arial", 20);
                    unReadCntLabel.setPosition(avatarBg.width - 5, avatarBg.height - 5);
                    avatarBg.addChild(unReadCntLabel);
                }
                else {
                    var unReadCntLabel = cc.LabelTTF(_unreadCnt.toString(), "Arial", 20);
                    unReadCntLabel.setPosition(avatarBg.width - 5, avatarBg.height - 5);
                    avatarBg.addChild(unReadCntLabel);
                }
            }

            var nickname = cc.LabelTTF(_nickname, "Arial", 28);
            nickname.setColor(cc.color(255, 250, 214));
            nickname.setAnchorPoint(0, 0.5);
            nickname.setPosition(160, 95);
            itemback.addChild(nickname);

            var awardCup = new ccui.ImageView(res.awardCup_png);
            awardCup.setScale(0.8);
            awardCup.setPosition(320, 95);
            itemback.addChild(awardCup);

            var awardLabel = cc.LabelTTF(_awardscore.toString(), "Arial", 28);
            awardLabel.setColor(cc.color(255, 250, 214));
            awardLabel.setAnchorPoint(0, 0.5);
            awardLabel.setPosition(360, 95);
            itemback.addChild(awardLabel);

            cc.log("timestamp " + _timestamp + " " + formatTimestamp(_timestamp));
            var time = cc.LabelTTF(formatTimestamp(_timestamp), "Arial", 26);
            time.setAnchorPoint(1, 0.5);
            time.setColor(cc.color(247, 255, 184));
            time.setPosition(640, 95);
            itemback.addChild(time);

            var content = "";
            if (_type == "text") {
                content = _data;
            }
            else if (_type == "custom") {
                var obj = JSON.parse(_data);
                content = obj["desc"];
            }
            if (content.length > 10) {
                content = content.substr(0, 10) + "...";
            }
            var lastMessage = cc.LabelTTF(content, "Arial", 26);
            lastMessage.setColor(cc.color(235, 139, 68));
            lastMessage.setAnchorPoint(0, 0.5);
            lastMessage.setPosition(160, 40);
            itemback.addChild(lastMessage);

            if (_currentGameRoomId != -1) {
                var roomback = new ccui.Button(res.FriendRoomback_png);
                roomback.setAnchorPoint(1, 0.5);
                roomback.setPosition(640, 40);
                roomback.setUserData(_currentGameRoomId);
                roomback.addClickEventListener(function () {
                    MqttHelper.getInstance().joinRoom(this.getUserData());
                });
                itemback.addChild(roomback);

                var roomid = cc.LabelTTF(_currentGameRoomId.toString() + "房", "Arial", 16);
                roomid.setColor(cc.color(1, 255, 130));
                roomid.setAnchorPoint(0, 0.5);
                roomid.setPosition(4, roomback.height / 2);
                roomback.addChild(roomid);
            }

            this._task_list.pushBackCustomItem(defaultItemLayout);
        }

        this.addChild(this._task_list);
    },

    onNewMessage: function(jsonStr) {
        this.loadData();
    }
});

var FriendMessageScene = cc.Scene.extend({
    joinRoom:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(997001);
        joinRoomSendFlag = false;
        quickJoinRoomSendFlag = false;
        createRoomSendFlag = false;
        DataManager.getInstance().getCurrentRoomData().clear();
        DataManager.getInstance().getCurrentRoomData().parseFromObj(payloadObj);
        cc.director.runScene(new RoomScene(false));
    },

    joinRoomFailed:function (payloadObj) {
        joinRoomSendFlag = false;
        quickJoinRoomSendFlag = false;
        cc.director.getRunningScene().removeChildByTag(997001);
        var lastRoomId = payloadObj.roomId;
        if(lastRoomId != null && lastRoomId != undefined && lastRoomId != -1) {
            var resumeConfirmDialog = new CommonDialog(DialogType.ResumeConfirmDialog, lastRoomId);
            resumeConfirmDialog.popup();
        } else {
            ToastUtil.systemToastInMiddle(payloadObj.message, 2.0);
        }
    },

    resumePush:function (payloadObj) {
        joinRoomSendFlag = false;
        quickJoinRoomSendFlag = false;
        createRoomSendFlag = false;
        DataManager.getInstance().getCurrentRoomData().clear();
        DataManager.getInstance().getResumeData().parseData(payloadObj);
        cc.director.runScene(new RoomScene(true));
    },

    joinRoomWithPasswordResponse:function(payloadObj) {
        joinRoomSendFlag = false;
        quickJoinRoomSendFlag = false;
        createRoomSendFlag = false;
        cc.director.getRunningScene().removeChildByTag(997001);
        var passwordDialog = new ModalDialogueBox(DialogType.InputPassword, [payloadObj.hallRoomId]);
        passwordDialog.popup();
    },

    verifyPasswordFailedResponse:function (payloadObj) {
        cc.director.getRunningScene().removeChildByTag(997001);
        ToastUtil.systemToastInMiddle(payloadObj.message, 2.0);
    },

    _backListener : null,

    onEnter: function () {
        this._super();
        this.friendMessageLayer = new FriendMessageLayer();
        this.addChild(this.friendMessageLayer);

        this._backListener = cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if(keyCode == cc.KEY.back) {
                    cc.log("jijun android back");
                    var quitAppConfirmDialog = new CommonDialog(DialogType.QuitAppConfrimDialog, -1);
                    quitAppConfirmDialog.setTag(DialogType.QuitAppConfrimDialog);
                    quitAppConfirmDialog.popup();
                } else if(keyCode == cc.KEY.menu) {
                    cc.log("jijun android menu");
                }
            }
        }, this);

        MqttClient.getInstance().clearMqttCallBackMap();
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.JOINROOM_RESPONSE, this.joinRoom);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.JOINROOM_FAILED_RESPONSE, this.joinRoomFailed);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.RESUME_PUSH, this.resumePush);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.JOINROOM_WITH_PASSWORD_RESPONSE, this.joinRoomWithPasswordResponse);
        MqttClient.getInstance()._mqttCallbackRegister(GameCmd.VERIFY_PASSWORD_FAILED_RESPONSE, this.verifyPasswordFailedResponse);
    },

    onNewMessage: function(jsonStr) {
        this.friendMessageLayer.onNewMessage(jsonStr);
    },

    onExit:function () {
        this._super();
        cc.eventManager.removeListener(this._backListener);
    },
});
