/**
 * Created by ziaoang on 2017/4/4.
 */

var FriendSettingLayer = cc.LayerColor.extend({
    _width : 720,
    _height : 936,
    _listener : null,
    _isChatTop : false,
    _identifier : null,
    _data : null,
    _toplist: new Array(),
    ctor: function (identifier) {
        this._super(cc.color.BLACK);
        this.setOpacity(153);

        this._identifier = identifier;

        this.initBg();

        this.loadData();
    },

    initBg: function(){
        var size = cc.winSize;

        // 弹窗背景
        var alterBg = new ccui.ImageView(res.CommonDialogBg_png);
        alterBg.setScale9Enabled(true);
        alterBg.setCapInsets(cc.rect(30, 30, 499 - 60, 281 - 60));
        alterBg.width = this._width;
        alterBg.height = this._height;
        alterBg.setPosition(size.width / 2, size.height / 2);
        this.addChild(alterBg);

        // 弹窗标题
        var titleBg = new ccui.ImageView(res.DialogTitle2_png);
        titleBg.setPosition(alterBg.width / 2, alterBg.height);
        alterBg.addChild(titleBg);

        var title = new ccui.ImageView(res.FriendMoreInfo_png);
        title.setPosition(titleBg.width / 2, titleBg.height/2 + 20);
        titleBg.addChild(title);

        var that = this;
        var closeButton = new ccui.Button(res.RedClose_png, "");
        closeButton.setPosition(this._width - 20, this._height - 20);
        closeButton.addClickEventListener(function () {
            that.removeFromParent();
        });
        alterBg.addChild(closeButton);

        this.innerBg = new ccui.ImageView(res.CommonDialogInnerBg_png);
        this.innerBg.setScale9Enabled(true);
        this.innerBg.setCapInsets(cc.rect(30, 30, 126 - 60, 145 - 60));
        this.innerBg.width = 656;
        this.innerBg.height = 200;
        this.innerBg.setPosition(alterBg.width / 2, alterBg.height - 210);
        alterBg.addChild(this.innerBg);

        var innerBg2 = new ccui.ImageView(res.CommonDialogInnerBg_png);
        innerBg2.setScale9Enabled(true);
        innerBg2.setCapInsets(cc.rect(30, 30, 126 - 60, 145 - 60));
        innerBg2.width = 656;
        innerBg2.height = 436;
        innerBg2.setPosition(alterBg.width / 2, alterBg.height - 548);
        alterBg.addChild(innerBg2);

        var itemback = new ccui.ImageView(res.FriendItemback2_png);
        itemback.setPosition(innerBg2.width / 2, innerBg2.height - 80);
        innerBg2.addChild(itemback);

        var itemTTF = new cc.LabelTTF("置顶聊天", "Arial", 36);
        itemTTF.setColor(cc.color(235, 227, 134));
        itemTTF.setAnchorPoint(0, 0.5);
        itemTTF.setPosition(100, itemback.height / 2);
        itemback.addChild(itemTTF);

        // 加载本地置顶聊天列表
        var toplistJsonStr = cc.sys.localStorage.getItem("toplist");
        if (toplistJsonStr != null) {
            var obj = JSON.parse(toplistJsonStr);
            for (var i = 0; i < obj.length; i ++) {
                this._toplist[obj[i]] = true;
            }
        }
        if (this._toplist.hasOwnProperty(this._identifier)) {
            this._isChatTop = true;
        }
        else {
            this._isChatTop = false;
        }

        var that = this;
        this.slidebuttonback = new ccui.Button(res.FriendSlideButtonBack_png, res.FriendSlideButtonBack_png);
        this.slidebuttonback.setPosition(itemback.width - 100, itemback.height / 2);
        this.slidebuttonback.addClickEventListener(function () {
            that.setChatTop();
        });
        itemback.addChild(this.slidebuttonback);

        this.slidebuttonback2 = new ccui.ImageView(res.FriendSlideButtonBack2_png);
        this.slidebuttonback2.setPosition(this.slidebuttonback.width / 2, this.slidebuttonback.height / 2);
        this.slidebuttonback2.setVisible(this._isChatTop ? true : false);
        this.slidebuttonback.addChild(this.slidebuttonback2);

        this.slidebutton = new ccui.ImageView(res.FriendSlideButton_png);
        this.slidebutton.setPosition(this._isChatTop ? this.slidebuttonback.width - 20: 20, this.slidebuttonback.height / 2);
        this.slidebuttonback.addChild(this.slidebutton);

        var itemback2 = new ccui.Button(res.FriendItemback2_png, res.FriendItemback2_png);
        itemback2.setPosition(innerBg2.width / 2, innerBg2.height - 216);
        itemback2.addClickEventListener(function () {
            that.addChild(new FriendSetRemarkLayer(that._identifier));
        });
        innerBg2.addChild(itemback2);

        var itemTTF2 = new cc.LabelTTF("设置备注", "Arial", 36);
        itemTTF2.setColor(cc.color(235, 227, 134));
        itemTTF2.setAnchorPoint(0, 0.5);
        itemTTF2.setPosition(100, itemback2.height / 2);
        itemback2.addChild(itemTTF2);

        var arrowbutton = new ccui.ImageView(res.FriendArrow_png);
        arrowbutton.setPosition(itemback2.width - 100, itemback2.height / 2);
        itemback2.addChild(arrowbutton);

        var itemback3 = new ccui.Button(res.FriendItemback2_png, res.FriendItemback2_png);
        itemback3.setPosition(innerBg2.width / 2, innerBg2.height - 352);
        itemback3.addClickEventListener(function () {
            var layer = new OtherHomePageLayer(2, that._identifier);
            cc.director.getRunningScene().addChild(layer, 100);
        });
        innerBg2.addChild(itemback3);

        var itemTTF3 = new cc.LabelTTF("个人主页", "Arial", 36);
        itemTTF3.setColor(cc.color(235, 227, 134));
        itemTTF3.setAnchorPoint(0, 0.5);
        itemTTF3.setPosition(100, itemback3.height / 2);
        itemback3.addChild(itemTTF3);

        var arrowbutton2 = new ccui.ImageView(res.FriendArrow_png);
        arrowbutton2.setPosition(itemback3.width - 100, itemback3.height / 2);
        itemback3.addChild(arrowbutton2);

        var confirmButton = new ccui.Button(res.QuickJoinRoom_png, res.QuickJoinRoomDown_png);
        confirmButton.setPosition(this._width / 2, 80);
        confirmButton.setScale(1.2);
        confirmButton.addClickEventListener(function () {
            that.addChild(new FriendDeleteFriendConfirmLayer(that._identifier));
        });
        alterBg.addChild(confirmButton);

        var buttonTitle = new ccui.ImageView(res.FriendDelFriend2_png);
        buttonTitle.setPosition(confirmButton.width / 2, confirmButton.height / 2);
        buttonTitle.setScale(0.9);
        confirmButton.addChild(buttonTitle);
    },

    loadData: function(){
        var that = this;
        TXIMSDK_getLocalFriendProfileCallback = function(jsonStr){
            that._data = JSON.parse(jsonStr);
            if (that._data.length == 1) {
                var userList = [];
                userList.push(parseInt(that._data[0]['identifier']));

                getUserListConfigCallback = function(jsonStr) {
                    var responseObj = JSON.parse(jsonStr);
                    if (responseObj.retCode == 1) {
                        that._persondata = {};
                        for (var i = 0; i < responseObj.retBody.friendInfoList.length; i ++) {
                            var now = responseObj.retBody.friendInfoList[i];
                            that._persondata[now["userId"].toString()] = now;
                        }
                        that.renderData();
                    } else {
                        ToastUtil.systemToastInMiddle("服务器获取用户个人信息失败", 2.0);
                    }
                };
                getUserListConfig(userList);
            }
            else {
                ToastUtil.systemToastInMiddle("云通信获取用户个人信息失败", 2.0);
            }
        };

        TXIMSDK_getLocalFriendProfile(this._identifier);
    },

    renderData: function(){
        var _identifier = this._identifier;

        var _remark = this._data[0]["remark"];

        var _nickname          = this._persondata[_identifier]['nickName'];
        var _avatar            = this._persondata[_identifier]['avatar'];
        var _awardscore        = this._persondata[_identifier]['cup'];
        var _currentGameRoomId = this._persondata[_identifier]['currentGameRoomId'];

        var avatarBg = new ccui.ImageView(res.AvatarBg_png);
        avatarBg.setScale(0.9);
        avatarBg.setPosition(100, this.innerBg.height / 2);
        this.innerBg.addChild(avatarBg);

        var avatar = new ccui.ImageView(AvatarMap.get(_avatar)[1]);
        avatar.setPosition(avatarBg.width / 2, avatarBg.height / 2);
        avatar.setScale(0.8);
        avatarBg.addChild(avatar);

        var ttf1 = new cc.LabelTTF(_nickname, "Arial", 40);
        ttf1.setColor(cc.color(252, 192, 0));
        ttf1.setAnchorPoint(0, 0.5);
        ttf1.setPosition(200, this.innerBg.height / 2 + 30);
        this.innerBg.addChild(ttf1);

        this.ttf2 = new cc.LabelTTF("备注名：" + _remark, "Arial", 30);
        this.ttf2.setColor(cc.color(235, 227, 134));
        this.ttf2.setAnchorPoint(0, 0.5);
        this.ttf2.setPosition(200, this.innerBg.height / 2 - 30);
        this.innerBg.addChild(this.ttf2);
    },

    renderRemark: function(remark){
        this.ttf2.setString("备注名：" + remark);
    },

    setChatTop: function(){
        if (this._isChatTop) {
            this._isChatTop = false;
            this.slidebuttonback2.setVisible(false);
            this.slidebutton.setPosition(20, this.slidebuttonback.height / 2);

            var futureToplist = new Array();
            var toplistJsonStr = cc.sys.localStorage.getItem("toplist");
            if (toplistJsonStr != null) {
                var obj = JSON.parse(toplistJsonStr);
                for (var i = 0; i < obj.length; i ++) {
                    if (obj[i] != this._identifier) {
                        futureToplist.push(obj[i]);
                    }
                }
            }
            cc.log("取消置顶前" + toplistJsonStr);
            cc.log("取消置顶后" + JSON.stringify(futureToplist));
            cc.sys.localStorage.setItem("toplist", JSON.stringify(futureToplist));
        }
        else {
            this._isChatTop = true;
            this.slidebuttonback2.setVisible(true);
            this.slidebutton.setPosition(this.slidebuttonback.width - 20, this.slidebuttonback.height / 2);

            var futureToplist = new Array();
            var toplistJsonStr = cc.sys.localStorage.getItem("toplist");
            if (toplistJsonStr != null) {
                var obj = JSON.parse(toplistJsonStr);
                for (var i = 0; i < obj.length; i++) {
                    futureToplist.push(obj[i]);
                }
            }
            futureToplist.push(this._identifier);
            cc.log("取消置顶前" + toplistJsonStr);
            cc.log("取消置顶后" + JSON.stringify(futureToplist));
            cc.sys.localStorage.setItem("toplist", JSON.stringify(futureToplist));
        }
    },

    onEnter: function() {
        this._super();

        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        cc.eventManager.addListener(this._listener, this);
    },

    onExit: function() {
        this._super();

        cc.eventManager.removeListener(this._listener);
    },
});

var FriendSetRemarkLayer = cc.LayerColor.extend({
    _width : 640,
    _height : 400,
    _listener : null,
    _identifier: null,
    ctor: function (identifier) {
        this._super(cc.color.BLACK);
        this.setOpacity(153);

        this._identifier = identifier;

        var size = cc.winSize;

        // 弹窗背景
        var alterBg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        alterBg.setScale9Enabled(true);
        alterBg.setCapInsets(cc.rect(30, 30, 499 - 60, 281 - 60));
        alterBg.width = this._width;
        alterBg.height = this._height;
        alterBg.setPosition(size.width / 2, size.height / 2);
        this.addChild(alterBg);

        // 弹窗标题
        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setPosition(this._width / 2, this._height);
        alterBg.addChild(titleBg);

        var title = new ccui.ImageView(res.FriendSetRemark_png);
        title.setPosition(this._width / 2, this._height);
        alterBg.addChild(title);

        var that = this;
        var closeButton = new ccui.Button(res.RedClose_png, "");
        closeButton.setPosition(this._width - 20, this._height - 20);
        closeButton.addClickEventListener(function () {
            that.removeFromParent();
        });
        alterBg.addChild(closeButton);

        // 弹窗内容
        var infoTTF = new cc.LabelTTF("请输入备注", "Arial", 30);
        infoTTF.setColor(cc.color(235, 227, 134));
        infoTTF.setPosition(this._width / 2, this._height / 2 + 80);
        alterBg.addChild(infoTTF);

        var searchBg =new ccui.ImageView(res.FriendSearchback2_png);
        searchBg.setPosition(this._width / 2, this._height / 2);
        alterBg.addChild(searchBg);

        var searchEditBox = new cc.EditBox(cc.size(searchBg.width - 10, searchBg.height - 6), new cc.Scale9Sprite(res.Transparency_50x50_png));
        searchEditBox.setPosition(this._width / 2, this._height / 2);
        searchEditBox.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
        searchEditBox.setMaxLength(20);
        alterBg.addChild(searchEditBox);

        var confirmButton = new ccui.Button(res.IdJoinRoom_png, res.IdJoinRoomDown_png);
        confirmButton.setPosition(this._width / 2, this._height / 2 - 100);
        confirmButton.addClickEventListener(function () {
            var remark = searchEditBox.getString();
            if (remark != "") {
                TXIMSDK_setFriendRemarkSucc = function(){
                    ToastUtil.systemToastInMiddle("设置昵称成功", 2.0);
                    that.parent.renderRemark(remark);
                    that.removeFromParent();
                };
                TXIMSDK_setFriendRemarkFail = function(code, msg){
                    ToastUtil.systemToastInMiddle("设置昵称失败：" + code.toString() + "->" + msg, 2.0);
                };
                TXIMSDK_setFriendRemark(remark, that._identifier);
            }
        });
        alterBg.addChild(confirmButton);

        var buttonTitle = new ccui.ImageView(res.CommonConfirmLabel_png);
        buttonTitle.setPosition(this._width / 2, this._height / 2 - 100);
        alterBg.addChild(buttonTitle);
    },

    onEnter: function() {
        this._super();

        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        cc.eventManager.addListener(this._listener, this);
    },

    onExit: function() {
        this._super();

        cc.eventManager.removeListener(this._listener);
    },
});

var FriendDeleteFriendConfirmLayer = cc.LayerColor.extend({
    _width : 640,
    _height : 300,
    _listener : null,
    _identifier: null,
    ctor: function (identifier) {
        this._super(cc.color.BLACK);
        this.setOpacity(153);

        this._identifier = identifier;

        var size = cc.winSize;

        // 弹窗背景
        var alterBg = new ccui.ImageView(res.YesOrNoDialogBg_png);
        alterBg.setScale9Enabled(true);
        alterBg.setCapInsets(cc.rect(30, 30, 499 - 60, 281 - 60));
        alterBg.width = this._width;
        alterBg.height = this._height;
        alterBg.setPosition(size.width / 2, size.height / 2);
        this.addChild(alterBg);

        // 弹窗标题
        var titleBg = new ccui.ImageView(res.DialogTitleBg_png);
        titleBg.setPosition(this._width / 2, this._height);
        alterBg.addChild(titleBg);

        var title = new ccui.ImageView(res.FriendDelFriend_png);
        title.setPosition(this._width / 2, this._height);
        alterBg.addChild(title);

        // 关闭按钮
        var that = this;
        var closeButton = new ccui.Button(res.RedClose_png, "");
        closeButton.setPosition(this._width - 20, this._height - 20);
        closeButton.addClickEventListener(function () {
            that.removeFromParent();
        });
        alterBg.addChild(closeButton);

        // 弹窗内容
        var infoTTF = new cc.LabelTTF("确认删除该好友?", "Arial", 30);
        infoTTF.setColor(cc.color(235, 227, 134));
        infoTTF.setPosition(this._width / 2, this._height / 2 + 40);
        alterBg.addChild(infoTTF);

        var confirmButton = new ccui.Button(res.IdJoinRoom_png, res.IdJoinRoomDown_png);
        confirmButton.setPosition(this._width / 2 - 150, 90);
        confirmButton.addClickEventListener(function () {
            TXIMSDK_delFriendSucc = function(){
                TXIMSDK_deleteConversationAndMessagesForClient(that._identifier);
                cc.director.runScene(new FriendMessageScene());
            };
            TXIMSDK_delFriendFail = function(code, msg){
                ToastUtil.systemToastInMiddle("删除好友失败：" + code.toString() + "->" + msg, 2.0);
            };
            TXIMSDK_delFriend(that._identifier);
        });
        alterBg.addChild(confirmButton);

        var buttonTitle = new ccui.ImageView(res.CommonConfirmLabel_png);
        buttonTitle.setPosition(confirmButton.width / 2, confirmButton.height / 2);
        confirmButton.addChild(buttonTitle);

        var cancelButton = new ccui.Button(res.QuickJoinRoom_png, res.QuickJoinRoomDown_png);
        cancelButton.setPosition(this._width / 2 + 150, 90);
        cancelButton.addClickEventListener(function () {
            that.removeFromParent();
        });
        alterBg.addChild(cancelButton);

        var buttonTitle2 = new ccui.ImageView(res.CancelLabel_png);
        buttonTitle2.setPosition(cancelButton.width / 2, cancelButton.height / 2);
        cancelButton.addChild(buttonTitle2);
    },

    onEnter: function() {
        this._super();

        this._listener = new cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        });

        cc.eventManager.addListener(this._listener, this);
    },

    onExit: function() {
        this._super();

        cc.eventManager.removeListener(this._listener);
    },
});




