/**
 * Created by fanfeifan on 2017/1/19.
 */

var bagLayer;

var BagScene = cc.Scene.extend({

    _backListener:null,

    ctor: function () {
        this._super();
        this.initBackground();

        this._backListener = cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if(keyCode == cc.KEY.back) {
                    cc.log("jijun android back");
                    cc.director.runScene(new HomeScene());
                } else if(keyCode == cc.KEY.menu) {
                    cc.log("jijun android menu");
                }
            }
        }, this);

        return true;
    },

    initBackground: function() {

        // 背景
        var background1 = new ccui.ImageView(res.BagBack1_png);
        background1.setAnchorPoint(0.5,0.5);
        background1.setScale9Enabled(true);
        background1.setCapInsets(cc.rect(100, 300, 550, 20));
        background1.setContentSize(BaseWindowConf.WIDTH,BaseWindowConf.HEIGHT);
        background1.setPosition(cc.p(cc.winSize.width/2,cc.winSize.height-background1.height/2));

        var pageLabel = new ccui.ImageView(res.BagLabel1_png);
        pageLabel.setPosition(cc.p(cc.winSize.width/2,cc.winSize.height-pageLabel.height/2-cc.winSize.height*0.03));
        this.addChild(pageLabel,2);

        // 添加返回按钮
        var returnBtn = new ccui.Button(res.BagReturnBtn_png, "", "");
        returnBtn.setPosition(0, cc.winSize.height);
        returnBtn.addClickEventListener(function () {
            cc.director.runScene(new HomeScene());
        });
        returnBtn.setAnchorPoint(cc.p(0,1));
        this.addChild(returnBtn,2);

        this.addChild(background1);

        var background = new ccui.ImageView(res.BagBack2_png);
        background.setAnchorPoint(0.5, 0);
        background.setPosition(cc.winSize.width/2, 10);
        this.addChild(background);

        // this.background = ccui.ImageView(res.BagBack2_png);
        // this.background.setScale9Enabled(true);
        // this.background.setContentSize(cc.size(cc.visibleRect.width*0.85,cc.visibleRect.height*0.72));
        // this.background.setPosition(cc.p(cc.visibleRect.center.x,cc.visibleRect.center.y-20));
        // this.addChild(this.background);

        bagLayer = new BagLayer();
        bagLayer.retain();
        bagLayer.setPosition(cc.p(0,0));
        this.addChild(bagLayer);
        //this.loadPageView();

        // test
        // var tutorial = new TutorialMainLayer();
        // tutorial.setPosition(cc.p(0,0));
        // this.addChild(tutorial,30);
    },

    onEnter:function () {
        this._super();
        var backPackAPi = new BackPackApi();
        backPackAPi.lookup(DataManager.getInstance().getUserData()._userId, "BagLookupResponse", function () {
            
        }, function () {
            
        }, function () {
            
        });
    },

    onExit:function () {
        this._super();
        bagLayer.release();
        cc.eventManager.removeListener(this._backListener);
    }

    // addPageItem: function() {
    //     var layout = new ccui.Layout();
    //     layout.setContentSize(cc.size(cc.visibleRect.width,cc.visibleRect.height));
    //     var propList = new BagLayer();
    //     propList.setPosition(cc.p(cc.visibleRect.left.x,cc.visibleRect.bottom.y));
    //     layout.addChild(propList);
    //     return layout;
    //
    // },
    //
    // loadPageView: function() {
    //     this.pageView = new ccui.PageView();
    //     this.pageView.setTouchEnabled(true);
    //     this.pageView.setContentSize(cc.size(cc.visibleRect.width, cc.visibleRect.height));
    //     this.pageView.x = 0;
    //     this.pageView.y = 0;
    //
    //     for (var i = 0; i < 3; ++i) {
    //         var layout = this.addPageItem();
    //
    //         this.pageView.insertPage(layout, i);
    //     }
    //     this.pageView.setCurrentPageIndex(1);
    //     this.pageView.addEventListener(this.pageViewEvent, this);
    //     this.addChild(this.pageView);
    // },
    //
    // pageViewEvent: function (sender, type) {
    //     switch (type) {
    //         case ccui.PageView.EVENT_TURNING:
    //             var pageView = sender;
    //             var pageIndex = pageView.getCurrentPageIndex().valueOf()-0;
    //             cc.log('page='+pageIndex);
    //             if (pageIndex == 0) {
    //                 this.leftPage.visible = false;
    //             } else if (pageIndex == 2) {
    //                 this.rightPage.visible = false;
    //             } else {
    //                 this.leftPage.visible = true;
    //                 this.rightPage.visible = true;
    //             }
    //             //this._topDisplayLabel.setString("page = " + (pageView.getCurPageIndex().valueOf()-0 + 1));
    //             break;
    //         default:
    //             break;
    //     }
    // }
});

function BagLookupResponse(responseString) {
    if(responseString == "" || responseString == null || responseString == undefined) {
        ToastUtil.systemToastInMiddle("请求超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                BagLookupSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                BagLookupResume(responseObj.retBody);
            }
        } else {
            BagLookupFailed(responseObj.retCode);
        }
    }
};

function BagLookupSuccess(retBody) {
    cc.log(retBody.toolList);
    if(bagLayer != null && bagLayer != undefined && bagLayer instanceof BagLayer) {
        var skinList = new Array();
        var voiceList = new Array();

        var toolList = retBody.toolList;
        for (var i = 0; i < toolList.length; i++) {
            if (toolList[i].type == 2) {
                voiceList.push(toolList[i]);
            } else if (toolList[i].type == 4) {
                skinList.push(toolList[i]);
            }
        }
        bagLayer.refreshUi(skinList, voiceList);
    }
};

function BagLookupFailed(retCode) {
    cc.log(retCode);
    var errorString = "未知错误";
    if(retCode == -2000) {
        errorString = "用户名不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "用户名已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    } else if (retCode == -2009) {
        errorString = "这个第三方账号并没有注册过";
    }
    ToastUtil.showToast(errorString, 2.0);
};

function BagLookupResume(retBody) {
    cc.log(retBody);
};


function useToolResponse(responseString) {
    if(responseString == "" || responseString == null || responseString == undefined) {
        ToastUtil.systemToastInMiddle("请求超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                useToolSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                useToolResume(responseObj.retBody);
            }
        } else {
            useToolFailed(responseObj.retCode);
        }
    }
};

function useToolSuccess(retBody) {
    ToastUtil.systemToastInMiddle("装备成功", 1.5);
    if(retBody.currentToolType == 2) {
        DataManager.getInstance().getUserData()._currentVoice = retBody.currentToolCode;
    } else if (retBody.currentToolType == 4) {
        DataManager.getInstance().getUserData()._currentSkin = retBody.currentToolCode;
    }
};

function useToolFailed(retCode) {
    cc.log(retCode);
    var errorString = "装备失败";
    if(retCode == -2000) {
        errorString = "用户名不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "用户名已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    } else if (retCode == -2009) {
        errorString = "这个第三方账号并没有注册过";
    }
    ToastUtil.systemToastInMiddle(errorString, 2.0);
};

function useToolResume(retBody) {
    cc.log(retBody);
};
