/**
 * Created by junji on 2017/2/1.
 */

var OtherHomePageLayer = cc.Layer.extend({

    _data : null,
    _userId: null,  //string
    _type:null,

    _listener:null,

    ctor:function (type, data) {
        this._super();
        this._type = type;
        if(type == 1) {
            this._data = data;
            this._userId = data.userId + "";
        } else if (type == 2) {
            this._userId = data;
        }
        this._initUi();

        var _this = this;

        this._listener = cc.eventManager.addListener(cc.EventListener.create({
            event: cc.EventListener.CUSTOM,
            eventName: "onAddFriendSuccess",
            callback: function () {
                if(_this.friendBtn != null) {
                    _this.friendBtn.setVisible(false);
                }
                if(_this.sendMessageBtn != null) {
                    _this.sendMessageBtn.setVisible(true);
                }
            },
        }), 1);
    },

    onExit:function () {
        this._super();
        cc.eventManager.removeListener(this._listener);
    },

    onEnter:function () {
        this._super();
        var _this = this;
        if(this._type == 1) {
            this.refreshUI(this._data);
        } else if (this._type == 2) {
            otherHomePageResponse = function (responseString) {
                if(responseString == null || responseString == "" || responseString == undefined) {
                    ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
                } else {
                    var responseObj = JSON.parse(responseString);
                    if (responseObj.retCode > 0) {
                        if (responseObj.retCode == 1) {
                            _this.refreshUI(responseObj.retBody);
                        } else if (responseObj.retCode == 2) {
                            ToastUtil.systemToastInMiddle("获取玩家信息失败，请稍后重试...", 2.0);
                        }
                    } else {
                        ToastUtil.systemToastInMiddle("获取玩家信息失败，请稍后重试...", 2.0);
                    }
                }
            };
            var personalPageApi = new PersonalPageApi();
            personalPageApi.getPersonInfo(parseInt(_this._userId), "otherHomePageResponse", function () {
            }, function () {
            }, function () {
            });
        }
    },

    _initUi:function() {

        var _this = this;

        // 背景
        var bg = new ccui.ImageView(res.BagBack1_png);
        bg.setAnchorPoint(0.5,0.5);
        bg.setScale9Enabled(true);
        bg.setCapInsets(cc.rect(100, 300, 550, 20));
        bg.setContentSize(BaseWindowConf.WIDTH, BaseWindowConf.HEIGHT);
        bg.setPosition(cc.winSize.width/2, cc.winSize.height/2);
        this.addChild(bg);

        // 个人主页
        var pageLabel = new ccui.ImageView(res.homepageLabel_png);
        pageLabel.setPosition(cc.winSize.width/2, cc.winSize.height - 70);
        this.addChild(pageLabel);

        // 添加返回按钮
        var returnBtn = new ccui.Button(res.BagReturnBtn_png, "", "");
        returnBtn.setPosition(0, cc.winSize.height);
        returnBtn.addClickEventListener(function () {
            _this.removeFromParent(true);
        });
        returnBtn.setAnchorPoint(0, 1);
        this.addChild(returnBtn);

        var mainList = new ccui.ListView();
        this.addChild(mainList);
        mainList.setName("mainList");
        mainList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        mainList.setContentSize(BaseWindowConf.WIDTH, cc.winSize.height * 0.86);
        mainList.setAnchorPoint(0.5, 0);
        mainList.setScrollBarEnabled(false);
        mainList.setBounceEnabled(true);
        mainList.setTouchEnabled(true);
        mainList.setPosition(cc.winSize.width/2, 20);

        var item1 = new ccui.Layout();
        item1.setTouchEnabled(true);
        item1.setContentSize(BaseWindowConf.WIDTH, 435);

        // 添加中间四个显示值
        var awardLayer = new ccui.ImageView(res.awardCupBg_png);
        awardLayer.setPosition(cc.p(cc.winSize.width*0.3, item1.height - 40));
        item1.addChild(awardLayer);
        var awardCup = new ccui.ImageView(res.awardCup_png);
        awardCup.setPosition(0, awardLayer.height/2);
        awardLayer.addChild(awardCup);
        var awardJia = new ccui.ImageView(res.jia_png);
        awardJia.setPosition(awardLayer.width,awardLayer.height/2);
        awardLayer.addChild(awardJia);
        awardLayer.setName("awardLayer");
        var awardLabel = cc.LabelTTF('1223',"Arial",20);
        awardLabel.setName("awardLabel");
        awardLabel.setPosition(cc.p(awardLayer.width/2,awardLayer.height/2));
        awardLayer.addChild(awardLabel);

        var diamondLayer = new ccui.ImageView(res.diamondBg_png);
        diamondLayer.setPosition(cc.p(cc.winSize.width/2+cc.winSize.width*0.2,item1.height - 40));
        item1.addChild(diamondLayer);
        var diamond = new ccui.ImageView(res.diamond_png);
        diamond.setPosition(diamondLayer.width, diamondLayer.height/2);
        diamondLayer.addChild(diamond);
        var diamondJia = new ccui.ImageView(res.jia_png);
        diamondJia.setPosition(0,diamondLayer.height/2);
        diamondLayer.addChild(diamondJia);
        diamondLayer.setName("diamondLayer");
        var diamondLabel = cc.LabelTTF('1223',"Arial",20);
        diamondLabel.setName("diamondLabel");
        diamondLabel.setPosition(cc.p(diamondLayer.width/2,diamondLayer.height/2));
        diamondLayer.addChild(diamondLabel);

        var energyLayer = new ccui.ImageView(res.energyBg_png);
        energyLayer.setPosition(cc.p(cc.winSize.width*0.3,item1.height - 100));
        item1.addChild(energyLayer);
        var energy = new ccui.ImageView(res.HomepageVIPLabel_png);
        energy.setPosition(20, energyLayer.height/2);
        energyLayer.addChild(energy);
        var vipText = new ccui.Text("", "Arial", 22);
        vipText.setPosition(10 + energy.width, energyLayer.height/2);
        vipText.setName("vipText");
        energyLayer.addChild(vipText);
        // var energyJia = new ccui.ImageView(res.jia_png);
        // energyJia.setPosition(energyLayer.width,energyLayer.height/2);
        // energyLayer.addChild(energyJia);
        energyLayer.setName("energyLayer");
        // var energyLabel = cc.LabelTTF('1223',"Arial",20);
        // energyLabel.setName("energyLabel");
        // energyLabel.setPosition(cc.p(energyLayer.width/2,energyLayer.height/2));
        // energyLayer.addChild(energyLabel);

        var presentLayer = new ccui.ImageView(res.presentBg_png);
        presentLayer.setPosition(cc.p(cc.winSize.width/2+cc.winSize.width*0.2,item1.height - 100));
        item1.addChild(presentLayer);
        var present = new ccui.ImageView(res.GoldCoin_png);
        present.setScale(1.2);
        present.setPosition(presentLayer.width, presentLayer.height/2);
        presentLayer.addChild(present);
        var presentJia = new ccui.ImageView(res.jia_png);
        presentJia.setPosition(0,presentLayer.height/2);
        presentLayer.addChild(presentJia);
        presentLayer.setName("presentLayer");
        var presentLabel = cc.LabelTTF('1223',"Arial",20);
        presentLabel.setName("presentLabel");
        presentLabel.setPosition(cc.p(presentLayer.width/2,presentLayer.height/2));
        presentLayer.addChild(presentLabel);

        //  var avatar = new ccui.ImageView(res.avatarBg_png);
        var avatarBg = new ccui.ImageView(res.AvatarBg_png);
        avatarBg.setPosition(cc.p(cc.winSize.width/2,item1.height - 70));
        avatarBg.setName("avatarBg");
        item1.addChild(avatarBg);

        var avatar = new ccui.ImageView(res.NormalMaleAvatar_png);
        if(DataManager.getInstance().getUserData()._currentSkin != -1) {
            avatar.loadTexture(AvatarMap.get(DataManager.getInstance().getUserData()._currentSkin)[1]);
        }
        avatar.setPosition(avatarBg.width/2, avatarBg.height/2);
        avatar.setName("avatar");
        avatar.setScale(0.9);
        avatarBg.addChild(avatar);

        var nickNameLabel = new ccui.ImageView(res.NicknameLabel_png);
        nickNameLabel.setPosition(cc.p(cc.winSize.width*0.28,item1.height - 160));
        item1.addChild(nickNameLabel);

        var nickname = cc.LabelTTF('大尊哥',"Arial",24);
        nickname.setName("nickname");
        nickname.setColor(cc.color(110, 183, 32));
        nickname.setAnchorPoint(0, 0.5);
        nickname.setPosition(cc.p(cc.winSize.width*0.28 + 60,item1.height - 160));
        item1.addChild(nickname);

        var idLabel = new ccui.ImageView(res.IdLabel_png);
        idLabel.setPosition(cc.p(cc.winSize.width/2+cc.winSize.width*0.12,item1.height - 160));
        item1.addChild(idLabel);

        var userId = cc.LabelTTF('1223',"Arial",24);
        userId.setName("userId");
        userId.setColor(cc.color(110, 183, 32));
        userId.setAnchorPoint(0, 0.5);
        userId.setPosition(cc.p(cc.winSize.width/2+cc.winSize.width*0.12 + 50,item1.height - 160));
        item1.addChild(userId);

        var gradeLabel = new ccui.ImageView(res.HomePageGradeLabel_png);
        gradeLabel.setAnchorPoint(0.5, 0.5);
        gradeLabel.setPosition(cc.winSize.width/2+cc.winSize.width*0.12, item1.height - 200);
        item1.addChild(gradeLabel);

        var gradeText = new ccui.Text("", "Arial", 24);
        gradeText.setName("gradeText");
        gradeText.setColor(cc.color(110, 183, 32));
        gradeText.setAnchorPoint(0, 0.5);
        gradeText.setPosition(cc.winSize.width/2+cc.winSize.width*0.12 + 50, item1.height - 200);
        item1.addChild(gradeText);

        var charmLabel = new ccui.ImageView(res.HomePageCharmValueLabel_png);
        charmLabel.setPosition(cc.winSize.width*0.28, item1.height - 200);
        item1.addChild(charmLabel);

        var charmText = new ccui.Text("0", "Arial", 24);
        charmText.setPosition(cc.winSize.width*0.28 + 60, item1.height - 200);
        charmText.setAnchorPoint(0, 0.5);
        charmText.setName("charmText");
        charmText.setColor(cc.color(110, 183, 32));
        item1.addChild(charmText);

        var item2 = new ccui.Layout();
        item2.setTouchEnabled(true);
        item2.setContentSize(BaseWindowConf.WIDTH, 290);

        // 添加个人皮肤及雷达图
        var personBg = new ccui.ImageView(res.personBg_png);
        personBg.setScale9Enabled(true);
        personBg.setName("personBg");
        personBg.setContentSize(BaseWindowConf.WIDTH*0.9,cc.winSize.height*0.35);
        personBg.setPosition(cc.p(cc.winSize.width/2,item2.height - 5));
        item2.addChild(personBg);

        var personBg2 = new ccui.ImageView(res.personBg2_png);
        personBg2.setScale9Enabled(true);
        personBg2.setContentSize(personBg.width/2*0.95,personBg.height*0.92);
        personBg2.setPosition(cc.p(personBg.width/4+13,personBg.height/2));
        personBg2.setName("personBg2");
        personBg.addChild(personBg2);

        var personDi = new ccui.ImageView(res.personDi_png);
        personDi.setPosition(personBg2.width*0.5, personBg2.height*0.12);
        personBg2.addChild(personDi);

        var person = new ccui.ImageView(res.WolfFemale_png);
        if(DataManager.getInstance().getUserData()._currentSkin != -1) {
            person.loadTexture(SkinMap.get(DataManager.getInstance().getUserData()._currentSkin)[0]);
        }
        person.setScale(0.87);
        person.setName("person");
        person.setPosition(cc.p(personBg2.width*0.5, personBg2.height*0.5 + 20));
        personBg2.addChild(person);

        var leida = new ccui.ImageView(res.leida_png);
        leida.setPosition(cc.p(personBg.width*0.75,personBg.height/2));
        personBg.addChild(leida);
        leida.setScale9Enabled(true);
        leida.setName("leida");
        leida.setScale(0.95,0.95);

        // var leida2 = new ccui.ImageView(res.leida2_png);
        // leida2.setPosition(cc.p(leida.width/2,leida.height/2));
        // leida.addChild(leida2);

        // 添加雷达的属性
        var attr1 = new cc.LabelTTF('好人能力', "Arial", 22);
        attr1.setPosition(cc.p(leida.width*0.2,leida.height*1.1));
        attr1.setColor(cc.color(252,227,179));
        leida.addChild(attr1);

        var attr2 = new cc.LabelTTF('狼人能力', "Arial", 22);
        attr2.setPosition(cc.p(leida.width*0.8,leida.height*1.1));
        attr2.setColor(cc.color(252,227,179));
        leida.addChild(attr2);

        var attr3 = new cc.LabelTTF('土豪', "Arial", 22);
        attr3.setPosition(cc.p(leida.width*1.1,leida.height*0.5));
        attr3.setColor(cc.color(252,227,179));
        leida.addChild(attr3);

        var attr4 = new cc.LabelTTF('离线率', "Arial", 22);
        attr4.setPosition(cc.p(leida.width*0.8,-leida.height*0.1));
        attr4.setColor(cc.color(252,227,179));
        leida.addChild(attr4);

        var attr5 = new cc.LabelTTF('贴脸率', "Arial", 22);
        attr5.setPosition(cc.p(leida.width*0.2,-leida.height*0.1));
        attr5.setColor(cc.color(252,227,179));
        leida.addChild(attr5);

        var attr6 = new cc.LabelTTF('能力值', "Arial", 22);
        attr6.setPosition(cc.p(-leida.width*0.15,leida.height*0.5));
        attr6.setColor(cc.color(252,227,179));
        leida.addChild(attr6);

        var item3 = new ccui.Layout();
        item3.setTouchEnabled(true);
        item3.setContentSize(BaseWindowConf.WIDTH, 135);

        // 添加粉丝,关注
        this.friendBtn = new ccui.Button(res.HomePageFriendButtonBg_png, "", "");
        this.friendBtn.setPosition(cc.winSize.width/2, item3.height - 5);
        this.friendBtn.setVisible(false);
        this.friendBtn.addClickEventListener(function () {
            var addFriendConfirmDialog = new CommonDialog(DialogType.AddFriendConfirmDialog, Number(_this._userId));
            addFriendConfirmDialog.popup();
        });
        this.friendBtn.setAnchorPoint(cc.p(0.5,0.5));
        item3.addChild(this.friendBtn);
        var fanLabel = new ccui.ImageView(res.HomePageAddFriendLabel_png);
        fanLabel.setPosition(cc.p(this.friendBtn.width/2,this.friendBtn.height/2));
        fanLabel.setAnchorPoint(cc.p(0.5,0.5));
        this.friendBtn.addChild(fanLabel);

        this.sendMessageBtn = new ccui.Button(res.HomePageFriendButtonBg_png, "", "");
        this.sendMessageBtn.setPosition(cc.winSize.width/2, item3.height - 5);
        this.sendMessageBtn.setAnchorPoint(0.5, 0.5);
        this.sendMessageBtn.setVisible(false);
        this.sendMessageBtn.addClickEventListener(function () {
            cc.director.runScene(new FriendChatScene(_this._userId));
        });
        item3.addChild(this.sendMessageBtn);
        var sendMessageLabel = new ccui.ImageView(res.HomePageSendMessageLabel_png);
        sendMessageLabel.setPosition(this.sendMessageBtn.width/2, this.sendMessageBtn.height/2);
        this.sendMessageBtn.addChild(sendMessageLabel);

        isMyFriendSucc = function () {
            cc.log("is friend");
            _this.friendBtn.setVisible(false);
            _this.sendMessageBtn.setVisible(true);
        };

        isMyFriendFail = function () {
            cc.log("not friend");
            _this.friendBtn.setVisible(true);
            _this.sendMessageBtn.setVisible(false);
        };

        cc.log("userId " + _this._userId);

        isMyFriend(_this._userId);

        var homeLittleTitle = new ccui.ImageView(res.HomepageLittlePage_png);
        homeLittleTitle.setName("homeLittleTitle");
        homeLittleTitle.setPosition(cc.winSize.width/2, item3.height - 110);
        item3.addChild(homeLittleTitle);

        var totalWinRate = cc.LabelTTF('总胜率:10%',"Arial",25);
        totalWinRate.setName("totalWinRate");
        totalWinRate.setColor(cc.color(255, 204, 66));
        totalWinRate.setAnchorPoint(0, 0.5);
        totalWinRate.setPosition(20, homeLittleTitle.height/2 + 3);
        homeLittleTitle.addChild(totalWinRate);

        var totalWinAndLostTimes = cc.LabelTTF('10胜10负',"Arial",25);
        totalWinAndLostTimes.setName("totalWinAndLoseTimes");
        totalWinAndLostTimes.setColor(cc.color(255, 204, 66));
        totalWinAndLostTimes.setAnchorPoint(0.5, 0.5);
        totalWinAndLostTimes.setPosition(homeLittleTitle.width/2, homeLittleTitle.height/2 + 3);
        homeLittleTitle.addChild(totalWinAndLostTimes);

        var totalRank = cc.LabelTTF('排名:10000',"Arial",25);
        totalRank.setName("totalRank");
        totalRank.setColor(cc.color(255, 204, 66));
        totalRank.setAnchorPoint(1, 0.5);
        totalRank.setPosition(homeLittleTitle.width - 20, homeLittleTitle.height/2 + 3);
        homeLittleTitle.addChild(totalRank);

        mainList.pushBackCustomItem(item1);
        mainList.pushBackCustomItem(item2);
        mainList.pushBackCustomItem(item3);

        for (var i = 0 ; i < 15; i++) {
            var item = new ccui.Layout();
            item.setTouchEnabled(true);
            item.setContentSize(BaseWindowConf.WIDTH, 65);

            var container = new ccui.ImageView(res.homeRecordBg_png);
            container.setName("container");
            container.setScale9Enabled(true);
            container.setContentSize(BaseWindowConf.WIDTH*0.9, 55);
            container.setAnchorPoint(0.5,0.5);
            container.setPosition(item.width/2,item.height/2);

            var label1 = cc.LabelTTF('狼人',"Arial",30);
            label1.setPosition(cc.p(container.width*0.15,container.height*0.5));
            label1.setName("role");
            container.addChild(label1);

            var label2 = cc.LabelTTF('12胜6负',"Arial",30);
            label2.setPosition(cc.p(container.width*0.5,container.height*0.5));
            label2.setName("winAndLose");
            container.addChild(label2);

            var label4 = cc.LabelTTF('200名',"Arial",30);
            label4.setPosition(cc.p(container.width*0.85,container.height*0.5));
            label4.setName("winRate");
            container.addChild(label4);

            item.addChild(container);

            mainList.pushBackCustomItem(item);
        }
    },

    drawLeida:function (data, personBg) {
        var params = [[1, 0],[0.5, 0.866025],[-0.5, 0.866025],[-1, 0],[-0.5, -0.866025],[0.5, -0.866025]];
        var colors = [cc.color(196,161,143),cc.color(211,182,164),cc.color(171,127,112),
            cc.color(152,106,91),cc.color(128,80,68),cc.color(162,118,104)];
        var x0 = personBg.getChildByName("leida").x;
        var y0 = personBg.getChildByName("leida").y;
        var points = new Array();
        for(var i = 0; i < data.length; i++) {
            points.push([x0 + data[i] * params[i][0], y0 + data[i] * params[i][1]]);
        }
        var draw= new cc.DrawNode();
        personBg.addChild(draw,10);
        for(var i = 0; i < data.length; i++) {
            var vertices;
            if(i+1 >= data.length) {
                vertices = [cc.p(x0, y0), cc.p(points[i][0], points[i][1]), cc.p(points[0][0], points[0][1])];
            } else {
                vertices = [cc.p(x0, y0), cc.p(points[i][0], points[i][1]), cc.p(points[i + 1][0], points[i + 1][1])];
            }
            draw.drawPoly(vertices, colors[i], 1, colors[i]);
        }
    },

    refreshUI:function (data) {
        var mainList = this.getChildByName("mainList");
        var item1 = mainList.getItem(0);
        item1.getChildByName("awardLayer").getChildByName("awardLabel").setString(data.cup);
        item1.getChildByName("diamondLayer").getChildByName("diamondLabel").setString(data.diamond);
        item1.getChildByName("presentLayer").getChildByName("presentLabel").setString(data.coin);
        item1.getChildByName("energyLayer").getChildByName("vipText").setString(data.vipLevel);
        item1.getChildByName("nickname").setString(data.nickName);
        item1.getChildByName("userId").setString(data.userId);
        item1.getChildByName("avatarBg").getChildByName("avatar").loadTexture(AvatarMap.get(data.avatar)[1]);
        item1.getChildByName("gradeText").setString(data.grade);
        item1.getChildByName("charmText").setString(data.charmValue);

        var item2 = mainList.getItem(1);
        this.drawLeida([data.richIndex*0.88, data.wolfAbility*0.88,
                data.goodManAbility*0.88, data.ability*0.88,
                data.faceRate*0.88, data.offlineRate*0.88],
            item2.getChildByName("personBg"));
        item2.getChildByName("personBg").getChildByName("personBg2").getChildByName("person").loadTexture(SkinMap.get(data.avatar)[0]);

        var item3 = mainList.getItem(2);
        var homeLittleTitle = item3.getChildByName("homeLittleTitle");
        if(data.totalRank > 10000) {
            homeLittleTitle.getChildByName("totalRank").setString("排名:10000+");
        } else {
            homeLittleTitle.getChildByName("totalRank").setString("排名:" + data.totalRank);
        }

        homeLittleTitle.getChildByName("totalWinAndLoseTimes").setString(data.totalWinTimes+"胜"+data.totalLoseTimes+"负");
        var winRate = "";
        if(data.totalWinTimes == 0) {
            winRate = "0";
        } else {
            if(data.totalLoseTimes == 0) {
                winRate = "100";
            } else {
                winRate = "" + Math.round(100*data.totalWinTimes/(data.totalLoseTimes+data.totalWinTimes));
            }
        }
        homeLittleTitle.getChildByName("totalWinRate").setString("总胜率:"+winRate+"%");

        for(var i = 0; i < data.detailList.length; i++) {
            var item = mainList.getItem(i+3);
            if(item != null && item != undefined) {
                item.getChildByName("container").getChildByName("role").setString(RoleMap.get(data.detailList[i].role));
                item.getChildByName("container").getChildByName("winAndLose").setString(data.detailList[i].winTimes + "胜/" + data.detailList[i].loseTimes + "负");
                var winRate = 0;
                if ((data.detailList[i].winTimes + data.detailList[i].loseTimes) != 0) {
                    if (data.detailList[i].loseTimes == 0)
                        winRate = 100;
                    else {
                        winRate = Math.round(data.detailList[i].winTimes * 100 / (data.detailList[i].winTimes + data.detailList[i].loseTimes));
                    }
                }

                item.getChildByName("container").getChildByName("winRate").setString("胜率:" + winRate + "%");
            }
        }
    },

});

function addFriendResponse(responseString) {
};