/**
 * Created by fanfeifan on 17/1/2.
 */
var rankLayer;

var RankLayer = cc.Layer.extend({
    _spacing:3,
    _headerMenuCount:6,
    _mainRankCount:50,

    //当前的rank type
    _currentType:1,
    _currentSubtype:1,

    ctor: function () {
        this._super();
        this.initBackground();

        return true;
    },

    onEnter:function () {
        this._super();
        this.loadRankData();
    },

    loadRankData:function () {
        var _this = this;
        if (cc.sys.localStorage.getItem("ConfirmUseDataToRank") == 1) {
            var rankApi = new RankApi();
            rankApi.getRankList(this._currentType, this._currentSubtype, "rankListResponse", function (retBody) {
            },function () {
            },function () {
            });
        } else {
            cc.log("show ConfirmUseDataToRank dialog");
            var dialog = new ConfirmDialog("提示", "您的个人游戏数据\n（魅力，能力，狼人，好人，钻石，MVP等）\n将被用于做全服排名，您同意吗？", function () {
                cc.sys.localStorage.setItem("ConfirmUseDataToRank", 1);
                var rankApi = new RankApi();
                rankApi.getRankList(_this._currentType, _this._currentSubtype, "rankListResponse", function (retBody) {
                },function () {
                },function () {
                });
            }, function () {

            });
            dialog.popup();
            cc.log("showed ConfirmUseDataToRank dialog");
        }
    },

    initBackground: function () {
        var _this = this;
        var background = new ccui.ImageView(res.rankBgLayer_png);
        background.setPosition(cc.p(cc.winSize.width/2,cc.winSize.height/2));
        this.addChild(background);
        var header = new ccui.ImageView(res.RankHeader_png);
        header.setPosition(cc.winSize.width / 2, cc.winSize.height * 0.92);
        this.addChild(header);
        // 今日实时
        var todayRankButton = new ccui.Button(res.RankTypeButtonDown_png, res.RankTypeButtonDown_png, "");
        todayRankButton.setPosition(cc.winSize.width*0.16, cc.winSize.height-cc.winSize.height*0.17);
        todayRankButton.addClickEventListener(function () {
            todayRankButton.loadTextures(res.RankTypeButtonDown_png, res.RankTypeButtonDown_png, "");
            yesterdayRankBtn.loadTextures(res.RankTypeButton_png, res.RankTypeButton_png, "");
            allRankBtn.loadTextures(res.RankTypeButton_png, res.RankTypeButton_png, "");
            _this._currentType = rankType.RankType_TODAY;
            cc.log("jijun rank test" + _this._currentType + _this._currentSubtype);
            var topBar = _this.getChildByName("top_bar");
            topBar.getChildByName("awardLabel").setVisible(true);
            topBar.getChildByName("awardNumLabel").setPosition(topBar.width*0.7,topBar.height/2);
            topBar.getChildByName("playerLabel").setPosition(topBar.width*0.36,topBar.height/2);
            _this.loadRankData();
        });
        this.addChild(todayRankButton,1);

        var todayLabel = new ccui.ImageView(res.TodayRankLabel_png);
        todayLabel.setPosition(todayRankButton.width * 0.5, todayRankButton.height * 0.5);
        todayRankButton.addChild(todayLabel);

        // 昨日
        var yesterdayRankBtn = new ccui.Button(res.RankTypeButton_png, res.RankTypeButton_png, "");
        yesterdayRankBtn.setPosition(todayRankButton.x+yesterdayRankBtn.width - 5, todayRankButton.y);
        yesterdayRankBtn.addClickEventListener(function() {
            todayRankButton.loadTextures(res.RankTypeButton_png, res.RankTypeButton_png, "");
            yesterdayRankBtn.loadTextures(res.RankTypeButtonDown_png, res.RankTypeButtonDown_png, "");
            allRankBtn.loadTextures(res.RankTypeButton_png, res.RankTypeButton_png, "");
            _this._currentType = rankType.RankType_YESTERDAY;
            var topBar = _this.getChildByName("top_bar");
            topBar.getChildByName("awardLabel").setVisible(true);
            topBar.getChildByName("awardNumLabel").setPosition(topBar.width*0.7,topBar.height/2);
            topBar.getChildByName("playerLabel").setPosition(topBar.width*0.36,topBar.height/2);
            cc.log("jijun rank test" + _this._currentType + _this._currentSubtype);
            _this.loadRankData();
        });
        this.addChild(yesterdayRankBtn,1);

        var yesterdayLabel = new ccui.ImageView(res.yesterdayLabel_png);
        yesterdayLabel.setPosition(yesterdayRankBtn.width * 0.5, yesterdayRankBtn.height * 0.5);
        yesterdayRankBtn.addChild(yesterdayLabel);

        // 总排行
        var allRankBtn = new ccui.Button(res.RankTypeButton_png, res.RankTypeButton_png, "");
        allRankBtn.setPosition(yesterdayRankBtn.x+allRankBtn.width - 5, todayRankButton.y);
        allRankBtn.addClickEventListener(function() {
            todayRankButton.loadTextures(res.RankTypeButton_png, res.RankTypeButton_png);
            yesterdayRankBtn.loadTextures(res.RankTypeButton_png, res.RankTypeButton_png);
            allRankBtn.loadTextures(res.RankTypeButtonDown_png, res.RankTypeButtonDown_png);
            _this._currentType = rankType.RankType_TOTAL;
            cc.log("jijun rank test" + _this._currentType + _this._currentSubtype);
            var topBar = _this.getChildByName("top_bar");
            topBar.getChildByName("awardLabel").setVisible(false);
            topBar.getChildByName("awardNumLabel").setPosition(topBar.width*0.9,topBar.height/2);
            topBar.getChildByName("playerLabel").setPosition(topBar.width*0.5,topBar.height/2);
            _this.loadRankData();
        });
        this.addChild(allRankBtn,1);

        var allRankLabel = new ccui.ImageView(res.allRankLabel_png);
        allRankLabel.setPosition(allRankBtn.width * 0.5, allRankBtn.height * 0.5);
        allRankBtn.addChild(allRankLabel);

        // 结算时间
        var calculateTime = new cc.LabelTTF('结算时间:  00:00:00', "Arial", 20);
        calculateTime.setColor(cc.color(119,197,36));
        calculateTime.setPosition(cc.winSize.width*0.85,cc.winSize.height*0.88);
        this.addChild(calculateTime,5);

        this.loadHeaderRankList();

        this.loadMainRankList();

        // 边界条
        var border = new ccui.ImageView(res.RankSceneBorder_png);
        border.setScale9Enabled(true);
        border.setContentSize(BaseWindowConf.WIDTH, BaseWindowConf.HEIGHT*0.81);
        border.setCapInsets(cc.rect(89, 45, 2, 2));
        border.setAnchorPoint(0.5,0);
        border.setPosition(cc.director.getVisibleSize().width * 0.5 - 3, 0);
        this.addChild(border,2);

        // 我的排名
        var myRankBg = new cc.LayerColor(cc.color(83,101,142));
        myRankBg.setContentSize(this.mainRankList.width,60);
        myRankBg.x = cc.winSize.width*0.01;
        myRankBg.y = cc.winSize.height * 0.08;
        myRankBg.setAnchorPoint(0,0);
        myRankBg.setName("myRankBg");
        this.addChild(myRankBg);

        var myRank = new ccui.ImageView(res.MyRank_png);
        myRank.setPosition(myRankBg.width*0.2,myRankBg.height/2);
        myRankBg.addChild(myRank);

        var myRankText = new ccui.Text("暂无数据", "Arial", 30);
        myRankText.setColor(cc.color(254,216,46));
        myRankText.setPosition(myRankBg.width*0.2 + 80,myRankBg.height/2);
        myRankText.setAnchorPoint(0, 0.5);
        myRankText.setName("myRankText");
        myRankBg.addChild(myRankText);

        var normalCup = new ccui.ImageView(res.NormalCup_png);
        normalCup.setPosition(myRankBg.width*0.73,myRankBg.height/2);
        normalCup.setAnchorPoint(1, 0.5);
        normalCup.setName("normalCup");
        myRankBg.addChild(normalCup);

        var cupNum = new cc.LabelTTF('暂无数据', "Arial", 30);
        cupNum.setColor(cc.color(254,216,46));
        cupNum.setAnchorPoint(0, 0.5);
        cupNum.setPosition(cc.p(myRankBg.width*0.75,myRankBg.height/2));
        cupNum.setName("cupNum");
        myRankBg.addChild(cupNum);

        var tabMenuLayer = new TabMenuLayer();
        tabMenuLayer.setAnchorPoint(cc.p(0,0));
        tabMenuLayer.setPosition(cc.p(0,0));
        this.addChild(tabMenuLayer, 10);
        tabMenuLayer.getChildByName("rankButton").setScale(1.1);

        var noDataLabel = new ccui.ImageView(res.NoData_png);
        noDataLabel.setPosition(cc.winSize.width/2, cc.winSize.height/2 - 30);
        noDataLabel.setName("noDataLabel");
        this.addChild(noDataLabel);
    },

    // 加载上层各个榜单
    loadHeaderRankList: function() {

        var _this = this;

        this.headerRankList = new ccui.ListView();
        this.headerRankList.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
        this.headerRankList.setTouchEnabled(true);
        this.headerRankList.setBounceEnabled(true);
        this.headerRankList.setContentSize(cc.size(BaseWindowConf.WIDTH*0.99, 100));
        this.headerRankList.setAnchorPoint(0.5, 0.5);
        this.headerRankList.addEventListener(this.selectedHeaderItemEvent, this);
        this.headerRankList.setPosition(cc.p(cc.winSize.width/2,cc.winSize.height/2+cc.winSize.height*0.28));
        this.addChild(this.headerRankList);

        var headerMenu = [res.RankHeaderMenu1_png,res.RankHeaderMenu2_png,res.RankHeaderMenu3_png,
            res.RankHeaderMenu6_png,res.RankHeaderMenu5_png,res.RankHeaderMenu4_png];

        for(var i = 0; i < this._headerMenuCount; ++i) {
            // create model
            var btn = new ccui.Button();
            btn.setTouchEnabled(true);
            btn.setName("subTypeButton");
            if(i == 3) {
                btn.setTag(6);
            } else if (i == 5) {
                btn.setTag(4);
            } else {
                btn.setTag(i + 1);
            }
            if (i == 0) {
                btn.loadTextures(res.LeftMenuButtonDown_png, res.LeftMenuButtonDown_png, "");
            } else if (i == this._headerMenuCount - 1) {
                btn.loadTextures(res.RightMenuButtonNormal_png, res.RightMenuButtonNormal_png, "");
            } else {
                btn.loadTextures(res.MenuButtonNormal_png, res.MenuButtonNormal_png, "");
            }

            btn.addClickEventListener(function () {
                _this.clearSubtypeButton();
                var tag = this.getTag();
                _this._currentSubtype = tag;
                if (tag == 1) {
                    this.loadTextures(res.LeftMenuButtonDown_png, res.LeftMenuButtonDown_png, "");
                } else if (tag == this._headerMenuCount) {
                    this.loadTextures(res.RightMenuButtonDown_png, res.RightMenuButtonDown_png, "");
                } else {
                    this.loadTextures(res.MenuButtonDown_png, res.MenuButtonDown_png, "");
                }

                if(tag == 4) {
                    _this.getChildByName("top_bar").getChildByName("awardNumLabel").loadTexture(res.MvpNumber_png);
                } else if (tag == 5) {
                    _this.getChildByName("top_bar").getChildByName("awardNumLabel").loadTexture(res.RichManNumber_png);
                } else if (tag == 6) {
                    _this.getChildByName("top_bar").getChildByName("awardNumLabel").loadTexture(res.CharmValue_png);
                } else {
                    _this.getChildByName("top_bar").getChildByName("awardNumLabel").loadTexture(res.RankAwardNumBg_png);
                }

                cc.log("jijun rank test" + _this._currentType + _this._currentSubtype);
                _this.loadRankData();
            });


            // layout
            var item = new ccui.Layout();
            item.setTouchEnabled(true);
            item.setContentSize(btn.getContentSize());
            item.width = btn.getContentSize().width;
            btn.setPosition(item.width/2, item.height/2);
            var title = new ccui.ImageView(headerMenu[i]);
            title.setAnchorPoint(0.5,0.5);
            title.setPosition(btn.getContentSize().width/2,btn.getContentSize().height/2);
            btn.addChild(title);
            item.addChild(btn);
            this.headerRankList.pushBackCustomItem(item);
        }
        this.headerRankList.setItemsMargin(0);
    },

    clearSubtypeButton:function () {
        var items = this.headerRankList.getItems();
        for(var i = 0; i < items.length; i++) {
            var tempBtn = items[i].getChildByName("subTypeButton");
            var btnId = tempBtn.getTag();
            if (btnId == 1) {
                tempBtn.loadTextures(res.LeftMenuButtonNormal_png, res.LeftMenuButtonNormal_png, "");
            } else if (btnId == this._headerMenuCount) {
                tempBtn.loadTextures(res.RightMenuButtonNormal_png, res.RightMenuButtonNormal_png, "");
            } else {
                tempBtn.loadTextures(res.MenuButtonNormal_png, res.MenuButtonNormal_png, "");
            }
        }
    },

    selectedHeaderItemEvent: function (sender, type) {
        switch (type) {
            case ccui.ListView.EVENT_SELECTED_ITEM:
                var listViewEx = sender;
                var item = listViewEx.getItem(listViewEx.getCurSelectedIndex());
                cc.log("select child index = " + item.getTag());
                break;
            case ccui.ListView.EVENT_SLIDEBALL_UP:
                cc.log("up");
                break;
            case ccui.ListView.EVENT_SLIDEBALL_DOWN:
                cc.log("down");
            default:
                break;
        }
    },
    // 添加一个rank item
    addMainRankItem: function(index) {
        var item = new ccui.Layout();
        item.setTouchEnabled(true);

        var container = new cc.Node();
        container.setAnchorPoint(0.5,0.5);
        // 偶数折叠层
        var evenLayer = ccui.ImageView(res.RankEvenLayer_png);
        evenLayer.setScale9Enabled(true);
        evenLayer.width = this.mainRankList.width;
        evenLayer.height = cc.winSize.height/20;
        container.setContentSize(evenLayer.getContentSize());
        evenLayer.setPosition(evenLayer.width/2,evenLayer.height/2);
        if (index % 2 != 0) {
            container.addChild(evenLayer);
        }
        // 排名
        var rank;
        var player;
        var awardNum;
        var award;
        if (index == 0) {
            rank = new ccui.ImageView(res.GoldCup_png);
            player = new cc.LabelTTF('大尊哥', "Arial", 30);
            player.setColor(cc.color(214,39,39));
            awardNum = new cc.LabelTTF('2000', "Arial", 30);
            awardNum.setColor(cc.color(214,39,39));
            award = new ccui.ImageView(res.AwardBox1_png);
            var vipFlag = new ccui.ImageView(res.VIPFlag_png);
            vipFlag.setPosition(container.width*0.47,container.height/2);
            container.addChild(vipFlag);
        } else if (index == 1) {
            rank = new ccui.ImageView(res.SilverCup_png);
            player = new cc.LabelTTF('大尊哥', "Arial", 30);
            player.setColor(cc.color(236,129,51));
            awardNum = new cc.LabelTTF('2000', "Arial", 30);
            awardNum.setColor(cc.color(236,129,51));
            award = new ccui.ImageView(res.AwardBox2_png);
        } else if (index == 2) {
            rank = new ccui.ImageView(res.BronzeCup_png);
            player = new cc.LabelTTF('大尊哥', "Arial", 30);
            player.setColor(cc.color(119,197,36));
            awardNum = new cc.LabelTTF('2000', "Arial", 30);
            awardNum.setColor(cc.color(119,197,36));
            award = new ccui.ImageView(res.AwardBox3_png);
        } else {
            rank = new cc.LabelTTF(index+1, "Arial", 30);
            player = new cc.LabelTTF('大尊哥', "Arial", 30);
            awardNum = new cc.LabelTTF('2000', "Arial", 30);
            award = new ccui.ImageView(res.diamond_png);
            //rank.setTextColor()
        }
        rank.setPosition(container.width*0.1,container.height/2);
        container.addChild(rank);
        player.setPosition(container.width*0.36, container.height/2);
        container.addChild(player);
        awardNum.setPosition(container.width*0.7, container.height/2);
        container.addChild(awardNum);
        award.setPosition(container.width*0.9, container.height/2);
        container.addChild(award);

        item.setContentSize(container.getContentSize());
        container.setPosition(item.width/2,item.height/2);
        item.addChild(container);
        return item;
    },

    // 添加一个rank item
    addMainRankItemWithData: function(data) {

        var item = new ccui.Layout();
        item.setTouchEnabled(true);

        var container = new cc.Node();
        container.setAnchorPoint(0.5, 0.5);
        // 偶数折叠层
        var evenLayer = ccui.ImageView(res.RankEvenLayer_png);
        evenLayer.setScale9Enabled(true);
        evenLayer.width = this.mainRankList.width;
        evenLayer.height = cc.winSize.height / 20;
        container.setContentSize(evenLayer.getContentSize());
        evenLayer.setPosition(evenLayer.width / 2, evenLayer.height / 2);
        if (data.rank % 2 != 0) {
            container.addChild(evenLayer);
        }

        // 排名
        var rank;
        var player;
        var awardNum;
        if (data.rank == 1) {
            rank = new ccui.ImageView(res.GoldCup_png);
            player = new cc.LabelTTF(data.nickName, "Arial", 29);
            player.setColor(cc.color(214, 39, 39));
            awardNum = new cc.LabelTTF(data.score + "", "Arial", 29);
            awardNum.setColor(cc.color(214, 39, 39));
        } else if (data.rank == 2) {
            rank = new ccui.ImageView(res.SilverCup_png);
            player = new cc.LabelTTF(data.nickName, "Arial", 29);
            player.setColor(cc.color(236, 129, 51));
            awardNum = new cc.LabelTTF(data.score + "", "Arial", 29);
            awardNum.setColor(cc.color(236, 129, 51));
        } else if (data.rank == 3) {
            rank = new ccui.ImageView(res.BronzeCup_png);
            player = new cc.LabelTTF(data.nickName, "Arial", 29);
            player.setColor(cc.color(119, 197, 36));
            awardNum = new cc.LabelTTF(data.score + "", "Arial", 29);
            awardNum.setColor(cc.color(119, 197, 36));
        } else {
            rank = new cc.LabelTTF(data.rank + "", "Arial", 30);
            player = new cc.LabelTTF(data.nickName, "Arial", 29);
            awardNum = new cc.LabelTTF(data.score + "", "Arial", 29);
        }

        if (data.reward != null && data.reward != undefined && rankLayer._currentType != rankType.RankType_TOTAL) {
            var award;
            switch (data.reward.rewardType) {
                case 1:
                    award = new ccui.ImageView(res.AwardBox1_png);
                    break;
                case 2:
                    award = new ccui.ImageView(res.AwardBox2_png);
                    break;
                case 3:
                    award = new ccui.ImageView(res.AwardBox3_png);
                    break;
                case 4:
                    award = new ccui.ImageView(res.diamond_png);
                    break;
                case 5:
                    award = new ccui.ImageView(res.GoldCoin_png);
                    break;
                default:
                    award = new ccui.ImageView(res.GoldCoin_png);
                    break;
            }
            award.setPosition(container.width*0.84, container.height/2);
            container.addChild(award);
            var awardAmount = new ccui.Text("×" + data.reward.rewardNum, "Arial", 29);
            awardAmount.setAnchorPoint(0.5,0.5);
            awardAmount.setPosition(container.width*0.91, container.height/2);
            container.addChild(awardAmount);
        }

        rank.setPosition(container.width*0.1,container.height/2);
        container.addChild(rank);
        if(rankLayer._currentType == rankType.RankType_TOTAL) {
            awardNum.setPosition(container.width * 0.9, container.height / 2);
        }else {
            awardNum.setPosition(container.width * 0.7, container.height / 2);
        }
        container.addChild(awardNum);

        if(data.avatar != -1) {
            var avatarBg = new ccui.ImageView(res.AvatarBg_png);
            if(rankLayer._currentType == rankType.RankType_TOTAL) {
                avatarBg.setPosition(container.width * 0.32, container.height / 2);
            } else {
                avatarBg.setPosition(container.width * 0.21, container.height / 2);
            }
            avatarBg.setAnchorPoint(0, 0.5);
            avatarBg.setScale(0.45);
            container.addChild(avatarBg);
            var avatar = new ccui.ImageView(AvatarMap.get(data.avatar)[1]);
            avatar.setScale(0.9);
            avatar.setPosition(avatarBg.width/2, avatarBg.height/2);
            avatarBg.addChild(avatar);
        }

        if(rankLayer._currentType == rankType.RankType_TOTAL) {
            player.setPosition(container.width * 0.32 + 60, container.height / 2);
        } else {
            player.setPosition(container.width * 0.21 + 60, container.height / 2);
        }
        player.setAnchorPoint(0, 0.5);
        container.addChild(player);

        var vipFlag = new ccui.ImageView(res.VIPFlag_png);
        vipFlag.setAnchorPoint(0, 0.5);
        if(rankLayer._currentType == rankType.RankType_TOTAL) {
            vipFlag.setPosition(container.width * 0.32 + 65 + player.width, container.height / 2);
        } else {
            vipFlag.setPosition(container.width * 0.21 + 65 + player.width, container.height / 2);
        }
        container.addChild(vipFlag);

        var vipText = new ccui.Text(data.vipLevel+"", "Arial", 29);
        vipText.setAnchorPoint(0,0.5);
        vipText.setColor(cc.color(249,200,95));
        if(rankLayer._currentType == rankType.RankType_TOTAL) {
            vipText.setPosition(container.width * 0.32 + 70 + player.width + vipFlag.width, container.height / 2);
        } else {
            vipText.setPosition(container.width * 0.21 + 70 + player.width + vipFlag.width, container.height / 2);
        }
        container.addChild(vipText);

        item.setContentSize(container.getContentSize());
        container.setPosition(item.width/2,item.height/2);
        item.addChild(container);
        return item;
    },

    // 加载主榜单
    loadMainRankList: function() {
        var mainRankBg = ccui.ImageView(res.MainRankListBg_png);
        mainRankBg.setContentSize(cc.size(BaseWindowConf.WIDTH*0.97,BaseWindowConf.HEIGHT*0.763));
        mainRankBg.setScale9Enabled(true);
        mainRankBg.setAnchorPoint(0.5,0.5);
        mainRankBg.setPosition(cc.winSize.width/2,cc.winSize.height/2*0.763);
        //mainRankBg.setCapInsets()
        this.addChild(mainRankBg);

        this.mainRankList = new ccui.ListView();
        this.mainRankList.setDirection(ccui.ScrollView.DIR_VERTICAL);
        this.mainRankList.setTouchEnabled(true);
        this.mainRankList.setBounceEnabled(true);
        this.mainRankList.setName("mainRankList");
        //this.mainRankList.setBackGroundImage(res.MainRankListBg_png);
        //this.mainRankList.setBackGroundImageScale9Enabled(true);
        this.mainRankList.setContentSize(cc.size(BaseWindowConf.WIDTH*0.97, BaseWindowConf.HEIGHT*0.6));
        this.mainRankList.setPosition(cc.winSize.width/2, cc.winSize.height/2*0.85);
        this.mainRankList.setAnchorPoint(0.5, 0.5);
        this.mainRankList.setItemsMargin(this._spacing);
        this.mainRankList.addEventListener(this.selectedMainItemEvent, this);
        //this.mainRankList.setGravity(ccui.ListView.LINEAR_GRAVITY_CENTER_VERTICAL);
        this.mainRankList.setItemsMargin(0);
        this.mainRankList.setScrollBarEnabled(false);
        this.addChild(this.mainRankList);

        // 标题栏
        var top_bar = new ccui.ImageView(res.TopItemBar_png);
        top_bar.setScale9Enabled(true);
        top_bar.setContentSize(cc.size(this.mainRankList.width,50));
        top_bar.setName("top_bar");
        top_bar.setPosition(cc.winSize.width/2,cc.winSize.height/2+cc.winSize.height*0.243);
        var rankLabel = new ccui.ImageView(res.RankRankBg_png);
        rankLabel.setPosition(top_bar.width*0.1,top_bar.height/2);
        top_bar.addChild(rankLabel);

        var playerLabel = new ccui.ImageView(res.RankPlayerBg_png);
        playerLabel.setPosition(top_bar.width*0.36,top_bar.height/2);
        playerLabel.setName("playerLabel");
        top_bar.addChild(playerLabel);

        var awardNumLabel = new ccui.ImageView(res.RankAwardNumBg_png);
        awardNumLabel.setPosition(top_bar.width*0.7,top_bar.height/2);
        awardNumLabel.setName("awardNumLabel");
        top_bar.addChild(awardNumLabel);

        var awardLabel = new ccui.ImageView(res.RankAwardBg_png);
        awardLabel.setPosition(top_bar.width*0.9,top_bar.height/2);
        awardLabel.setName("awardLabel");
        top_bar.addChild(awardLabel);

        this.addChild(top_bar,2);
    },

    selectedMainItemEvent: function(sender, type) {
        switch (type) {
            case ccui.ListView.EVENT_SELECTED_ITEM:
                var listViewEx = sender;
                var item = listViewEx.getItem(listViewEx.getCurSelectedIndex());
                cc.log("select child index = " + item.getTag());
                break;
            case ccui.ListView.EVENT_SLIDEBALL_UP:
                cc.log("up");
                break;
            case ccui.ListView.EVENT_SLIDEBALL_DOWN:
                cc.log("down");
            default:
                break;
        }
    },

    refreshRankList:function (rankList) {
        var mainRankList = this.getChildByName("mainRankList");
        mainRankList.removeAllItems();
        for(var i = 0; i < rankList.length; i++) {
            var item = rankLayer.addMainRankItemWithData(rankList[i]);
            mainRankList.pushBackCustomItem(item);
        }
    },
});

var RankScene = cc.Scene.extend({
    _backListener:null,

    ctor:function () {
        this._super();
        this._backListener = cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if(keyCode == cc.KEY.back) {
                    cc.log("jijun android back");
                    var quitAppConfirmDialog = new CommonDialog(DialogType.QuitAppConfrimDialog, -1);
                    quitAppConfirmDialog.setTag(DialogType.QuitAppConfrimDialog);
                    quitAppConfirmDialog.popup();
                } else if(keyCode == cc.KEY.menu) {
                    cc.log("jijun android menu");
                }
            }
        }, this);
    },

    onEnter: function () {
        this._super();
        rankLayer = new RankLayer();
        rankLayer.retain();
        this.addChild(rankLayer);
    },

    onExit:function () {
        this._super();
        rankLayer.release();
        cc.eventManager.removeListener(this._backListener);
    }
});

function rankListSuccess(retBody) {
    cc.log(retBody.userRank + " " +  retBody.userScore + " " + retBody.rankList.length);
    if(rankLayer != null && rankLayer != undefined && rankLayer instanceof RankLayer) {
        if (retBody.rankList.length == 0) {
            rankLayer.getChildByName("noDataLabel").setVisible(true);
        } else {
            rankLayer.getChildByName("noDataLabel").setVisible(false);
        }
        if (rankLayer._currentSubtype == 4) {
            rankLayer.getChildByName("myRankBg").getChildByName("normalCup").loadTexture(res.MvpNumber_png);
        } else if (rankLayer._currentSubtype == 5) {
            rankLayer.getChildByName("myRankBg").getChildByName("normalCup").loadTexture(res.RichManNumber_png);
        } else if (rankLayer._currentSubtype == 6) {
            rankLayer.getChildByName("myRankBg").getChildByName("normalCup").loadTexture(res.CharmValue_png);
        } else {
            rankLayer.getChildByName("myRankBg").getChildByName("normalCup").loadTexture(res.NormalCup_png);
        }
        rankLayer.getChildByName("myRankBg").getChildByName("cupNum").setString("" + retBody.userScore);
        if (retBody.userRank > 10000) {
            rankLayer.getChildByName("myRankBg").getChildByName("myRankText").setString("10000+");
        } else {
            rankLayer.getChildByName("myRankBg").getChildByName("myRankText").setString("" + retBody.userRank);
        }
        rankLayer.refreshRankList(retBody.rankList);
    }
};

function rankListFailed(retCode) {
    cc.log(retCode);
    var errorString = "未知错误";
    if(retCode == -2000) {
        errorString = "用户名不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "用户名已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    }
    ToastUtil.showToast(errorString, 2.0);
};

function rankListResume(retBody) {
    cc.log(retBody);
};

function rankListResponse(responseString) {
   // sendAliLog("rankListResponse", "info", responseString);
    cc.director.getRunningScene().removeChildByTag(997001);
    if(responseString == "" || responseString == null || responseString == undefined) {
        ToastUtil.systemToastInMiddle("请求超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                rankListSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                rankListResume(responseObj.retBody);
            }
        } else {
            rankListFailed(responseObj.retCode);
        }
    }
};
