/**
 * Created by fanfeifan on 2017/1/14.
 */

var ShopScene = cc.Scene.extend({

    _backListener:null,

    ctor: function (shopType) {
        this._super();
        this.initBackground(shopType);
        this._backListener = cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if(keyCode == cc.KEY.back) {
                    cc.log("jijun android back");
                    var quitAppConfirmDialog = new CommonDialog(DialogType.QuitAppConfrimDialog, -1);
                    quitAppConfirmDialog.setTag(DialogType.QuitAppConfrimDialog);
                    quitAppConfirmDialog.popup();
                } else if(keyCode == cc.KEY.menu) {
                    cc.log("jijun android menu");
                }
            }
        }, this);

        return true;
    },

    onExit:function () {
        this._super();
        cc.eventManager.removeListener(this._backListener);
    },

    initBackground: function (shopType) {

        var background = ccui.ImageView(res.ShopBack1_png);
        background.setAnchorPoint(0.5,1);
        background.setScale9Enabled(true);
        background.setCapInsets(cc.rect(100, 300, 550, 20));
        background.setContentSize(BaseWindowConf.WIDTH, BaseWindowConf.HEIGHT);
        background.setPosition(cc.winSize.width/2,cc.winSize.height);

        this.addChild(background);

        // 商店字样
        var shopLabel = new ccui.ImageView(res.ShopTitile_png);
        shopLabel.setScale(1.2);
        shopLabel.setPosition(cc.p(cc.winSize.width/2,cc.winSize.height-cc.winSize.height*0.05));
        this.addChild(shopLabel);

        // 主购买界面
        this.addBuyDiamondLayer();
        this.addBuyPropLayer();

        var _this = this;

        // 购买钻石
        var buyDiamondBtn = new ccui.Button(res.ShopBuyDiamondBtn_png, res.ShopBuyDiamondBtn_png, "");

        buyDiamondBtn.setPosition(cc.winSize.width*0.225, cc.winSize.height-cc.winSize.height*0.13);
        buyDiamondBtn.addClickEventListener(function () {
            _this.buyDiamondLayer.setVisible(true);
            _this.buyPropLayer.setVisible(false);
            buyDiamondBtn.loadTextures(res.ShopBuyDiamondBtn_png, res.ShopBuyDiamondBtn_png, "");
            buyPropBtn.loadTextures(res.ShopBuyPropBtn_png, res.ShopBuyPropBtn_png, "")
        });
        this.addChild(buyDiamondBtn,2);
        var buyDiamondLabel = new ccui.ImageView(res.ShopBuyDiamondLabel_png);
        buyDiamondLabel.setPosition(buyDiamondBtn.width/2,buyDiamondBtn.height/2);
        buyDiamondBtn.addChild(buyDiamondLabel);

        // 购买道具
        var buyPropBtn = new ccui.Button(res.ShopBuyPropBtn_png, res.ShopBuyPropBtn_png, "");
        buyPropBtn.setPosition(buyDiamondBtn.x+buyPropBtn.width+5, buyDiamondBtn.y);
        buyPropBtn.addClickEventListener(function () {
            _this.buyDiamondLayer.setVisible(false);
            _this.buyPropLayer.setVisible(true);
            buyDiamondBtn.loadTextures(res.ShopBuyPropBtn_png, res.ShopBuyPropBtn_png, "");
            buyPropBtn.loadTextures(res.ShopBuyDiamondBtn_png, res.ShopBuyDiamondBtn_png, "");
        });
        this.addChild(buyPropBtn,2);

        var buyPropLabel = new ccui.ImageView(res.ShopBuyPropLabel_png);
        buyPropLabel.setPosition(buyPropBtn.width/2,buyPropBtn.height/2);
        buyPropBtn.addChild(buyPropLabel);

        if(shopType == ShopType.Diamond) {
            _this.buyDiamondLayer.setVisible(true);
            _this.buyPropLayer.setVisible(false);
            buyDiamondBtn.loadTextures(res.ShopBuyDiamondBtn_png, res.ShopBuyDiamondBtn_png, "");
            buyPropBtn.loadTextures(res.ShopBuyPropBtn_png, res.ShopBuyPropBtn_png, "")
        } else if (shopType == ShopType.Prop) {
            _this.buyDiamondLayer.setVisible(false);
            _this.buyPropLayer.setVisible(true);
            buyDiamondBtn.loadTextures(res.ShopBuyPropBtn_png, res.ShopBuyPropBtn_png, "");
            buyPropBtn.loadTextures(res.ShopBuyDiamondBtn_png, res.ShopBuyDiamondBtn_png, "");
        }

        var tabMenuLayer = new TabMenuLayer();
        tabMenuLayer.setAnchorPoint(cc.p(0,0));
        tabMenuLayer.setPosition(cc.p(0,0));
        this.addChild(tabMenuLayer,10);
        tabMenuLayer.getChildByName("shopButton").setScale(1.1);
    },

    addBuyDiamondLayer: function() {
        this.buyDiamondLayer = new BuyDiamondLayer();
        this.buyDiamondLayer.setPosition(cc.p(0,0));
        this.addChild(this.buyDiamondLayer);
    },

    addBuyPropLayer: function() {
        this.buyPropLayer = new BuyPropLayer();
        this.buyPropLayer.setPosition(cc.p(0,0));
        this.buyPropLayer.setVisible(false);
        this.addChild(this.buyPropLayer);
    },

    onEnter: function () {
        this._super();
        var httpUtil = new HttpUtil();
        httpUtil.requestDiamond("loadDiamondListResponse", function (responseString) {
            cc.log("success " + responseString);
        }, function (responseString) {
            cc.log("resume " + responseString);
        }, function (responseCode) {
            cc.log("failed " + responseCode);
        });
        var httpUtil = new HttpUtil();
        httpUtil.requestProp("loadPropListResponse", function (responseString) {
            cc.log("success " + responseString);
        }, function (responseString) {
            cc.log("resume " + responseString);
        }, function (responseCode) {
            cc.log("failed " + responseCode);
        });
    }
});

function loadDiamondListResponse (responseString) {
    if(responseString == "" || responseString == null || responseString == undefined) {
        ToastUtil.systemToastInMiddle("请求超时，请检查网络...", 2.0);
    } else {
        if (cc.director.getRunningScene() instanceof ShopScene) {
            var responseObj = JSON.parse(responseString);
            if (responseObj.retCode == 1) {
                cc.director.getRunningScene().buyDiamondLayer.reloadDiamondListData(responseObj.retBody);
            }
        }
    }
};

function loadPropListResponse (responseString) {
    if(responseString == "" || responseString == null || responseString == undefined) {
        ToastUtil.systemToastInMiddle("请求超时，请检查网络...", 2.0);
    } else {
        if (cc.director.getRunningScene() instanceof ShopScene) {
            var responseObj = JSON.parse(responseString);
            if (responseObj.retCode == 1) {
                cc.director.getRunningScene().buyPropLayer.reloadPropListData(responseObj.retBody);
            }
        }
    }
};


var orderId = 0;

function buyDiamondSuccess(retBody) {
    cc.log("jijun js " + retBody.aliPayOrderInfo);

    orderId = retBody.orderId;
    if (cc.sys.os === cc.sys.OS_ANDROID) {
        if(retBody.channel == 2) {
            cc.log("will call WXPay");
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "WXPay"
                , "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", retBody.appId, retBody.mchId, retBody.prepayId, retBody.wxnoncestr, retBody.wxsign, retBody.timestamp);
            cc.log("did call WXPay");
        } else if (retBody.channel == 1){
            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "AliPayV2"
                , "(Ljava/lang/String;)V", retBody.aliPayOrderInfo);
        }
    } else if (cc.sys.os === cc.sys.OS_IOS) {
        if(retBody.channel == 2) {
            jsb.reflection.callStaticMethod("IosWechatPay", "WXPay:partnerId:prepayID:nonceStr:sign:timestamp:"
                , retBody.appId, retBody.mchId, retBody.prepayId, retBody.wxnoncestr, retBody.wxsign, retBody.timestamp);
        } else if (retBody.channel == 1){
            jsb.reflection.callStaticMethod("IosAlipay", "AliPayV2:"
                , retBody.aliPayOrderInfo);
        } else if (retBody.channel == 3){
            jsb.reflection.callStaticMethod("IosIap", "BuyWithProductId:", retBody.skuId+"");
        }
    } else {

    }
};

function buyDiamondFailed(retCode) {
    cc.log(retCode);
    var errorString = "未知错误";
    if(retCode == -2000) {
        errorString = "用户名不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "用户名已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    }
    ToastUtil.showToast(errorString, 2.0);
};

function buyDiamondResume(retBody) {
    cc.log(retBody);
};

function buyDiamondResponse(responseString) {
    //sendAliLog("signinResponse", "info", responseString);
    if(responseString == "" || responseString == null || responseString == undefined) {
        ToastUtil.systemToastInMiddle("请求超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                buyDiamondSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                buyDiamondResume(responseObj.retBody);
            }
        } else {
            buyDiamondFailed(responseObj.retCode);
        }
    }
};

function PayResponse(retCode) {
    cc.log("jijun pay response");
    cc.director.getRunningScene().removeChildByTag(DialogType.BuyDiamond);
    if(retCode == undefined) {
        ToastUtil.systemToastInMiddle("请求超时，请检查网络...", 2.0);
    } else {
        if (retCode == 0) {
            //TODO
            var loadingDialog = new LoadingDialog();
            loadingDialog.setTag(997001);
            loadingDialog.popup();

            pullOrderStatus();
        } else {
            ToastUtil.showToast("支付失败", 2.0);
        }
    }
};

function ApplePayResponse(responseString) {
    cc.log(responseString);
    var buyDiamondApi = new BuyDiamondApi();
    buyDiamondApi.applePayReceiveNotify(orderId, responseString, "pullAppleOrderStatusResponse", function () {
    },function () {
    },function () {
    });
};

function pullOrderStatus() {
    var buyDiamondApi = new BuyDiamondApi();
    buyDiamondApi.pullOrderStatus(orderId, "pullOrderStatusResponse", function () {
    },function () {
    },function () {
    });
};

function pullOrderStatusResponse(responseString) {
    cc.log("jijun js pullOrderStatusResponse " +  responseString);
    if(responseString == "" || responseString == null || responseString == undefined) {
        ToastUtil.systemToastInMiddle("请求超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                pullOrderStatusSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                pullOrderStatusResume(responseObj.retBody);
            }
        } else {
            pullOrderStatusFailed(responseObj.retCode);
        }
    }
};

function pullAppleOrderStatusResponse(responseString) {
    cc.log("jijun js pullOrderStatusResponse " +  responseString);
    if(responseString == "" || responseString == null || responseString == undefined) {
        ToastUtil.systemToastInMiddle("请求超时，请检查网络...", 2.0);
    } else {
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                pullAppleOrderStatusSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                pullOrderStatusResume(responseObj.retBody);
            }
        } else {
            pullOrderStatusFailed(responseObj.retCode);
        }
    }
};

function pullOrderStatusSuccess(retBody) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        if (retBody.status == 0) {
            setTimeout(pullOrderStatus(), 500);
        } else {
            cc.director.getRunningScene().removeChildByTag(997001);
            cc.log("jijun js" + retBody.content.code);
            if (retBody.content.code == 1) {
                cc.log("jijun js" + retBody.content.desc);
                DataManager.getInstance().getUserData()._diamond = retBody.content.totalDiamond;
                ClickRecod("PayStatistics", UMengStatistics.get(retBody.content.skuId));
                var buyResultDialog = new BuyResultDialog("获得物品",retBody.content.desc);
                buyResultDialog.popup();
            }
        }
    } else if(cc.sys.os === cc.sys.OS_IOS){
        if (retBody.status == 0) {
            setTimeout(pullOrderStatus(), 500);
        } else {
            cc.director.getRunningScene().removeChildByTag(997001);
            cc.log("jijun js" + retBody.content.code);
            if (retBody.content.code == 1) {
                cc.log("jijun js" + retBody.content.desc);
                DataManager.getInstance().getUserData()._diamond = retBody.content.totalDiamond;
                ClickRecod("PayStatistics", UMengStatistics.get(retBody.content.skuId));
                var buyResultDialog = new BuyResultDialog("获得物品",retBody.content.desc);
                buyResultDialog.popup();
            }
        }
    }
};

function pullAppleOrderStatusSuccess(retBody) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        if (retBody.status == 0) {
            setTimeout(pullOrderStatus(), 500);
        } else {
            cc.director.getRunningScene().removeChildByTag(997001);
            cc.log("jijun js" + retBody.content.code);
            if (retBody.content.code == 1) {
                cc.log("jijun js" + retBody.content.desc);
                DataManager.getInstance().getUserData()._diamond = retBody.content.totalDiamond;
                ClickRecod("PayStatistics", UMengStatistics.get(retBody.content.skuId));
                var buyResultDialog = new BuyResultDialog("获得物品",retBody.content.desc);
                buyResultDialog.popup();
            }
        }
    } else if(cc.sys.os === cc.sys.OS_IOS){
        cc.log("jijun js" + retBody.code);
        if (retBody.code == 1) {
            DataManager.getInstance().getUserData()._diamond = retBody.totalDiamond;
            ClickRecod("PayStatistics", UMengStatistics.get(retBody.skuId));
            var buyResultDialog = new BuyResultDialog("获得物品",retBody.desc);
            buyResultDialog.popup();
        }
    }
};

function pullOrderStatusFailed(retCode) {
    cc.log(retCode);
    cc.director.getRunningScene().removeChildByTag(997001);
    var errorString = "未知错误";
    if(retCode == -2000) {
        errorString = "用户名不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "用户名已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    } else if (retCode == -1001) {
        errorString = "支付校验出错，请联系客服";
    }
    ToastUtil.showToast(errorString, 2.0);
};

function pullOrderStatusResume(retBody) {
    cc.log(retBody);
};

function buyToolSuccess(retBody) {
    cc.log("jijun js " + "购买成功");

    if(retBody.totalCoin != -1) {
        DataManager.getInstance().getUserData()._goldenCoin = retBody.totalCoin;
    }

    if(retBody.totalDiamond != -1) {
        DataManager.getInstance().getUserData()._diamond = retBody.totalDiamond;
    }

    if(retBody.skuId >= 4007 && retBody.skuId <= 4010) {
        ClickRecod("GoldUseType", UMengStatistics.get(retBody.skuId));
    } else {
        ClickRecod("DiamondUseType", UMengStatistics.get(retBody.skuId));
    }

    var contentArray = new Array();
    for(var i = 0; i < retBody.desc.length; i++) {
        contentArray.push(retBody.desc[i]);
    }
    var buyResultDialog = new BuyResultDialog("获得物品", contentArray);
    buyResultDialog.popup();
};

function buyToolFailed(retCode) {
    cc.log(retCode);
    var errorString = "未知错误";
    if(retCode == -2000) {
        errorString = "用户名不存在或者密码不正确";
    } else if(retCode == -2001) {
        errorString = "用户名已经存在";
    } else if (retCode == -2002) {
        errorString = "房间密码错误";
    } else if (retCode == -2003) {
        errorString = "钻石或金币不足，请充值";
    } else if (retCode == -2005) {
        errorString = "您已购买过此物品，不可以重复购买哦~";
    }
    ToastUtil.systemToastInMiddle(errorString, 2.0);
};

function buyToolResume(retBody) {
    cc.log(retBody);
};

function buyToolResponse(responseString) {
    if(responseString == null || responseString == "" || responseString == undefined) {
        ToastUtil.systemToastInMiddle("网络超时，请检查网络...", 2.0);
    } else {
        cc.director.getRunningScene().removeChildByTag(DialogType.BuyProp);
        var responseObj = JSON.parse(responseString);
        if (responseObj.retCode > 0) {
            if (responseObj.retCode == 1) {
                buyToolSuccess(responseObj.retBody);
            } else if (responseObj.retCode == 2) {
                buyToolResume(responseObj.retBody);
            }
        } else {
            buyToolFailed(responseObj.retCode);
        }
    }
};




