/**
 * Created by fanfeifan on 2017/1/25.
 */

var BaseCard = cc.Node.extend({
    _headLabel: '',
    _cardCount: 0,

    ctor: function (headLabel) {
        this._super();
        this._headLabel = headLabel;
        this.initBackground();
        return true;
    },

    initBackground: function() {
        // 背景
        this.back = ccui.ImageView(res.TutorialItemBg_png);
        this.back.setScale9Enabled(true);
        this.back.setContentSize(cc.size(BaseWindowConf.WIDTH*0.79,BaseWindowConf.HEIGHT*0.195));
        this.addChild(this.back);

        // 头部背景及字样
        this.headBg = ccui.ImageView(res.TutorialItemTitleBg_png);
        this.headBg.setAnchorPoint(cc.p(0.5,1));
        this.headBg.setPosition(cc.p(this.back.width/2,this.back.height));
        this.back.addChild(this.headBg,10);
        var label = ccui.ImageView(this._headLabel);
        label.setPosition(this.headBg.width/2,this.headBg.height/2);
        this.headBg.addChild(label);
    },

    getInnerHeight: function() {
        return (this._cardCount-1) * cc.winSize.height * 0.27 + cc.winSize.height*0.25;
    },

    // 添加一张新卡牌
    addCard: function(card, label, description) {
        var node = new cc.LayerColor(cc.color(184,145,111));
        node.setContentSize(this.back.width,cc.winSize.height*0.27);

        var _card = new ccui.ImageView(card);
        _card.setPosition(node.width*0.15,node.height*0.5);
        node.addChild(_card);

        var _label = new cc.LabelTTF(label, "Arial", 30);
        _label.setColor(cc.color(246,242,175));
        _label.setPosition(node.width*0.42,node.height*0.74);
        node.addChild(_label);

        var _description = new cc.LabelTTF(description, "Arial", 25);
        _description.setColor(cc.color(70,30,0));
        _description.setPosition(node.width*0.65,node.height*0.19);
        _description.setDimensions(node.width*0.65,node.height);
        node.addChild(_description);

        node.setAnchorPoint(cc.p(0,0));
        node.x = 0;
        node.y = -70 - node.height * this._cardCount;

        this._cardCount += 1;
        this.back.addChild(node);
    },

    // 添加带有划线的卡片(下面带有小tip)
    addCardWithSlide: function(card, label, description, tip) {
        var node = new cc.LayerColor(cc.color(184,145,111));
        node.setContentSize(this.back.width,cc.winSize.height*0.22);

        var _card = new ccui.ImageView(card);
        _card.setPosition(node.width*0.15,node.height*0.47);
        node.addChild(_card,5);

        var _label = new cc.LabelTTF(label, "Arial", 30);
        _label.setColor(cc.color(246,242,175));
        _label.setPosition(node.width*0.42,node.height*0.72);
        node.addChild(_label);

        var _description = new cc.LabelTTF(description, "Arial", 25);
        _description.setColor(cc.color(70,30,0));
        _description.setAnchorPoint(cc.p(0.5,1));
        _description.setPosition(node.width*0.65,node.height*0.63);
        _description.setDimensions(node.width*0.65,node.height*0.5);
        node.addChild(_description);

        node.setAnchorPoint(cc.p(0,0));
        node.x = 0;
        node.y = 0 - node.height * this._cardCount;

        // 添加划线
        var slide = new ccui.ImageView(res.TutorialSlide_png);
        slide.setAnchorPoint(cc.p(0.5,1));
        slide.setPosition(node.width*0.6,node.height*0.2);
        node.addChild(slide);

        // 修正坐标
        if (this._cardCount == 0) {
            cc.log('this.count =0 ');
            this.headBg.setPosition(cc.p(this.back.width/2,this.back.height+cc.winSize.height*0.023));
            //this.back.setContentSize(cc.size(cc.visibleRect.width*0.79,cc.visibleRect.height*0.253));
        }

        // 添加tip
        var _tip = new cc.LabelTTF(tip, "Arial", 20);
        _tip.setColor(cc.color(70,30,0));
        _tip.setPosition(node.width*0.5,node.height*0.08);
        _tip.setDimensions(node.width*0.8,node.height*0.1);
        node.addChild(_tip);

        this._cardCount += 1;
        this.back.addChild(node);
    },

})