var resumeRequestSendFlag = false;
var resumeRequestSendTime = -1;

function ClickRecod(eventId, label) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/UMengSDK",
            "clickRecord",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            eventId, label);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("UmengUtil",
            "ClickRecordWithEventId:andLabel:",
            eventId, label);
    }
}

function WXShareWebpageToFriend(url, title, description, image) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity",
            "WXShareWebpageToFriend",
            "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V",
            url, title, description, image);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        var url = url;
        var title = title;
        var description = description;
        var image = image;
        jsb.reflection.callStaticMethod("WXLoginUtil",
            "WXShareWebpageToFriendWithUrl:Title:Description:Image:",
            url, title, description, image);
    }
}

function WXShareWebpageToTimeline(url, title, description, image) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity",
            "WXShareWebpageToTimeline",
            "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V",
            url, title, description, image);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        var url = url;
        var title = title;
        var description = description;
        var image = image;
        jsb.reflection.callStaticMethod("WXLoginUtil",
            "WXShareWebpageToTimelineWithUrl:Title:Description:Image:",
            url, title, description, image);
    }
}

function vibrate() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/VibratorUtil", "playVibrator", "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("WXLoginUtil", "vibrate");
    }
}

function isWXAppInstalled() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        return jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "isWXAppInstalled", "()Z");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        return jsb.reflection.callStaticMethod("WXLoginUtil", "isWXAppInstalled");
    }
}

function controlVoiceDirectly(micEnable, speakerEnable) {
    if(micEnable) {
        _gcloudvoice.openMic();
    } else {
        _gcloudvoice.closeMic();
    }

    if(speakerEnable) {
        _gcloudvoice.openSpeaker();
    } else {
        _gcloudvoice.closeSpeaker();
    }
}

function playSound(soundCode) {
    if(DataManager.getInstance().getUserData()._currentVoice == SystemVoiceState.MENG_MEI_ZI) {
        cc.audioEngine.playEffect(AudioMap.get(soundCode)[1], false);
    } else {
        cc.audioEngine.playEffect(AudioMap.get(soundCode)[0], false);
    }
}

function initMqtt() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "initMqttClient", "(I)V", DataManager.getInstance().getUserData()._userId);
    } else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("MqttSDK", "connectWithUserId:", DataManager.getInstance().getUserData()._userId+"");
    }
}

function tranferMqttMessage() {
    var messageArray = new Array();
    var queue = MqttClient.getInstance()._mqttMessageQueue;
    if(queue != null && queue != undefined) {
        var size = queue.size();
        if (size > 0) {
            for (var i = 0; i < size; i++) {
                var obj = queue.shift();
                messageArray.push(obj);
            }

            if (cc.sys.os === cc.sys.OS_ANDROID) {
                jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "transferMqttMessage", "(Ljava/lang/String;)V", JSON.stringify(messageArray));
            } else if (cc.sys.os === cc.sys.OS_IOS) {
                // TODO transfer ios message
            }
        }
    }
}

function notifySceneShow() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "notifySceneShow", "()V");
    } else if (cc.sys.os === cc.sys.OS_IOS) {
        //TODO init ios mqtt
    }
}

function isMqttConnected() {
    var isConnect = false;
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        isConnect = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "isMqttConnected", "()Z");
    } else if(cc.sys.os === cc.sys.OS_IOS) {
        isConnect = jsb.reflection.callStaticMethod("MqttSDK", "isConnected");
    }
    return isConnect;
}

function sendResumeRequest() {
    resumeRequestSendFlag = true;
    resumeRequestSendTime = new Date().getTime();
    MqttHelper.getInstance().resumeRequest();
}

function inviteFriend(title, detail) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "WXShareWebpageToFriend", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V",
            "http://a.app.qq.com/o/simple.jsp?pkgname=cn.quanminsha", title, detail, "");
    } else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("WXLoginUtil", "WXShareWebpageToFriendWithUrl:Title:Description:Image:",
            "http://a.app.qq.com/o/simple.jsp?pkgname=cn.quanminsha", title, detail, "res/AppIcon.png.png");
    }
}

function logHtml(content) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        // jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/AliLogUtil", "logHtml", "(Ljava/lang/String;)V",
        //     content);
    } else if (cc.sys.os === cc.sys.OS_IOS) {
        // jsb.reflection.callStaticMethod("WXLoginUtil", "WXShareWebpageToFriendWithUrl:Title:Description:Image:",
        //     "http://www.quanminsha.cn", title, detail, "res/systemAvatar.png");
    }
}

function checkPermission() {
    var hasPermission = false;
    if(cc.sys.os === cc.sys.OS_ANDROID) {
         hasPermission = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "isHasPermission", "()Z");
    } else if (cc.sys.os === cc.sys.OS_IOS) {
         hasPermission = jsb.reflection.callStaticMethod("KeyCenter", "canRecord");
    }
    cc.log("checkPermissioin" + hasPermission);
    return hasPermission;
}