function getChannelName() {
    var roomId = DataManager.getInstance().getCurrentRoomData()._roomId;
    if(roomId == null || roomId == 0) {
        return null;
    }
    return "channel" +  roomId;
}

function sendAliLog(topic, level, content) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/AliLogUtil", "sendAliLog", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V",
            topic, DataManager.getInstance().getUserData()._userId+"", level, content);
    } else if (cc.sys.os === cc.sys.OS_IOS) {
        // cc.log("send ali log test");
        //jsb.reflection.callStaticMethod("AliLogUtil", "sendAliLog:from:use:with:", topic, DataManager.getInstance().getUserData()._userId+"", level, content);
        // cc.log("send ali log test 1");
    }
}

function containsSubSequence(longStr, shortStr) {
    var j = 0;
    for (var i = 0; i < longStr.length && j < shortStr.length; i ++) {
        if (longStr[i] == shortStr[j]) {
            j ++;
        }
    }
    return j == shortStr.length;
}

function getUserListConfig(userList) {
    var params = new Object();
    params.clientVersion = DataManager.getInstance().getCommonData().getClientVersion();
    params.protocalVersion = DataManager.getInstance().getCommonData().getProtocalVersion();
    params.userIdList = userList;

    if(cc.sys.os === cc.sys.OS_ANDROID) {
        var address = "http://test.lyingmanonline.com";
        if(SoftVersion == VersionConfig.RELEASE || 1) {
            address = "https://api.lyingmanonline.com";
        }
        var path = "/gameProfile/getFriendInfoList";
        var jsonBody = JSON.stringify(params);
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/AliGatewayUtil", "asynPostRequest"
            , "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", address, path, jsonBody, "getUserListConfigCallback");
    } else if (cc.sys.os === cc.sys.OS_IOS) {
        var address = "test.lyingmanonline.com";
        if (SoftVersion == VersionConfig.RELEASE || 1) {
            address = "api.lyingmanonline.com";
        }
        var path = "/gameProfile/getFriendInfoList";
        var jsonBody = JSON.stringify(params);
        jsb.reflection.callStaticMethod("AliGatewayUtil", "asynPostRequest:path:jsonBody:callBack:", address, path, jsonBody, "getUserListConfigCallback");
    }
}

function getUserListConfigCallback(jsonStr) {
    cc.log(jsonStr);
}

function diffDay(newDate, oldDate) {
    var date1 = new Date(newDate.getFullYear(), newDate.getMonth(), newDate.getDate());
    var date2 = new Date(oldDate.getFullYear(), oldDate.getMonth(), oldDate.getDate());
    return (date1 - date2) / 86400000;
}

function formatTimestamp(timestamp) {
    var timestamp2 = timestamp.replace(/-/g, "/");
    var datetime = new Date(Date.parse(timestamp2));
    var now = new Date();
    var diffDayCnt = diffDay(now, datetime);
    if (diffDayCnt == 0) {      // 今天
        var t1 = timestamp.split(" ")[1];
        var t2 = t1.split(":");
        return t2[0] + ":" + t2[1];
    }
    else if (diffDayCnt == 1) { // 昨天
        return "昨天";
    }
    else if (diffDayCnt == 2) { // 前天
        return "前天";
    }
    else {
        return timestamp.split(" ")[0];
    }
}

function formatTimestampWithHour(timestamp) {
    var timestamp2 = timestamp.replace(/-/g, "/");
    var datetime = new Date(Date.parse(timestamp2));
    var now = new Date();
    var diffDayCnt = diffDay(now, datetime);
    var t1 = timestamp.split(" ")[1];
    var t2 = t1.split(":");
    if (diffDayCnt == 0) {      // 今天
        return t2[0] + ":" + t2[1];
    }
    else if (diffDayCnt == 1) { // 昨天
        return "昨天 " + t2[0] + ":" + t2[1];
    }
    else if (diffDayCnt == 2) { // 前天
        return "前天" + t2[0] + ":" + t2[1];
    }
    else {
        return timestamp.split(" ")[0];
    }
}

function getMillisecondDiff(oldTime, newTime) {
    var oldTemp = oldTime.replace(/-/g, "/");
    var newTemp = newTime.replace(/-/g, "/");
    var oldMillisecond = new Date(Date.parse(oldTemp)).getTime();
    var newMillisecond = new Date(Date.parse(newTemp)).getTime();
    return newMillisecond - oldMillisecond;
}

function isMyFriendSucc() {}

function isMyFriendFail() {}

function isMyFriend(identifier) {
    TXIMSDK_getLocalFriendProfileCallback = function(jsonStr) {
        var obj = JSON.parse(jsonStr);
        if (obj.length == 1) {
            isMyFriendSucc();
        }
        else {
            isMyFriendFail();
        }
    };
    TXIMSDK_getLocalFriendProfile(identifier);
}
