/**
 * Created by junji on 2017/2/4.
 */
FixedLengthQueue = cc.Class.extend({

    elements:null,
    fixedLength:1,

    ctor:function (length) {
        this.elements = new Array();
        this.fixedLength = length;
    },

    get:function (index) {
        if(index < 0 || index > this.elements.length - 1)
            return null;
        else
            return this.elements[index];
    },

    push:function (ele) {
        if (ele.length == 0) {
            return -1
        };
        this.elements.push(ele);
        if(this.elements.length > this.fixedLength) {
            this.elements.shift();
        }
        return this.elements.length;
    },

    shift:function () {
        if (this.elements.length <= 0) {
            return null
        };
        return this.elements.shift();
    },

    sortWithSequenceId:function () {
        this.elements.sort(function (a,b) {
            return a.sequenceId -  b.sequenceId;
        });
    },

    clear:function () {
        this.elements = new Array();
    },

    size:function () {
        return this.elements.length;
    },

    isEmpty:function () {
        if (this.elements.length > 0) {
            return false;
        } else {
            return true;
        }
    },
});