function TXIMSDK_alert(message) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "alert",
            "(Ljava/lang/String;)V",
            message);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "alert:",
            message);
    }
};

function TXIMSDK_onNewMessage(jsonStr) {
    cc.log("ziaoang->" + jsonStr);

    if (cc.director.getRunningScene() instanceof FriendMessageScene) {
        cc.director.getRunningScene().onNewMessage(jsonStr);
    }
    else if (cc.director.getRunningScene() instanceof FriendChatScene) {
        cc.director.getRunningScene().onNewMessage(jsonStr);
    }

};

function TXIMSDK_initSDK() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "initSDK",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "initSDK");
    }
};

function TXIMSDK_login(identifier, userSig) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "login",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            identifier, userSig);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "loginWithIdentifier:andUserSig:",
            identifier, userSig);
    }
};
function TXIMSDK_loginSucc() {};
function TXIMSDK_loginFail(code, msg) {};


function TXIMSDK_logout() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "logout",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "logout");
    }
};
function TXIMSDK_logoutSucc() {};
function TXIMSDK_logoutFail(code, msg) {};


function TXIMSDK_getLoginUser() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        return jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getLoginUser",
            "()Ljava/lang/String;");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        return jsb.reflection.callStaticMethod("TXIMSDK",
            "getLoginUser");
    }
    return "";
};


function TXIMSDK_sendTextMessagetoClient(message, identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "sendTextMessagetoClient",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            message, identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "sendTextMessage:toClient:",
            message, identifier);
    }
};
function TXIMSDK_sendTextMessagetoClientSucc() {};
function TXIMSDK_sendTextMessagetoClientFail(code, msg) {};


function TXIMSDK_sendTextMessagetoGroup(message, groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "sendTextMessagetoGroup",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            message, groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "sendTextMessage:toGroup:",
            message, groupId);
    }
};
function TXIMSDK_sendTextMessagetoGroupSucc() {};
function TXIMSDK_sendTextMessagetoGroupFail(code, msg) {};


function TXIMSDK_sendCustomMessagetoClient(jsonStr, identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "sendCustomMessagetoClient",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            jsonStr, identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "sendCustomMessage:toClient:",
            jsonStr, identifier);
    }
};
function TXIMSDK_sendCustomMessagetoClientSucc() {};
function TXIMSDK_sendCustomMessagetoClientFail(code, msg) {};


function TXIMSDK_sendCustomMessagetoGroup(jsonStr, groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "sendCustomMessagetoGroup",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            jsonStr, groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "sendCustomMessage:toGroup:",
            jsonStr, groupId);
    }
};
function TXIMSDK_sendCustomMessagetoGroupSucc() {};
function TXIMSDK_sendCustomMessagetoGroupFail(code, msg) {};


function TXIMSDK_getAllConversation() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getAllConversation",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getAllConversation");
    }
}
function TXIMSDK_getAllConversationSucc(jsonStr) {};
function TXIMSDK_getAllConversationFail(code, msg) {};


function TXIMSDK_initGetLocalMessageForClient(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "initGetLocalMessageForClient",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "initGetLocalMessageForClient:",
            identifier);
    }
};


function TXIMSDK_getLocalMessageForClient(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getLocalMessageForClient",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getLocalMessageForClient:",
            identifier);
    }
};
function TXIMSDK_getLocalMessageForClientSucc(jsonStr) {};
function TXIMSDK_getLocalMessageForClientFail(code, msg) {};


function TXIMSDK_initGetLocalMessageForGroup(groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "initGetLocalMessageForGroup",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "initGetLocalMessageForGroup:",
            groupId);
    }
};


function TXIMSDK_getLocalMessageForGroup(groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getLocalMessageForGroup",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getLocalMessageForGroup:",
            groupId);
    }
};
function TXIMSDK_getLocalMessageForGroupSucc(jsonStr) {};
function TXIMSDK_getLocalMessageForGroupFail(code, msg) {};

function TXIMSDK_initGetMessageForClient(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "initGetMessageForClient",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "initGetMessageForClient:",
            identifier);
    }
};


function TXIMSDK_getMessageForClient(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getMessageForClient",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getMessageForClient:",
            identifier);
    }
};
function TXIMSDK_getMessageForClientSucc(jsonStr) {};
function TXIMSDK_getMessageForClientFail(code, msg) {};


function TXIMSDK_initGetMessageForGroup(groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "initGetMessageForGroup",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "initGetMessageForGroup:",
            groupId);
    }
};


function TXIMSDK_getMessageForGroup(groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getMessageForGroup",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getMessageForGroup:",
            groupId);
    }
};
function TXIMSDK_getMessageForGroupSucc(jsonStr) {};
function TXIMSDK_getMessageForGroupFail(code, msg) {};


function TXIMSDK_deleteConversationForClient(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "deleteConversationForClient",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "deleteConversationForClient:",
            identifier);
    }
}


function TXIMSDK_deleteConversationAndMessagesForClient(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "deleteConversationAndMessagesForClient",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "deleteConversationAndMessagesForClient:",
            identifier);
    }
}


function TXIMSDK_deleteConversationForGroup(groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "deleteConversationForGroup",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "deleteConversationForGroup:",
            groupId);
    }
}


function TXIMSDK_deleteConversationAndMessagesForGroup(groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "deleteConversationAndMessagesForGroup",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "deleteConversationAndMessagesForGroup:",
            groupId);
    }
}


function TXIMSDK_createPublicGroup(groupId, groupName) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "createPublicGroup",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            groupId, groupName);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "createPublicGroupWithGroupId:andGroupName:",
            groupId, groupName);
    }
};
function TXIMSDK_createPublicGroupSucc() {};
function TXIMSDK_createPublicGroupFail(code, msg) {};


function TXIMSDK_joinGroup(groupId){
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "joinGroup",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "joinGroup:",
            groupId);
    }
};
function TXIMSDK_joinGroupSucc() {};
function TXIMSDK_joinGroupFail(code, msg) {};


function TXIMSDK_quitGroup(groupId){
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "quitGroup",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "quitGroup:",
            groupId);
    }
};
function TXIMSDK_quitGroupSucc() {};
function TXIMSDK_quitGroupFail(code, msg) {};


function TXIMSDK_deleteGroupMember(identifier, groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "deleteGroupMember",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            identifier, groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "deleteGroupMember:forGroupId:",
            identifier, groupId);
    }
};
function TXIMSDK_deleteGroupMemberSucc() {};
function TXIMSDK_deleteGroupMemberFail(code, msg) {};


function TXIMSDK_getGroupMembers(groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getGroupMembers",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getGroupMembers:",
            groupId);
    }
};
function TXIMSDK_getGroupMembersSucc(jsonStr) {};
function TXIMSDK_getGroupMembersFail(code, msg) {};


function TXIMSDK_getGroupList(){
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getGroupList",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getGroupList");
    }
};
function TXIMSDK_getGroupListSucc(jsonStr) {};
function TXIMSDK_getGroupListFail(code, msg) {};


function TXIMSDK_deleteGroup(groupId){
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "deleteGroup",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "deleteGroup:",
            groupId);
    }
};
function TXIMSDK_deleteGroupSucc() {};
function TXIMSDK_deleteGroupFail(code, msg) {};


function TXIMSDK_modifyGroupOwner(groupId, identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "modifyGroupOwner",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            groupId, identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "modifyGroupOwner:toIdentifier:",
            groupId, identifier);
    }
};
function TXIMSDK_modifyGroupOwnerSucc() {};
function TXIMSDK_modifyGroupOwnerFail(code, msg) {};


function TXIMSDK_getGroupPublicInfo(groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getGroupPublicInfo",
            "(Ljava/lang/String;)V",
            groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getGroupPublicInfo:",
            groupId);
    }
};
function TXIMSDK_getGroupPublicInfoSucc(jsonStr) {};
function TXIMSDK_getGroupPublicInfoFail(code, msg) {};


function TXIMSDK_modifyGroupName(groupName, groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "modifyGroupName",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            groupName, groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "modifyGroupName:forGroupId:",
            groupName, groupId);
    }
};
function TXIMSDK_modifyGroupNameSucc() {};
function TXIMSDK_modifyGroupNameFail(code, msg) {};


function TXIMSDK_modifyGroupIntroduction(groupIntroduction, groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "modifyGroupIntroduction",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            groupIntroduction, groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "modifyGroupIntroduction:forGroupId:",
            groupIntroduction, groupId);
    }
};
function TXIMSDK_modifyGroupIntroductionSucc() {};
function TXIMSDK_modifyGroupIntroductionFail(code, msg) {};


function TXIMSDK_modifyGroupNotification(groupNotification, groupId) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "modifyGroupNotification",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            groupNotification, groupId);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "modifyGroupNotification:forGroupId:",
            groupNotification, groupId);
    }
};
function TXIMSDK_modifyGroupNotificationSucc() {};
function TXIMSDK_modifyGroupNotificationFail(code, msg) {};


function TXIMSDK_addGroupAdmin(groupId, identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "addGroupAdmin",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            groupId, identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "addGroupAdminWithGroupId:andIdentifier:",
            groupId, identifier);
    }
};
function TXIMSDK_addGroupAdminSucc() {};
function TXIMSDK_addGroupAdminFail(code, msg) {};

function TXIMSDK_removeGroupAdmin(groupId, identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "removeGroupAdmin",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            groupId, identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "removeGroupAdminWithGroupId:andIdentifier:",
            groupId, identifier);
    }
};
function TXIMSDK_removeGroupAdminSucc() {};
function TXIMSDK_removeGroupAdminFail(code, msg) {};


function TXIMSDK_initGetPendencyFromServer() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "initGetPendencyFromServer",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "initGetPendencyFromServer");
    }
};


function TXIMSDK_getPendencyFromServer() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getPendencyFromServer",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getPendencyFromServer");
    }
};
function TXIMSDK_getPendencyFromServerSucc(jsonStr) {};
function TXIMSDK_getPendencyFromServerFail(code, msg) {};


function TXIMSDK_accept(index) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "accept",
            "(I)V",
            index);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "accept:",
            index);
    }
};
function TXIMSDK_acceptSucc() {};
function TXIMSDK_acceptFail(code, msg) {};


function TXIMSDK_refuse(index) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "refuse",
            "(I)V",
            index);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "refuse:",
            index);
    }
};
function TXIMSDK_refuseSucc() {};
function TXIMSDK_refuseFail(code, msg) {};


function TXIMSDK_setNickName(nickName) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "setNickName",
            "(Ljava/lang/String;)V",
            nickName);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "setNickName:",
            nickName);
    }
};
function TXIMSDK_setNickNameSucc() {};
function TXIMSDK_setNickNameFail(code, msg) {};


function TXIMSDK_addConfirmAllowType() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "addConfirmAllowType",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "addConfirmAllowType");
    }
};
function TXIMSDK_addConfirmAllowTypeSucc() {};
function TXIMSDK_addConfirmAllowTypeFail(code, msg) {};


function TXIMSDK_removeConfirmAllowType() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "removeConfirmAllowType",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "removeConfirmAllowType");
    }
};
function TXIMSDK_removeConfirmAllowTypeSucc() {};
function TXIMSDK_removeConfirmAllowTypeFail(code, msg) {};


function TXIMSDK_getSelfProfile() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getSelfProfile",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getSelfProfile");
    }
};
function TXIMSDK_getSelfProfileSucc(jsonStr) {};
function TXIMSDK_getSelfProfileFail(code, msg) {};


function TXIMSDK_getFriendsProfile(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getFriendsProfile",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getFriendsProfile:",
            identifier);
    }
};
function TXIMSDK_getFriendsProfileSucc(jsonStr) {};
function TXIMSDK_getFriendsProfileFail(code, msg) {};


function TXIMSDK_getUsersProfile(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getUsersProfile",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getUsersProfile:",
            identifier);
    }
};
function TXIMSDK_getUsersProfileSucc(jsonStr) {};
function TXIMSDK_getUsersProfileFail(code, msg) {};


function TXIMSDK_setFriendRemark(remark, identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "setFriendRemark",
            "(Ljava/lang/String;Ljava/lang/String;)V",
            remark, identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "setFriendRemark:withIdentifier:",
            remark, identifier);
    }
};
function TXIMSDK_setFriendRemarkSucc() {};
function TXIMSDK_setFriendRemarkFail(code, msg) {};


function TXIMSDK_addFriend(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "addFriend",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "addFriendWithIdentifier:",
            identifier);
    }
};
function TXIMSDK_addFriendSucc() {};
function TXIMSDK_addFriendFail(code, msg) {};

function TXIMSDK_delFriend(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "delFriend",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "delFriendWithIdentifier:",
            identifier);
    }
};
function TXIMSDK_delFriendSucc() {};
function TXIMSDK_delFriendFail(code, msg) {};


function TXIMSDK_getFriendList(){
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getFriendList",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getFriendList");
    }
};
function TXIMSDK_getFriendListSucc(jsonStr) {};
function TXIMSDK_getFriendListFail(code, msg) {};


function TXIMSDK_agreeFriendRequest(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "agreeFriendRequest",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "agreeFriendRequest:",
            identifier);
    }
};
function TXIMSDK_agreeFriendRequestSucc() {};
function TXIMSDK_agreeFriendRequestFail(code, msg) {};


function TXIMSDK_rejectFriendRequest(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "rejectFriendRequest",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "rejectFriendRequest:",
            identifier);
    }
};
function TXIMSDK_rejectFriendRequestSucc() {};
function TXIMSDK_rejectFriendRequestFail(code, msg) {};


function TXIMSDK_addBlackList(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "addBlackList",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "addBlackListWithIdentifier:",
            identifier);
    }
};
function TXIMSDK_addBlackListSucc() {};
function TXIMSDK_addBlackListFail(code, msg) {};


function TXIMSDK_delBlackList(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "delBlackList",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "delBlackListWithIdentifier:",
            identifier);
    }
};
function TXIMSDK_delBlackListSucc() {};
function TXIMSDK_delBlackListFail(code, msg) {};


function TXIMSDK_getBlackList() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getBlackList",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getBlackList");
    }
};
function TXIMSDK_getBlackListSucc(jsonStr) {};
function TXIMSDK_getBlackListFail(code, msg) {};


function TXIMSDK_getLocalFriendProfileList() {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getLocalFriendProfileList",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getLocalFriendProfileList");
    }
};
function TXIMSDK_getLocalFriendProfileListCallback(jsonStr) {};


function TXIMSDK_getLocalFriendProfile(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getLocalFriendProfile",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getLocalFriendProfileWithIdentifier:",
            identifier);
    }
};
function TXIMSDK_getLocalFriendProfileCallback(jsonStr) {};


function TXIMSDK_getFutureFriends(){
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "getFutureFriends",
            "()V");
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "getFutureFriends");
    }
};
function TXIMSDK_getFutureFriendsSucc(jsonStr) {};
function TXIMSDK_getFutureFriendsFail(code, msg) {};


function TXIMSDK_uploadClientRead(identifier) {
    if(cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.reflection.callStaticMethod("org/cocos2dx/javascript/Util/TXIMSDK",
            "uploadClientRead",
            "(Ljava/lang/String;)V",
            identifier);
    }
    else if (cc.sys.os === cc.sys.OS_IOS) {
        jsb.reflection.callStaticMethod("TXIMSDK",
            "uploadClientRead:",
            identifier);
    }
};


